/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.application;


import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


import javax.faces.application.StateManager.SerializedView;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.ResponseStateManager;

import com.ibm.faces.util.Base64;

/**
 * @author ieu93313
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AjaxResponseStateManagerImpl extends ResponseStateManager {

	ResponseStateManager _responseStateManager;
	public final static String view_input_name ="com.ibm.faces.JWLAJAX.VIEW";
	
	public final static String view_state ="com.ibm.faces.JWLAJAX.state";
	
	/**
	 * 
	 */
	public AjaxResponseStateManagerImpl(ResponseStateManager responseStateManager) {
		
		_responseStateManager = responseStateManager;
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see javax.faces.render.ResponseStateManager#writeState(javax.faces.context.FacesContext, javax.faces.application.StateManager.SerializedView)
	 */
	public void writeState(FacesContext context, SerializedView view)
			throws IOException {
		// TODO Auto-generated method stub
		String viewdone =null;
		String viewid =null;
		
		/*
		 * whatever we do need to do reverse to restore teh view
		 * */
		if(context.getApplication().getStateManager().isSavingStateInClient(context))
		{
			ByteArrayOutputStream b = new ByteArrayOutputStream();
			ObjectOutputStream o = new ObjectOutputStream(b);
			o.writeObject(view.getState());
			o.writeObject(view.getStructure());
			
			viewdone = Base64.encode(b.toByteArray());
			
			ResponseWriter writer = context.getResponseWriter();
			writer.startElement("input", null);
			writer.writeAttribute("type", "hidden", "type");
			writer.writeAttribute("name", view_input_name , null);
			writer.writeAttribute("value", viewdone , null);
			writer.endElement("input");
			//writer.write("<input type=\"hidden\" name=\""+ view_input_name +"\" value=\""+ viewdone+"\" />");
		}
		else
		{
			_responseStateManager.writeState(context, view);
		}
		

	}

	/* (non-Javadoc)
	 * @see javax.faces.render.ResponseStateManager#getTreeStructureToRestore(javax.faces.context.FacesContext, java.lang.String)
	 */
	public Object getTreeStructureToRestore(FacesContext context, String viewId) {
		// TODO Auto-generated method stub
		//return _responseStateManager.getTreeStructureToRestore(arg0, arg1);
		Object structure = null;
		Object state = null;
		String viewString = null;		

		if(context.getApplication().getStateManager().isSavingStateInClient(context))
		{
		
			viewString = (String)context.getExternalContext().getRequestParameterMap().get(view_input_name);
			
			if(viewString != null)
			{
				byte[] ba = Base64.decode(viewString);
				
				ByteArrayInputStream b = new ByteArrayInputStream(ba);
				try{
					ObjectInputStream i = new ObjectInputStream(b);				
					state = i.readObject();
					structure = i.readObject();
				}catch(IOException ioe)
				{
					ioe.printStackTrace();
				}catch(ClassNotFoundException cnfe)
				{
					cnfe.printStackTrace();
				}
				
				context.getExternalContext().getSessionMap().put(view_state, state);		
			}
		}
		
		if(structure == null)
			return _responseStateManager.getTreeStructureToRestore(context, viewId);
		else
			return structure;
	}

	/* (non-Javadoc)
	 * @see javax.faces.render.ResponseStateManager#getComponentStateToRestore(javax.faces.context.FacesContext)
	 */
	public Object getComponentStateToRestore(FacesContext context) {
		// TODO Auto-generated method stub
		//return _responseStateManager.getComponentStateToRestore(arg0);
		Object obj = null;
		
		if(context.getApplication().getStateManager().isSavingStateInClient(context))		
			obj = context.getExternalContext().getSessionMap().get(view_state);
		
		if(obj == null)
			return _responseStateManager.getComponentStateToRestore(context);
		else
			return obj;
	}

}
