package com.ibm.faces.component;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

/**
 * Interface for components and renderers that hold a value on the client
 * in a field with ID other than their own clientId.
 * 
 * Such components and renderers can implement getValueHolderClientId()
 * and return ID of the field that holds the value.
 */
public interface IClientValueHolder {
	public String getValueHolderClientId(FacesContext context, UIComponent component);
}
