/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/
package com.ibm.faces.component;

import javax.faces.component.UIColumn;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * <p>Extended UIColumn component</p>
 * @author pandrews
 */
public class UIColumnEx extends UIColumn {
	
	public static final String COMPONENT_TYPE = "com.ibm.faces.Column";
	public static final String COMPONENT_FAMILY = "com.ibm.faces.Column";
	
	private String footerClass;
	private String headerClass;
	private String width;
	private String dir;
	private String scope;
	private String axis;
	private String height;
	private String nowrap;
	private String align;
	private String valign;
	private String bgcolor;
	private String background;
	private String style;
	private String title;
	

	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	
	
	public UIColumnEx(){
		super();
	}

	/**
	 * @return Returns the align.
	 */
	public String getAlign() {
		if(this.align != null){
			return this.align;
		}
		ValueBinding vb = getValueBinding("align");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param align The align to set.
	 */
	public void setAlign(String align) {
		this.align = align;
	}
	/**
	 * @return Returns the axis.
	 */
	public String getAxis() {
		if(this.axis != null){
			return this.axis;
		}
		ValueBinding vb = getValueBinding("axis");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
		
	}
	/**
	 * @param axis The axis to set.
	 */
	public void setAxis(String axis) {
		this.axis = axis;
	}
	/**
	 * @return Returns the background.
	 */
	public String getBackground() {
		if(this.background != null){
			return this.background;
		}
		ValueBinding vb = getValueBinding("background");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param background The background to set.
	 */
	public void setBackground(String background) {
		this.background = background;
	}
	/**
	 * @return Returns the bgcolor.
	 */
	public String getBgcolor() {
		if(this.bgcolor != null){
			return this.bgcolor;
		}
		ValueBinding vb = getValueBinding("bgcolor");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param bgcolor The bgcolor to set.
	 */
	public void setBgcolor(String bgcolor) {
		this.bgcolor = bgcolor;
	}
	/**
	 * @return Returns the dir.
	 */
	public String getDir() {
		if(this.dir != null){
			return this.dir;
		}
		ValueBinding vb = getValueBinding("dir");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param dir The dir to set.
	 */
	public void setDir(String dir) {
		this.dir = dir;
	}
	/**
	 * @return Returns the footerClass.
	 */
	public String getFooterClass() {
		if(this.footerClass != null){
			return this.footerClass;
		}
		ValueBinding vb = getValueBinding("footerClass");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param footerClass The footerClass to set.
	 */
	public void setFooterClass(String footerClass) {
		this.footerClass = footerClass;
	}
	/**
	 * @return Returns the headerClass.
	 */
	public String getHeaderClass() {
		if(this.headerClass != null){
			return this.headerClass;
		}
		ValueBinding vb = getValueBinding("headerClass");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param headerClass The headerClass to set.
	 */
	public void setHeaderClass(String headerClass) {
		this.headerClass = headerClass;
	}
	/**
	 * @return Returns the scope.
	 */
	public String getScope() {
		if(this.scope != null){
			return this.scope;
		}
		ValueBinding vb = getValueBinding("scope");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param scope The scope to set.
	 */
	public void setScope(String scope) {
		this.scope = scope;
	}
	/**
	 * @return Returns the style.
	 */
	public String getStyle() {
		if(this.style != null){
			return this.style;
		}
		ValueBinding vb = getValueBinding("style");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param style The style to set.
	 */
	public void setStyle(String style) {
		this.style = style;
	}
	/**
	 * @return Returns the valign.
	 */
	public String getValign() {
		if(this.valign != null){
			return this.valign;
		}
		ValueBinding vb = getValueBinding("valign");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param valign The valign to set.
	 */
	public void setValign(String valign) {
		this.valign = valign;
	}
	/**
	 * @return Returns the height.
	 */
	public String getHeight() {
		if(this.height != null){
			return this.height;
		}
		ValueBinding vb = getValueBinding("height");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param height The height to set.
	 */
	public void setHeight(String height) {
		this.height = height;
	}
	/**
	 * @return Returns the nowrap.
	 */
	public String getNowrap() {
		if(this.nowrap != null){
			return this.nowrap;
		}
		ValueBinding vb = getValueBinding("nowrap");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param nowrap The nowrap to set.
	 */
	public void setNowrap(String nowrap) {
		this.nowrap = nowrap;
	}
	/**
	 * @return Returns the width.
	 */
	public String getWidth() {
		if(this.width != null){
			return this.width;
		}
		ValueBinding vb = getValueBinding("width");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param width The width to set.
	 */
	public void setWidth(String width) {
		this.width = width;
	}

	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		if(this.title != null){
			return this.title;
		}
		ValueBinding vb = getValueBinding("title");
		if(vb != null){
			return (String)vb.getValue(FacesContext.getCurrentInstance());
		}
		//no value set
		return null;
	}
	/**
	 * @param nowrap The nowrap to set.
	 */
	public void setTitle(String title) {
		this.title = title;
	}

	public Object saveState(FacesContext _context) {
		Object _values[] = new Object[15];
		_values[0] = super.saveState(_context);
		_values[1] = align;
		_values[2] = axis;
		_values[3] = background;
		_values[4] = bgcolor;
		_values[5] = dir;
		_values[6] = footerClass;
		_values[7] = headerClass;
		_values[8] = height;
		_values[9] = nowrap;
		_values[10] = scope;
		_values[11] = style;
		_values[12] = valign;
		_values[13] = width;
		_values[14] = title;
		return _values;
	}

	public void restoreState(FacesContext _context, Object _state) {
		Object _values[] = (Object[]) _state;
		super.restoreState(_context, _values[0]);
		this.align = (java.lang.String) _values[1];
		this.axis = (java.lang.String) _values[2];
		this.background = (java.lang.String) _values[3];
		this.bgcolor = (java.lang.String) _values[4];
		this.dir = (java.lang.String) _values[5];
		this.footerClass = (java.lang.String) _values[6];
		this.headerClass = (java.lang.String) _values[7];
		this.height = (java.lang.String) _values[8];
		this.nowrap = (java.lang.String) _values[9];
		this.scope = (java.lang.String) _values[10];
		this.style = (java.lang.String) _values[11];
		this.valign = (java.lang.String) _values[12];
		this.width = (java.lang.String) _values[13];
		this.title = (java.lang.String) _values[14];
	}
	
	
}
