/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/
package com.ibm.faces.component;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;


/**
 * @author ekonstantinov
 *
 */
public class UIFileProp extends UIComponentBase {
	// ------------------------------------------------------ Manifest Constants
	/**
	 * <p>The standard component type for this component.</p>
	 */
	public static final String COMPONENT_TYPE = "com.ibm.faces.FileProp"; //$NON-NLS-1$


	/**
	 * <p>The standard component family for this component.</p>
	 */
	public static final String COMPONENT_FAMILY = "com.ibm.faces.FileProp"; //$NON-NLS-1$


	// ------------------------------------------------------ Instance Variables
	private String name;
	private String value;

	// ------------------------------------------------------------ Constructors
	/**
	 * Constructor.
	 * Allocates buffers to store scripts, script contributors and libraries.
	 */
	public UIFileProp() {
		super();
		setRendererType(null); // No renderer!
	}
    
	// -------------------------------------------------------------- Properties
	public String getFamily() {
		return (COMPONENT_FAMILY);
	}
	
	public void encodeBegin(FacesContext context)
		throws IOException {
		if (context == null) {
			throw new NullPointerException();
		}
		UIComponent parent = getParent();
		if((parent==null)||(!(parent instanceof UIFileupload))){return;}				
		if ((name == null)
			//RATLC01081331 if name is null return (use || instead of &&)
			|| ((!name.equalsIgnoreCase("filename")) && (!name.equalsIgnoreCase("contenttype")))) { //$NON-NLS-1$
			return;
		}		
		ValueBinding vb = getValueBinding("value");		 //$NON-NLS-1$
		if (vb != null) {
			String pvalue=(String)vb.getValue(context);	
			if(name.equalsIgnoreCase("filename")){ //$NON-NLS-1$
				((UIFileupload)parent).setFilename(pvalue);	
			}else if(name.equalsIgnoreCase("contenttype")){ //$NON-NLS-1$
				((UIFileupload)parent).setMimetype(pvalue);
			}
		}
	}

	/**
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}

	/**
	 * @param string
	 */
	public void setValue(String string) {
		value = string;
	}
	
	//RATLC01081331
	public Object saveState(FacesContext context) {
		Object _values[] = new Object[2];
		_values[0] = super.saveState(context);
		_values[1] = name;
		return _values;
	}
	
	public void restoreState(FacesContext context, Object state) {
		Object _values[] = (Object[])state;
		super.restoreState(context, _values[0]);
		this.name = (String)_values[1];
	}
	//RATLC01081331 end
}
