/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.component;

import javax.faces.component.UIComponentBase;

/**
 * <strong>UIInputHelper</strong> is a {@link javax.faces.component.UIComponent UIComponent} that
 * works together with another {@link javax.faces.component.UIInput} component and 
 * makes it easier for the user to input a value.
 * <p>
 * There are three Helpers implemented: {@link com.ibm.faces.taglib.html_extended.InputHelper_SpinnerTag Spinner} 
 * and {@link com.ibm.faces.taglib.html_extended.InputHelper_SliderTag Slider} for a number input field and
 * {@link com.ibm.faces.taglib.html_extended.InputHelper_DatePickerTag DatePicker} for a date input field.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.taglib.html_extended.InputHelperTag},
 * {@link com.ibm.faces.taglib.html_extended.InputHelper_SpinnerTag},
 * {@link com.ibm.faces.taglib.html_extended.InputHelper_SliderTag},
 * {@link com.ibm.faces.taglib.html_extended.InputHelper_DatePickerTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.renderkit.html_extended.SpinnerRenderer},
 * {@link com.ibm.faces.renderkit.html_extended.SliderRenderer},
 * {@link com.ibm.faces.renderkit.html_extended.DatePickerRenderer}
 */
public class UIInputHelper extends UIComponentBase {

	/**
	 * Returns component type.
	 * 
	 * @return component type
	 */
	public String getComponentType() {
		return UIInputHelper.class.getName();
	}
	
	
	/**
	 * <p>The standard component family for this component.</p>
	 */
	public static final String COMPONENT_FAMILY = "com.ibm.faces.InputHelper"; //$NON-NLS-1$

	public String getFamily() {
		return (COMPONENT_FAMILY);
	}

}
