/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.component;

import javax.faces.component.UIOutput;


/**
 * <strong>UIPlayer</strong> is a {@link javax.faces.component.UIComponent UIComponent} that
 * displays a media player (such as MS Media Player, Micromedia Flash etc) to the user.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.taglib.html_extended.PlayerTag},
 * {@link com.ibm.faces.taglib.html_extended.Player_MediaPlayerTag},
 * {@link com.ibm.faces.taglib.html_extended.Player_RealPlayerTag},
 * {@link com.ibm.faces.taglib.html_extended.Player_FlashTag},
 * {@link com.ibm.faces.taglib.html_extended.Player_ShockwaveTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.renderkit.html_extended.PlayerRenderer},
 * {@link com.ibm.faces.renderkit.html_extended.MediaPlayerRenderer},
 * {@link com.ibm.faces.renderkit.html_extended.RealPlayerRenderer},
 * {@link com.ibm.faces.renderkit.html_extended.FlashRenderer},
 * {@link com.ibm.faces.renderkit.html_extended.ShockwaveRenderer}
 */

public class UIPlayer extends UIOutput {
	/**
	 * Autostart attribute name
	 */
	public static final String ATTR_AUTOSTART = "autoStart"; //$NON-NLS-1$

	/**
	 * <p>The standard component family for this component.</p>
	 */
	public static final String COMPONENT_FAMILY = "com.ibm.faces.Player"; //$NON-NLS-1$

	public String getFamily() {
		return (COMPONENT_FAMILY);
	}
}
