/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.component;

import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;

/**

 */
public class UIProgress extends UIComponentBase {

	private String dir;
	private String lang;
	private String title;
	

	/**
	 * Returns component type.
	 * 
	 * @return component type
	 */
	public String getComponentType() {
		return UIProgress.class.getName();
	}
	
	
	/**
	 * <p>The standard component family for this component.</p>
	 */
	public static final String COMPONENT_FAMILY = "com.ibm.faces.Progress"; //$NON-NLS-1$

	public String getFamily() {
		return (COMPONENT_FAMILY);
	}
	
	
	/**
	 * @return Returns the dir.
	 */
	public String getDir() {
		return dir;
	}
	/**
	 * @param dir The dir to set.
	 */
	public void setDir(String dir) {
		this.dir = dir;
	}
	/**
	 * @return Returns the lang.
	 */
	public String getLang() {
		return lang;
	}
	/**
	 * @param lang The lang to set.
	 */
	public void setLang(String lang) {
		this.lang = lang;
	}
	
	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return title;
	}
	/**
	 * @param title The title to set.
	 */
	public void setTitle(String title) {
		this.title = title;
	}	
	
	public Object saveState(FacesContext _context) {
		Object _values[] = new Object[4];
		_values[0] = super.saveState(_context);		
		_values[1] = dir;
		_values[2] = lang;
		_values[3] = title;
		return _values;
	}

	public void restoreState(FacesContext _context, Object _state) {
		Object _values[] = (Object[]) _state;
		super.restoreState(_context, _values[0]);
		this.dir = (java.lang.String) _values[1];
		this.lang = (java.lang.String) _values[2];
		this.title = (java.lang.String) _values[3];
	}
}
