/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/
package com.ibm.faces.component;

import javax.faces.context.FacesContext;

/**
 * @author ieu93297
 */
public class UISortHeader extends UIRequest{
	
	public static final String COMPONENT_TYPE = "com.ibm.faces.SortHeader"; //$NON-NLS-1$
	public static final String COMPONENT_FAMILY = "com.ibm.faces.SortHeader"; //$NON-NLS-1$
	public static final String SORT_ASC = "sortasc";
	public static final String SORT_ASCON = "sortascon";
	public static final String SORT_DESC = "sortdesc";
	public static final String SORT_DESCON = "sortdescon";
	public static final String SORT_BI = "sortbi";
	public static final String SORT_BIUP = "sortbiup";
	public static final String SORT_BIDOWN = "sortbidown";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	public static String getCurrentSortOrder() {
		String state;
		FacesContext context = FacesContext.getCurrentInstance();
		state = (String)context.getExternalContext().getRequestParameterMap().get("sort_order");
		if(state==null)
			state = (String)context.getExternalContext().getRequestParameterMap().get("sort_hidden_order");		
		return state;
	}
	
	public static String getSortHeaderId() {
		String sortId;
		FacesContext context = FacesContext.getCurrentInstance();
		sortId = (String)context.getExternalContext().getRequestParameterMap().get("sort_id");
		if(sortId == null)
			sortId = (String)context.getExternalContext().getRequestParameterMap().get("sort_hidden_id");
		return sortId;
	}	
}
