/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/
package com.ibm.faces.component.base;

import javax.faces.component.UIPanel;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * @author pandrews
 */
public class PanelRowCategory extends UIPanel{

	  public PanelRowCategory() {
	    super();
	  }

	  /*
	   * <p>The standard component type for this component.</p>
	   */
	   public static final String COMPONENT_TYPE = "com.ibm.faces.PanelRowCategory";


	  private java.lang.String collapsed;

	  /**
	   * <p>Return the value of the <code>collapsed</code> property.  Contents:</p><p>
	   * Specifies the initial collapse state of the category
	   * 				row, values can be true or false, defaults to true if
	   * 				not set.
	   * </p>
	   */
	  public java.lang.String getCollapsed() {
	    if (null != this.collapsed) {
	      return this.collapsed;
	    }
	    ValueBinding _vb = getValueBinding("collapsed");
	    if (_vb != null) {
	      return (java.lang.String) _vb.getValue(getFacesContext());
	    } 
	     return null;
	  }

	  /**
	   * <p>Set the value of the <code>collapsed</code> property.</p>
	   */
	  public void setCollapsed(java.lang.String collapsed) {
	    this.collapsed = collapsed;
	  }


	  private java.lang.String collapsedImage;

	  /**
	   * <p>Return the value of the <code>collapsedImage</code> property.  Contents:</p><p>
	   * Specifies a custom image to be displayed when a category
	   * 				is collapsed
	   * </p>
	   */
	  public java.lang.String getCollapsedImage() {
	    if (null != this.collapsedImage) {
	      return this.collapsedImage;
	    }
	    ValueBinding _vb = getValueBinding("collapsedImage");
	    if (_vb != null) {
	      return (java.lang.String) _vb.getValue(getFacesContext());
	    } 
	    return null;
	  }

	  /**
	   * <p>Set the value of the <code>collapsedImage</code> property.</p>
	   */
	  public void setCollapsedImage(java.lang.String collapsedImage) {
	    this.collapsedImage = collapsedImage;
	  }


	  private java.lang.String expandedImage;

	  /**
	   * <p>Return the value of the <code>expandedImage</code> property.  Contents:</p><p>
	   * Specifies a custom image to be displayed when a category
	   * 				is expanded
	   * </p>
	   */
	  public java.lang.String getExpandedImage() {
	    if (null != this.expandedImage) {
	      return this.expandedImage;
	    }
	    ValueBinding _vb = getValueBinding("expandedImage");
	    if (_vb != null) {
	      return (java.lang.String) _vb.getValue(getFacesContext());
	    } 
	     return null;
	  }

	  /**
	   * <p>Set the value of the <code>expandedImage</code> property.</p>
	   */
	  public void setExpandedImage(java.lang.String expandedImage) {
	    this.expandedImage = expandedImage;
	  }


	  private java.lang.Object value;

	  /**
	   * <p>Return the value of the <code>value</code> property.  Contents:</p><p>
	   * Specifies the dataTable column to be categorized, this
	   * 				should be a sorted column. This can be overidden by
	   * 				placing child UIOutput component with the sorted column
	   * 				set as its value. The outputFormat component can be used
	   * 				a child component to customize the category title or
	   * 				sort on more than one column.
	   * </p>
	   */
	  public java.lang.Object getValue() {
	    if (null != this.value) {
	      return this.value;
	    }
	    ValueBinding _vb = getValueBinding("value");
	    if (_vb != null) {
	      return _vb.getValue(getFacesContext());
	    } 
	    return null;
	  }

	  /**
	   * <p>Set the value of the <code>value</code> property.</p>
	   */
	  public void setValue(java.lang.Object value) {
	    this.value = value;
	  }


	  public Object saveState(FacesContext _context) {
	    Object _values[] = new Object[10];
	    _values[0] = super.saveState(_context);
	    _values[1] = collapsed;
	    _values[2] = collapsedImage;
	    _values[3] = expandedImage;
	    _values[4] = value;
	    return _values;
	  }


	  public void restoreState(FacesContext _context, Object _state) {
	    Object _values[] = (Object[]) _state;
	    super.restoreState(_context, _values[0]);
	    this.collapsed = (java.lang.String) _values[1];
	    this.collapsedImage = (java.lang.String) _values[2];
	    this.expandedImage = (java.lang.String) _values[3];
	    this.value = _values[4];
	  }

}
