/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.RefreshRequest</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlAjaxRefreshRequest extends com.ibm.faces.component.UIAjax {


  public HtmlAjaxRefreshRequest() {
    super();
    setRendererType("com.ibm.faces.RefreshRequest"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlAjaxRefreshRequest"; //$NON-NLS-1$


  private java.lang.String params;

  /**
   * <p>Return the value of the <code>params</code> property.  Contents:</p><p>
   * semicolon separated list of component ids. The value of 
   * 				these components will be retrieved and appended as params 
   * 				to the URL used to get the new content. The name of the 
   * 				param will be the id of the component (not the clientId)..
   * </p>
   */
  public java.lang.String getParams() {
    if (null != this.params) {
      return this.params;
    }
    ValueBinding _vb = getValueBinding("params"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>params</code> property.</p>
   */
  public void setParams(java.lang.String params) {
    this.params = params;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[2];
    _values[0] = super.saveState(_context);
    _values[1] = params;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.params = (java.lang.String) _values[1];
  }


}
