/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.RowEdit</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlCommandExRowEdit extends com.ibm.faces.component.UICommandEx {


  public HtmlCommandExRowEdit() {
    super();
    setRendererType("com.ibm.faces.RowEdit"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlCommandExRowEdit"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String cancelLabel;

  /**
   * <p>Return the value of the <code>cancelLabel</code> property.  Contents:</p><p>
   * Custom label for cancel button.
   * </p>
   */
  public java.lang.String getCancelLabel() {
    if (null != this.cancelLabel) {
      return this.cancelLabel;
    }
    ValueBinding _vb = getValueBinding("cancelLabel"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>cancelLabel</code> property.</p>
   */
  public void setCancelLabel(java.lang.String cancelLabel) {
    this.cancelLabel = cancelLabel;
  }


  private java.lang.String editLabel;

  /**
   * <p>Return the value of the <code>editLabel</code> property.  Contents:</p><p>
   * Custom label for edit button.
   * </p>
   */
  public java.lang.String getEditLabel() {
    if (null != this.editLabel) {
      return this.editLabel;
    }
    ValueBinding _vb = getValueBinding("editLabel"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>editLabel</code> property.</p>
   */
  public void setEditLabel(java.lang.String editLabel) {
    this.editLabel = editLabel;
  }


  private java.lang.String editStyle;

  /**
   * <p>Return the value of the <code>editStyle</code> property.  Contents:</p><p>
   * CSS style applied to edit pane.
   * </p>
   */
  public java.lang.String getEditStyle() {
    if (null != this.editStyle) {
      return this.editStyle;
    }
    ValueBinding _vb = getValueBinding("editStyle"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>editStyle</code> property.</p>
   */
  public void setEditStyle(java.lang.String editStyle) {
    this.editStyle = editStyle;
  }


  private java.lang.String editStyleClass;

  /**
   * <p>Return the value of the <code>editStyleClass</code> property.  Contents:</p><p>
   * CSS style class applied to edit pane and controls.
   * </p>
   */
  public java.lang.String getEditStyleClass() {
    if (null != this.editStyleClass) {
      return this.editStyleClass;
    }
    ValueBinding _vb = getValueBinding("editStyleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>editStyleClass</code> property.</p>
   */
  public void setEditStyleClass(java.lang.String editStyleClass) {
    this.editStyleClass = editStyleClass;
  }


  private java.lang.String saveLabel;

  /**
   * <p>Return the value of the <code>saveLabel</code> property.  Contents:</p><p>
   * Custom label for save button.
   * </p>
   */
  public java.lang.String getSaveLabel() {
    if (null != this.saveLabel) {
      return this.saveLabel;
    }
    ValueBinding _vb = getValueBinding("saveLabel"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>saveLabel</code> property.</p>
   */
  public void setSaveLabel(java.lang.String saveLabel) {
    this.saveLabel = saveLabel;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[10];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = cancelLabel;
    _values[3] = editLabel;
    _values[4] = editStyle;
    _values[5] = editStyleClass;
    _values[6] = saveLabel;
    _values[7] = style;
    _values[8] = styleClass;
    _values[9] = title;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.cancelLabel = (java.lang.String) _values[2];
    this.editLabel = (java.lang.String) _values[3];
    this.editStyle = (java.lang.String) _values[4];
    this.editStyleClass = (java.lang.String) _values[5];
    this.saveLabel = (java.lang.String) _values[6];
    this.style = (java.lang.String) _values[7];
    this.styleClass = (java.lang.String) _values[8];
    this.title = (java.lang.String) _values[9];
  }


}
