/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Fileupload</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlFileupload extends com.ibm.faces.component.UIFileupload {


  public HtmlFileupload() {
    super();
    setRendererType("com.ibm.faces.Fileupload"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlFileupload"; //$NON-NLS-1$


  private java.lang.String accept;

  /**
   * <p>Return the value of the <code>accept</code> property.   * </p>
   */
  public java.lang.String getAccept() {
    if (null != this.accept) {
      return this.accept;
    }
    ValueBinding _vb = getValueBinding("accept"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>accept</code> property.</p>
   */
  public void setAccept(java.lang.String accept) {
    this.accept = accept;
  }


  private java.lang.String accesskey;

  /**
   * <p>Return the value of the <code>accesskey</code> property.  Contents:</p><p>
   * Access key to put focus on this compoent.
   * </p>
   */
  public java.lang.String getAccesskey() {
    if (null != this.accesskey) {
      return this.accesskey;
    }
    ValueBinding _vb = getValueBinding("accesskey"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>accesskey</code> property.</p>
   */
  public void setAccesskey(java.lang.String accesskey) {
    this.accesskey = accesskey;
  }


  private java.lang.String alt;

  /**
   * <p>Return the value of the <code>alt</code> property.   * </p>
   */
  public java.lang.String getAlt() {
    if (null != this.alt) {
      return this.alt;
    }
    ValueBinding _vb = getValueBinding("alt"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>alt</code> property.</p>
   */
  public void setAlt(java.lang.String alt) {
    this.alt = alt;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.  Contents:</p><p>
   * Text direction.
   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private boolean disabled = false;
  private boolean disabled_set = false;

  /**
   * <p>Return the value of the <code>disabled</code> property.  Contents:</p><p>
   * Boolean value to set the component to be rendered as
   * 				disabled.
   * </p>
   */
  public boolean isDisabled() {
    if (this.disabled_set) {
      return this.disabled;
    }
    ValueBinding _vb = getValueBinding("disabled"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.disabled;
    }
  }

  /**
   * <p>Set the value of the <code>disabled</code> property.</p>
   */
  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
    this.disabled_set = true;
  }


  private java.lang.String exclude;

  /**
   * <p>Return the value of the <code>exclude</code> property.   * </p>
   */
  public java.lang.String getExclude() {
    if (null != this.exclude) {
      return this.exclude;
    }
    ValueBinding _vb = getValueBinding("exclude"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>exclude</code> property.</p>
   */
  public void setExclude(java.lang.String exclude) {
    this.exclude = exclude;
  }


  private boolean immediate = false;
  private boolean immediate_set = false;

  /**
   * <p>Return the value of the <code>immediate</code> property.  Contents:</p><p>
   * Boolean value to set this component to be converted and
   * 				validated at Apply Request Values phase instead of
   * 				waiting until Process Validations phase.
   * </p>
   */
  public boolean isImmediate() {
    if (this.immediate_set) {
      return this.immediate;
    }
    ValueBinding _vb = getValueBinding("immediate"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.immediate;
    }
  }

  /**
   * <p>Set the value of the <code>immediate</code> property.</p>
   */
  public void setImmediate(boolean immediate) {
    this.immediate = immediate;
    this.immediate_set = true;
  }


  private boolean localValueSet = false;
  private boolean localValueSet_set = false;

  /**
   * <p>Return the value of the <code>localValueSet</code> property.  Contents:</p><p>
   * Boolean value indicating whether or not the localValue
   * 				property has been set, this is reset when the value
   * 				property is set
   * </p>
   */
  public boolean isLocalValueSet() {
    if (this.localValueSet_set) {
      return this.localValueSet;
    }
    ValueBinding _vb = getValueBinding("localValueSet"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.localValueSet;
    }
  }

  /**
   * <p>Set the value of the <code>localValueSet</code> property.</p>
   */
  public void setLocalValueSet(boolean localValueSet) {
    this.localValueSet = localValueSet;
    this.localValueSet_set = true;
  }


  private java.lang.String maxlength;

  /**
   * <p>Return the value of the <code>maxlength</code> property.   * </p>
   */
  public java.lang.String getMaxlength() {
    if (null != this.maxlength) {
      return this.maxlength;
    }
    ValueBinding _vb = getValueBinding("maxlength"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>maxlength</code> property.</p>
   */
  public void setMaxlength(java.lang.String maxlength) {
    this.maxlength = maxlength;
  }


  private java.lang.String onblur;

  /**
   * <p>Return the value of the <code>onblur</code> property.  Contents:</p><p>
   * onblur javascript event
   * </p>
   */
  public java.lang.String getOnblur() {
    if (null != this.onblur) {
      return this.onblur;
    }
    ValueBinding _vb = getValueBinding("onblur"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onblur</code> property.</p>
   */
  public void setOnblur(java.lang.String onblur) {
    this.onblur = onblur;
  }


  private java.lang.String onchange;

  /**
   * <p>Return the value of the <code>onchange</code> property.  Contents:</p><p>
   * onchange javascript event
   * </p>
   */
  public java.lang.String getOnchange() {
    if (null != this.onchange) {
      return this.onchange;
    }
    ValueBinding _vb = getValueBinding("onchange"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onchange</code> property.</p>
   */
  public void setOnchange(java.lang.String onchange) {
    this.onchange = onchange;
  }


  private java.lang.String onclick;

  /**
   * <p>Return the value of the <code>onclick</code> property.  Contents:</p><p>
   * Javascript onclick event
   * </p>
   */
  public java.lang.String getOnclick() {
    if (null != this.onclick) {
      return this.onclick;
    }
    ValueBinding _vb = getValueBinding("onclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onclick</code> property.</p>
   */
  public void setOnclick(java.lang.String onclick) {
    this.onclick = onclick;
  }


  private java.lang.String ondblclick;

  /**
   * <p>Return the value of the <code>ondblclick</code> property.  Contents:</p><p>
   * Javascript double click event
   * </p>
   */
  public java.lang.String getOndblclick() {
    if (null != this.ondblclick) {
      return this.ondblclick;
    }
    ValueBinding _vb = getValueBinding("ondblclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>ondblclick</code> property.</p>
   */
  public void setOndblclick(java.lang.String ondblclick) {
    this.ondblclick = ondblclick;
  }


  private java.lang.String onfocus;

  /**
   * <p>Return the value of the <code>onfocus</code> property.  Contents:</p><p>
   * onfocus javascript event
   * </p>
   */
  public java.lang.String getOnfocus() {
    if (null != this.onfocus) {
      return this.onfocus;
    }
    ValueBinding _vb = getValueBinding("onfocus"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocus</code> property.</p>
   */
  public void setOnfocus(java.lang.String onfocus) {
    this.onfocus = onfocus;
  }


  private java.lang.String onkeydown;

  /**
   * <p>Return the value of the <code>onkeydown</code> property.  Contents:</p><p>
   * Javascript key down event
   * </p>
   */
  public java.lang.String getOnkeydown() {
    if (null != this.onkeydown) {
      return this.onkeydown;
    }
    ValueBinding _vb = getValueBinding("onkeydown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeydown</code> property.</p>
   */
  public void setOnkeydown(java.lang.String onkeydown) {
    this.onkeydown = onkeydown;
  }


  private java.lang.String onkeypress;

  /**
   * <p>Return the value of the <code>onkeypress</code> property.  Contents:</p><p>
   * Javascript key press event
   * </p>
   */
  public java.lang.String getOnkeypress() {
    if (null != this.onkeypress) {
      return this.onkeypress;
    }
    ValueBinding _vb = getValueBinding("onkeypress"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeypress</code> property.</p>
   */
  public void setOnkeypress(java.lang.String onkeypress) {
    this.onkeypress = onkeypress;
  }


  private java.lang.String onkeyup;

  /**
   * <p>Return the value of the <code>onkeyup</code> property.  Contents:</p><p>
   * Javascript key up event
   * </p>
   */
  public java.lang.String getOnkeyup() {
    if (null != this.onkeyup) {
      return this.onkeyup;
    }
    ValueBinding _vb = getValueBinding("onkeyup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeyup</code> property.</p>
   */
  public void setOnkeyup(java.lang.String onkeyup) {
    this.onkeyup = onkeyup;
  }


  private java.lang.String onmousedown;

  /**
   * <p>Return the value of the <code>onmousedown</code> property.  Contents:</p><p>
   * Javascript mouse button press event
   * </p>
   */
  public java.lang.String getOnmousedown() {
    if (null != this.onmousedown) {
      return this.onmousedown;
    }
    ValueBinding _vb = getValueBinding("onmousedown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousedown</code> property.</p>
   */
  public void setOnmousedown(java.lang.String onmousedown) {
    this.onmousedown = onmousedown;
  }


  private java.lang.String onmousemove;

  /**
   * <p>Return the value of the <code>onmousemove</code> property.  Contents:</p><p>
   * Javascript mouse move event
   * </p>
   */
  public java.lang.String getOnmousemove() {
    if (null != this.onmousemove) {
      return this.onmousemove;
    }
    ValueBinding _vb = getValueBinding("onmousemove"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousemove</code> property.</p>
   */
  public void setOnmousemove(java.lang.String onmousemove) {
    this.onmousemove = onmousemove;
  }


  private java.lang.String onmouseout;

  /**
   * <p>Return the value of the <code>onmouseout</code> property.  Contents:</p><p>
   * Javascript mouse out event
   * </p>
   */
  public java.lang.String getOnmouseout() {
    if (null != this.onmouseout) {
      return this.onmouseout;
    }
    ValueBinding _vb = getValueBinding("onmouseout"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseout</code> property.</p>
   */
  public void setOnmouseout(java.lang.String onmouseout) {
    this.onmouseout = onmouseout;
  }


  private java.lang.String onmouseover;

  /**
   * <p>Return the value of the <code>onmouseover</code> property.  Contents:</p><p>
   * Javascript mouse over event
   * </p>
   */
  public java.lang.String getOnmouseover() {
    if (null != this.onmouseover) {
      return this.onmouseover;
    }
    ValueBinding _vb = getValueBinding("onmouseover"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseover</code> property.</p>
   */
  public void setOnmouseover(java.lang.String onmouseover) {
    this.onmouseover = onmouseover;
  }


  private java.lang.String onmouseup;

  /**
   * <p>Return the value of the <code>onmouseup</code> property.  Contents:</p><p>
   * Javascript mouse button release event
   * </p>
   */
  public java.lang.String getOnmouseup() {
    if (null != this.onmouseup) {
      return this.onmouseup;
    }
    ValueBinding _vb = getValueBinding("onmouseup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseup</code> property.</p>
   */
  public void setOnmouseup(java.lang.String onmouseup) {
    this.onmouseup = onmouseup;
  }


  private java.lang.String onselect;

  /**
   * <p>Return the value of the <code>onselect</code> property.  Contents:</p><p>
   * onselect javascript event
   * </p>
   */
  public java.lang.String getOnselect() {
    if (null != this.onselect) {
      return this.onselect;
    }
    ValueBinding _vb = getValueBinding("onselect"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onselect</code> property.</p>
   */
  public void setOnselect(java.lang.String onselect) {
    this.onselect = onselect;
  }


  private boolean readonly = false;
  private boolean readonly_set = false;

  /**
   * <p>Return the value of the <code>readonly</code> property.  Contents:</p><p>
   * Boolean value to set the component to be rendered as
   * 				read only.
   * </p>
   */
  public boolean isReadonly() {
    if (this.readonly_set) {
      return this.readonly;
    }
    ValueBinding _vb = getValueBinding("readonly"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.readonly;
    }
  }

  /**
   * <p>Set the value of the <code>readonly</code> property.</p>
   */
  public void setReadonly(boolean readonly) {
    this.readonly = readonly;
    this.readonly_set = true;
  }


  private java.lang.String size;

  /**
   * <p>Return the value of the <code>size</code> property.   * </p>
   */
  public java.lang.String getSize() {
    if (null != this.size) {
      return this.size;
    }
    ValueBinding _vb = getValueBinding("size"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>size</code> property.</p>
   */
  public void setSize(java.lang.String size) {
    this.size = size;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.Object submittedValue;

  /**
   * <p>Return the value of the <code>submittedValue</code> property.  Contents:</p><p>
   * Value entered by user before conversion or validation.
   * </p>
   */
  public java.lang.Object getSubmittedValue() {
    if (null != this.submittedValue) {
      return this.submittedValue;
    }
    ValueBinding _vb = getValueBinding("submittedValue"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.Object) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>submittedValue</code> property.</p>
   */
  public void setSubmittedValue(java.lang.Object submittedValue) {
    this.submittedValue = submittedValue;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.  Contents:</p><p>
   * Tabbing order for this component.
   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private javax.faces.el.MethodBinding validator;

  /**
   * <p>Return the value of the <code>validator</code> property.  Contents:</p><p>
   * MethodBinding to a validator method for the component,
   * 				method must public taking FacesContext, UIComponent and
   * 				Object parameter returning void.
   * </p>
   */
  public javax.faces.el.MethodBinding getValidator() {
    if (null != this.validator) {
      return this.validator;
    }
    ValueBinding _vb = getValueBinding("validator"); //$NON-NLS-1$
    if (_vb != null) {
      return (javax.faces.el.MethodBinding) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>validator</code> property.</p>
   */
  public void setValidator(javax.faces.el.MethodBinding validator) {
    this.validator = validator;
  }


  private javax.faces.el.MethodBinding valueChangeListener;

  /**
   * <p>Return the value of the <code>valueChangeListener</code> property.  Contents:</p><p>
   * MethodBinding to a value change listener method, the
   * 				method must be public taking a ValueChangeEvent
   * 				parameter and return void.
   * </p>
   */
  public javax.faces.el.MethodBinding getValueChangeListener() {
    if (null != this.valueChangeListener) {
      return this.valueChangeListener;
    }
    ValueBinding _vb = getValueBinding("valueChangeListener"); //$NON-NLS-1$
    if (_vb != null) {
      return (javax.faces.el.MethodBinding) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>valueChangeListener</code> property.</p>
   */
  public void setValueChangeListener(javax.faces.el.MethodBinding valueChangeListener) {
    this.valueChangeListener = valueChangeListener;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[38];
    _values[0] = super.saveState(_context);
    _values[1] = accept;
    _values[2] = accesskey;
    _values[3] = alt;
    _values[4] = binding;
    _values[5] = dir;
    _values[6] = this.disabled ? Boolean.TRUE : Boolean.FALSE;
    _values[7] = this.disabled_set ? Boolean.TRUE : Boolean.FALSE;
    _values[8] = exclude;
    _values[9] = this.immediate ? Boolean.TRUE : Boolean.FALSE;
    _values[10] = this.immediate_set ? Boolean.TRUE : Boolean.FALSE;
    _values[11] = this.localValueSet ? Boolean.TRUE : Boolean.FALSE;
    _values[12] = this.localValueSet_set ? Boolean.TRUE : Boolean.FALSE;
    _values[13] = maxlength;
    _values[14] = onblur;
    _values[15] = onchange;
    _values[16] = onclick;
    _values[17] = ondblclick;
    _values[18] = onfocus;
    _values[19] = onkeydown;
    _values[20] = onkeypress;
    _values[21] = onkeyup;
    _values[22] = onmousedown;
    _values[23] = onmousemove;
    _values[24] = onmouseout;
    _values[25] = onmouseover;
    _values[26] = onmouseup;
    _values[27] = onselect;
    _values[28] = this.readonly ? Boolean.TRUE : Boolean.FALSE;
    _values[29] = this.readonly_set ? Boolean.TRUE : Boolean.FALSE;
    _values[30] = size;
    _values[31] = style;
    _values[32] = styleClass;
    _values[33] = submittedValue;
    _values[34] = tabindex;
    _values[35] = title;
    _values[36] = validator;
    _values[37] = valueChangeListener;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.accept = (java.lang.String) _values[1];
    this.accesskey = (java.lang.String) _values[2];
    this.alt = (java.lang.String) _values[3];
    this.binding = (java.lang.String) _values[4];
    this.dir = (java.lang.String) _values[5];
    this.disabled = ((Boolean) _values[6]).booleanValue();
    this.disabled_set = ((Boolean) _values[7]).booleanValue();
    this.exclude = (java.lang.String) _values[8];
    this.immediate = ((Boolean) _values[9]).booleanValue();
    this.immediate_set = ((Boolean) _values[10]).booleanValue();
    this.localValueSet = ((Boolean) _values[11]).booleanValue();
    this.localValueSet_set = ((Boolean) _values[12]).booleanValue();
    this.maxlength = (java.lang.String) _values[13];
    this.onblur = (java.lang.String) _values[14];
    this.onchange = (java.lang.String) _values[15];
    this.onclick = (java.lang.String) _values[16];
    this.ondblclick = (java.lang.String) _values[17];
    this.onfocus = (java.lang.String) _values[18];
    this.onkeydown = (java.lang.String) _values[19];
    this.onkeypress = (java.lang.String) _values[20];
    this.onkeyup = (java.lang.String) _values[21];
    this.onmousedown = (java.lang.String) _values[22];
    this.onmousemove = (java.lang.String) _values[23];
    this.onmouseout = (java.lang.String) _values[24];
    this.onmouseover = (java.lang.String) _values[25];
    this.onmouseup = (java.lang.String) _values[26];
    this.onselect = (java.lang.String) _values[27];
    this.readonly = ((Boolean) _values[28]).booleanValue();
    this.readonly_set = ((Boolean) _values[29]).booleanValue();
    this.size = (java.lang.String) _values[30];
    this.style = (java.lang.String) _values[31];
    this.styleClass = (java.lang.String) _values[32];
    this.submittedValue = (java.lang.Object) _values[33];
    this.tabindex = (java.lang.String) _values[34];
    this.title = (java.lang.String) _values[35];
    this.validator = (javax.faces.el.MethodBinding) _values[36];
    this.valueChangeListener = (javax.faces.el.MethodBinding) _values[37];
  }


}
