/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.FormMessagesArea</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlFormMessagesArea extends com.ibm.faces.component.UIFormMessagesArea {


  public HtmlFormMessagesArea() {
    super();
    setRendererType("com.ibm.faces.FormMessagesArea"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlFormMessagesArea"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String errorText;

  /**
   * <p>Return the value of the <code>errorText</code> property.  Contents:</p><p>
   * This text string provides a general error message to alert 
   * 				the end user that there is a problem with the formBox.
   * </p>
   */
  public java.lang.String getErrorText() {
    if (null != this.errorText) {
      return this.errorText;
    }
    ValueBinding _vb = getValueBinding("errorText"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>errorText</code> property.</p>
   */
  public void setErrorText(java.lang.String errorText) {
    this.errorText = errorText;
  }


  private boolean escape = false;
  private boolean escape_set = false;

  /**
   * <p>Return the value of the <code>escape</code> property.  Contents:</p><p>
   * Boolean value indicating whether or not infoText and errorText are to
   * 				be escaped.
   * </p>
   */
  public boolean isEscape() {
    if (this.escape_set) {
      return this.escape;
    }
    ValueBinding _vb = getValueBinding("escape"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.escape;
    }
  }

  /**
   * <p>Set the value of the <code>escape</code> property.</p>
   */
  public void setEscape(boolean escape) {
    this.escape = escape;
    this.escape_set = true;
  }


  private java.lang.String infoText;

  /**
   * <p>Return the value of the <code>infoText</code> property.  Contents:</p><p>
   * This text string provides general information to describe 
   * 				the purpose of the formBox.
   * </p>
   */
  public java.lang.String getInfoText() {
    if (null != this.infoText) {
      return this.infoText;
    }
    ValueBinding _vb = getValueBinding("infoText"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>infoText</code> property.</p>
   */
  public void setInfoText(java.lang.String infoText) {
    this.infoText = infoText;
  }


  private java.lang.String showErrors;

  /**
   * <p>Return the value of the <code>showErrors</code> property.  Contents:</p><p>
   * Determines the format for displaying the errorText of all formItems 
   * 				with errors. This table or list of error messages will be shown in 
   * 				addition to any that are displayed by the showHelp attribute on 
   * 				individual formItems. The values of table and list are identical to 
   * 				those values on the h:messages tag.
   * </p>
   */
  public java.lang.String getShowErrors() {
    if (null != this.showErrors) {
      return this.showErrors;
    }
    ValueBinding _vb = getValueBinding("showErrors"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>showErrors</code> property.</p>
   */
  public void setShowErrors(java.lang.String showErrors) {
    this.showErrors = showErrors;
  }


  private java.lang.String showHelp;

  /**
   * <p>Return the value of the <code>showHelp</code> property.  Contents:</p><p>
   * Determines whether this formMessage's infoText, or errorText, 
   * 				or both, will be displayed (the text will be displayed whenever 
   * 				the formMessages tag is positioned - the helpPosition attribute 
   * 				on formBox should only apply to the messages from the formItems 
   * 				themselves). This message will be shown in addition to the 
   * 				collection of error messages displayed by the formMessages tag.
   * </p>
   */
  public java.lang.String getShowHelp() {
    if (null != this.showHelp) {
      return this.showHelp;
    }
    ValueBinding _vb = getValueBinding("showHelp"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>showHelp</code> property.</p>
   */
  public void setShowHelp(java.lang.String showHelp) {
    this.showHelp = showHelp;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style(s) to be applied when this component is
   * 				rendered.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * Space-separated list of CSS style class(es) to be
   * 				applied when this element is rendered. This value must
   * 				be passed through as the "class" property on generated
   * 				markup.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[11];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = errorText;
    _values[3] = this.escape ? Boolean.TRUE : Boolean.FALSE;
    _values[4] = this.escape_set ? Boolean.TRUE : Boolean.FALSE;
    _values[5] = infoText;
    _values[6] = showErrors;
    _values[7] = showHelp;
    _values[8] = style;
    _values[9] = styleClass;
    _values[10] = title;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.errorText = (java.lang.String) _values[2];
    this.escape = ((Boolean) _values[3]).booleanValue();
    this.escape_set = ((Boolean) _values[4]).booleanValue();
    this.infoText = (java.lang.String) _values[5];
    this.showErrors = (java.lang.String) _values[6];
    this.showHelp = (java.lang.String) _values[7];
    this.style = (java.lang.String) _values[8];
    this.styleClass = (java.lang.String) _values[9];
    this.title = (java.lang.String) _values[10];
  }


}
