/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Assist</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperAssist extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperAssist() {
    super();
    setRendererType("com.ibm.faces.Assist"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperAssist"; //$NON-NLS-1$


  private java.lang.String autoSubmit;

  /**
   * <p>Return the value of the <code>autoSubmit</code> property.  Contents:</p><p>
   * If set to true and the maximum number of characters are entered, the 
   * 			form contining the field is submitted. This feature is deprecated 
   * 			(it is not Section 508 compliant). It is available for special cases 
   * 			where "antique" UI paradigms are being used in the page.
   * </p>
   */
  public java.lang.String getAutoSubmit() {
    if (null != this.autoSubmit) {
      return this.autoSubmit;
    }
    ValueBinding _vb = getValueBinding("autoSubmit"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>autoSubmit</code> property.</p>
   */
  public void setAutoSubmit(java.lang.String autoSubmit) {
    this.autoSubmit = autoSubmit;
  }


  private java.lang.String autoTab;

  /**
   * <p>Return the value of the <code>autoTab</code> property.   * </p>
   */
  public java.lang.String getAutoTab() {
    if (null != this.autoTab) {
      return this.autoTab;
    }
    ValueBinding _vb = getValueBinding("autoTab"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>autoTab</code> property.</p>
   */
  public void setAutoTab(java.lang.String autoTab) {
    this.autoTab = autoTab;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String errorAction;

  /**
   * <p>Return the value of the <code>errorAction</code> property.   * </p>
   */
  public java.lang.String getErrorAction() {
    if (null != this.errorAction) {
      return this.errorAction;
    }
    ValueBinding _vb = getValueBinding("errorAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>errorAction</code> property.</p>
   */
  public void setErrorAction(java.lang.String errorAction) {
    this.errorAction = errorAction;
  }


  private java.lang.String errorClass;

  /**
   * <p>Return the value of the <code>errorClass</code> property.   * </p>
   */
  public java.lang.String getErrorClass() {
    if (null != this.errorClass) {
      return this.errorClass;
    }
    ValueBinding _vb = getValueBinding("errorClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>errorClass</code> property.</p>
   */
  public void setErrorClass(java.lang.String errorClass) {
    this.errorClass = errorClass;
  }


  private java.lang.String imeMode;

  /**
   * <p>Return the value of the <code>imeMode</code> property.   * </p>
   */
  public java.lang.String getImeMode() {
    if (null != this.imeMode) {
      return this.imeMode;
    }
    ValueBinding _vb = getValueBinding("imeMode"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>imeMode</code> property.</p>
   */
  public void setImeMode(java.lang.String imeMode) {
    this.imeMode = imeMode;
  }


  private java.lang.String inputAssist;

  /**
   * <p>Return the value of the <code>inputAssist</code> property.   * </p>
   */
  public java.lang.String getInputAssist() {
    if (null != this.inputAssist) {
      return this.inputAssist;
    }
    ValueBinding _vb = getValueBinding("inputAssist"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>inputAssist</code> property.</p>
   */
  public void setInputAssist(java.lang.String inputAssist) {
    this.inputAssist = inputAssist;
  }


  private java.lang.String onerror;

  /**
   * <p>Return the value of the <code>onerror</code> property.   * </p>
   */
  public java.lang.String getOnerror() {
    if (null != this.onerror) {
      return this.onerror;
    }
    ValueBinding _vb = getValueBinding("onerror"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onerror</code> property.</p>
   */
  public void setOnerror(java.lang.String onerror) {
    this.onerror = onerror;
  }


  private java.lang.String onfocusErrorAction;

  /**
   * <p>Return the value of the <code>onfocusErrorAction</code> property.   * </p>
   */
  public java.lang.String getOnfocusErrorAction() {
    if (null != this.onfocusErrorAction) {
      return this.onfocusErrorAction;
    }
    ValueBinding _vb = getValueBinding("onfocusErrorAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocusErrorAction</code> property.</p>
   */
  public void setOnfocusErrorAction(java.lang.String onfocusErrorAction) {
    this.onfocusErrorAction = onfocusErrorAction;
  }


  private java.lang.String onfocusErrorClass;

  /**
   * <p>Return the value of the <code>onfocusErrorClass</code> property.   * </p>
   */
  public java.lang.String getOnfocusErrorClass() {
    if (null != this.onfocusErrorClass) {
      return this.onfocusErrorClass;
    }
    ValueBinding _vb = getValueBinding("onfocusErrorClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocusErrorClass</code> property.</p>
   */
  public void setOnfocusErrorClass(java.lang.String onfocusErrorClass) {
    this.onfocusErrorClass = onfocusErrorClass;
  }


  private java.lang.String onfocusSuccessAction;

  /**
   * <p>Return the value of the <code>onfocusSuccessAction</code> property.   * </p>
   */
  public java.lang.String getOnfocusSuccessAction() {
    if (null != this.onfocusSuccessAction) {
      return this.onfocusSuccessAction;
    }
    ValueBinding _vb = getValueBinding("onfocusSuccessAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocusSuccessAction</code> property.</p>
   */
  public void setOnfocusSuccessAction(java.lang.String onfocusSuccessAction) {
    this.onfocusSuccessAction = onfocusSuccessAction;
  }


  private java.lang.String onfocusSuccessClass;

  /**
   * <p>Return the value of the <code>onfocusSuccessClass</code> property.   * </p>
   */
  public java.lang.String getOnfocusSuccessClass() {
    if (null != this.onfocusSuccessClass) {
      return this.onfocusSuccessClass;
    }
    ValueBinding _vb = getValueBinding("onfocusSuccessClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocusSuccessClass</code> property.</p>
   */
  public void setOnfocusSuccessClass(java.lang.String onfocusSuccessClass) {
    this.onfocusSuccessClass = onfocusSuccessClass;
  }


  private java.lang.String onfocuserror;

  /**
   * <p>Return the value of the <code>onfocuserror</code> property.   * </p>
   */
  public java.lang.String getOnfocuserror() {
    if (null != this.onfocuserror) {
      return this.onfocuserror;
    }
    ValueBinding _vb = getValueBinding("onfocuserror"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocuserror</code> property.</p>
   */
  public void setOnfocuserror(java.lang.String onfocuserror) {
    this.onfocuserror = onfocuserror;
  }


  private java.lang.String onfocussuccess;

  /**
   * <p>Return the value of the <code>onfocussuccess</code> property.   * </p>
   */
  public java.lang.String getOnfocussuccess() {
    if (null != this.onfocussuccess) {
      return this.onfocussuccess;
    }
    ValueBinding _vb = getValueBinding("onfocussuccess"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocussuccess</code> property.</p>
   */
  public void setOnfocussuccess(java.lang.String onfocussuccess) {
    this.onfocussuccess = onfocussuccess;
  }


  private java.lang.String onsuccess;

  /**
   * <p>Return the value of the <code>onsuccess</code> property.   * </p>
   */
  public java.lang.String getOnsuccess() {
    if (null != this.onsuccess) {
      return this.onsuccess;
    }
    ValueBinding _vb = getValueBinding("onsuccess"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onsuccess</code> property.</p>
   */
  public void setOnsuccess(java.lang.String onsuccess) {
    this.onsuccess = onsuccess;
  }


  private java.lang.String promptCharacter;

  /**
   * <p>Return the value of the <code>promptCharacter</code> property.   * </p>
   */
  public java.lang.String getPromptCharacter() {
    if (null != this.promptCharacter) {
      return this.promptCharacter;
    }
    ValueBinding _vb = getValueBinding("promptCharacter"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>promptCharacter</code> property.</p>
   */
  public void setPromptCharacter(java.lang.String promptCharacter) {
    this.promptCharacter = promptCharacter;
  }


  private java.lang.String successAction;

  /**
   * <p>Return the value of the <code>successAction</code> property.   * </p>
   */
  public java.lang.String getSuccessAction() {
    if (null != this.successAction) {
      return this.successAction;
    }
    ValueBinding _vb = getValueBinding("successAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>successAction</code> property.</p>
   */
  public void setSuccessAction(java.lang.String successAction) {
    this.successAction = successAction;
  }


  private java.lang.String successClass;

  /**
   * <p>Return the value of the <code>successClass</code> property.   * </p>
   */
  public java.lang.String getSuccessClass() {
    if (null != this.successClass) {
      return this.successClass;
    }
    ValueBinding _vb = getValueBinding("successClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>successClass</code> property.</p>
   */
  public void setSuccessClass(java.lang.String successClass) {
    this.successClass = successClass;
  }


  private java.lang.String targetErrorAction;

  /**
   * <p>Return the value of the <code>targetErrorAction</code> property.   * </p>
   */
  public java.lang.String getTargetErrorAction() {
    if (null != this.targetErrorAction) {
      return this.targetErrorAction;
    }
    ValueBinding _vb = getValueBinding("targetErrorAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>targetErrorAction</code> property.</p>
   */
  public void setTargetErrorAction(java.lang.String targetErrorAction) {
    this.targetErrorAction = targetErrorAction;
  }


  private java.lang.String targetOnfocusErrorAction;

  /**
   * <p>Return the value of the <code>targetOnfocusErrorAction</code> property.   * </p>
   */
  public java.lang.String getTargetOnfocusErrorAction() {
    if (null != this.targetOnfocusErrorAction) {
      return this.targetOnfocusErrorAction;
    }
    ValueBinding _vb = getValueBinding("targetOnfocusErrorAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>targetOnfocusErrorAction</code> property.</p>
   */
  public void setTargetOnfocusErrorAction(java.lang.String targetOnfocusErrorAction) {
    this.targetOnfocusErrorAction = targetOnfocusErrorAction;
  }


  private java.lang.String targetOnfocusSuccessAction;

  /**
   * <p>Return the value of the <code>targetOnfocusSuccessAction</code> property.   * </p>
   */
  public java.lang.String getTargetOnfocusSuccessAction() {
    if (null != this.targetOnfocusSuccessAction) {
      return this.targetOnfocusSuccessAction;
    }
    ValueBinding _vb = getValueBinding("targetOnfocusSuccessAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>targetOnfocusSuccessAction</code> property.</p>
   */
  public void setTargetOnfocusSuccessAction(java.lang.String targetOnfocusSuccessAction) {
    this.targetOnfocusSuccessAction = targetOnfocusSuccessAction;
  }


  private java.lang.String targetSuccessAction;

  /**
   * <p>Return the value of the <code>targetSuccessAction</code> property.   * </p>
   */
  public java.lang.String getTargetSuccessAction() {
    if (null != this.targetSuccessAction) {
      return this.targetSuccessAction;
    }
    ValueBinding _vb = getValueBinding("targetSuccessAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>targetSuccessAction</code> property.</p>
   */
  public void setTargetSuccessAction(java.lang.String targetSuccessAction) {
    this.targetSuccessAction = targetSuccessAction;
  }


  private java.lang.String validation;

  /**
   * <p>Return the value of the <code>validation</code> property.   * </p>
   */
  public java.lang.String getValidation() {
    if (null != this.validation) {
      return this.validation;
    }
    ValueBinding _vb = getValueBinding("validation"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>validation</code> property.</p>
   */
  public void setValidation(java.lang.String validation) {
    this.validation = validation;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[24];
    _values[0] = super.saveState(_context);
    _values[1] = autoSubmit;
    _values[2] = autoTab;
    _values[3] = binding;
    _values[4] = errorAction;
    _values[5] = errorClass;
    _values[6] = imeMode;
    _values[7] = inputAssist;
    _values[8] = onerror;
    _values[9] = onfocusErrorAction;
    _values[10] = onfocusErrorClass;
    _values[11] = onfocusSuccessAction;
    _values[12] = onfocusSuccessClass;
    _values[13] = onfocuserror;
    _values[14] = onfocussuccess;
    _values[15] = onsuccess;
    _values[16] = promptCharacter;
    _values[17] = successAction;
    _values[18] = successClass;
    _values[19] = targetErrorAction;
    _values[20] = targetOnfocusErrorAction;
    _values[21] = targetOnfocusSuccessAction;
    _values[22] = targetSuccessAction;
    _values[23] = validation;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.autoSubmit = (java.lang.String) _values[1];
    this.autoTab = (java.lang.String) _values[2];
    this.binding = (java.lang.String) _values[3];
    this.errorAction = (java.lang.String) _values[4];
    this.errorClass = (java.lang.String) _values[5];
    this.imeMode = (java.lang.String) _values[6];
    this.inputAssist = (java.lang.String) _values[7];
    this.onerror = (java.lang.String) _values[8];
    this.onfocusErrorAction = (java.lang.String) _values[9];
    this.onfocusErrorClass = (java.lang.String) _values[10];
    this.onfocusSuccessAction = (java.lang.String) _values[11];
    this.onfocusSuccessClass = (java.lang.String) _values[12];
    this.onfocuserror = (java.lang.String) _values[13];
    this.onfocussuccess = (java.lang.String) _values[14];
    this.onsuccess = (java.lang.String) _values[15];
    this.promptCharacter = (java.lang.String) _values[16];
    this.successAction = (java.lang.String) _values[17];
    this.successClass = (java.lang.String) _values[18];
    this.targetErrorAction = (java.lang.String) _values[19];
    this.targetOnfocusErrorAction = (java.lang.String) _values[20];
    this.targetOnfocusSuccessAction = (java.lang.String) _values[21];
    this.targetSuccessAction = (java.lang.String) _values[22];
    this.validation = (java.lang.String) _values[23];
  }


}
