/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.DatePicker</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperDatePicker extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperDatePicker() {
    super();
    setRendererType("com.ibm.faces.DatePicker"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperDatePicker"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String buttonBorder;

  /**
   * <p>Return the value of the <code>buttonBorder</code> property.   * </p>
   */
  public java.lang.String getButtonBorder() {
    if (null != this.buttonBorder) {
      return this.buttonBorder;
    }
    ValueBinding _vb = getValueBinding("buttonBorder"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>buttonBorder</code> property.</p>
   */
  public void setButtonBorder(java.lang.String buttonBorder) {
    this.buttonBorder = buttonBorder;
  }


  private java.lang.String buttonColor;

  /**
   * <p>Return the value of the <code>buttonColor</code> property.   * </p>
   */
  public java.lang.String getButtonColor() {
    if (null != this.buttonColor) {
      return this.buttonColor;
    }
    ValueBinding _vb = getValueBinding("buttonColor"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>buttonColor</code> property.</p>
   */
  public void setButtonColor(java.lang.String buttonColor) {
    this.buttonColor = buttonColor;
  }


  private java.lang.String delta;

  /**
   * <p>Return the value of the <code>delta</code> property.   * </p>
   */
  public java.lang.String getDelta() {
    if (null != this.delta) {
      return this.delta;
    }
    ValueBinding _vb = getValueBinding("delta"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>delta</code> property.</p>
   */
  public void setDelta(java.lang.String delta) {
    this.delta = delta;
  }


  private java.lang.String deltaHours;

  /**
   * <p>Return the value of the <code>deltaHours</code> property.  Contents:</p><p>
   * This is the number of Hours that the input will cycle up or down (applies when type="time"). 
   * 			Value must be greater than zero.
   * </p>
   */
  public java.lang.String getDeltaHours() {
    if (null != this.deltaHours) {
      return this.deltaHours;
    }
    ValueBinding _vb = getValueBinding("deltaHours"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>deltaHours</code> property.</p>
   */
  public void setDeltaHours(java.lang.String deltaHours) {
    this.deltaHours = deltaHours;
  }


  private java.lang.String deltaMinutes;

  /**
   * <p>Return the value of the <code>deltaMinutes</code> property.  Contents:</p><p>
   * This is the number of Minutes that the input will cycle up or down (applies when type="time"). 
   * 			Value must be greater than zero.
   * </p>
   */
  public java.lang.String getDeltaMinutes() {
    if (null != this.deltaMinutes) {
      return this.deltaMinutes;
    }
    ValueBinding _vb = getValueBinding("deltaMinutes"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>deltaMinutes</code> property.</p>
   */
  public void setDeltaMinutes(java.lang.String deltaMinutes) {
    this.deltaMinutes = deltaMinutes;
  }


  private java.lang.String deltaSeconds;

  /**
   * <p>Return the value of the <code>deltaSeconds</code> property.  Contents:</p><p>
   * This is the number of Seconds that the input will cycle up or down (applies when type="time"). 
   * 			Value must be greater than zero.
   * </p>
   */
  public java.lang.String getDeltaSeconds() {
    if (null != this.deltaSeconds) {
      return this.deltaSeconds;
    }
    ValueBinding _vb = getValueBinding("deltaSeconds"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>deltaSeconds</code> property.</p>
   */
  public void setDeltaSeconds(java.lang.String deltaSeconds) {
    this.deltaSeconds = deltaSeconds;
  }


  private java.lang.String firstDay;

  /**
   * <p>Return the value of the <code>firstDay</code> property.   * </p>
   */
  public java.lang.String getFirstDay() {
    if (null != this.firstDay) {
      return this.firstDay;
    }
    ValueBinding _vb = getValueBinding("firstDay"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>firstDay</code> property.</p>
   */
  public void setFirstDay(java.lang.String firstDay) {
    this.firstDay = firstDay;
  }


  private boolean multiLine = true;
  private boolean multiLine_set = false;

  /**
   * <p>Return the value of the <code>multiLine</code> property.   * </p>
   */
  public boolean isMultiLine() {
    if (this.multiLine_set) {
      return this.multiLine;
    }
    ValueBinding _vb = getValueBinding("multiLine"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.multiLine;
    }
  }

  /**
   * <p>Set the value of the <code>multiLine</code> property.</p>
   */
  public void setMultiLine(boolean multiLine) {
    this.multiLine = multiLine;
    this.multiLine_set = true;
  }


  private boolean positional = false;
  private boolean positional_set = false;

  /**
   * <p>Return the value of the <code>positional</code> property.  Contents:</p><p>
   * This is a boolean flag that is used to turn on (true) or off (false or attribute not set) this behaviour. 
   * 			By Default this behaviour is turned off. 
   * 			When enabled, the delta attribute is ignored.(applies when type="time")
   * </p>
   */
  public boolean isPositional() {
    if (this.positional_set) {
      return this.positional;
    }
    ValueBinding _vb = getValueBinding("positional"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.positional;
    }
  }

  /**
   * <p>Set the value of the <code>positional</code> property.</p>
   */
  public void setPositional(boolean positional) {
    this.positional = positional;
    this.positional_set = true;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[14];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = buttonBorder;
    _values[3] = buttonColor;
    _values[4] = delta;
    _values[5] = deltaHours;
    _values[6] = deltaMinutes;
    _values[7] = deltaSeconds;
    _values[8] = firstDay;
    _values[9] = this.multiLine ? Boolean.TRUE : Boolean.FALSE;
    _values[10] = this.multiLine_set ? Boolean.TRUE : Boolean.FALSE;
    _values[11] = this.positional ? Boolean.TRUE : Boolean.FALSE;
    _values[12] = this.positional_set ? Boolean.TRUE : Boolean.FALSE;
    _values[13] = styleClass;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.buttonBorder = (java.lang.String) _values[2];
    this.buttonColor = (java.lang.String) _values[3];
    this.delta = (java.lang.String) _values[4];
    this.deltaHours = (java.lang.String) _values[5];
    this.deltaMinutes = (java.lang.String) _values[6];
    this.deltaSeconds = (java.lang.String) _values[7];
    this.firstDay = (java.lang.String) _values[8];
    this.multiLine = ((Boolean) _values[9]).booleanValue();
    this.multiLine_set = ((Boolean) _values[10]).booleanValue();
    this.positional = ((Boolean) _values[11]).booleanValue();
    this.positional_set = ((Boolean) _values[12]).booleanValue();
    this.styleClass = (java.lang.String) _values[13];
  }


}
