/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.FormTracker</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperFormTracker extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperFormTracker() {
    super();
    setRendererType("com.ibm.faces.FormTracker"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperFormTracker"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String lastCursorPosition;

  /**
   * <p>Return the value of the <code>lastCursorPosition</code> property.  Contents:</p><p>
   * Cursor position with last field
   * </p>
   */
  public java.lang.String getLastCursorPosition() {
    if (null != this.lastCursorPosition) {
      return this.lastCursorPosition;
    }
    ValueBinding _vb = getValueBinding("lastCursorPosition"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lastCursorPosition</code> property.</p>
   */
  public void setLastCursorPosition(java.lang.String lastCursorPosition) {
    this.lastCursorPosition = lastCursorPosition;
  }


  private java.lang.String lastFieldId;

  /**
   * <p>Return the value of the <code>lastFieldId</code> property.  Contents:</p><p>
   * id value of last field entered
   * </p>
   */
  public java.lang.String getLastFieldId() {
    if (null != this.lastFieldId) {
      return this.lastFieldId;
    }
    ValueBinding _vb = getValueBinding("lastFieldId"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lastFieldId</code> property.</p>
   */
  public void setLastFieldId(java.lang.String lastFieldId) {
    this.lastFieldId = lastFieldId;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[4];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = lastCursorPosition;
    _values[3] = lastFieldId;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.lastCursorPosition = (java.lang.String) _values[2];
    this.lastFieldId = (java.lang.String) _values[3];
  }


}
