/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.KeyBind</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperKeybind extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperKeybind() {
    super();
    setRendererType("com.ibm.faces.KeyBind"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperKeybind"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String cancelBubble;

  /**
   * <p>Return the value of the <code>cancelBubble</code> property.   * </p>
   */
  public java.lang.String getCancelBubble() {
    if (null != this.cancelBubble) {
      return this.cancelBubble;
    }
    ValueBinding _vb = getValueBinding("cancelBubble"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>cancelBubble</code> property.</p>
   */
  public void setCancelBubble(java.lang.String cancelBubble) {
    this.cancelBubble = cancelBubble;
  }


  private java.lang.String key;

  /**
   * <p>Return the value of the <code>key</code> property.   * </p>
   */
  public java.lang.String getKey() {
    if (null != this.key) {
      return this.key;
    }
    ValueBinding _vb = getValueBinding("key"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>key</code> property.</p>
   */
  public void setKey(java.lang.String key) {
    this.key = key;
  }


  private java.lang.String onpress;

  /**
   * <p>Return the value of the <code>onpress</code> property.   * </p>
   */
  public java.lang.String getOnpress() {
    if (null != this.onpress) {
      return this.onpress;
    }
    ValueBinding _vb = getValueBinding("onpress"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onpress</code> property.</p>
   */
  public void setOnpress(java.lang.String onpress) {
    this.onpress = onpress;
  }


  private java.lang.String target;

  /**
   * <p>Return the value of the <code>target</code> property.   * </p>
   */
  public java.lang.String getTarget() {
    if (null != this.target) {
      return this.target;
    }
    ValueBinding _vb = getValueBinding("target"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>target</code> property.</p>
   */
  public void setTarget(java.lang.String target) {
    this.target = target;
  }


  private java.lang.String targetAction;

  /**
   * <p>Return the value of the <code>targetAction</code> property.   * </p>
   */
  public java.lang.String getTargetAction() {
    if (null != this.targetAction) {
      return this.targetAction;
    }
    ValueBinding _vb = getValueBinding("targetAction"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>targetAction</code> property.</p>
   */
  public void setTargetAction(java.lang.String targetAction) {
    this.targetAction = targetAction;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[7];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = cancelBubble;
    _values[3] = key;
    _values[4] = onpress;
    _values[5] = target;
    _values[6] = targetAction;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.cancelBubble = (java.lang.String) _values[2];
    this.key = (java.lang.String) _values[3];
    this.onpress = (java.lang.String) _values[4];
    this.target = (java.lang.String) _values[5];
    this.targetAction = (java.lang.String) _values[6];
  }


}
