/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.SetFocus</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperSetFocus extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperSetFocus() {
    super();
    setRendererType("com.ibm.faces.SetFocus"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperSetFocus"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private boolean select = false;
  private boolean select_set = false;

  /**
   * <p>Return the value of the <code>select</code> property.   * </p>
   */
  public boolean isSelect() {
    if (this.select_set) {
      return this.select;
    }
    ValueBinding _vb = getValueBinding("select"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.select;
    }
  }

  /**
   * <p>Set the value of the <code>select</code> property.</p>
   */
  public void setSelect(boolean select) {
    this.select = select;
    this.select_set = true;
  }


  private java.lang.String target;

  /**
   * <p>Return the value of the <code>target</code> property.   * </p>
   */
  public java.lang.String getTarget() {
    if (null != this.target) {
      return this.target;
    }
    ValueBinding _vb = getValueBinding("target"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>target</code> property.</p>
   */
  public void setTarget(java.lang.String target) {
    this.target = target;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[5];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = this.select ? Boolean.TRUE : Boolean.FALSE;
    _values[3] = this.select_set ? Boolean.TRUE : Boolean.FALSE;
    _values[4] = target;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.select = ((Boolean) _values[2]).booleanValue();
    this.select_set = ((Boolean) _values[3]).booleanValue();
    this.target = (java.lang.String) _values[4];
  }


}
