/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Slider</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperSlider extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperSlider() {
    super();
    setRendererType("com.ibm.faces.Slider"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperSlider"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String buttonBorder;

  /**
   * <p>Return the value of the <code>buttonBorder</code> property.   * </p>
   */
  public java.lang.String getButtonBorder() {
    if (null != this.buttonBorder) {
      return this.buttonBorder;
    }
    ValueBinding _vb = getValueBinding("buttonBorder"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>buttonBorder</code> property.</p>
   */
  public void setButtonBorder(java.lang.String buttonBorder) {
    this.buttonBorder = buttonBorder;
  }


  private java.lang.String buttonColor;

  /**
   * <p>Return the value of the <code>buttonColor</code> property.   * </p>
   */
  public java.lang.String getButtonColor() {
    if (null != this.buttonColor) {
      return this.buttonColor;
    }
    ValueBinding _vb = getValueBinding("buttonColor"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>buttonColor</code> property.</p>
   */
  public void setButtonColor(java.lang.String buttonColor) {
    this.buttonColor = buttonColor;
  }


  private java.lang.String delta;

  /**
   * <p>Return the value of the <code>delta</code> property.   * </p>
   */
  public java.lang.String getDelta() {
    if (null != this.delta) {
      return this.delta;
    }
    ValueBinding _vb = getValueBinding("delta"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>delta</code> property.</p>
   */
  public void setDelta(java.lang.String delta) {
    this.delta = delta;
  }


  private java.lang.String hideLabels;

  /**
   * <p>Return the value of the <code>hideLabels</code> property.   * </p>
   */
  public java.lang.String getHideLabels() {
    if (null != this.hideLabels) {
      return this.hideLabels;
    }
    ValueBinding _vb = getValueBinding("hideLabels"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>hideLabels</code> property.</p>
   */
  public void setHideLabels(java.lang.String hideLabels) {
    this.hideLabels = hideLabels;
  }


  private java.lang.String labelIncrement;

  /**
   * <p>Return the value of the <code>labelIncrement</code> property.   * </p>
   */
  public java.lang.String getLabelIncrement() {
    if (null != this.labelIncrement) {
      return this.labelIncrement;
    }
    ValueBinding _vb = getValueBinding("labelIncrement"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>labelIncrement</code> property.</p>
   */
  public void setLabelIncrement(java.lang.String labelIncrement) {
    this.labelIncrement = labelIncrement;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[9];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = buttonBorder;
    _values[3] = buttonColor;
    _values[4] = delta;
    _values[5] = hideLabels;
    _values[6] = labelIncrement;
    _values[7] = styleClass;
    _values[8] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.buttonBorder = (java.lang.String) _values[2];
    this.buttonColor = (java.lang.String) _values[3];
    this.delta = (java.lang.String) _values[4];
    this.hideLabels = (java.lang.String) _values[5];
    this.labelIncrement = (java.lang.String) _values[6];
    this.styleClass = (java.lang.String) _values[7];
    this.width = (java.lang.String) _values[8];
  }


}
