/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Typeahead</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputHelperTypeahead extends com.ibm.faces.component.UIInputHelper {


  public HtmlInputHelperTypeahead() {
    super();
    setRendererType("com.ibm.faces.Typeahead"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputHelperTypeahead"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * An expression that binds the component's instance to a bean property.
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String inProgress;

  /**
   * <p>Return the value of the <code>inProgress</code> property.  Contents:</p><p>
   * JavaScript busy animation. Details TBD.
   * </p>
   */
  public java.lang.String getInProgress() {
    if (null != this.inProgress) {
      return this.inProgress;
    }
    ValueBinding _vb = getValueBinding("inProgress"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>inProgress</code> property.</p>
   */
  public void setInProgress(java.lang.String inProgress) {
    this.inProgress = inProgress;
  }


  private java.lang.String matchWidth;

  /**
   * <p>Return the value of the <code>matchWidth</code> property.  Contents:</p><p>
   * Whether the suggestion area's (dropdown's) width should match the width of the input field. Default is true.
   * </p>
   */
  public java.lang.String getMatchWidth() {
    if (null != this.matchWidth) {
      return this.matchWidth;
    }
    ValueBinding _vb = getValueBinding("matchWidth"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>matchWidth</code> property.</p>
   */
  public void setMatchWidth(java.lang.String matchWidth) {
    this.matchWidth = matchWidth;
  }


  private java.lang.String maxSuggestions;

  /**
   * <p>Return the value of the <code>maxSuggestions</code> property.  Contents:</p><p>
   * Maximum number of results displayed in the suggestion area (dropdown). Default is 10.
   * </p>
   */
  public java.lang.String getMaxSuggestions() {
    if (null != this.maxSuggestions) {
      return this.maxSuggestions;
    }
    ValueBinding _vb = getValueBinding("maxSuggestions"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>maxSuggestions</code> property.</p>
   */
  public void setMaxSuggestions(java.lang.String maxSuggestions) {
    this.maxSuggestions = maxSuggestions;
  }


  private java.lang.String oncomplete;

  /**
   * <p>Return the value of the <code>oncomplete</code> property.  Contents:</p><p>
   * JavaScript to execute after the suggestion list request has been retrieved.
   * </p>
   */
  public java.lang.String getOncomplete() {
    if (null != this.oncomplete) {
      return this.oncomplete;
    }
    ValueBinding _vb = getValueBinding("oncomplete"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>oncomplete</code> property.</p>
   */
  public void setOncomplete(java.lang.String oncomplete) {
    this.oncomplete = oncomplete;
  }


  private java.lang.String onstart;

  /**
   * <p>Return the value of the <code>onstart</code> property.  Contents:</p><p>
   * Javascript to execute before the suggestion list request is issued.
   * </p>
   */
  public java.lang.String getOnstart() {
    if (null != this.onstart) {
      return this.onstart;
    }
    ValueBinding _vb = getValueBinding("onstart"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onstart</code> property.</p>
   */
  public void setOnstart(java.lang.String onstart) {
    this.onstart = onstart;
  }


  private java.lang.String size;

  /**
   * <p>Return the value of the <code>size</code> property.  Contents:</p><p>
   * Maximum number of results displayed in the suggestion area (dropdown). Default is 10.
   * </p>
   */
  public java.lang.String getSize() {
    if (null != this.size) {
      return this.size;
    }
    ValueBinding _vb = getValueBinding("size"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>size</code> property.</p>
   */
  public void setSize(java.lang.String size) {
    this.size = size;
  }


  private java.lang.String startCharacters;

  /**
   * <p>Return the value of the <code>startCharacters</code> property.  Contents:</p><p>
   * The minimum number of characters which need to be in the input field before a suggestion list request
   * 				is issued. Default is 1.
   * </p>
   */
  public java.lang.String getStartCharacters() {
    if (null != this.startCharacters) {
      return this.startCharacters;
    }
    ValueBinding _vb = getValueBinding("startCharacters"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>startCharacters</code> property.</p>
   */
  public void setStartCharacters(java.lang.String startCharacters) {
    this.startCharacters = startCharacters;
  }


  private java.lang.String startDelay;

  /**
   * <p>Return the value of the <code>startDelay</code> property.  Contents:</p><p>
   * Time delay since last keypress required before a request for a suggestion list is issued measuerd in 
   * 				milliseconds. Default is 500. Minumum value is 100. If this is set to 0ms, race conditions can occur 
   * 				between the dom update for the parent component and the type ahead behaviour keydown event.
   * </p>
   */
  public java.lang.String getStartDelay() {
    if (null != this.startDelay) {
      return this.startDelay;
    }
    ValueBinding _vb = getValueBinding("startDelay"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>startDelay</code> property.</p>
   */
  public void setStartDelay(java.lang.String startDelay) {
    this.startDelay = startDelay;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String type;

  /**
   * <p>Return the value of the <code>type</code> property.  Contents:</p><p>
   * Whether the typeahead displays choices int a dropdown or autocompletes the field selecting that 
   * 				completed characters.
   * 				Permitted values are "suggest" and "autocomplete".
   * </p>
   */
  public java.lang.String getType() {
    if (null != this.type) {
      return this.type;
    }
    ValueBinding _vb = getValueBinding("type"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>type</code> property.</p>
   */
  public void setType(java.lang.String type) {
    this.type = type;
  }


  private java.lang.String value;

  /**
   * <p>Return the value of the <code>value</code> property.  Contents:</p><p>
   * An expression that names a class that implements Map where the 
   * 				current value that the user typed in is passed to the implementation.  
   * 				For example, "{#suggestions['value']}".
   * </p>
   */
  public java.lang.String getValue() {
    if (null != this.value) {
      return this.value;
    }
    ValueBinding _vb = getValueBinding("value"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>value</code> property.</p>
   */
  public void setValue(java.lang.String value) {
    this.value = value;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[13];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = inProgress;
    _values[3] = matchWidth;
    _values[4] = maxSuggestions;
    _values[5] = oncomplete;
    _values[6] = onstart;
    _values[7] = size;
    _values[8] = startCharacters;
    _values[9] = startDelay;
    _values[10] = styleClass;
    _values[11] = type;
    _values[12] = value;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.inProgress = (java.lang.String) _values[2];
    this.matchWidth = (java.lang.String) _values[3];
    this.maxSuggestions = (java.lang.String) _values[4];
    this.oncomplete = (java.lang.String) _values[5];
    this.onstart = (java.lang.String) _values[6];
    this.size = (java.lang.String) _values[7];
    this.startCharacters = (java.lang.String) _values[8];
    this.startDelay = (java.lang.String) _values[9];
    this.styleClass = (java.lang.String) _values[10];
    this.type = (java.lang.String) _values[11];
    this.value = (java.lang.String) _values[12];
  }


}
