/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.RowSelect</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlInputRowSelect extends javax.faces.component.UIInput {


  public HtmlInputRowSelect() {
    super();
    setRendererType("com.ibm.faces.RowSelect"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlInputRowSelect"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String columnClasses;

  /**
   * <p>Return the value of the <code>columnClasses</code> property.  Contents:</p><p>
   * CSS styles to be applied when row is selected.
   * </p>
   */
  public java.lang.String getColumnClasses() {
    if (null != this.columnClasses) {
      return this.columnClasses;
    }
    ValueBinding _vb = getValueBinding("columnClasses"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>columnClasses</code> property.</p>
   */
  public void setColumnClasses(java.lang.String columnClasses) {
    this.columnClasses = columnClasses;
  }


  private java.lang.String noscript;

  /**
   * <p>Return the value of the <code>noscript</code> property.  Contents:</p><p>
   * Do not use JavaScript with this control.
   * </p>
   */
  public java.lang.String getNoscript() {
    if (null != this.noscript) {
      return this.noscript;
    }
    ValueBinding _vb = getValueBinding("noscript"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>noscript</code> property.</p>
   */
  public void setNoscript(java.lang.String noscript) {
    this.noscript = noscript;
  }


  private java.lang.String onclick;

  /**
   * <p>Return the value of the <code>onclick</code> property.  Contents:</p><p>
   * Javascript onclick event
   * </p>
   */
  public java.lang.String getOnclick() {
    if (null != this.onclick) {
      return this.onclick;
    }
    ValueBinding _vb = getValueBinding("onclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onclick</code> property.</p>
   */
  public void setOnclick(java.lang.String onclick) {
    this.onclick = onclick;
  }


  private java.lang.String onmouseup;

  /**
   * <p>Return the value of the <code>onmouseup</code> property.  Contents:</p><p>
   * Javascript onmouseup event
   * </p>
   */
  public java.lang.String getOnmouseup() {
    if (null != this.onmouseup) {
      return this.onmouseup;
    }
    ValueBinding _vb = getValueBinding("onmouseup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseup</code> property.</p>
   */
  public void setOnmouseup(java.lang.String onmouseup) {
    this.onmouseup = onmouseup;
  }


  private java.lang.String selectOne;

  /**
   * <p>Return the value of the <code>selectOne</code> property.  Contents:</p><p>
   * Allow only one selection, i.e. radio style
   * </p>
   */
  public java.lang.String getSelectOne() {
    if (null != this.selectOne) {
      return this.selectOne;
    }
    ValueBinding _vb = getValueBinding("selectOne"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>selectOne</code> property.</p>
   */
  public void setSelectOne(java.lang.String selectOne) {
    this.selectOne = selectOne;
  }


  private java.lang.String srcSelected;

  /**
   * <p>Return the value of the <code>srcSelected</code> property.  Contents:</p><p>
   * URL of image to display when selected.
   * </p>
   */
  public java.lang.String getSrcSelected() {
    if (null != this.srcSelected) {
      return this.srcSelected;
    }
    ValueBinding _vb = getValueBinding("srcSelected"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcSelected</code> property.</p>
   */
  public void setSrcSelected(java.lang.String srcSelected) {
    this.srcSelected = srcSelected;
  }


  private java.lang.String srcUnselected;

  /**
   * <p>Return the value of the <code>srcUnselected</code> property.  Contents:</p><p>
   * URL of image to display when unselected.
   * </p>
   */
  public java.lang.String getSrcUnselected() {
    if (null != this.srcUnselected) {
      return this.srcUnselected;
    }
    ValueBinding _vb = getValueBinding("srcUnselected"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcUnselected</code> property.</p>
   */
  public void setSrcUnselected(java.lang.String srcUnselected) {
    this.srcUnselected = srcUnselected;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String titleSelected;

  /**
   * <p>Return the value of the <code>titleSelected</code> property.  Contents:</p><p>
   * title for radio button / checkbox when selected
   * </p>
   */
  public java.lang.String getTitleSelected() {
    if (null != this.titleSelected) {
      return this.titleSelected;
    }
    ValueBinding _vb = getValueBinding("titleSelected"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>titleSelected</code> property.</p>
   */
  public void setTitleSelected(java.lang.String titleSelected) {
    this.titleSelected = titleSelected;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[13];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = columnClasses;
    _values[3] = noscript;
    _values[4] = onclick;
    _values[5] = onmouseup;
    _values[6] = selectOne;
    _values[7] = srcSelected;
    _values[8] = srcUnselected;
    _values[9] = style;
    _values[10] = styleClass;
    _values[11] = title;
    _values[12] = titleSelected;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.columnClasses = (java.lang.String) _values[2];
    this.noscript = (java.lang.String) _values[3];
    this.onclick = (java.lang.String) _values[4];
    this.onmouseup = (java.lang.String) _values[5];
    this.selectOne = (java.lang.String) _values[6];
    this.srcSelected = (java.lang.String) _values[7];
    this.srcUnselected = (java.lang.String) _values[8];
    this.style = (java.lang.String) _values[9];
    this.styleClass = (java.lang.String) _values[10];
    this.title = (java.lang.String) _values[11];
    this.titleSelected = (java.lang.String) _values[12];
  }


}
