/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Selecticons</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlOutputSelecticons extends javax.faces.component.UIOutput {


  public HtmlOutputSelecticons() {
    super();
    setRendererType("com.ibm.faces.Selecticons"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlOutputSelecticons"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String _for;

  /**
   * <p>Return the value of the <code>for</code> property.   * </p>
   */
  public java.lang.String getFor() {
    if (null != this._for) {
      return this._for;
    }
    ValueBinding _vb = getValueBinding("for"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>for</code> property.</p>
   */
  public void setFor(java.lang.String _for) {
    this._for = _for;
  }


  private java.lang.String srcAll;

  /**
   * <p>Return the value of the <code>srcAll</code> property.  Contents:</p><p>
   * URL to image for use as Select All icon.
   * </p>
   */
  public java.lang.String getSrcAll() {
    if (null != this.srcAll) {
      return this.srcAll;
    }
    ValueBinding _vb = getValueBinding("srcAll"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcAll</code> property.</p>
   */
  public void setSrcAll(java.lang.String srcAll) {
    this.srcAll = srcAll;
  }


  private java.lang.String srcInverse;

  /**
   * <p>Return the value of the <code>srcInverse</code> property.  Contents:</p><p>
   * URL to image for use as Select Inverse icon.
   * </p>
   */
  public java.lang.String getSrcInverse() {
    if (null != this.srcInverse) {
      return this.srcInverse;
    }
    ValueBinding _vb = getValueBinding("srcInverse"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcInverse</code> property.</p>
   */
  public void setSrcInverse(java.lang.String srcInverse) {
    this.srcInverse = srcInverse;
  }


  private java.lang.String srcNone;

  /**
   * <p>Return the value of the <code>srcNone</code> property.  Contents:</p><p>
   * URL to image for use as Select None icon.
   * </p>
   */
  public java.lang.String getSrcNone() {
    if (null != this.srcNone) {
      return this.srcNone;
    }
    ValueBinding _vb = getValueBinding("srcNone"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcNone</code> property.</p>
   */
  public void setSrcNone(java.lang.String srcNone) {
    this.srcNone = srcNone;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String useButtons;

  /**
   * <p>Return the value of the <code>useButtons</code> property.  Contents:</p><p>
   * Render text buttons instead of images.
   * </p>
   */
  public java.lang.String getUseButtons() {
    if (null != this.useButtons) {
      return this.useButtons;
    }
    ValueBinding _vb = getValueBinding("useButtons"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>useButtons</code> property.</p>
   */
  public void setUseButtons(java.lang.String useButtons) {
    this.useButtons = useButtons;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[10];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = _for;
    _values[3] = srcAll;
    _values[4] = srcInverse;
    _values[5] = srcNone;
    _values[6] = style;
    _values[7] = styleClass;
    _values[8] = title;
    _values[9] = useButtons;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this._for = (java.lang.String) _values[2];
    this.srcAll = (java.lang.String) _values[3];
    this.srcInverse = (java.lang.String) _values[4];
    this.srcNone = (java.lang.String) _values[5];
    this.style = (java.lang.String) _values[6];
    this.styleClass = (java.lang.String) _values[7];
    this.title = (java.lang.String) _values[8];
    this.useButtons = (java.lang.String) _values[9];
  }


}
