/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Statistics</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlOutputStatistics extends javax.faces.component.UIOutput {


  public HtmlOutputStatistics() {
    super();
    setRendererType("com.ibm.faces.Statistics"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlOutputStatistics"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String filtered;

  /**
   * <p>Return the value of the <code>filtered</code> property.  Contents:</p><p>
   * Filtered Info
   * </p>
   */
  public java.lang.String getFiltered() {
    if (null != this.filtered) {
      return this.filtered;
    }
    ValueBinding _vb = getValueBinding("filtered"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>filtered</code> property.</p>
   */
  public void setFiltered(java.lang.String filtered) {
    this.filtered = filtered;
  }


  private java.lang.String _for;

  /**
   * <p>Return the value of the <code>for</code> property.   * </p>
   */
  public java.lang.String getFor() {
    if (null != this._for) {
      return this._for;
    }
    ValueBinding _vb = getValueBinding("for"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>for</code> property.</p>
   */
  public void setFor(java.lang.String _for) {
    this._for = _for;
  }


  private java.lang.String paging;

  /**
   * <p>Return the value of the <code>paging</code> property.  Contents:</p><p>
   * Paging Info
   * </p>
   */
  public java.lang.String getPaging() {
    if (null != this.paging) {
      return this.paging;
    }
    ValueBinding _vb = getValueBinding("paging"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>paging</code> property.</p>
   */
  public void setPaging(java.lang.String paging) {
    this.paging = paging;
  }


  private java.lang.String selected;

  /**
   * <p>Return the value of the <code>selected</code> property.  Contents:</p><p>
   * Selected Info
   * </p>
   */
  public java.lang.String getSelected() {
    if (null != this.selected) {
      return this.selected;
    }
    ValueBinding _vb = getValueBinding("selected"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>selected</code> property.</p>
   */
  public void setSelected(java.lang.String selected) {
    this.selected = selected;
  }


  private java.lang.String shown;

  /**
   * <p>Return the value of the <code>shown</code> property.  Contents:</p><p>
   * Shown Info
   * </p>
   */
  public java.lang.String getShown() {
    if (null != this.shown) {
      return this.shown;
    }
    ValueBinding _vb = getValueBinding("shown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>shown</code> property.</p>
   */
  public void setShown(java.lang.String shown) {
    this.shown = shown;
  }


  private java.lang.String statusText;

  /**
   * <p>Return the value of the <code>statusText</code> property.  Contents:</p><p>
   * Status Text Used
   * </p>
   */
  public java.lang.String getStatusText() {
    if (null != this.statusText) {
      return this.statusText;
    }
    ValueBinding _vb = getValueBinding("statusText"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>statusText</code> property.</p>
   */
  public void setStatusText(java.lang.String statusText) {
    this.statusText = statusText;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String total;

  /**
   * <p>Return the value of the <code>total</code> property.  Contents:</p><p>
   * Total Info
   * </p>
   */
  public java.lang.String getTotal() {
    if (null != this.total) {
      return this.total;
    }
    ValueBinding _vb = getValueBinding("total"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>total</code> property.</p>
   */
  public void setTotal(java.lang.String total) {
    this.total = total;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[12];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = filtered;
    _values[3] = _for;
    _values[4] = paging;
    _values[5] = selected;
    _values[6] = shown;
    _values[7] = statusText;
    _values[8] = style;
    _values[9] = styleClass;
    _values[10] = title;
    _values[11] = total;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.filtered = (java.lang.String) _values[2];
    this._for = (java.lang.String) _values[3];
    this.paging = (java.lang.String) _values[4];
    this.selected = (java.lang.String) _values[5];
    this.shown = (java.lang.String) _values[6];
    this.statusText = (java.lang.String) _values[7];
    this.style = (java.lang.String) _values[8];
    this.styleClass = (java.lang.String) _values[9];
    this.title = (java.lang.String) _values[10];
    this.total = (java.lang.String) _values[11];
  }


}
