/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Deluxe</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPagerDeluxe extends com.ibm.faces.component.UIPager {


  public HtmlPagerDeluxe() {
    super();
    setRendererType("com.ibm.faces.Deluxe"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPagerDeluxe"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String _for;

  /**
   * <p>Return the value of the <code>for</code> property.   * </p>
   */
  public java.lang.String getFor() {
    if (null != this._for) {
      return this._for;
    }
    ValueBinding _vb = getValueBinding("for"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>for</code> property.</p>
   */
  public void setFor(java.lang.String _for) {
    this._for = _for;
  }


  private java.lang.String hideDisabledButtons;

  /**
   * <p>Return the value of the <code>hideDisabledButtons</code> property.  Contents:</p><p>
   * Hide Disabled Buttons
   * </p>
   */
  public java.lang.String getHideDisabledButtons() {
    if (null != this.hideDisabledButtons) {
      return this.hideDisabledButtons;
    }
    ValueBinding _vb = getValueBinding("hideDisabledButtons"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>hideDisabledButtons</code> property.</p>
   */
  public void setHideDisabledButtons(java.lang.String hideDisabledButtons) {
    this.hideDisabledButtons = hideDisabledButtons;
  }


  private java.lang.String showOnlyNextPrevious;

  /**
   * <p>Return the value of the <code>showOnlyNextPrevious</code> property.  Contents:</p><p>
   * Show Only Next and Previous Buttons
   * </p>
   */
  public java.lang.String getShowOnlyNextPrevious() {
    if (null != this.showOnlyNextPrevious) {
      return this.showOnlyNextPrevious;
    }
    ValueBinding _vb = getValueBinding("showOnlyNextPrevious"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>showOnlyNextPrevious</code> property.</p>
   */
  public void setShowOnlyNextPrevious(java.lang.String showOnlyNextPrevious) {
    this.showOnlyNextPrevious = showOnlyNextPrevious;
  }


  private java.lang.String srcFirst;

  /**
   * <p>Return the value of the <code>srcFirst</code> property.  Contents:</p><p>
   * The URL to an image representing the first button.
   * </p>
   */
  public java.lang.String getSrcFirst() {
    if (null != this.srcFirst) {
      return this.srcFirst;
    }
    ValueBinding _vb = getValueBinding("srcFirst"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcFirst</code> property.</p>
   */
  public void setSrcFirst(java.lang.String srcFirst) {
    this.srcFirst = srcFirst;
  }


  private java.lang.String srcLast;

  /**
   * <p>Return the value of the <code>srcLast</code> property.  Contents:</p><p>
   * The URL to an image representing the last button.
   * </p>
   */
  public java.lang.String getSrcLast() {
    if (null != this.srcLast) {
      return this.srcLast;
    }
    ValueBinding _vb = getValueBinding("srcLast"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcLast</code> property.</p>
   */
  public void setSrcLast(java.lang.String srcLast) {
    this.srcLast = srcLast;
  }


  private java.lang.String srcNext;

  /**
   * <p>Return the value of the <code>srcNext</code> property.  Contents:</p><p>
   * The URL to an image representing the next button.
   * </p>
   */
  public java.lang.String getSrcNext() {
    if (null != this.srcNext) {
      return this.srcNext;
    }
    ValueBinding _vb = getValueBinding("srcNext"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcNext</code> property.</p>
   */
  public void setSrcNext(java.lang.String srcNext) {
    this.srcNext = srcNext;
  }


  private java.lang.String srcPrevious;

  /**
   * <p>Return the value of the <code>srcPrevious</code> property.  Contents:</p><p>
   * The URL to an image representing the previous button.
   * </p>
   */
  public java.lang.String getSrcPrevious() {
    if (null != this.srcPrevious) {
      return this.srcPrevious;
    }
    ValueBinding _vb = getValueBinding("srcPrevious"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcPrevious</code> property.</p>
   */
  public void setSrcPrevious(java.lang.String srcPrevious) {
    this.srcPrevious = srcPrevious;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.  Contents:</p><p>
   * Tabbing order for this component.
   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String useButtons;

  /**
   * <p>Return the value of the <code>useButtons</code> property.  Contents:</p><p>
   * Render text buttons instead of images.
   * </p>
   */
  public java.lang.String getUseButtons() {
    if (null != this.useButtons) {
      return this.useButtons;
    }
    ValueBinding _vb = getValueBinding("useButtons"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>useButtons</code> property.</p>
   */
  public void setUseButtons(java.lang.String useButtons) {
    this.useButtons = useButtons;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[14];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = _for;
    _values[3] = hideDisabledButtons;
    _values[4] = showOnlyNextPrevious;
    _values[5] = srcFirst;
    _values[6] = srcLast;
    _values[7] = srcNext;
    _values[8] = srcPrevious;
    _values[9] = style;
    _values[10] = styleClass;
    _values[11] = tabindex;
    _values[12] = title;
    _values[13] = useButtons;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this._for = (java.lang.String) _values[2];
    this.hideDisabledButtons = (java.lang.String) _values[3];
    this.showOnlyNextPrevious = (java.lang.String) _values[4];
    this.srcFirst = (java.lang.String) _values[5];
    this.srcLast = (java.lang.String) _values[6];
    this.srcNext = (java.lang.String) _values[7];
    this.srcPrevious = (java.lang.String) _values[8];
    this.style = (java.lang.String) _values[9];
    this.styleClass = (java.lang.String) _values[10];
    this.tabindex = (java.lang.String) _values[11];
    this.title = (java.lang.String) _values[12];
    this.useButtons = (java.lang.String) _values[13];
  }


}
