/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Web</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPagerWeb extends com.ibm.faces.component.UIPager {


  public HtmlPagerWeb() {
    super();
    setRendererType("com.ibm.faces.Web"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPagerWeb"; //$NON-NLS-1$


  private java.lang.String binaryNavigation;

  /**
   * <p>Return the value of the <code>binaryNavigation</code> property.  Contents:</p><p>
   * An alternative method of displaying pages. Allows users
   * 				to navigate the page list in the fewest possible steps.
   * </p>
   */
  public java.lang.String getBinaryNavigation() {
    if (null != this.binaryNavigation) {
      return this.binaryNavigation;
    }
    ValueBinding _vb = getValueBinding("binaryNavigation"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binaryNavigation</code> property.</p>
   */
  public void setBinaryNavigation(java.lang.String binaryNavigation) {
    this.binaryNavigation = binaryNavigation;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String currentPageLast;

  /**
   * <p>Return the value of the <code>currentPageLast</code> property.  Contents:</p><p>
   * Render the current page as the last of the current batch
   * 				in standard list form.
   * </p>
   */
  public java.lang.String getCurrentPageLast() {
    if (null != this.currentPageLast) {
      return this.currentPageLast;
    }
    ValueBinding _vb = getValueBinding("currentPageLast"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>currentPageLast</code> property.</p>
   */
  public void setCurrentPageLast(java.lang.String currentPageLast) {
    this.currentPageLast = currentPageLast;
  }


  private java.lang.String _for;

  /**
   * <p>Return the value of the <code>for</code> property.   * </p>
   */
  public java.lang.String getFor() {
    if (null != this._for) {
      return this._for;
    }
    ValueBinding _vb = getValueBinding("for"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>for</code> property.</p>
   */
  public void setFor(java.lang.String _for) {
    this._for = _for;
  }


  private java.lang.String numberOfPages;

  /**
   * <p>Return the value of the <code>numberOfPages</code> property.  Contents:</p><p>
   * The maximum number of pages to show at one time.
   * </p>
   */
  public java.lang.String getNumberOfPages() {
    if (null != this.numberOfPages) {
      return this.numberOfPages;
    }
    ValueBinding _vb = getValueBinding("numberOfPages"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>numberOfPages</code> property.</p>
   */
  public void setNumberOfPages(java.lang.String numberOfPages) {
    this.numberOfPages = numberOfPages;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.  Contents:</p><p>
   * Tabbing order for this component.
   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[10];
    _values[0] = super.saveState(_context);
    _values[1] = binaryNavigation;
    _values[2] = binding;
    _values[3] = currentPageLast;
    _values[4] = _for;
    _values[5] = numberOfPages;
    _values[6] = style;
    _values[7] = styleClass;
    _values[8] = tabindex;
    _values[9] = title;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binaryNavigation = (java.lang.String) _values[1];
    this.binding = (java.lang.String) _values[2];
    this.currentPageLast = (java.lang.String) _values[3];
    this._for = (java.lang.String) _values[4];
    this.numberOfPages = (java.lang.String) _values[5];
    this.style = (java.lang.String) _values[6];
    this.styleClass = (java.lang.String) _values[7];
    this.tabindex = (java.lang.String) _values[8];
    this.title = (java.lang.String) _values[9];
  }


}
