/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Actionbar</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPanelActionbar extends javax.faces.component.UIPanel {


  public HtmlPanelActionbar() {
    super();
    setRendererType("com.ibm.faces.Actionbar"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPanelActionbar"; //$NON-NLS-1$


  private java.lang.String autoseparate;

  /**
   * <p>Return the value of the <code>autoseparate</code> property.   * </p>
   */
  public java.lang.String getAutoseparate() {
    if (null != this.autoseparate) {
      return this.autoseparate;
    }
    ValueBinding _vb = getValueBinding("autoseparate"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>autoseparate</code> property.</p>
   */
  public void setAutoseparate(java.lang.String autoseparate) {
    this.autoseparate = autoseparate;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String height;

  /**
   * <p>Return the value of the <code>height</code> property.   * </p>
   */
  public java.lang.String getHeight() {
    if (null != this.height) {
      return this.height;
    }
    ValueBinding _vb = getValueBinding("height"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>height</code> property.</p>
   */
  public void setHeight(java.lang.String height) {
    this.height = height;
  }


  private java.lang.String layout;

  /**
   * <p>Return the value of the <code>layout</code> property.   * </p>
   */
  public java.lang.String getLayout() {
    if (null != this.layout) {
      return this.layout;
    }
    ValueBinding _vb = getValueBinding("layout"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>layout</code> property.</p>
   */
  public void setLayout(java.lang.String layout) {
    this.layout = layout;
  }


  private java.lang.String nestedExpanded;

  /**
   * <p>Return the value of the <code>nestedExpanded</code> property.   * </p>
   */
  public java.lang.String getNestedExpanded() {
    if (null != this.nestedExpanded) {
      return this.nestedExpanded;
    }
    ValueBinding _vb = getValueBinding("nestedExpanded"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>nestedExpanded</code> property.</p>
   */
  public void setNestedExpanded(java.lang.String nestedExpanded) {
    this.nestedExpanded = nestedExpanded;
  }


  private java.lang.String nestedImagePosition;

  /**
   * <p>Return the value of the <code>nestedImagePosition</code> property.   * </p>
   */
  public java.lang.String getNestedImagePosition() {
    if (null != this.nestedImagePosition) {
      return this.nestedImagePosition;
    }
    ValueBinding _vb = getValueBinding("nestedImagePosition"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>nestedImagePosition</code> property.</p>
   */
  public void setNestedImagePosition(java.lang.String nestedImagePosition) {
    this.nestedImagePosition = nestedImagePosition;
  }


  private java.lang.String nestedIndent;

  /**
   * <p>Return the value of the <code>nestedIndent</code> property.   * </p>
   */
  public java.lang.String getNestedIndent() {
    if (null != this.nestedIndent) {
      return this.nestedIndent;
    }
    ValueBinding _vb = getValueBinding("nestedIndent"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>nestedIndent</code> property.</p>
   */
  public void setNestedIndent(java.lang.String nestedIndent) {
    this.nestedIndent = nestedIndent;
  }


  private java.lang.String nestedTitleImage;

  /**
   * <p>Return the value of the <code>nestedTitleImage</code> property.   * </p>
   */
  public java.lang.String getNestedTitleImage() {
    if (null != this.nestedTitleImage) {
      return this.nestedTitleImage;
    }
    ValueBinding _vb = getValueBinding("nestedTitleImage"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>nestedTitleImage</code> property.</p>
   */
  public void setNestedTitleImage(java.lang.String nestedTitleImage) {
    this.nestedTitleImage = nestedTitleImage;
  }


  private java.lang.String nestedTitleText;

  /**
   * <p>Return the value of the <code>nestedTitleText</code> property.   * </p>
   */
  public java.lang.String getNestedTitleText() {
    if (null != this.nestedTitleText) {
      return this.nestedTitleText;
    }
    ValueBinding _vb = getValueBinding("nestedTitleText"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>nestedTitleText</code> property.</p>
   */
  public void setNestedTitleText(java.lang.String nestedTitleText) {
    this.nestedTitleText = nestedTitleText;
  }


  private java.lang.String separatorSize;

  /**
   * <p>Return the value of the <code>separatorSize</code> property.   * </p>
   */
  public java.lang.String getSeparatorSize() {
    if (null != this.separatorSize) {
      return this.separatorSize;
    }
    ValueBinding _vb = getValueBinding("separatorSize"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>separatorSize</code> property.</p>
   */
  public void setSeparatorSize(java.lang.String separatorSize) {
    this.separatorSize = separatorSize;
  }


  private java.lang.String separatorStyle;

  /**
   * <p>Return the value of the <code>separatorStyle</code> property.   * </p>
   */
  public java.lang.String getSeparatorStyle() {
    if (null != this.separatorStyle) {
      return this.separatorStyle;
    }
    ValueBinding _vb = getValueBinding("separatorStyle"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>separatorStyle</code> property.</p>
   */
  public void setSeparatorStyle(java.lang.String separatorStyle) {
    this.separatorStyle = separatorStyle;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style(s) to be applied when this component is
   * 				rendered.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * Space-separated list of CSS style class(es) to be
   * 				applied when this element is rendered. This value must
   * 				be passed through as the "class" property on generated
   * 				markup.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.  Contents:</p><p>
   * Tabindex only applied to nested tables so these can be
   * 				tabbed to as well as other components in the parent
   * 				panelActionbar
   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Set the title on rendered table.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[17];
    _values[0] = super.saveState(_context);
    _values[1] = autoseparate;
    _values[2] = binding;
    _values[3] = height;
    _values[4] = layout;
    _values[5] = nestedExpanded;
    _values[6] = nestedImagePosition;
    _values[7] = nestedIndent;
    _values[8] = nestedTitleImage;
    _values[9] = nestedTitleText;
    _values[10] = separatorSize;
    _values[11] = separatorStyle;
    _values[12] = style;
    _values[13] = styleClass;
    _values[14] = tabindex;
    _values[15] = title;
    _values[16] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.autoseparate = (java.lang.String) _values[1];
    this.binding = (java.lang.String) _values[2];
    this.height = (java.lang.String) _values[3];
    this.layout = (java.lang.String) _values[4];
    this.nestedExpanded = (java.lang.String) _values[5];
    this.nestedImagePosition = (java.lang.String) _values[6];
    this.nestedIndent = (java.lang.String) _values[7];
    this.nestedTitleImage = (java.lang.String) _values[8];
    this.nestedTitleText = (java.lang.String) _values[9];
    this.separatorSize = (java.lang.String) _values[10];
    this.separatorStyle = (java.lang.String) _values[11];
    this.style = (java.lang.String) _values[12];
    this.styleClass = (java.lang.String) _values[13];
    this.tabindex = (java.lang.String) _values[14];
    this.title = (java.lang.String) _values[15];
    this.width = (java.lang.String) _values[16];
  }


}
