/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Box</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPanelBox extends javax.faces.component.UIPanel {


  public HtmlPanelBox() {
    super();
    setRendererType("com.ibm.faces.Box"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPanelBox"; //$NON-NLS-1$


  private java.lang.String align;

  /**
   * <p>Return the value of the <code>align</code> property.   * </p>
   */
  public java.lang.String getAlign() {
    if (null != this.align) {
      return this.align;
    }
    ValueBinding _vb = getValueBinding("align"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>align</code> property.</p>
   */
  public void setAlign(java.lang.String align) {
    this.align = align;
  }


  private java.lang.String bgcolor;

  /**
   * <p>Return the value of the <code>bgcolor</code> property.   * </p>
   */
  public java.lang.String getBgcolor() {
    if (null != this.bgcolor) {
      return this.bgcolor;
    }
    ValueBinding _vb = getValueBinding("bgcolor"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>bgcolor</code> property.</p>
   */
  public void setBgcolor(java.lang.String bgcolor) {
    this.bgcolor = bgcolor;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String border;

  /**
   * <p>Return the value of the <code>border</code> property.   * </p>
   */
  public java.lang.String getBorder() {
    if (null != this.border) {
      return this.border;
    }
    ValueBinding _vb = getValueBinding("border"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>border</code> property.</p>
   */
  public void setBorder(java.lang.String border) {
    this.border = border;
  }


  private java.lang.String cellpadding;

  /**
   * <p>Return the value of the <code>cellpadding</code> property.   * </p>
   */
  public java.lang.String getCellpadding() {
    if (null != this.cellpadding) {
      return this.cellpadding;
    }
    ValueBinding _vb = getValueBinding("cellpadding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>cellpadding</code> property.</p>
   */
  public void setCellpadding(java.lang.String cellpadding) {
    this.cellpadding = cellpadding;
  }


  private java.lang.String cellspacing;

  /**
   * <p>Return the value of the <code>cellspacing</code> property.   * </p>
   */
  public java.lang.String getCellspacing() {
    if (null != this.cellspacing) {
      return this.cellspacing;
    }
    ValueBinding _vb = getValueBinding("cellspacing"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>cellspacing</code> property.</p>
   */
  public void setCellspacing(java.lang.String cellspacing) {
    this.cellspacing = cellspacing;
  }


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private java.lang.String height;

  /**
   * <p>Return the value of the <code>height</code> property.   * </p>
   */
  public java.lang.String getHeight() {
    if (null != this.height) {
      return this.height;
    }
    ValueBinding _vb = getValueBinding("height"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>height</code> property.</p>
   */
  public void setHeight(java.lang.String height) {
    this.height = height;
  }


  private java.lang.String lang;

  /**
   * <p>Return the value of the <code>lang</code> property.   * </p>
   */
  public java.lang.String getLang() {
    if (null != this.lang) {
      return this.lang;
    }
    ValueBinding _vb = getValueBinding("lang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lang</code> property.</p>
   */
  public void setLang(java.lang.String lang) {
    this.lang = lang;
  }


  private java.lang.String layout;

  /**
   * <p>Return the value of the <code>layout</code> property.   * </p>
   */
  public java.lang.String getLayout() {
    if (null != this.layout) {
      return this.layout;
    }
    ValueBinding _vb = getValueBinding("layout"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>layout</code> property.</p>
   */
  public void setLayout(java.lang.String layout) {
    this.layout = layout;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String valign;

  /**
   * <p>Return the value of the <code>valign</code> property.   * </p>
   */
  public java.lang.String getValign() {
    if (null != this.valign) {
      return this.valign;
    }
    ValueBinding _vb = getValueBinding("valign"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>valign</code> property.</p>
   */
  public void setValign(java.lang.String valign) {
    this.valign = valign;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[16];
    _values[0] = super.saveState(_context);
    _values[1] = align;
    _values[2] = bgcolor;
    _values[3] = binding;
    _values[4] = border;
    _values[5] = cellpadding;
    _values[6] = cellspacing;
    _values[7] = dir;
    _values[8] = height;
    _values[9] = lang;
    _values[10] = layout;
    _values[11] = style;
    _values[12] = styleClass;
    _values[13] = title;
    _values[14] = valign;
    _values[15] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.align = (java.lang.String) _values[1];
    this.bgcolor = (java.lang.String) _values[2];
    this.binding = (java.lang.String) _values[3];
    this.border = (java.lang.String) _values[4];
    this.cellpadding = (java.lang.String) _values[5];
    this.cellspacing = (java.lang.String) _values[6];
    this.dir = (java.lang.String) _values[7];
    this.height = (java.lang.String) _values[8];
    this.lang = (java.lang.String) _values[9];
    this.layout = (java.lang.String) _values[10];
    this.style = (java.lang.String) _values[11];
    this.styleClass = (java.lang.String) _values[12];
    this.title = (java.lang.String) _values[13];
    this.valign = (java.lang.String) _values[14];
    this.width = (java.lang.String) _values[15];
  }


}
