/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.FormBox</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPanelFormBox extends javax.faces.component.UIPanel {


  public HtmlPanelFormBox() {
    super();
    setRendererType("com.ibm.faces.FormBox"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPanelFormBox"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private boolean escape = false;
  private boolean escape_set = false;

  /**
   * <p>Return the value of the <code>escape</code> property.  Contents:</p><p>
   * Boolean value indicating whether or not label is to
   * 					be escaped.
   * </p>
   */
  public boolean isEscape() {
    if (this.escape_set) {
      return this.escape;
    }
    ValueBinding _vb = getValueBinding("escape"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.escape;
    }
  }

  /**
   * <p>Set the value of the <code>escape</code> property.</p>
   */
  public void setEscape(boolean escape) {
    this.escape = escape;
    this.escape_set = true;
  }


  private java.lang.String helpPosition;

  /**
   * <p>Return the value of the <code>helpPosition</code> property.  Contents:</p><p>
   * Specifies the visual position of the child formItem's 
   * 					errorText and infoText messages, relative to the respective 
   * 					formItems. ErrorText and infoText messages can be over,
   * 					under, to the left, or to the right of a formItem.
   * </p>
   */
  public java.lang.String getHelpPosition() {
    if (null != this.helpPosition) {
      return this.helpPosition;
    }
    ValueBinding _vb = getValueBinding("helpPosition"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>helpPosition</code> property.</p>
   */
  public void setHelpPosition(java.lang.String helpPosition) {
    this.helpPosition = helpPosition;
  }


  private java.lang.String interItemSpacing;

  /**
   * <p>Return the value of the <code>interItemSpacing</code> property.  Contents:</p><p>
   * Specifies distance between each formItem
   * </p>
   */
  public java.lang.String getInterItemSpacing() {
    if (null != this.interItemSpacing) {
      return this.interItemSpacing;
    }
    ValueBinding _vb = getValueBinding("interItemSpacing"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>interItemSpacing</code> property.</p>
   */
  public void setInterItemSpacing(java.lang.String interItemSpacing) {
    this.interItemSpacing = interItemSpacing;
  }


  private java.lang.String label;

  /**
   * <p>Return the value of the <code>label</code> property.  Contents:</p><p>
   * This attribute's value will be displayed in the title 
   * 				bar of the formBox.
   * </p>
   */
  public java.lang.String getLabel() {
    if (null != this.label) {
      return this.label;
    }
    ValueBinding _vb = getValueBinding("label"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>label</code> property.</p>
   */
  public void setLabel(java.lang.String label) {
    this.label = label;
  }


  private java.lang.String labelPosition;

  /**
   * <p>Return the value of the <code>labelPosition</code> property.  Contents:</p><p>
   * Specifies the visual position of the child formItems' 
   * 				labels, relative to the respective formItems (a label 
   * 				can be over, under, to the left, or to the right of a 
   * 				formItem).
   * </p>
   */
  public java.lang.String getLabelPosition() {
    if (null != this.labelPosition) {
      return this.labelPosition;
    }
    ValueBinding _vb = getValueBinding("labelPosition"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>labelPosition</code> property.</p>
   */
  public void setLabelPosition(java.lang.String labelPosition) {
    this.labelPosition = labelPosition;
  }


  private java.lang.String showInPopup;

  /**
   * <p>Return the value of the <code>showInPopup</code> property.  Contents:</p><p>
   * This attribute allows users to specify to show info
   * 						message and error message with popup window.
   * </p>
   */
  public java.lang.String getShowInPopup() {
    if (null != this.showInPopup) {
      return this.showInPopup;
    }
    ValueBinding _vb = getValueBinding("showInPopup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>showInPopup</code> property.</p>
   */
  public void setShowInPopup(java.lang.String showInPopup) {
    this.showInPopup = showInPopup;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style(s) to be applied when this component is
   * 				rendered.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * Space-separated list of CSS style class(es) to be
   * 					applied when this element is rendered. This value must
   * 					be passed through as the "class" property on generated
   * 					markup.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String widthContent;

  /**
   * <p>Return the value of the <code>widthContent</code> property.  Contents:</p><p>
   * Specifies width of table cells for the child
   * 				formItems' input fields
   * </p>
   */
  public java.lang.String getWidthContent() {
    if (null != this.widthContent) {
      return this.widthContent;
    }
    ValueBinding _vb = getValueBinding("widthContent"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>widthContent</code> property.</p>
   */
  public void setWidthContent(java.lang.String widthContent) {
    this.widthContent = widthContent;
  }


  private java.lang.String widthHelp;

  /**
   * <p>Return the value of the <code>widthHelp</code> property.  Contents:</p><p>
   * Specifies width of table cells for the child
   * 				formItems' info or error texts
   * </p>
   */
  public java.lang.String getWidthHelp() {
    if (null != this.widthHelp) {
      return this.widthHelp;
    }
    ValueBinding _vb = getValueBinding("widthHelp"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>widthHelp</code> property.</p>
   */
  public void setWidthHelp(java.lang.String widthHelp) {
    this.widthHelp = widthHelp;
  }


  private java.lang.String widthLabel;

  /**
   * <p>Return the value of the <code>widthLabel</code> property.  Contents:</p><p>
   * Specifies width of table cells for the child
   * 				formItems' labels
   * </p>
   */
  public java.lang.String getWidthLabel() {
    if (null != this.widthLabel) {
      return this.widthLabel;
    }
    ValueBinding _vb = getValueBinding("widthLabel"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>widthLabel</code> property.</p>
   */
  public void setWidthLabel(java.lang.String widthLabel) {
    this.widthLabel = widthLabel;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[15];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = this.escape ? Boolean.TRUE : Boolean.FALSE;
    _values[3] = this.escape_set ? Boolean.TRUE : Boolean.FALSE;
    _values[4] = helpPosition;
    _values[5] = interItemSpacing;
    _values[6] = label;
    _values[7] = labelPosition;
    _values[8] = showInPopup;
    _values[9] = style;
    _values[10] = styleClass;
    _values[11] = title;
    _values[12] = widthContent;
    _values[13] = widthHelp;
    _values[14] = widthLabel;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.escape = ((Boolean) _values[2]).booleanValue();
    this.escape_set = ((Boolean) _values[3]).booleanValue();
    this.helpPosition = (java.lang.String) _values[4];
    this.interItemSpacing = (java.lang.String) _values[5];
    this.label = (java.lang.String) _values[6];
    this.labelPosition = (java.lang.String) _values[7];
    this.showInPopup = (java.lang.String) _values[8];
    this.style = (java.lang.String) _values[9];
    this.styleClass = (java.lang.String) _values[10];
    this.title = (java.lang.String) _values[11];
    this.widthContent = (java.lang.String) _values[12];
    this.widthHelp = (java.lang.String) _values[13];
    this.widthLabel = (java.lang.String) _values[14];
  }


}
