/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Layout</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPanelLayout extends javax.faces.component.UIPanel {


  public HtmlPanelLayout() {
    super();
    setRendererType("com.ibm.faces.Layout"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPanelLayout"; //$NON-NLS-1$


  private java.lang.String align;

  /**
   * <p>Return the value of the <code>align</code> property.   * </p>
   */
  public java.lang.String getAlign() {
    if (null != this.align) {
      return this.align;
    }
    ValueBinding _vb = getValueBinding("align"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>align</code> property.</p>
   */
  public void setAlign(java.lang.String align) {
    this.align = align;
  }


  private java.lang.String bgcolor;

  /**
   * <p>Return the value of the <code>bgcolor</code> property.   * </p>
   */
  public java.lang.String getBgcolor() {
    if (null != this.bgcolor) {
      return this.bgcolor;
    }
    ValueBinding _vb = getValueBinding("bgcolor"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>bgcolor</code> property.</p>
   */
  public void setBgcolor(java.lang.String bgcolor) {
    this.bgcolor = bgcolor;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String border;

  /**
   * <p>Return the value of the <code>border</code> property.   * </p>
   */
  public java.lang.String getBorder() {
    if (null != this.border) {
      return this.border;
    }
    ValueBinding _vb = getValueBinding("border"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>border</code> property.</p>
   */
  public void setBorder(java.lang.String border) {
    this.border = border;
  }


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.  Contents:</p><p>
   * Text direction for directionally neutral text, values
   * 				can be "LTR" (left to right) or "RTL" (right to left).
   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private java.lang.String frame;

  /**
   * <p>Return the value of the <code>frame</code> property.   * </p>
   */
  public java.lang.String getFrame() {
    if (null != this.frame) {
      return this.frame;
    }
    ValueBinding _vb = getValueBinding("frame"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>frame</code> property.</p>
   */
  public void setFrame(java.lang.String frame) {
    this.frame = frame;
  }


  private java.lang.String height;

  /**
   * <p>Return the value of the <code>height</code> property.   * </p>
   */
  public java.lang.String getHeight() {
    if (null != this.height) {
      return this.height;
    }
    ValueBinding _vb = getValueBinding("height"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>height</code> property.</p>
   */
  public void setHeight(java.lang.String height) {
    this.height = height;
  }


  private java.lang.String lang;

  /**
   * <p>Return the value of the <code>lang</code> property.  Contents:</p><p>
   * Specifies the base language of attributes and text
   * 				context for this component
   * </p>
   */
  public java.lang.String getLang() {
    if (null != this.lang) {
      return this.lang;
    }
    ValueBinding _vb = getValueBinding("lang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lang</code> property.</p>
   */
  public void setLang(java.lang.String lang) {
    this.lang = lang;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String summary;

  /**
   * <p>Return the value of the <code>summary</code> property.   * </p>
   */
  public java.lang.String getSummary() {
    if (null != this.summary) {
      return this.summary;
    }
    ValueBinding _vb = getValueBinding("summary"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>summary</code> property.</p>
   */
  public void setSummary(java.lang.String summary) {
    this.summary = summary;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[14];
    _values[0] = super.saveState(_context);
    _values[1] = align;
    _values[2] = bgcolor;
    _values[3] = binding;
    _values[4] = border;
    _values[5] = dir;
    _values[6] = frame;
    _values[7] = height;
    _values[8] = lang;
    _values[9] = style;
    _values[10] = styleClass;
    _values[11] = summary;
    _values[12] = title;
    _values[13] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.align = (java.lang.String) _values[1];
    this.bgcolor = (java.lang.String) _values[2];
    this.binding = (java.lang.String) _values[3];
    this.border = (java.lang.String) _values[4];
    this.dir = (java.lang.String) _values[5];
    this.frame = (java.lang.String) _values[6];
    this.height = (java.lang.String) _values[7];
    this.lang = (java.lang.String) _values[8];
    this.style = (java.lang.String) _values[9];
    this.styleClass = (java.lang.String) _values[10];
    this.summary = (java.lang.String) _values[11];
    this.title = (java.lang.String) _values[12];
    this.width = (java.lang.String) _values[13];
  }


}
