/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Menu</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPanelMenu extends javax.faces.component.UIPanel {


  public HtmlPanelMenu() {
    super();
    setRendererType("com.ibm.faces.Menu"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPanelMenu"; //$NON-NLS-1$


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String flyOpen;

  /**
   * <p>Return the value of the <code>flyOpen</code> property.  Contents:</p><p>
   * Do the menus "fly-open" when you mouse over them or is one always displayed (the last one used).
   * 				Default is true.
   * </p>
   */
  public java.lang.String getFlyOpen() {
    if (null != this.flyOpen) {
      return this.flyOpen;
    }
    ValueBinding _vb = getValueBinding("flyOpen"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>flyOpen</code> property.</p>
   */
  public void setFlyOpen(java.lang.String flyOpen) {
    this.flyOpen = flyOpen;
  }


  private java.lang.String flyOpenBody;

  /**
   * <p>Return the value of the <code>flyOpenBody</code> property.  Contents:</p><p>
   * For the sub-menus (menus below the top-level), determines if sub-menus below them are
   * 			       	displayed when you mouse over a menu item (true) or when you click on a menu item (false).
   * 			       	For example, in the Windows menu bar, this is "true" -- sub-menus are displayed when you
   * 			       	mouse over them. Default to true.
   * </p>
   */
  public java.lang.String getFlyOpenBody() {
    if (null != this.flyOpenBody) {
      return this.flyOpenBody;
    }
    ValueBinding _vb = getValueBinding("flyOpenBody"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>flyOpenBody</code> property.</p>
   */
  public void setFlyOpenBody(java.lang.String flyOpenBody) {
    this.flyOpenBody = flyOpenBody;
  }


  private java.lang.String initialSelection;

  /**
   * <p>Return the value of the <code>initialSelection</code> property.  Contents:</p><p>
   * If fly-open is false, which menu is initially selected.
   * </p>
   */
  public java.lang.String getInitialSelection() {
    if (null != this.initialSelection) {
      return this.initialSelection;
    }
    ValueBinding _vb = getValueBinding("initialSelection"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>initialSelection</code> property.</p>
   */
  public void setInitialSelection(java.lang.String initialSelection) {
    this.initialSelection = initialSelection;
  }


  private java.lang.String onchange;

  /**
   * <p>Return the value of the <code>onchange</code> property.  Contents:</p><p>
   * If provided, the function is called whenever a "leaf" is clicked (i.e., an action
   * 			       	is taken). The function is called after the menu item is "clicked" (e.g., if the
   * 			       	menu item is a link, the link will be clicked and then this function called). The
   * 			       	selection hidden field should be added to the page if this is used -- the selected
   * 			       	item is specified as the value of this field. Defaults to false.
   * </p>
   */
  public java.lang.String getOnchange() {
    if (null != this.onchange) {
      return this.onchange;
    }
    ValueBinding _vb = getValueBinding("onchange"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onchange</code> property.</p>
   */
  public void setOnchange(java.lang.String onchange) {
    this.onchange = onchange;
  }


  private java.lang.String openInPlace;

  /**
   * <p>Return the value of the <code>openInPlace</code> property.  Contents:</p><p>
   * By default, sub-menus are displayed in a 'separate window" (that is, they float above
   * 			       	the page content). If open-in-place is set to true, the sub-menus open "in-place", that
   * 			       	is, space is opened up in the menu bar after the parent menu item and the sub-menu is
   * 			       	displayed in that space. This allows a menu to be "tree-style" (like Windows explorer).
   * 			       	Only one sub-menu at each level of the menu tree is displayed "in-place" -- if you pick
   * 			       	a different sub-menu to display, any other menu that is displayed in-place is "closed"
   * 			       	(hidden) before the new sub-menu is displayed. Defaults to false.
   * </p>
   */
  public java.lang.String getOpenInPlace() {
    if (null != this.openInPlace) {
      return this.openInPlace;
    }
    ValueBinding _vb = getValueBinding("openInPlace"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>openInPlace</code> property.</p>
   */
  public void setOpenInPlace(java.lang.String openInPlace) {
    this.openInPlace = openInPlace;
  }


  private java.lang.String openSticky;

  /**
   * <p>Return the value of the <code>openSticky</code> property.  Contents:</p><p>
   * By default, sub-menus are displayed as "pop-ups" that are only on display when they are
   * 			       	"active" (they parent menu item has been moused-over or clicked on). If open-sticky is
   * 			       	set to true, for each level below the main menu, the last sub-menu that is moused/clicked
   * 			       	at that level is left on display. Defaults to true for other than top-level.
   * </p>
   */
  public java.lang.String getOpenSticky() {
    if (null != this.openSticky) {
      return this.openSticky;
    }
    ValueBinding _vb = getValueBinding("openSticky"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>openSticky</code> property.</p>
   */
  public void setOpenSticky(java.lang.String openSticky) {
    this.openSticky = openSticky;
  }


  private java.lang.String selectAll;

  /**
   * <p>Return the value of the <code>selectAll</code> property.  Contents:</p><p>
   * If a selection is used, specifies if only the leafmost item is shown selected
   * 			       	(false) or if all items from the containing parent menu down to the leafmost
   * 			       	item are shown as selected. Defaults to false.
   * </p>
   */
  public java.lang.String getSelectAll() {
    if (null != this.selectAll) {
      return this.selectAll;
    }
    ValueBinding _vb = getValueBinding("selectAll"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>selectAll</code> property.</p>
   */
  public void setSelectAll(java.lang.String selectAll) {
    this.selectAll = selectAll;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style(s) to be applied when this component is
   * 				rendered.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * Space-separated list of CSS style class(es) to be
   * 				applied when this element is rendered. This value must
   * 				be passed through as the "class" property on generated
   * 				markup.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabIndex;

  /**
   * <p>Return the value of the <code>tabIndex</code> property.  Contents:</p><p>
   * The tab index for the menu component.
   * 				Default is 0.
   * </p>
   */
  public java.lang.String getTabIndex() {
    if (null != this.tabIndex) {
      return this.tabIndex;
    }
    ValueBinding _vb = getValueBinding("tabIndex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabIndex</code> property.</p>
   */
  public void setTabIndex(java.lang.String tabIndex) {
    this.tabIndex = tabIndex;
  }


  private java.lang.String vertical;

  /**
   * <p>Return the value of the <code>vertical</code> property.  Contents:</p><p>
   * Is the top level menu vertical (true) or horizontal (false).
   * 				Default is false.
   * </p>
   */
  public java.lang.String getVertical() {
    if (null != this.vertical) {
      return this.vertical;
    }
    ValueBinding _vb = getValueBinding("vertical"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>vertical</code> property.</p>
   */
  public void setVertical(java.lang.String vertical) {
    this.vertical = vertical;
  }


  private java.lang.String verticalBody;

  /**
   * <p>Return the value of the <code>verticalBody</code> property.  Contents:</p><p>
   * Are the lower-level menus vertical (true) or horizontal (false).
   * 				Default is true.
   * </p>
   */
  public java.lang.String getVerticalBody() {
    if (null != this.verticalBody) {
      return this.verticalBody;
    }
    ValueBinding _vb = getValueBinding("verticalBody"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>verticalBody</code> property.</p>
   */
  public void setVerticalBody(java.lang.String verticalBody) {
    this.verticalBody = verticalBody;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[14];
    _values[0] = super.saveState(_context);
    _values[1] = binding;
    _values[2] = flyOpen;
    _values[3] = flyOpenBody;
    _values[4] = initialSelection;
    _values[5] = onchange;
    _values[6] = openInPlace;
    _values[7] = openSticky;
    _values[8] = selectAll;
    _values[9] = style;
    _values[10] = styleClass;
    _values[11] = tabIndex;
    _values[12] = vertical;
    _values[13] = verticalBody;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.binding = (java.lang.String) _values[1];
    this.flyOpen = (java.lang.String) _values[2];
    this.flyOpenBody = (java.lang.String) _values[3];
    this.initialSelection = (java.lang.String) _values[4];
    this.onchange = (java.lang.String) _values[5];
    this.openInPlace = (java.lang.String) _values[6];
    this.openSticky = (java.lang.String) _values[7];
    this.selectAll = (java.lang.String) _values[8];
    this.style = (java.lang.String) _values[9];
    this.styleClass = (java.lang.String) _values[10];
    this.tabIndex = (java.lang.String) _values[11];
    this.vertical = (java.lang.String) _values[12];
    this.verticalBody = (java.lang.String) _values[13];
  }


}
