/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.RealPlayer</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlPlayerRealPlayer extends com.ibm.faces.component.UIPlayer {


  public HtmlPlayerRealPlayer() {
    super();
    setRendererType("com.ibm.faces.RealPlayer"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlPlayerRealPlayer"; //$NON-NLS-1$


  private java.lang.String accesskey;

  /**
   * <p>Return the value of the <code>accesskey</code> property.  Contents:</p><p>
   * Access key to put focus on this compoent.
   * </p>
   */
  public java.lang.String getAccesskey() {
    if (null != this.accesskey) {
      return this.accesskey;
    }
    ValueBinding _vb = getValueBinding("accesskey"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>accesskey</code> property.</p>
   */
  public void setAccesskey(java.lang.String accesskey) {
    this.accesskey = accesskey;
  }


  private java.lang.String align;

  /**
   * <p>Return the value of the <code>align</code> property.   * </p>
   */
  public java.lang.String getAlign() {
    if (null != this.align) {
      return this.align;
    }
    ValueBinding _vb = getValueBinding("align"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>align</code> property.</p>
   */
  public void setAlign(java.lang.String align) {
    this.align = align;
  }


  private java.lang.String alt;

  /**
   * <p>Return the value of the <code>alt</code> property.   * </p>
   */
  public java.lang.String getAlt() {
    if (null != this.alt) {
      return this.alt;
    }
    ValueBinding _vb = getValueBinding("alt"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>alt</code> property.</p>
   */
  public void setAlt(java.lang.String alt) {
    this.alt = alt;
  }


  private java.lang.String archive;

  /**
   * <p>Return the value of the <code>archive</code> property.   * </p>
   */
  public java.lang.String getArchive() {
    if (null != this.archive) {
      return this.archive;
    }
    ValueBinding _vb = getValueBinding("archive"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>archive</code> property.</p>
   */
  public void setArchive(java.lang.String archive) {
    this.archive = archive;
  }


  private java.lang.String autoStart;

  /**
   * <p>Return the value of the <code>autoStart</code> property.   * </p>
   */
  public java.lang.String getAutoStart() {
    if (null != this.autoStart) {
      return this.autoStart;
    }
    ValueBinding _vb = getValueBinding("autoStart"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>autoStart</code> property.</p>
   */
  public void setAutoStart(java.lang.String autoStart) {
    this.autoStart = autoStart;
  }


  private java.lang.String backgroundcolor;

  /**
   * <p>Return the value of the <code>backgroundcolor</code> property.   * </p>
   */
  public java.lang.String getBackgroundcolor() {
    if (null != this.backgroundcolor) {
      return this.backgroundcolor;
    }
    ValueBinding _vb = getValueBinding("backgroundcolor"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>backgroundcolor</code> property.</p>
   */
  public void setBackgroundcolor(java.lang.String backgroundcolor) {
    this.backgroundcolor = backgroundcolor;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String border;

  /**
   * <p>Return the value of the <code>border</code> property.   * </p>
   */
  public java.lang.String getBorder() {
    if (null != this.border) {
      return this.border;
    }
    ValueBinding _vb = getValueBinding("border"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>border</code> property.</p>
   */
  public void setBorder(java.lang.String border) {
    this.border = border;
  }


  private java.lang.String center;

  /**
   * <p>Return the value of the <code>center</code> property.   * </p>
   */
  public java.lang.String getCenter() {
    if (null != this.center) {
      return this.center;
    }
    ValueBinding _vb = getValueBinding("center"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>center</code> property.</p>
   */
  public void setCenter(java.lang.String center) {
    this.center = center;
  }


  private java.lang.String codebase;

  /**
   * <p>Return the value of the <code>codebase</code> property.   * </p>
   */
  public java.lang.String getCodebase() {
    if (null != this.codebase) {
      return this.codebase;
    }
    ValueBinding _vb = getValueBinding("codebase"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>codebase</code> property.</p>
   */
  public void setCodebase(java.lang.String codebase) {
    this.codebase = codebase;
  }


  private java.lang.String console;

  /**
   * <p>Return the value of the <code>console</code> property.  Contents:</p><p>
   * Name for a RealPlayer console, multiple consoles can be
   * 				used to play one media file.
   * </p>
   */
  public java.lang.String getConsole() {
    if (null != this.console) {
      return this.console;
    }
    ValueBinding _vb = getValueBinding("console"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>console</code> property.</p>
   */
  public void setConsole(java.lang.String console) {
    this.console = console;
  }


  private java.lang.String controls;

  /**
   * <p>Return the value of the <code>controls</code> property.  Contents:</p><p>
   * Display settings for a RealPlayer console, default is
   * 				all controls displayed.
   * </p>
   */
  public java.lang.String getControls() {
    if (null != this.controls) {
      return this.controls;
    }
    ValueBinding _vb = getValueBinding("controls"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>controls</code> property.</p>
   */
  public void setControls(java.lang.String controls) {
    this.controls = controls;
  }


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.  Contents:</p><p>
   * Text direction for directionally neutral text, values
   * 				can be "LTR" (left to right) or "RTL" (right to left).
   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private java.lang.String height;

  /**
   * <p>Return the value of the <code>height</code> property.   * </p>
   */
  public java.lang.String getHeight() {
    if (null != this.height) {
      return this.height;
    }
    ValueBinding _vb = getValueBinding("height"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>height</code> property.</p>
   */
  public void setHeight(java.lang.String height) {
    this.height = height;
  }


  private java.lang.String hspace;

  /**
   * <p>Return the value of the <code>hspace</code> property.   * </p>
   */
  public java.lang.String getHspace() {
    if (null != this.hspace) {
      return this.hspace;
    }
    ValueBinding _vb = getValueBinding("hspace"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>hspace</code> property.</p>
   */
  public void setHspace(java.lang.String hspace) {
    this.hspace = hspace;
  }


  private java.lang.String lang;

  /**
   * <p>Return the value of the <code>lang</code> property.  Contents:</p><p>
   * Specifies the base language of attributes and text
   * 				context for this component
   * </p>
   */
  public java.lang.String getLang() {
    if (null != this.lang) {
      return this.lang;
    }
    ValueBinding _vb = getValueBinding("lang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lang</code> property.</p>
   */
  public void setLang(java.lang.String lang) {
    this.lang = lang;
  }


  private java.lang.String loop;

  /**
   * <p>Return the value of the <code>loop</code> property.   * </p>
   */
  public java.lang.String getLoop() {
    if (null != this.loop) {
      return this.loop;
    }
    ValueBinding _vb = getValueBinding("loop"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>loop</code> property.</p>
   */
  public void setLoop(java.lang.String loop) {
    this.loop = loop;
  }


  private java.lang.String mimeType;

  /**
   * <p>Return the value of the <code>mimeType</code> property.  Contents:</p><p>
   * Used for declaring the media MIME type when src is bound
   * 				to binary data
   * </p>
   */
  public java.lang.String getMimeType() {
    if (null != this.mimeType) {
      return this.mimeType;
    }
    ValueBinding _vb = getValueBinding("mimeType"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>mimeType</code> property.</p>
   */
  public void setMimeType(java.lang.String mimeType) {
    this.mimeType = mimeType;
  }


  private java.lang.String onblur;

  /**
   * <p>Return the value of the <code>onblur</code> property.  Contents:</p><p>
   * onblur javascript event
   * </p>
   */
  public java.lang.String getOnblur() {
    if (null != this.onblur) {
      return this.onblur;
    }
    ValueBinding _vb = getValueBinding("onblur"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onblur</code> property.</p>
   */
  public void setOnblur(java.lang.String onblur) {
    this.onblur = onblur;
  }


  private java.lang.String onclick;

  /**
   * <p>Return the value of the <code>onclick</code> property.  Contents:</p><p>
   * Javascript onclick event
   * </p>
   */
  public java.lang.String getOnclick() {
    if (null != this.onclick) {
      return this.onclick;
    }
    ValueBinding _vb = getValueBinding("onclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onclick</code> property.</p>
   */
  public void setOnclick(java.lang.String onclick) {
    this.onclick = onclick;
  }


  private java.lang.String ondblclick;

  /**
   * <p>Return the value of the <code>ondblclick</code> property.  Contents:</p><p>
   * Javascript double click event
   * </p>
   */
  public java.lang.String getOndblclick() {
    if (null != this.ondblclick) {
      return this.ondblclick;
    }
    ValueBinding _vb = getValueBinding("ondblclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>ondblclick</code> property.</p>
   */
  public void setOndblclick(java.lang.String ondblclick) {
    this.ondblclick = ondblclick;
  }


  private java.lang.String onfocus;

  /**
   * <p>Return the value of the <code>onfocus</code> property.  Contents:</p><p>
   * onfocus javascript event
   * </p>
   */
  public java.lang.String getOnfocus() {
    if (null != this.onfocus) {
      return this.onfocus;
    }
    ValueBinding _vb = getValueBinding("onfocus"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocus</code> property.</p>
   */
  public void setOnfocus(java.lang.String onfocus) {
    this.onfocus = onfocus;
  }


  private java.lang.String onkeydown;

  /**
   * <p>Return the value of the <code>onkeydown</code> property.  Contents:</p><p>
   * Javascript key down event
   * </p>
   */
  public java.lang.String getOnkeydown() {
    if (null != this.onkeydown) {
      return this.onkeydown;
    }
    ValueBinding _vb = getValueBinding("onkeydown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeydown</code> property.</p>
   */
  public void setOnkeydown(java.lang.String onkeydown) {
    this.onkeydown = onkeydown;
  }


  private java.lang.String onkeypress;

  /**
   * <p>Return the value of the <code>onkeypress</code> property.  Contents:</p><p>
   * Javascript key press event
   * </p>
   */
  public java.lang.String getOnkeypress() {
    if (null != this.onkeypress) {
      return this.onkeypress;
    }
    ValueBinding _vb = getValueBinding("onkeypress"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeypress</code> property.</p>
   */
  public void setOnkeypress(java.lang.String onkeypress) {
    this.onkeypress = onkeypress;
  }


  private java.lang.String onkeyup;

  /**
   * <p>Return the value of the <code>onkeyup</code> property.  Contents:</p><p>
   * Javascript key up event
   * </p>
   */
  public java.lang.String getOnkeyup() {
    if (null != this.onkeyup) {
      return this.onkeyup;
    }
    ValueBinding _vb = getValueBinding("onkeyup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeyup</code> property.</p>
   */
  public void setOnkeyup(java.lang.String onkeyup) {
    this.onkeyup = onkeyup;
  }


  private java.lang.String onmousedown;

  /**
   * <p>Return the value of the <code>onmousedown</code> property.  Contents:</p><p>
   * Javascript mouse button press event
   * </p>
   */
  public java.lang.String getOnmousedown() {
    if (null != this.onmousedown) {
      return this.onmousedown;
    }
    ValueBinding _vb = getValueBinding("onmousedown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousedown</code> property.</p>
   */
  public void setOnmousedown(java.lang.String onmousedown) {
    this.onmousedown = onmousedown;
  }


  private java.lang.String onmousemove;

  /**
   * <p>Return the value of the <code>onmousemove</code> property.  Contents:</p><p>
   * Javascript mouse move event
   * </p>
   */
  public java.lang.String getOnmousemove() {
    if (null != this.onmousemove) {
      return this.onmousemove;
    }
    ValueBinding _vb = getValueBinding("onmousemove"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousemove</code> property.</p>
   */
  public void setOnmousemove(java.lang.String onmousemove) {
    this.onmousemove = onmousemove;
  }


  private java.lang.String onmouseout;

  /**
   * <p>Return the value of the <code>onmouseout</code> property.  Contents:</p><p>
   * Javascript mouse out event
   * </p>
   */
  public java.lang.String getOnmouseout() {
    if (null != this.onmouseout) {
      return this.onmouseout;
    }
    ValueBinding _vb = getValueBinding("onmouseout"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseout</code> property.</p>
   */
  public void setOnmouseout(java.lang.String onmouseout) {
    this.onmouseout = onmouseout;
  }


  private java.lang.String onmouseover;

  /**
   * <p>Return the value of the <code>onmouseover</code> property.  Contents:</p><p>
   * Javascript mouse over event
   * </p>
   */
  public java.lang.String getOnmouseover() {
    if (null != this.onmouseover) {
      return this.onmouseover;
    }
    ValueBinding _vb = getValueBinding("onmouseover"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseover</code> property.</p>
   */
  public void setOnmouseover(java.lang.String onmouseover) {
    this.onmouseover = onmouseover;
  }


  private java.lang.String onmouseup;

  /**
   * <p>Return the value of the <code>onmouseup</code> property.  Contents:</p><p>
   * Javascript mouse button release event
   * </p>
   */
  public java.lang.String getOnmouseup() {
    if (null != this.onmouseup) {
      return this.onmouseup;
    }
    ValueBinding _vb = getValueBinding("onmouseup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseup</code> property.</p>
   */
  public void setOnmouseup(java.lang.String onmouseup) {
    this.onmouseup = onmouseup;
  }


  private java.lang.String playerAttributes;

  /**
   * <p>Return the value of the <code>playerAttributes</code> property.  Contents:</p><p>
   * For adding a list of additional player
   * 				propertys/parameters, the list should be a comma
   * 				seperated list of name=value pairs
   * </p>
   */
  public java.lang.String getPlayerAttributes() {
    if (null != this.playerAttributes) {
      return this.playerAttributes;
    }
    ValueBinding _vb = getValueBinding("playerAttributes"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>playerAttributes</code> property.</p>
   */
  public void setPlayerAttributes(java.lang.String playerAttributes) {
    this.playerAttributes = playerAttributes;
  }


  private java.lang.String shuffle;

  /**
   * <p>Return the value of the <code>shuffle</code> property.   * </p>
   */
  public java.lang.String getShuffle() {
    if (null != this.shuffle) {
      return this.shuffle;
    }
    ValueBinding _vb = getValueBinding("shuffle"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>shuffle</code> property.</p>
   */
  public void setShuffle(java.lang.String shuffle) {
    this.shuffle = shuffle;
  }


  private java.lang.Object src;

  /**
   * <p>Return the value of the <code>src</code> property.   * </p>
   */
  public java.lang.Object getSrc() {
    if (null != this.src) {
      return this.src;
    }
    ValueBinding _vb = getValueBinding("src"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.Object) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>src</code> property.</p>
   */
  public void setSrc(java.lang.Object src) {
    this.src = src;
  }


  private java.lang.String standby;

  /**
   * <p>Return the value of the <code>standby</code> property.   * </p>
   */
  public java.lang.String getStandby() {
    if (null != this.standby) {
      return this.standby;
    }
    ValueBinding _vb = getValueBinding("standby"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>standby</code> property.</p>
   */
  public void setStandby(java.lang.String standby) {
    this.standby = standby;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.  Contents:</p><p>
   * Tabbing order for this component.
   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.String vspace;

  /**
   * <p>Return the value of the <code>vspace</code> property.   * </p>
   */
  public java.lang.String getVspace() {
    if (null != this.vspace) {
      return this.vspace;
    }
    ValueBinding _vb = getValueBinding("vspace"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>vspace</code> property.</p>
   */
  public void setVspace(java.lang.String vspace) {
    this.vspace = vspace;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[41];
    _values[0] = super.saveState(_context);
    _values[1] = accesskey;
    _values[2] = align;
    _values[3] = alt;
    _values[4] = archive;
    _values[5] = autoStart;
    _values[6] = backgroundcolor;
    _values[7] = binding;
    _values[8] = border;
    _values[9] = center;
    _values[10] = codebase;
    _values[11] = console;
    _values[12] = controls;
    _values[13] = dir;
    _values[14] = height;
    _values[15] = hspace;
    _values[16] = lang;
    _values[17] = loop;
    _values[18] = mimeType;
    _values[19] = onblur;
    _values[20] = onclick;
    _values[21] = ondblclick;
    _values[22] = onfocus;
    _values[23] = onkeydown;
    _values[24] = onkeypress;
    _values[25] = onkeyup;
    _values[26] = onmousedown;
    _values[27] = onmousemove;
    _values[28] = onmouseout;
    _values[29] = onmouseover;
    _values[30] = onmouseup;
    _values[31] = playerAttributes;
    _values[32] = shuffle;
    _values[33] = src;
    _values[34] = standby;
    _values[35] = style;
    _values[36] = styleClass;
    _values[37] = tabindex;
    _values[38] = title;
    _values[39] = vspace;
    _values[40] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.accesskey = (java.lang.String) _values[1];
    this.align = (java.lang.String) _values[2];
    this.alt = (java.lang.String) _values[3];
    this.archive = (java.lang.String) _values[4];
    this.autoStart = (java.lang.String) _values[5];
    this.backgroundcolor = (java.lang.String) _values[6];
    this.binding = (java.lang.String) _values[7];
    this.border = (java.lang.String) _values[8];
    this.center = (java.lang.String) _values[9];
    this.codebase = (java.lang.String) _values[10];
    this.console = (java.lang.String) _values[11];
    this.controls = (java.lang.String) _values[12];
    this.dir = (java.lang.String) _values[13];
    this.height = (java.lang.String) _values[14];
    this.hspace = (java.lang.String) _values[15];
    this.lang = (java.lang.String) _values[16];
    this.loop = (java.lang.String) _values[17];
    this.mimeType = (java.lang.String) _values[18];
    this.onblur = (java.lang.String) _values[19];
    this.onclick = (java.lang.String) _values[20];
    this.ondblclick = (java.lang.String) _values[21];
    this.onfocus = (java.lang.String) _values[22];
    this.onkeydown = (java.lang.String) _values[23];
    this.onkeypress = (java.lang.String) _values[24];
    this.onkeyup = (java.lang.String) _values[25];
    this.onmousedown = (java.lang.String) _values[26];
    this.onmousemove = (java.lang.String) _values[27];
    this.onmouseout = (java.lang.String) _values[28];
    this.onmouseover = (java.lang.String) _values[29];
    this.onmouseup = (java.lang.String) _values[30];
    this.playerAttributes = (java.lang.String) _values[31];
    this.shuffle = (java.lang.String) _values[32];
    this.src = (java.lang.Object) _values[33];
    this.standby = (java.lang.String) _values[34];
    this.style = (java.lang.String) _values[35];
    this.styleClass = (java.lang.String) _values[36];
    this.tabindex = (java.lang.String) _values[37];
    this.title = (java.lang.String) _values[38];
    this.vspace = (java.lang.String) _values[39];
    this.width = (java.lang.String) _values[40];
  }


}
