/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.ScriptCollector</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlScriptCollector extends com.ibm.faces.component.UIScriptCollector {


  public HtmlScriptCollector() {
    super();
    setRendererType("com.ibm.faces.ScriptCollector"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlScriptCollector"; //$NON-NLS-1$


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[1];
    _values[0] = super.saveState(_context);
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
  }


}
