/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.Color</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlSelectOneColor extends javax.faces.component.UISelectOne {


  public HtmlSelectOneColor() {
    super();
    setRendererType("com.ibm.faces.Color"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlSelectOneColor"; //$NON-NLS-1$


  private java.lang.String accesskey;

  /**
   * <p>Return the value of the <code>accesskey</code> property.   * </p>
   */
  public java.lang.String getAccesskey() {
    if (null != this.accesskey) {
      return this.accesskey;
    }
    ValueBinding _vb = getValueBinding("accesskey"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>accesskey</code> property.</p>
   */
  public void setAccesskey(java.lang.String accesskey) {
    this.accesskey = accesskey;
  }


  private java.lang.String buttonBorder;

  /**
   * <p>Return the value of the <code>buttonBorder</code> property.  Contents:</p><p>
   * Optional defaults to -1. Controls how the "popup" button is drawn relative to the input field.
   * 			 By default, the button is drawn in a manner appropriate to the OS of the browser such that the button
   * 			 	looks like a Combo Box button. On Win2000/Win9X, the button is drawn as "part of the border".
   * 			 On WinXP, it should be drawn "inside the border" but we currently can't do this, so we draw the
   * 				button separate from the input field (to the right). A value of -1 means, draw the button in a
   * 				manner appropriate to the OS.
   * 			 A value of +1 means always draw the button to the right of the input field (as we do for WinXP).
   * 			 In the future, a value of +2 will mean "draw a real XP style button".
   * </p>
   */
  public java.lang.String getButtonBorder() {
    if (null != this.buttonBorder) {
      return this.buttonBorder;
    }
    ValueBinding _vb = getValueBinding("buttonBorder"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>buttonBorder</code> property.</p>
   */
  public void setButtonBorder(java.lang.String buttonBorder) {
    this.buttonBorder = buttonBorder;
  }


  private java.lang.String buttonColor;

  /**
   * <p>Return the value of the <code>buttonColor</code> property.  Contents:</p><p>
   * Optional. Specifies the background-color of the button. By default the background color
   * 				matches the border color of the input field.
   * 			Use of this attribute is of limited value, it's currently more of a placeholder for
   * 				a future extension that will allow an alternate button background graphic to be supplied.
   * </p>
   */
  public java.lang.String getButtonColor() {
    if (null != this.buttonColor) {
      return this.buttonColor;
    }
    ValueBinding _vb = getValueBinding("buttonColor"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>buttonColor</code> property.</p>
   */
  public void setButtonColor(java.lang.String buttonColor) {
    this.buttonColor = buttonColor;
  }


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private boolean disabled = false;
  private boolean disabled_set = false;

  /**
   * <p>Return the value of the <code>disabled</code> property.   * </p>
   */
  public boolean isDisabled() {
    if (this.disabled_set) {
      return this.disabled;
    }
    ValueBinding _vb = getValueBinding("disabled"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.disabled;
    }
  }

  /**
   * <p>Set the value of the <code>disabled</code> property.</p>
   */
  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
    this.disabled_set = true;
  }


  private java.lang.String dropdownClass;

  /**
   * <p>Return the value of the <code>dropdownClass</code> property.  Contents:</p><p>
   * Optional, defaults to inputColor. The base class of a set of CSS classes that describe the visual
   * 				appearance of the dropdown popup.
   * 				Note that the name excludes the suffixes (e.g., it's inputColor1 not inputColor1_ColorPicker).
   * </p>
   */
  public java.lang.String getDropdownClass() {
    if (null != this.dropdownClass) {
      return this.dropdownClass;
    }
    ValueBinding _vb = getValueBinding("dropdownClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dropdownClass</code> property.</p>
   */
  public void setDropdownClass(java.lang.String dropdownClass) {
    this.dropdownClass = dropdownClass;
  }


  private java.lang.String lang;

  /**
   * <p>Return the value of the <code>lang</code> property.   * </p>
   */
  public java.lang.String getLang() {
    if (null != this.lang) {
      return this.lang;
    }
    ValueBinding _vb = getValueBinding("lang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lang</code> property.</p>
   */
  public void setLang(java.lang.String lang) {
    this.lang = lang;
  }


  private java.lang.String onblur;

  /**
   * <p>Return the value of the <code>onblur</code> property.   * </p>
   */
  public java.lang.String getOnblur() {
    if (null != this.onblur) {
      return this.onblur;
    }
    ValueBinding _vb = getValueBinding("onblur"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onblur</code> property.</p>
   */
  public void setOnblur(java.lang.String onblur) {
    this.onblur = onblur;
  }


  private java.lang.String onchange;

  /**
   * <p>Return the value of the <code>onchange</code> property.   * </p>
   */
  public java.lang.String getOnchange() {
    if (null != this.onchange) {
      return this.onchange;
    }
    ValueBinding _vb = getValueBinding("onchange"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onchange</code> property.</p>
   */
  public void setOnchange(java.lang.String onchange) {
    this.onchange = onchange;
  }


  private java.lang.String onclick;

  /**
   * <p>Return the value of the <code>onclick</code> property.   * </p>
   */
  public java.lang.String getOnclick() {
    if (null != this.onclick) {
      return this.onclick;
    }
    ValueBinding _vb = getValueBinding("onclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onclick</code> property.</p>
   */
  public void setOnclick(java.lang.String onclick) {
    this.onclick = onclick;
  }


  private java.lang.String ondblclick;

  /**
   * <p>Return the value of the <code>ondblclick</code> property.   * </p>
   */
  public java.lang.String getOndblclick() {
    if (null != this.ondblclick) {
      return this.ondblclick;
    }
    ValueBinding _vb = getValueBinding("ondblclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>ondblclick</code> property.</p>
   */
  public void setOndblclick(java.lang.String ondblclick) {
    this.ondblclick = ondblclick;
  }


  private java.lang.String onfocus;

  /**
   * <p>Return the value of the <code>onfocus</code> property.   * </p>
   */
  public java.lang.String getOnfocus() {
    if (null != this.onfocus) {
      return this.onfocus;
    }
    ValueBinding _vb = getValueBinding("onfocus"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocus</code> property.</p>
   */
  public void setOnfocus(java.lang.String onfocus) {
    this.onfocus = onfocus;
  }


  private java.lang.String onkeydown;

  /**
   * <p>Return the value of the <code>onkeydown</code> property.   * </p>
   */
  public java.lang.String getOnkeydown() {
    if (null != this.onkeydown) {
      return this.onkeydown;
    }
    ValueBinding _vb = getValueBinding("onkeydown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeydown</code> property.</p>
   */
  public void setOnkeydown(java.lang.String onkeydown) {
    this.onkeydown = onkeydown;
  }


  private java.lang.String onkeypress;

  /**
   * <p>Return the value of the <code>onkeypress</code> property.   * </p>
   */
  public java.lang.String getOnkeypress() {
    if (null != this.onkeypress) {
      return this.onkeypress;
    }
    ValueBinding _vb = getValueBinding("onkeypress"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeypress</code> property.</p>
   */
  public void setOnkeypress(java.lang.String onkeypress) {
    this.onkeypress = onkeypress;
  }


  private java.lang.String onkeyup;

  /**
   * <p>Return the value of the <code>onkeyup</code> property.   * </p>
   */
  public java.lang.String getOnkeyup() {
    if (null != this.onkeyup) {
      return this.onkeyup;
    }
    ValueBinding _vb = getValueBinding("onkeyup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeyup</code> property.</p>
   */
  public void setOnkeyup(java.lang.String onkeyup) {
    this.onkeyup = onkeyup;
  }


  private java.lang.String onmousedown;

  /**
   * <p>Return the value of the <code>onmousedown</code> property.   * </p>
   */
  public java.lang.String getOnmousedown() {
    if (null != this.onmousedown) {
      return this.onmousedown;
    }
    ValueBinding _vb = getValueBinding("onmousedown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousedown</code> property.</p>
   */
  public void setOnmousedown(java.lang.String onmousedown) {
    this.onmousedown = onmousedown;
  }


  private java.lang.String onmousemove;

  /**
   * <p>Return the value of the <code>onmousemove</code> property.   * </p>
   */
  public java.lang.String getOnmousemove() {
    if (null != this.onmousemove) {
      return this.onmousemove;
    }
    ValueBinding _vb = getValueBinding("onmousemove"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousemove</code> property.</p>
   */
  public void setOnmousemove(java.lang.String onmousemove) {
    this.onmousemove = onmousemove;
  }


  private java.lang.String onmouseout;

  /**
   * <p>Return the value of the <code>onmouseout</code> property.   * </p>
   */
  public java.lang.String getOnmouseout() {
    if (null != this.onmouseout) {
      return this.onmouseout;
    }
    ValueBinding _vb = getValueBinding("onmouseout"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseout</code> property.</p>
   */
  public void setOnmouseout(java.lang.String onmouseout) {
    this.onmouseout = onmouseout;
  }


  private java.lang.String onmouseover;

  /**
   * <p>Return the value of the <code>onmouseover</code> property.   * </p>
   */
  public java.lang.String getOnmouseover() {
    if (null != this.onmouseover) {
      return this.onmouseover;
    }
    ValueBinding _vb = getValueBinding("onmouseover"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseover</code> property.</p>
   */
  public void setOnmouseover(java.lang.String onmouseover) {
    this.onmouseover = onmouseover;
  }


  private java.lang.String onmouseup;

  /**
   * <p>Return the value of the <code>onmouseup</code> property.   * </p>
   */
  public java.lang.String getOnmouseup() {
    if (null != this.onmouseup) {
      return this.onmouseup;
    }
    ValueBinding _vb = getValueBinding("onmouseup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseup</code> property.</p>
   */
  public void setOnmouseup(java.lang.String onmouseup) {
    this.onmouseup = onmouseup;
  }


  private java.lang.String onselect;

  /**
   * <p>Return the value of the <code>onselect</code> property.   * </p>
   */
  public java.lang.String getOnselect() {
    if (null != this.onselect) {
      return this.onselect;
    }
    ValueBinding _vb = getValueBinding("onselect"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onselect</code> property.</p>
   */
  public void setOnselect(java.lang.String onselect) {
    this.onselect = onselect;
  }


  private boolean showLabels = false;
  private boolean showLabels_set = false;

  /**
   * <p>Return the value of the <code>showLabels</code> property.  Contents:</p><p>
   * Optional, defaults to inputColor. The base class of a set of CSS classes that describe the visual
   * 				appearance of the dropdown popup.
   * 				Note that the name excludes the suffixes (e.g., it's inputColor1 not inputColor1_ColorPicker).
   * </p>
   */
  public boolean isShowLabels() {
    if (this.showLabels_set) {
      return this.showLabels;
    }
    ValueBinding _vb = getValueBinding("showLabels"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.showLabels;
    }
  }

  /**
   * <p>Set the value of the <code>showLabels</code> property.</p>
   */
  public void setShowLabels(boolean showLabels) {
    this.showLabels = showLabels;
    this.showLabels_set = true;
  }


  private java.lang.String size;

  /**
   * <p>Return the value of the <code>size</code> property.   * </p>
   */
  public java.lang.String getSize() {
    if (null != this.size) {
      return this.size;
    }
    ValueBinding _vb = getValueBinding("size"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>size</code> property.</p>
   */
  public void setSize(java.lang.String size) {
    this.size = size;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[30];
    _values[0] = super.saveState(_context);
    _values[1] = accesskey;
    _values[2] = buttonBorder;
    _values[3] = buttonColor;
    _values[4] = dir;
    _values[5] = this.disabled ? Boolean.TRUE : Boolean.FALSE;
    _values[6] = this.disabled_set ? Boolean.TRUE : Boolean.FALSE;
    _values[7] = dropdownClass;
    _values[8] = lang;
    _values[9] = onblur;
    _values[10] = onchange;
    _values[11] = onclick;
    _values[12] = ondblclick;
    _values[13] = onfocus;
    _values[14] = onkeydown;
    _values[15] = onkeypress;
    _values[16] = onkeyup;
    _values[17] = onmousedown;
    _values[18] = onmousemove;
    _values[19] = onmouseout;
    _values[20] = onmouseover;
    _values[21] = onmouseup;
    _values[22] = onselect;
    _values[23] = this.showLabels ? Boolean.TRUE : Boolean.FALSE;
    _values[24] = this.showLabels_set ? Boolean.TRUE : Boolean.FALSE;
    _values[25] = size;
    _values[26] = style;
    _values[27] = styleClass;
    _values[28] = tabindex;
    _values[29] = title;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.accesskey = (java.lang.String) _values[1];
    this.buttonBorder = (java.lang.String) _values[2];
    this.buttonColor = (java.lang.String) _values[3];
    this.dir = (java.lang.String) _values[4];
    this.disabled = ((Boolean) _values[5]).booleanValue();
    this.disabled_set = ((Boolean) _values[6]).booleanValue();
    this.dropdownClass = (java.lang.String) _values[7];
    this.lang = (java.lang.String) _values[8];
    this.onblur = (java.lang.String) _values[9];
    this.onchange = (java.lang.String) _values[10];
    this.onclick = (java.lang.String) _values[11];
    this.ondblclick = (java.lang.String) _values[12];
    this.onfocus = (java.lang.String) _values[13];
    this.onkeydown = (java.lang.String) _values[14];
    this.onkeypress = (java.lang.String) _values[15];
    this.onkeyup = (java.lang.String) _values[16];
    this.onmousedown = (java.lang.String) _values[17];
    this.onmousemove = (java.lang.String) _values[18];
    this.onmouseout = (java.lang.String) _values[19];
    this.onmouseover = (java.lang.String) _values[20];
    this.onmouseup = (java.lang.String) _values[21];
    this.onselect = (java.lang.String) _values[22];
    this.showLabels = ((Boolean) _values[23]).booleanValue();
    this.showLabels_set = ((Boolean) _values[24]).booleanValue();
    this.size = (java.lang.String) _values[25];
    this.style = (java.lang.String) _values[26];
    this.styleClass = (java.lang.String) _values[27];
    this.tabindex = (java.lang.String) _values[28];
    this.title = (java.lang.String) _values[29];
  }


}
