/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>com.ibm.faces.SortHeader</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlSortHeader extends com.ibm.faces.component.UISortHeader {


  public HtmlSortHeader() {
    super();
    setRendererType("com.ibm.faces.SortHeader"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.HtmlSortHeader"; //$NON-NLS-1$


  private java.lang.String accesskey;

  /**
   * <p>Return the value of the <code>accesskey</code> property.  Contents:</p><p>
   * Access key to put focus on this compoent.
   * </p>
   */
  public java.lang.String getAccesskey() {
    if (null != this.accesskey) {
      return this.accesskey;
    }
    ValueBinding _vb = getValueBinding("accesskey"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>accesskey</code> property.</p>
   */
  public void setAccesskey(java.lang.String accesskey) {
    this.accesskey = accesskey;
  }


  private java.lang.String binding;

  /**
   * <p>Return the value of the <code>binding</code> property.  Contents:</p><p>
   * ValueBinding to bind the component to a component
   * 				property of a JavaBean
   * </p>
   */
  public java.lang.String getBinding() {
    if (null != this.binding) {
      return this.binding;
    }
    ValueBinding _vb = getValueBinding("binding"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>binding</code> property.</p>
   */
  public void setBinding(java.lang.String binding) {
    this.binding = binding;
  }


  private java.lang.String charset;

  /**
   * <p>Return the value of the <code>charset</code> property.  Contents:</p><p>
   * The character encoding of the resource designated by this hyperlink.
   * </p>
   */
  public java.lang.String getCharset() {
    if (null != this.charset) {
      return this.charset;
    }
    ValueBinding _vb = getValueBinding("charset"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>charset</code> property.</p>
   */
  public void setCharset(java.lang.String charset) {
    this.charset = charset;
  }


  private java.lang.String defaultSortOrder;

  /**
   * <p>Return the value of the <code>defaultSortOrder</code> property.  Contents:</p><p>
   * Initial sort order of the column
   * </p>
   */
  public java.lang.String getDefaultSortOrder() {
    if (null != this.defaultSortOrder) {
      return this.defaultSortOrder;
    }
    ValueBinding _vb = getValueBinding("defaultSortOrder"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>defaultSortOrder</code> property.</p>
   */
  public void setDefaultSortOrder(java.lang.String defaultSortOrder) {
    this.defaultSortOrder = defaultSortOrder;
  }


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.  Contents:</p><p>
   * Text direction for directionally neutral text, values
   * 				can be "LTR" (left to right) or "RTL" (right to left).
   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private java.lang.String hreflang;

  /**
   * <p>Return the value of the <code>hreflang</code> property.  Contents:</p><p>
   * The language code of the resource designated by this hyperlink.
   * </p>
   */
  public java.lang.String getHreflang() {
    if (null != this.hreflang) {
      return this.hreflang;
    }
    ValueBinding _vb = getValueBinding("hreflang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>hreflang</code> property.</p>
   */
  public void setHreflang(java.lang.String hreflang) {
    this.hreflang = hreflang;
  }


  private java.lang.String lang;

  /**
   * <p>Return the value of the <code>lang</code> property.  Contents:</p><p>
   * Specifies the base language of attributes and text
   * 				context for this component
   * </p>
   */
  public java.lang.String getLang() {
    if (null != this.lang) {
      return this.lang;
    }
    ValueBinding _vb = getValueBinding("lang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lang</code> property.</p>
   */
  public void setLang(java.lang.String lang) {
    this.lang = lang;
  }


  private java.lang.String onblur;

  /**
   * <p>Return the value of the <code>onblur</code> property.  Contents:</p><p>
   * onblur javascript event
   * </p>
   */
  public java.lang.String getOnblur() {
    if (null != this.onblur) {
      return this.onblur;
    }
    ValueBinding _vb = getValueBinding("onblur"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onblur</code> property.</p>
   */
  public void setOnblur(java.lang.String onblur) {
    this.onblur = onblur;
  }


  private java.lang.String onclick;

  /**
   * <p>Return the value of the <code>onclick</code> property.  Contents:</p><p>
   * Javascript onclick event
   * </p>
   */
  public java.lang.String getOnclick() {
    if (null != this.onclick) {
      return this.onclick;
    }
    ValueBinding _vb = getValueBinding("onclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onclick</code> property.</p>
   */
  public void setOnclick(java.lang.String onclick) {
    this.onclick = onclick;
  }


  private java.lang.String ondblclick;

  /**
   * <p>Return the value of the <code>ondblclick</code> property.  Contents:</p><p>
   * Javascript double click event
   * </p>
   */
  public java.lang.String getOndblclick() {
    if (null != this.ondblclick) {
      return this.ondblclick;
    }
    ValueBinding _vb = getValueBinding("ondblclick"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>ondblclick</code> property.</p>
   */
  public void setOndblclick(java.lang.String ondblclick) {
    this.ondblclick = ondblclick;
  }


  private java.lang.String onfocus;

  /**
   * <p>Return the value of the <code>onfocus</code> property.  Contents:</p><p>
   * onfocus javascript event
   * </p>
   */
  public java.lang.String getOnfocus() {
    if (null != this.onfocus) {
      return this.onfocus;
    }
    ValueBinding _vb = getValueBinding("onfocus"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onfocus</code> property.</p>
   */
  public void setOnfocus(java.lang.String onfocus) {
    this.onfocus = onfocus;
  }


  private java.lang.String onkeydown;

  /**
   * <p>Return the value of the <code>onkeydown</code> property.  Contents:</p><p>
   * Javascript key down event
   * </p>
   */
  public java.lang.String getOnkeydown() {
    if (null != this.onkeydown) {
      return this.onkeydown;
    }
    ValueBinding _vb = getValueBinding("onkeydown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeydown</code> property.</p>
   */
  public void setOnkeydown(java.lang.String onkeydown) {
    this.onkeydown = onkeydown;
  }


  private java.lang.String onkeypress;

  /**
   * <p>Return the value of the <code>onkeypress</code> property.  Contents:</p><p>
   * Javascript key press event
   * </p>
   */
  public java.lang.String getOnkeypress() {
    if (null != this.onkeypress) {
      return this.onkeypress;
    }
    ValueBinding _vb = getValueBinding("onkeypress"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeypress</code> property.</p>
   */
  public void setOnkeypress(java.lang.String onkeypress) {
    this.onkeypress = onkeypress;
  }


  private java.lang.String onkeyup;

  /**
   * <p>Return the value of the <code>onkeyup</code> property.  Contents:</p><p>
   * Javascript key up event
   * </p>
   */
  public java.lang.String getOnkeyup() {
    if (null != this.onkeyup) {
      return this.onkeyup;
    }
    ValueBinding _vb = getValueBinding("onkeyup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onkeyup</code> property.</p>
   */
  public void setOnkeyup(java.lang.String onkeyup) {
    this.onkeyup = onkeyup;
  }


  private java.lang.String onmousedown;

  /**
   * <p>Return the value of the <code>onmousedown</code> property.  Contents:</p><p>
   * Javascript mouse button press event
   * </p>
   */
  public java.lang.String getOnmousedown() {
    if (null != this.onmousedown) {
      return this.onmousedown;
    }
    ValueBinding _vb = getValueBinding("onmousedown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousedown</code> property.</p>
   */
  public void setOnmousedown(java.lang.String onmousedown) {
    this.onmousedown = onmousedown;
  }


  private java.lang.String onmousemove;

  /**
   * <p>Return the value of the <code>onmousemove</code> property.  Contents:</p><p>
   * Javascript mouse move event
   * </p>
   */
  public java.lang.String getOnmousemove() {
    if (null != this.onmousemove) {
      return this.onmousemove;
    }
    ValueBinding _vb = getValueBinding("onmousemove"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmousemove</code> property.</p>
   */
  public void setOnmousemove(java.lang.String onmousemove) {
    this.onmousemove = onmousemove;
  }


  private java.lang.String onmouseout;

  /**
   * <p>Return the value of the <code>onmouseout</code> property.  Contents:</p><p>
   * Javascript mouse out event
   * </p>
   */
  public java.lang.String getOnmouseout() {
    if (null != this.onmouseout) {
      return this.onmouseout;
    }
    ValueBinding _vb = getValueBinding("onmouseout"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseout</code> property.</p>
   */
  public void setOnmouseout(java.lang.String onmouseout) {
    this.onmouseout = onmouseout;
  }


  private java.lang.String onmouseover;

  /**
   * <p>Return the value of the <code>onmouseover</code> property.  Contents:</p><p>
   * Javascript mouse over event
   * </p>
   */
  public java.lang.String getOnmouseover() {
    if (null != this.onmouseover) {
      return this.onmouseover;
    }
    ValueBinding _vb = getValueBinding("onmouseover"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseover</code> property.</p>
   */
  public void setOnmouseover(java.lang.String onmouseover) {
    this.onmouseover = onmouseover;
  }


  private java.lang.String onmouseup;

  /**
   * <p>Return the value of the <code>onmouseup</code> property.  Contents:</p><p>
   * Javascript mouse button release event
   * </p>
   */
  public java.lang.String getOnmouseup() {
    if (null != this.onmouseup) {
      return this.onmouseup;
    }
    ValueBinding _vb = getValueBinding("onmouseup"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onmouseup</code> property.</p>
   */
  public void setOnmouseup(java.lang.String onmouseup) {
    this.onmouseup = onmouseup;
  }


  private java.lang.String srcAscending;

  /**
   * <p>Return the value of the <code>srcAscending</code> property.  Contents:</p><p>
   * The URL to an image representing sort ascending.
   * </p>
   */
  public java.lang.String getSrcAscending() {
    if (null != this.srcAscending) {
      return this.srcAscending;
    }
    ValueBinding _vb = getValueBinding("srcAscending"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcAscending</code> property.</p>
   */
  public void setSrcAscending(java.lang.String srcAscending) {
    this.srcAscending = srcAscending;
  }


  private java.lang.String srcAscendingOn;

  /**
   * <p>Return the value of the <code>srcAscendingOn</code> property.  Contents:</p><p>
   * The URL to an image representing sort ascending on.
   * </p>
   */
  public java.lang.String getSrcAscendingOn() {
    if (null != this.srcAscendingOn) {
      return this.srcAscendingOn;
    }
    ValueBinding _vb = getValueBinding("srcAscendingOn"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcAscendingOn</code> property.</p>
   */
  public void setSrcAscendingOn(java.lang.String srcAscendingOn) {
    this.srcAscendingOn = srcAscendingOn;
  }


  private java.lang.String srcBi;

  /**
   * <p>Return the value of the <code>srcBi</code> property.  Contents:</p><p>
   * The URL to an image representing sort bi-directional.
   * </p>
   */
  public java.lang.String getSrcBi() {
    if (null != this.srcBi) {
      return this.srcBi;
    }
    ValueBinding _vb = getValueBinding("srcBi"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcBi</code> property.</p>
   */
  public void setSrcBi(java.lang.String srcBi) {
    this.srcBi = srcBi;
  }


  private java.lang.String srcBiDown;

  /**
   * <p>Return the value of the <code>srcBiDown</code> property.  Contents:</p><p>
   * The URL to an image representing sort bi-directional down is on.
   * </p>
   */
  public java.lang.String getSrcBiDown() {
    if (null != this.srcBiDown) {
      return this.srcBiDown;
    }
    ValueBinding _vb = getValueBinding("srcBiDown"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcBiDown</code> property.</p>
   */
  public void setSrcBiDown(java.lang.String srcBiDown) {
    this.srcBiDown = srcBiDown;
  }


  private java.lang.String srcBiUp;

  /**
   * <p>Return the value of the <code>srcBiUp</code> property.  Contents:</p><p>
   * The URL to an image representing sort bi-directional up is on.
   * </p>
   */
  public java.lang.String getSrcBiUp() {
    if (null != this.srcBiUp) {
      return this.srcBiUp;
    }
    ValueBinding _vb = getValueBinding("srcBiUp"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcBiUp</code> property.</p>
   */
  public void setSrcBiUp(java.lang.String srcBiUp) {
    this.srcBiUp = srcBiUp;
  }


  private java.lang.String srcDescending;

  /**
   * <p>Return the value of the <code>srcDescending</code> property.  Contents:</p><p>
   * The URL to an image representing sort descending.
   * </p>
   */
  public java.lang.String getSrcDescending() {
    if (null != this.srcDescending) {
      return this.srcDescending;
    }
    ValueBinding _vb = getValueBinding("srcDescending"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcDescending</code> property.</p>
   */
  public void setSrcDescending(java.lang.String srcDescending) {
    this.srcDescending = srcDescending;
  }


  private java.lang.String srcDescendingOn;

  /**
   * <p>Return the value of the <code>srcDescendingOn</code> property.  Contents:</p><p>
   * The URL to an image representing sort descending on.
   * </p>
   */
  public java.lang.String getSrcDescendingOn() {
    if (null != this.srcDescendingOn) {
      return this.srcDescendingOn;
    }
    ValueBinding _vb = getValueBinding("srcDescendingOn"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>srcDescendingOn</code> property.</p>
   */
  public void setSrcDescendingOn(java.lang.String srcDescendingOn) {
    this.srcDescendingOn = srcDescendingOn;
  }


  private java.lang.String style;

  /**
   * <p>Return the value of the <code>style</code> property.  Contents:</p><p>
   * CSS style that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyle() {
    if (null != this.style) {
      return this.style;
    }
    ValueBinding _vb = getValueBinding("style"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>style</code> property.</p>
   */
  public void setStyle(java.lang.String style) {
    this.style = style;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * CSS class that is applied to the rendered component.
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String tabindex;

  /**
   * <p>Return the value of the <code>tabindex</code> property.  Contents:</p><p>
   * Tabbing order for this component.
   * </p>
   */
  public java.lang.String getTabindex() {
    if (null != this.tabindex) {
      return this.tabindex;
    }
    ValueBinding _vb = getValueBinding("tabindex"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>tabindex</code> property.</p>
   */
  public void setTabindex(java.lang.String tabindex) {
    this.tabindex = tabindex;
  }


  private java.lang.String target;

  /**
   * <p>Return the value of the <code>target</code> property.  Contents:</p><p>
   * Assigns the target frame within a frameset that a page should be loaded into when the hyperlink is clicked.
   * </p>
   */
  public java.lang.String getTarget() {
    if (null != this.target) {
      return this.target;
    }
    ValueBinding _vb = getValueBinding("target"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>target</code> property.</p>
   */
  public void setTarget(java.lang.String target) {
    this.target = target;
  }


  private java.lang.String title;

  /**
   * <p>Return the value of the <code>title</code> property.  Contents:</p><p>
   * Rendered title information.
   * </p>
   */
  public java.lang.String getTitle() {
    if (null != this.title) {
      return this.title;
    }
    ValueBinding _vb = getValueBinding("title"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>title</code> property.</p>
   */
  public void setTitle(java.lang.String title) {
    this.title = title;
  }


  private java.lang.Object value;

  /**
   * <p>Return the value of the <code>value</code> property.   * </p>
   */
  public java.lang.Object getValue() {
    if (null != this.value) {
      return this.value;
    }
    ValueBinding _vb = getValueBinding("value"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.Object) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>value</code> property.</p>
   */
  public void setValue(java.lang.Object value) {
    this.value = value;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[33];
    _values[0] = super.saveState(_context);
    _values[1] = accesskey;
    _values[2] = binding;
    _values[3] = charset;
    _values[4] = defaultSortOrder;
    _values[5] = dir;
    _values[6] = hreflang;
    _values[7] = lang;
    _values[8] = onblur;
    _values[9] = onclick;
    _values[10] = ondblclick;
    _values[11] = onfocus;
    _values[12] = onkeydown;
    _values[13] = onkeypress;
    _values[14] = onkeyup;
    _values[15] = onmousedown;
    _values[16] = onmousemove;
    _values[17] = onmouseout;
    _values[18] = onmouseover;
    _values[19] = onmouseup;
    _values[20] = srcAscending;
    _values[21] = srcAscendingOn;
    _values[22] = srcBi;
    _values[23] = srcBiDown;
    _values[24] = srcBiUp;
    _values[25] = srcDescending;
    _values[26] = srcDescendingOn;
    _values[27] = style;
    _values[28] = styleClass;
    _values[29] = tabindex;
    _values[30] = target;
    _values[31] = title;
    _values[32] = value;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.accesskey = (java.lang.String) _values[1];
    this.binding = (java.lang.String) _values[2];
    this.charset = (java.lang.String) _values[3];
    this.defaultSortOrder = (java.lang.String) _values[4];
    this.dir = (java.lang.String) _values[5];
    this.hreflang = (java.lang.String) _values[6];
    this.lang = (java.lang.String) _values[7];
    this.onblur = (java.lang.String) _values[8];
    this.onclick = (java.lang.String) _values[9];
    this.ondblclick = (java.lang.String) _values[10];
    this.onfocus = (java.lang.String) _values[11];
    this.onkeydown = (java.lang.String) _values[12];
    this.onkeypress = (java.lang.String) _values[13];
    this.onkeyup = (java.lang.String) _values[14];
    this.onmousedown = (java.lang.String) _values[15];
    this.onmousemove = (java.lang.String) _values[16];
    this.onmouseout = (java.lang.String) _values[17];
    this.onmouseover = (java.lang.String) _values[18];
    this.onmouseup = (java.lang.String) _values[19];
    this.srcAscending = (java.lang.String) _values[20];
    this.srcAscendingOn = (java.lang.String) _values[21];
    this.srcBi = (java.lang.String) _values[22];
    this.srcBiDown = (java.lang.String) _values[23];
    this.srcBiUp = (java.lang.String) _values[24];
    this.srcDescending = (java.lang.String) _values[25];
    this.srcDescendingOn = (java.lang.String) _values[26];
    this.style = (java.lang.String) _values[27];
    this.styleClass = (java.lang.String) _values[28];
    this.tabindex = (java.lang.String) _values[29];
    this.target = (java.lang.String) _values[30];
    this.title = (java.lang.String) _values[31];
    this.value = (java.lang.Object) _values[32];
  }


}
