/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;
import javax.faces.event.PhaseId;

/**
 * <p></p>
 * @author contributed by Stephen Renwick (xfaces)
 */
public class DataIndexEvent extends FacesEvent {
    
    private FacesEvent _event;
    private int _index;

    public DataIndexEvent(UIComponent component, FacesEvent event, int index) {
        super(component);
        
        _event = event;
        _index = index;
    }
    
    /**
     * @return the index
     */
    public int getIndex() {
        return _index;
    }
    
    /**
     * @return the event
     */
    public FacesEvent getEvent() {
        return _event;
    }
    
    /* (non-Javadoc)
     * @see javax.faces.event.FacesEvent#getPhaseId()
     */
    public PhaseId getPhaseId() {
    	return _event.getPhaseId();
    }
    
    /* (non-Javadoc)
     * @see javax.faces.event.FacesEvent#setPhaseId(javax.faces.event.PhaseId)
     */
    public void setPhaseId(PhaseId phaseId) {
    	_event.setPhaseId(phaseId);
    }

    /* (non-Javadoc)
     * @see javax.faces.event.FacesEvent#isAppropriateListener(javax.faces.event.FacesListener)
     */
    public boolean isAppropriateListener(FacesListener listener) {
        return _event.isAppropriateListener(listener);
    }

    /* (non-Javadoc)
     * @see javax.faces.event.FacesEvent#processListener(javax.faces.event.FacesListener)
     */
    public void processListener(FacesListener listener) {
        _event.processListener(listener);
    }
}

