/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
 
package com.ibm.faces.event;

import javax.faces.component.UIComponent;
import javax.faces.event.ActionEvent;

/**
 * Event supported by a pager.
 */
public class PagerEvent extends ActionEvent {

    private int page = 0;

    /**
     * @param component the source component
     * @param date      the target component
     * @param page      0-based index page
     */
    public PagerEvent(UIComponent component, int page) {
        super(component);
        
        if(page<0) {
            throw new IllegalArgumentException("page<0"); //$NON-NLS-1$
        }
        
        this.page = page;
    }
    
    /**
     * @return  the target page
     */
    public int getPage() {
        return page;
    }

}
