/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.jwlajaxencoder;

import javax.faces.context.FacesContext;

/**
 *
 * This is the interface to use for creating an ajaxurlencoder
 */
public interface AjaxUrlEncoder {

	/*
	 * The url given to this method is obtained from the ViewHandler for the application,
	 * it is the current page you are rendering with some parameters tagged on to the end
	 * 
	 * on a servlet platform like tomcat or WAS with JSPs, the URL would look like this 
	 *   /myapp/faces/mypage.jsp?$$ajaxid=form1:group1&$$ajaxmode=axpartial (ajaxrefreshrequest)
	 * or
	 *   /myapp/faces/mypage.jsp?$$ajaxid=form1:group1&$$ajaxmode=axfull	(ajaxrefreshsubmit)
	 * 
	 * The string url returned must have been encoded, etc. for the particular paltform you are operating on.
	 * 
	 * */
	public String encodeAjaxUrl(FacesContext context, String url);
	
}
