/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.jwlajaxencoder;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;



import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Map;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.portlet.PortletException;
import javax.portlet.PortletMode;
import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;
import javax.portlet.WindowState;

//import com.ibm.commons.log.Situation;
import com.ibm.faces.portlet.util.PortletConstants;
import com.ibm.portal.ObjectID;
import com.ibm.portal.portlet.service.PortletServiceHome;
import com.ibm.portal.portlet.service.PortletServiceUnavailableException;
import com.ibm.portal.state.EngineURL;
import com.ibm.portal.state.PortletStateManager;
import com.ibm.portal.state.URLFactory;
import com.ibm.portal.state.Constants.Clone;
import com.ibm.portal.state.accessors.portlet.PortletAccessorController;
import com.ibm.portal.state.accessors.portlet.PortletAccessorFactory;
import com.ibm.portal.state.accessors.portlet.PortletTargetAccessorController;
import com.ibm.portal.state.accessors.selection.SelectionAccessorController;
import com.ibm.portal.state.accessors.selection.SelectionAccessorFactory;
import com.ibm.portal.state.accessors.solo.SoloAccessorController;
import com.ibm.portal.state.accessors.solo.SoloAccessorFactory;
//import com.ibm.portal.state.accessors.themetemplate.ThemeTemplateAccessorController;
//import com.ibm.portal.state.accessors.themetemplate.ThemeTemplateAccessorFactory;
import com.ibm.portal.state.exceptions.StateException;
import com.ibm.portal.state.service.PortletStateManagerService;
import com.ibm.portal.state.service.StateManagerService;
import com.ibm.wps.pe.om.window.PortletWindow;
import com.ibm.wps.pe.om.window.PortletWindowEx;
import com.ibm.wps.pe.pc.std.core.InternalPortletRequest;
import com.ibm.wps.pe.pc.std.core.PortletUtils;



import com.ibm.faces.portlet.httpbridge.*;
import javax.servlet.http.*;
import javax.servlet.*;






/**
 * this class creates an action url that will force portlet into solo mode 
 * This is using private portal 6.0 API calls to do this. Will not work
 * for other portal's as far as I know.
 */
public class PortalAjaxUrlEncoder implements AjaxUrlEncoder {

	/**
	 * 
	 */
	public PortalAjaxUrlEncoder() throws Exception {
		super();
		
        try {
            Context ctxt = new InitialContext();
            final PortletServiceHome serviceHome = (PortletServiceHome) ctxt.lookup(JNDI_NAME);
            //_urlGenService = (PortalURLGenerationService) serviceHome.getPortletService(PortalURLGenerationService.class);
            _stateManService = (PortletStateManagerService) serviceHome.getPortletService(PortletStateManagerService.class);
        }
        catch(PortletServiceUnavailableException e)
        {
        	throw new Exception(e);
        }
        catch (NamingException e) {
            throw new Exception(e);
        }
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see temp.AjaxUrlEncoder#encodeAjaxUrl(null, java.lang.String)
	 */
	public String encodeAjaxUrl(FacesContext context, String url) {
		// TODO Auto-generated method stub
		ExternalContext extcontext = context.getExternalContext();
		
		HashMap map = new HashMap(3);
		
		String params = null;
		int n = url.indexOf('?');
		if (n > 0) {
			params = url.substring(n + 1);
			url = url.substring(0, n);
		}
		if (url.startsWith(extcontext.getRequestContextPath())) {
			url = url.substring(extcontext.getRequestContextPath().length());
		}
		if (url.startsWith(extcontext.getRequestServletPath())) {
			url = url.substring(extcontext.getRequestServletPath().length());
		}
				
		if (null != url) {
			String [] urla = {url};
			map.put(PortletConstants.SERVLET_PATH_INFO, urla);
		}
		if(null != params){
			addParams(params, map);
		}
		
		
		
		
		PortletRequest req = null;
		PortletResponse resp = null;

		ServletRequest arg0 = (ServletRequest)extcontext.getRequest();
		ServletResponse arg1 = (ServletResponse)extcontext.getResponse();
		
		while(arg0 instanceof HttpServletRequestWrapper) {
			arg0 = ((HttpServletRequestWrapper) arg0).getRequest();
		}
		while(arg1 instanceof HttpServletResponseWrapper) {
			arg1 = ((HttpServletResponseWrapper) arg1).getResponse();
		}
		
		if(arg0 instanceof PortletRequestWrapper) {
			req = ((PortletRequestWrapper) arg0).getPortletRequest();
		}

		if(arg1 instanceof PortletResponseWrapper) {
			resp = ((PortletResponseWrapper) arg1).getPortletResponse();
		}
		
		
		
		try{
			return createAjaxUrl(req, resp, map);
		}catch(IOException ioe)
		{
			
		}
		catch(PortletException pe)
		{
			
		}
		return null;
	}
	
	private void addParams(String params, Map map)
	{
		if(params != null){
			if((params.indexOf("=")) > -1){
				int pos1=0;
				int pos2=0;
				String name=null;
				String value=null;
				while(pos1 > -1){
					pos2=params.indexOf("=",pos1);
					name=params.substring(pos1,pos2);
					pos1=params.indexOf("&",pos2);
					if(pos1 == -1){
						value=params.substring(pos2+1);
					} else {
						value=params.substring(pos2+1,pos1);
						++pos1;
					}
					String [] valuea = {value};
					map.put(name,valuea);
				}
			}
		}
	}


  
	    private static final String JNDI_NAME = "portletservice/com.ibm.portal.state.service.PortletStateManagerService"; //$NON-NLS-1$
	    
	    /**Theme name: see jsp file in wps.ear\wps.war\themes\html\PortletFragment.jsp*/
	    private static final String THEME_NAME = "PortletFragment"; //$NON-NLS-1$
	    
	    private static final String MULTIPLE_ACTION_EXECUTION_ALLOWED = "wps.multiple.action.execution"; //$NON-NLS-1$
	    
	    private static final String ENFORCE_REDIRECT = "wps.multiple.action.execution"; //$NON-NLS-1$
	    
	    private PortletStateManagerService _stateManService;
	    
	    private boolean _useTheme = false;
	    
	    private boolean _useSoloMode = true;
	    
	    private boolean _useAction = true;
	    
	  
	    public String createAjaxUrl(PortletRequest request,
	            PortletResponse response, Map actionParameters)
	    throws PortletException, IOException {
	        PortletStateManager stateManager = null;
	        try {
	        	
	            ObjectID pageID = getPageId(request);
	            
	            ObjectID portletWindowID = getWindowId(request);
	            
	            stateManager = _stateManService.getPortletStateManager(request, response);
	            
	            StringWriter buffer = new StringWriter();
	            PrintWriter writer = new PrintWriter(buffer);
	            writePortletActionURL(stateManager, writer, pageID, portletWindowID, actionParameters, request.getPortletMode(), request.getWindowState());
	            
	            writer.flush();
	            return buffer.toString();
	        } catch(Exception e) {
	            throw new PortletException(e);
	        } finally {
	            if(stateManager!=null) {
	                stateManager.dispose();
	            }
	        }
	    }

	    private void writePortletActionURL(
	            final PortletStateManager stateManager, final PrintWriter writer,
	            final ObjectID pageID, final ObjectID portletWindowID,
	            final Map actionParams, final PortletMode portletMode,
	            final WindowState windowState) throws IOException, StateException {

	        // get a EngineURL from our URL factory

	        final URLFactory urlFactory = stateManager.getURLFactory();
	        final EngineURL returnURL = urlFactory.newURL((Clone) null);
	        
	        //use getAccessorFactory from StateManagerService rather than StateManager to avoid deprecated warning
	        final StateManagerService stateManagerService = stateManager;
	        
	        try {

	            // modify the state which is associated with the EngineURL

	           /* if(_useTheme) { // NOT CURRENTLY USABLE
	                // set the theme template
	                final ThemeTemplateAccessorFactory themeFct = (ThemeTemplateAccessorFactory) stateManagerService
	                .getAccessorFactory(ThemeTemplateAccessorFactory.class);
	                final ThemeTemplateAccessorController themeCtrl = themeFct
	                .getThemeTemplateAccessorController(returnURL.getState());
	                try {
	                    themeCtrl.setThemeTemplate(THEME_NAME);
	                }
	                finally {
	                    themeCtrl.dispose();
	                }
	            }*/

	        	
	        	
	            // set the target selection
	            final SelectionAccessorFactory selFct = (SelectionAccessorFactory) stateManagerService
	                    .getAccessorFactory(SelectionAccessorFactory.class);
	            final SelectionAccessorController selCtrl = selFct
	                    .getSelectionAccessorController(returnURL.getState());
	            try {
	                selCtrl.setSelection(pageID);
	                selCtrl.setSelectionMapping(pageID, portletWindowID);
	            }
	            finally {
	                selCtrl.dispose();
	            }

	            
	            if(_useSoloMode) {
	                final SoloAccessorFactory soloFct = (SoloAccessorFactory) stateManagerService.getAccessorFactory(SoloAccessorFactory.class);
	                final SoloAccessorController soloCtrl = soloFct.getSoloAccessorController(returnURL.getState());
	                try {
	                    soloCtrl.setSoloPortlet(portletWindowID);
	                } finally {
	                    soloCtrl.dispose();
	                }
	            }
	            
	            if(_useAction) {
	                // set the portlet action
	                final PortletTargetAccessorController targetCtrl = stateManager
	                .getPortletTargetAccessorController(returnURL.getState());
	                try {
	                    targetCtrl.setActionTarget(portletWindowID);
	                }
	                finally {
	                    targetCtrl.dispose();
	                }
	            }
	            
	            // set the portlet-specific state (portlet mode, window state,
	            // render parameters)
	            final PortletAccessorFactory portletFct = (PortletAccessorFactory) stateManagerService
	                    .getAccessorFactory(PortletAccessorFactory.class);
	            
	            final PortletAccessorController portletCtrl = portletFct
	                    .getPortletAccessorController(portletWindowID, returnURL
	                            .getState());
	            
	            try {
	                if (portletMode != null) {
	                    portletCtrl.setPortletMode(portletMode);
	                }
	            
	                if (windowState != null) {
	                    portletCtrl.setWindowState(windowState);
	                }
	            
	                try{
		                if (actionParams != null && !actionParams.isEmpty()) {
		                    portletCtrl.getParameters().putAll(actionParams);
		                }
	                }catch(Exception e)
	                {
	                	e.printStackTrace(System.out);
	                }
	            
	            }
	            finally {
	                portletCtrl.dispose();
	            }
	            
	            // write the URL to the given writer
	            returnURL.writeDispose(writer);

	        }
	        finally {
	            urlFactory.dispose();
	        }
	    }
	    
	    private PortletWindow getPortletWindow(PortletRequest request) {
	    	
	        InternalPortletRequest internalPortletRequest = PortletUtils
	                .getInternalRequest(request);
	        return internalPortletRequest.getPortletWindow();
	    }

	    private ObjectID getPageIdFromWindow(PortletWindow portletWindow) {
	        if (portletWindow instanceof PortletWindowEx) {
	            return ((PortletWindowEx) portletWindow).getContentPageId();
	        }
	        else {
	            return /*(ObjectID)*/ portletWindow.getCompositionId();
	        }
	    }

	    private ObjectID getPageId(PortletRequest request) {
	        PortletWindow portletWindow = getPortletWindow(request);
	        if (portletWindow == null) {
	            return null;
	        }
	        return getPageIdFromWindow(portletWindow);
	    }

	    private ObjectID getWindowId(PortletRequest request) {
	        PortletWindow portletWindow = getPortletWindow(request);
	        if (portletWindow == null) {
	            return null;
	        }
	        return /*(ObjectID)*/ portletWindow.getId();
	    }
	    
	
	
	
}
