/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.renderkit.html_extended;

import javax.faces.component.UIComponent;
import javax.faces.event.PhaseId;

import com.ibm.faces.event.PagerEvent;
import javax.faces.render.Renderer;

/**
 * Abstract class for pager renderers.
 */
public abstract class AbstractPagerRenderer extends Renderer {

    protected void queueEvent(
        UIComponent component,
        int currentPage,
        int newPage,
        int lastPage) {
        //note: lastPage could be -1 for unknown
        if ((newPage > lastPage) && (lastPage >= 0)) {
            newPage = lastPage;
        }
        if (newPage < 0) {
            newPage = 0;
        }

        if (newPage != currentPage) {
            PagerEvent pagerEvent = new PagerEvent(component, newPage);
            pagerEvent.setPhaseId(PhaseId.INVOKE_APPLICATION);
            component.queueEvent(pagerEvent);
        }
    }

}
