/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2000, 2003 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.renderkit.html_extended;

import java.util.HashMap;
import java.util.Map;

/**
 * Variables for AssistRenderer
 */
public class AssistVariables {
	
	//Variables from inputHelperAssist
	private String _autoTab = "false"; //$NON-NLS-1$
	private String _imeMode = "auto"; //$NON-NLS-1$
	private String _errorClass = null;
	private String _successClass = null;
	private String _errorAction = null;
	private String _successAction = null;
	private String _trigger = null;
	private String _onerror = null;
	private String _onsuccess = null;
	private String _inputAssist = "false"; //$NON-NLS-1$
	private String _validation = "false"; //$NON-NLS-1$
	private String _promptCharacter = "_"; //$NON-NLS-1$
	
	// Flag for the following values are used or not
	private boolean isSuccessActionUsed = false;
	private boolean isErrorActionUsed = false;
	private boolean isOnSuccessUsed = false;
	private boolean isOnErrorUsed = false;
	private boolean isMaxDigitUsed = false;
	
	// Variable from parent <h:input_text>
	private String _id;
	private String _defaultStyle;

	// Variables from Converter and Validators
	private Map _attrMap;

	// Parent UIComponent has which converter or validator
	private boolean _hasMaskConverter = false;
	private boolean _hasDateTimeConverter = false;
	private boolean _hasNumberConverter = false;
	private boolean _hasConstraintValidator = false;
	private boolean _hasDoubleRangeValidator = false;
	private boolean _hasLengthValidator = false;
	private boolean _hasLongRangeValidator = false;
	private boolean _hasDateTimeRangeValidator = false;

	// Parent Input field specified maxlength
	private boolean _isSpecifiedMaxLength = false;
	
	public AssistVariables(){
	}
	
	public void setAttributeToMap(String attrName, Object value){
		if(_attrMap == null){
			_attrMap = new HashMap();
		}
		_attrMap.put(attrName, value);
	}
	
	public Object getAttributeFromMap(String attrName){
		return _attrMap.get(attrName);
	}
	/**
	 * @return
	 */
	public Map getAttrMap() {
		return _attrMap;
	}

	/**
	 * @return
	 */
	public String getAutoTab() {
		return _autoTab;
	}

	/**
	 * @return
	 */
	public String getDefaultStyle() {
		return _defaultStyle;
	}

	/**
	 * @return
	 */
	public String getErrorAction() {
		return _errorAction;
	}

	/**
	 * @return
	 */
	public String getErrorClass() {
		return _errorClass;
	}

	/**
	 * @return
	 */
	public boolean isHasConstraintValidator() {
		return _hasConstraintValidator;
	}

	/**
	 * @return
	 */
	public boolean isHasDateTimeConverter() {
		return _hasDateTimeConverter;
	}

	/**
	 * @return
	 */
	public boolean isHasDateTimeRangeValidator() {
		return _hasDateTimeRangeValidator;
	}

	/**
	 * @return
	 */
	public boolean isHasDoubleRangeValidator() {
		return _hasDoubleRangeValidator;
	}

	/**
	 * @return
	 */
	public boolean isHasLengthValidator() {
		return _hasLengthValidator;
	}

	/**
	 * @return
	 */
	public boolean isHasLongRangeValidator() {
		return _hasLongRangeValidator;
	}

	/**
	 * @return
	 */
	public boolean isHasMaskConverter() {
		return _hasMaskConverter;
	}

	/**
	 * @return
	 */
	public boolean isHasNumberConverter() {
		return _hasNumberConverter;
	}

	/**
	 * @return
	 */
	public String getId() {
		return _id;
	}

	/**
	 * @return
	 */
	public String getImeMode() {
		return _imeMode;
	}

	/**
	 * @return
	 */
	public String getInputAssist() {
		return _inputAssist;
	}

	/**
	 * @return
	 */
	public boolean isIsSpecifiedMaxLength() {
		return _isSpecifiedMaxLength;
	}

	/**
	 * @return
	 */
	public String getOnerror() {
		return _onerror;
	}

	/**
	 * @return
	 */
	public String getOnsuccess() {
		return _onsuccess;
	}

	/**
	 * @return
	 */
	public String getSuccessAction() {
		return _successAction;
	}

	/**
	 * @return
	 */
	public String getSuccessClass() {
		return _successClass;
	}

	/**
	 * @return
	 */
	public String getTrigger() {
		return _trigger;
	}

	/**
	 * @return
	 */
	public String getValidation() {
		return _validation;
	}

	/**
	 * @param map
	 */
	public void setAttrMap(Map map) {
		_attrMap = map;
	}

	/**
	 * @param string
	 */
	public void setAutoTab(String string) {
		_autoTab = string;
	}

	/**
	 * @param string
	 */
	public void setDefaultStyle(String string) {
		_defaultStyle = string;
	}

	/**
	 * @param string
	 */
	public void setErrorAction(String string) {
		_errorAction = string;
	}

	/**
	 * @param string
	 */
	public void setErrorClass(String string) {
		_errorClass = string;
	}

	/**
	 * @param b
	 */
	public void setHasConstraintValidator(boolean b) {
		_hasConstraintValidator = b;
	}

	/**
	 * @param b
	 */
	public void setHasDateTimeConverter(boolean b) {
		_hasDateTimeConverter = b;
	}

	/**
	 * @param b
	 */
	public void setHasDateTimeRangeValidator(boolean b) {
		_hasDateTimeRangeValidator = b;
	}

	/**
	 * @param b
	 */
	public void setHasDoubleRangeValidator(boolean b) {
		_hasDoubleRangeValidator = b;
	}

	/**
	 * @param b
	 */
	public void setHasLengthValidator(boolean b) {
		_hasLengthValidator = b;
	}

	/**
	 * @param b
	 */
	public void setHasLongRangeValidator(boolean b) {
		_hasLongRangeValidator = b;
	}

	/**
	 * @param b
	 */
	public void setHasMaskConverter(boolean b) {
		_hasMaskConverter = b;
	}

	/**
	 * @param b
	 */
	public void setHasNumberConverter(boolean b) {
		_hasNumberConverter = b;
	}

	/**
	 * @param string
	 */
	public void setId(String string) {
		_id = string;
	}

	/**
	 * @param string
	 */
	public void setImeMode(String string) {
		_imeMode = string;
	}

	/**
	 * @param string
	 */
	public void setInputAssist(String string) {
		_inputAssist = string;
	}

	/**
	 * @param b
	 */
	public void setIsSpecifiedMaxLength(boolean b) {
		_isSpecifiedMaxLength = b;
	}

	/**
	 * @param string
	 */
	public void setOnerror(String string) {
		_onerror = string;
	}

	/**
	 * @param string
	 */
	public void setOnsuccess(String string) {
		_onsuccess = string;
	}

	/**
	 * @param string
	 */
	public void setSuccessAction(String string) {
		_successAction = string;
	}

	/**
	 * @param string
	 */
	public void setSuccessClass(String string) {
		_successClass = string;
	}

	/**
	 * @param string
	 */
	public void setTrigger(String string) {
		_trigger = string;
	}

	/**
	 * @param string
	 */
	public void setValidation(String string) {
		_validation = string;
	}

	/**
	 * @return
	 */
	public boolean isErrorActionUsed() {
		return isErrorActionUsed;
	}

	/**
	 * @return
	 */
	public boolean isOnErrorUsed() {
		return isOnErrorUsed;
	}

	/**
	 * @return
	 */
	public boolean isOnSuccessUsed() {
		return isOnSuccessUsed;
	}

	/**
	 * @return
	 */
	public boolean isSuccessActionUsed() {
		return isSuccessActionUsed;
	}

	/**
	 * @param b
	 */
	public void setErrorActionUsed(boolean b) {
		isErrorActionUsed = b;
	}

	/**
	 * @param b
	 */
	public void setOnErrorUsed(boolean b) {
		isOnErrorUsed = b;
	}

	/**
	 * @param b
	 */
	public void setOnSuccessUsed(boolean b) {
		isOnSuccessUsed = b;
	}

	/**
	 * @param b
	 */
	public void setSuccessActionUsed(boolean b) {
		isSuccessActionUsed = b;
	}

	/**
	 * @return
	 */
	public String getPromptCharacter() {
		return _promptCharacter;
	}

	/**
	 * @param string
	 */
	public void setPromptCharacter(String string) {
		_promptCharacter = string;
	}

	/**
	 * @return
	 */
	public boolean isMaxDigitUsed() {
		return isMaxDigitUsed;
	}

	/**
	 * @param b
	 */
	public void setMaxDigitUsed(boolean b) {
		isMaxDigitUsed = b;
	}

}
