/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.renderkit.html_extended;




import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.render.Renderer;

import java.io.IOException;
import java.util.Iterator;


/**
 * Arbitrary grouping "renderer" that simply renders its children
 * recursively in the <code>encodeChildren()</code> method.
 *
 * @version $Id: JspPanelRenderer.java,v 1.1.10.1.4.2.2.1 2006/06/02 12:40:23 bpmurray Exp $
 */
public class JspPanelRenderer extends Renderer {

    public JspPanelRenderer() {
        super();
    }

    public boolean getRendersChildren() {
        return true;
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        // Render our children recursively
        Iterator kids = component.getChildren().iterator();
        while (kids.hasNext()) {
            Utils.encodeComponent(context, (UIComponent) kids.next());
        }

    }

}
