/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2000, 2003 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.renderkit.html_extended;

/**
 * Variables for KeybindRenderer
 */
public class KeybindVariables {
	
	private String _scope;
	private String _key;
	private String _action;
	private String _target;
	private String _cancelBubble = "true"; //$NON-NLS-1$
	private String _onpressAction;
	
	public KeybindVariables(){
	}

	/**
	 * @return
	 */
	public String getAction() {
		return _action;
	}

	/**
	 * @return
	 */
	public String getCancelBubble() {
		return _cancelBubble;
	}

	/**
	 * @return
	 */
	public String getKey() {
		return _key;
	}

	/**
	 * @return
	 */
	public String getOnpressAction() {
		return _onpressAction;
	}

	/**
	 * @return
	 */
	public String getScope() {
		return _scope;
	}

	/**
	 * @return
	 */
	public String getTarget() {
		return _target;
	}

	/**
	 * @param string
	 */
	public void setAction(String string) {
		_action = string;
	}

	/**
	 * @param string
	 */
	public void setCancelBubble(String string) {
		_cancelBubble = string;
	}

	/**
	 * @param string
	 */
	public void setKey(String string) {
		_key = string;
	}

	/**
	 * @param string
	 */
	public void setOnpressAction(String string) {
		_onpressAction = string;
	}

	/**
	 * @param string
	 */
	public void setScope(String string) {
		_scope = string;
	}

	/**
	 * @param string
	 */
	public void setTarget(String string) {
		_target = string;
	}

}
