/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.renderkit.html_extended;

import java.io.IOException;

import javax.faces.component.UIComponent;

import javax.faces.context.FacesContext;

import javax.faces.render.Renderer;



/**
 * Renderer that does nothing, for components
 * that doen't need to render anything at all. 
 */

/**
 * @author womahony
 *
 */
public class NonRenderingRenderer extends Renderer {

	
	/** 
	 * This does nothing	
	 */
	public void encodeBegin(FacesContext context, UIComponent component)
		throws IOException {
		
		return;		
	}

	/**
	 * The componenets really should not have children
	 * but makes sure that if it does, they render themselves 
	 */
	public boolean getRendersChildren() {
		
		return false;
	}


	/**
	 * Does nothing
	 */
	public void encodeEnd(FacesContext context, UIComponent component)
		throws IOException {

		return;
	}
}
