/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.renderkit.html_extended;
import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import com.ibm.faces.component.UIRequest;
import com.ibm.faces.component.UIScriptCollector;

public class RequestRowActionRenderer extends Renderer {

    /**
     * @see javax.faces.render.Renderer#encodeBegin(javax.faces.context.FacesContext, javax.faces.component.UIComponent)
     * @param context
     * @param component
     * @throws IOException
     */
    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        
        //just a span to be rendered to get an id rendered, script will take care of rest
        ResponseWriter writer = context.getResponseWriter();
        writer.startElement("span",component);
        writer.writeAttribute("id",component.getClientId(context),"id");
        writer.endElement("span");

		String id = component.getClientId(context);
        
        StringBuffer script = new StringBuffer();
		script.append(HxClientRenderUtil.HX_VAR_NAME)
		.append(".addBehavior(")
		.append(HxClientRenderUtil.HX_VAR_NAME)
		.append(".getParentIdByType(\"")
		.append(id).append("\",\"TR")
		.append("\"),\"onclick\",new ")
		.append(HxClientRenderUtil.HX_VAR_NAME)
		.append(".JSFBehaviorRowAction(\"action-id:")
		.append(id)
		.append("\",\"url:")
		.append(((UIRequest)component).generateRequestURL(context))
		.append("\"));");

        //output script
        UIScriptCollector scriptCollector = UIScriptCollector.find(component);
		HxClientRenderUtil.initJSLibraries(scriptCollector, context);
		HxClientRenderUtil.addScriptLibrary("hxclient_be.js", component);
        HxClientRenderUtil.addScriptLibrary("hxclient_table.js",component);
		scriptCollector.addScript(script.toString());
    }


}
