/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;
import javax.faces.webapp.UIComponentTag;
import com.ibm.faces.component.UIFileProp;

/**
 * @author ekonstantinov
 *
 */
public class FilePropTag extends UIComponentTag {

	private java.lang.String name;
	private java.lang.String value;

	public void setName(java.lang.String name) {
		this.name = name;
	}

	public void setValue(java.lang.String value) {
		this.value = value;
	}

	public String getRendererType() { return null; }
	public String getComponentType() { return "com.ibm.faces.FileProp"; } //$NON-NLS-1$

	protected void setProperties(UIComponent component) {
		super.setProperties(component);
		UIFileProp attachment_property = (UIFileProp)component;

		attachment_property.setName(name);
		if (value != null) {
			if (isValueReference(value)) {
				ValueBinding vb = FacesContext.getCurrentInstance().getApplication().createValueBinding(value);
				attachment_property.setValueBinding("value", vb); //$NON-NLS-1$
			} else {
				attachment_property.setValue(value);
			}
		}
	}


}


