/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UICommandEx;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class CommandExButtonTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(CommandExButtonTag.class);

    //
    // Instance Variables
    //

    private java.lang.String action;
    private java.lang.String actionListener;
    private java.lang.String immediate;

    private java.lang.String accesskey;
    private java.lang.String alt;
    private java.lang.String confirm;
    private java.lang.String dimage;
    private java.lang.String dir;
    private java.lang.String disabled;
    private java.lang.String himage;
    private java.lang.String iconDepressed;
    private java.lang.String iconDisabled;
    private java.lang.String iconMoused;
    private java.lang.String iconNormal;
    private java.lang.String image;
    private java.lang.String lang;
    private java.lang.String onblur;
    private java.lang.String onchange;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String onselect;
    private java.lang.String pimage;
    private java.lang.String readonly;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String title;
    private java.lang.String type;
    private java.lang.String value;

    //
    // Setter Methods
    //

    public void setAction(java.lang.String action) {
        this.action = action;
    }

    public void setActionListener(java.lang.String actionListener) {
        this.actionListener = actionListener;
    }

    public void setImmediate(java.lang.String immediate) {
        this.immediate = immediate;
    }

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setAlt(java.lang.String alt) {
        this.alt = alt;
    }

    public void setConfirm(java.lang.String confirm) {
        this.confirm = confirm;
    }

    public void setDimage(java.lang.String dimage) {
        this.dimage = dimage;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setDisabled(java.lang.String disabled) {
        this.disabled = disabled;
    }

    public void setHimage(java.lang.String himage) {
        this.himage = himage;
    }

    public void setIconDepressed(java.lang.String iconDepressed) {
        this.iconDepressed = iconDepressed;
    }

    public void setIconDisabled(java.lang.String iconDisabled) {
        this.iconDisabled = iconDisabled;
    }

    public void setIconMoused(java.lang.String iconMoused) {
        this.iconMoused = iconMoused;
    }

    public void setIconNormal(java.lang.String iconNormal) {
        this.iconNormal = iconNormal;
    }

    public void setImage(java.lang.String image) {
        this.image = image;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnchange(java.lang.String onchange) {
        this.onchange = onchange;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setOnselect(java.lang.String onselect) {
        this.onselect = onselect;
    }

    public void setPimage(java.lang.String pimage) {
        this.pimage = pimage;
    }

    public void setReadonly(java.lang.String readonly) {
        this.readonly = readonly;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setType(java.lang.String type) {
        this.type = type;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Button";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlCommandExButton"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UICommandEx commandexComponent = (UICommandEx)component;

        if (action != null) {
             if (isValueReference(action)) {
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(action, null);
                commandexComponent.setAction(vb);
            } else {
                final String outcome = action;
                MethodBinding vb = new StaticMethodBinding(action);
                commandexComponent.setAction(vb);
            }
        }
        if (actionListener != null) {
            if (isValueReference(actionListener)) {
                Class args[] = { ActionEvent.class };
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(actionListener, args);
                commandexComponent.setActionListener(vb);
            } else {
              Object params [] = {actionListener};
              throw new javax.faces.FacesException();
            }
            }
        if (immediate != null) {
            if (isValueReference(immediate)) {
                ValueBinding vb = TagUtil.getValueBinding(immediate);
                commandexComponent.setValueBinding("immediate", vb); //$NON-NLS-1$
            } else {
                boolean _immediate = new Boolean(immediate).booleanValue();
                commandexComponent.setImmediate(_immediate);
            }
        }
        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                commandexComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (alt != null) {
            if (isValueReference(alt)) {
                ValueBinding vb = TagUtil.getValueBinding(alt);
                commandexComponent.setValueBinding("alt", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("alt", alt); //$NON-NLS-1$
            }
        }
        if (confirm != null) {
            if (isValueReference(confirm)) {
                ValueBinding vb = TagUtil.getValueBinding(confirm);
                commandexComponent.setValueBinding("confirm", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("confirm", confirm); //$NON-NLS-1$
            }
        }
        if (dimage != null) {
            if (isValueReference(dimage)) {
                ValueBinding vb = TagUtil.getValueBinding(dimage);
                commandexComponent.setValueBinding("dimage", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("dimage", dimage); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                commandexComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (disabled != null) {
            if (isValueReference(disabled)) {
                ValueBinding vb = TagUtil.getValueBinding(disabled);
                commandexComponent.setValueBinding("disabled", vb); //$NON-NLS-1$
            } else {
                boolean _disabled = new Boolean(disabled).booleanValue();
                commandexComponent.getAttributes().put("disabled", _disabled ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (himage != null) {
            if (isValueReference(himage)) {
                ValueBinding vb = TagUtil.getValueBinding(himage);
                commandexComponent.setValueBinding("himage", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("himage", himage); //$NON-NLS-1$
            }
        }
        if (iconDepressed != null) {
            if (isValueReference(iconDepressed)) {
                ValueBinding vb = TagUtil.getValueBinding(iconDepressed);
                commandexComponent.setValueBinding("iconDepressed", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("iconDepressed", iconDepressed); //$NON-NLS-1$
            }
        }
        if (iconDisabled != null) {
            if (isValueReference(iconDisabled)) {
                ValueBinding vb = TagUtil.getValueBinding(iconDisabled);
                commandexComponent.setValueBinding("iconDisabled", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("iconDisabled", iconDisabled); //$NON-NLS-1$
            }
        }
        if (iconMoused != null) {
            if (isValueReference(iconMoused)) {
                ValueBinding vb = TagUtil.getValueBinding(iconMoused);
                commandexComponent.setValueBinding("iconMoused", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("iconMoused", iconMoused); //$NON-NLS-1$
            }
        }
        if (iconNormal != null) {
            if (isValueReference(iconNormal)) {
                ValueBinding vb = TagUtil.getValueBinding(iconNormal);
                commandexComponent.setValueBinding("iconNormal", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("iconNormal", iconNormal); //$NON-NLS-1$
            }
        }
        if (image != null) {
            if (isValueReference(image)) {
                ValueBinding vb = TagUtil.getValueBinding(image);
                commandexComponent.setValueBinding("image", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("image", image); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                commandexComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                commandexComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onchange != null) {
            if (isValueReference(onchange)) {
                ValueBinding vb = TagUtil.getValueBinding(onchange);
                commandexComponent.setValueBinding("onchange", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onchange", onchange); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                commandexComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                commandexComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                commandexComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                commandexComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                commandexComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                commandexComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                commandexComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                commandexComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                commandexComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                commandexComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                commandexComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (onselect != null) {
            if (isValueReference(onselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onselect);
                commandexComponent.setValueBinding("onselect", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("onselect", onselect); //$NON-NLS-1$
            }
        }
        if (pimage != null) {
            if (isValueReference(pimage)) {
                ValueBinding vb = TagUtil.getValueBinding(pimage);
                commandexComponent.setValueBinding("pimage", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("pimage", pimage); //$NON-NLS-1$
            }
        }
        if (readonly != null) {
            if (isValueReference(readonly)) {
                ValueBinding vb = TagUtil.getValueBinding(readonly);
                commandexComponent.setValueBinding("readonly", vb); //$NON-NLS-1$
            } else {
                boolean _readonly = new Boolean(readonly).booleanValue();
                commandexComponent.getAttributes().put("readonly", _readonly ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                commandexComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                commandexComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                commandexComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                commandexComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (type != null) {
            if (isValueReference(type)) {
                ValueBinding vb = TagUtil.getValueBinding(type);
                commandexComponent.setValueBinding("type", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("type", type); //$NON-NLS-1$
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                commandexComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("value", value); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
