/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UICommandEx;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class CommandExRowEditTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(CommandExRowEditTag.class);

    //
    // Instance Variables
    //

    private java.lang.String action;
    private java.lang.String actionListener;
    private java.lang.String immediate;

    private java.lang.String cancelLabel;
    private java.lang.String editLabel;
    private java.lang.String editStyle;
    private java.lang.String editStyleClass;
    private java.lang.String saveLabel;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String title;

    //
    // Setter Methods
    //

    public void setAction(java.lang.String action) {
        this.action = action;
    }

    public void setActionListener(java.lang.String actionListener) {
        this.actionListener = actionListener;
    }

    public void setImmediate(java.lang.String immediate) {
        this.immediate = immediate;
    }

    public void setCancelLabel(java.lang.String cancelLabel) {
        this.cancelLabel = cancelLabel;
    }

    public void setEditLabel(java.lang.String editLabel) {
        this.editLabel = editLabel;
    }

    public void setEditStyle(java.lang.String editStyle) {
        this.editStyle = editStyle;
    }

    public void setEditStyleClass(java.lang.String editStyleClass) {
        this.editStyleClass = editStyleClass;
    }

    public void setSaveLabel(java.lang.String saveLabel) {
        this.saveLabel = saveLabel;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.RowEdit";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlCommandExRowEdit"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UICommandEx commandexComponent = (UICommandEx)component;

        if (action != null) {
             if (isValueReference(action)) {
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(action, null);
                commandexComponent.setAction(vb);
            } else {
                final String outcome = action;
                MethodBinding vb = new StaticMethodBinding(action);
                commandexComponent.setAction(vb);
            }
        }
        if (actionListener != null) {
            if (isValueReference(actionListener)) {
                Class args[] = { ActionEvent.class };
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(actionListener, args);
                commandexComponent.setActionListener(vb);
            } else {
              Object params [] = {actionListener};
              throw new javax.faces.FacesException();
            }
            }
        if (immediate != null) {
            if (isValueReference(immediate)) {
                ValueBinding vb = TagUtil.getValueBinding(immediate);
                commandexComponent.setValueBinding("immediate", vb); //$NON-NLS-1$
            } else {
                boolean _immediate = new Boolean(immediate).booleanValue();
                commandexComponent.setImmediate(_immediate);
            }
        }
        if (cancelLabel != null) {
            if (isValueReference(cancelLabel)) {
                ValueBinding vb = TagUtil.getValueBinding(cancelLabel);
                commandexComponent.setValueBinding("cancelLabel", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("cancelLabel", cancelLabel); //$NON-NLS-1$
            }
        }
        if (editLabel != null) {
            if (isValueReference(editLabel)) {
                ValueBinding vb = TagUtil.getValueBinding(editLabel);
                commandexComponent.setValueBinding("editLabel", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("editLabel", editLabel); //$NON-NLS-1$
            }
        }
        if (editStyle != null) {
            if (isValueReference(editStyle)) {
                ValueBinding vb = TagUtil.getValueBinding(editStyle);
                commandexComponent.setValueBinding("editStyle", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("editStyle", editStyle); //$NON-NLS-1$
            }
        }
        if (editStyleClass != null) {
            if (isValueReference(editStyleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(editStyleClass);
                commandexComponent.setValueBinding("editStyleClass", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("editStyleClass", editStyleClass); //$NON-NLS-1$
            }
        }
        if (saveLabel != null) {
            if (isValueReference(saveLabel)) {
                ValueBinding vb = TagUtil.getValueBinding(saveLabel);
                commandexComponent.setValueBinding("saveLabel", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("saveLabel", saveLabel); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                commandexComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                commandexComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                commandexComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                commandexComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
