/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIData;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class DataTableExTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(DataTableExTag.class);

    //
    // Instance Variables
    //

    private java.lang.String first;
    private java.lang.String rows;
    private java.lang.String value;
    private java.lang.String _var;

    private java.lang.String bgcolor;
    private java.lang.String border;
    private java.lang.String cellpadding;
    private java.lang.String cellspacing;
    private java.lang.String columnClasses;
    private java.lang.String dir;
    private java.lang.String footerClass;
    private java.lang.String forceFixedWidths;
    private java.lang.String frame;
    private java.lang.String headerClass;
    private java.lang.String lang;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String rowClasses;
    private java.lang.String rules;
    private java.lang.String scrollSize;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String summary;
    private java.lang.String title;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setFirst(java.lang.String first) {
        this.first = first;
    }

    public void setRows(java.lang.String rows) {
        this.rows = rows;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setVar(java.lang.String _var) {
        this._var = _var;
    }

    public void setBgcolor(java.lang.String bgcolor) {
        this.bgcolor = bgcolor;
    }

    public void setBorder(java.lang.String border) {
        this.border = border;
    }

    public void setCellpadding(java.lang.String cellpadding) {
        this.cellpadding = cellpadding;
    }

    public void setCellspacing(java.lang.String cellspacing) {
        this.cellspacing = cellspacing;
    }

    public void setColumnClasses(java.lang.String columnClasses) {
        this.columnClasses = columnClasses;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setFooterClass(java.lang.String footerClass) {
        this.footerClass = footerClass;
    }

    public void setForceFixedWidths(java.lang.String forceFixedWidths) {
        this.forceFixedWidths = forceFixedWidths;
    }

    public void setFrame(java.lang.String frame) {
        this.frame = frame;
    }

    public void setHeaderClass(java.lang.String headerClass) {
        this.headerClass = headerClass;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setRowClasses(java.lang.String rowClasses) {
        this.rowClasses = rowClasses;
    }

    public void setRules(java.lang.String rules) {
        this.rules = rules;
    }

    public void setScrollSize(java.lang.String scrollSize) {
        this.scrollSize = scrollSize;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setSummary(java.lang.String summary) {
        this.summary = summary;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.TableEx";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlDataTableEx"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIData dataComponent = (UIData)component;

        if (first != null) {
            if (isValueReference(first)) {
                ValueBinding vb = TagUtil.getValueBinding(first);
                dataComponent.setValueBinding("first", vb); //$NON-NLS-1$
            } else {
                int _first = new Integer(first).intValue();
                dataComponent.setFirst(_first);
            }
        }
        if (rows != null) {
            if (isValueReference(rows)) {
                ValueBinding vb = TagUtil.getValueBinding(rows);
                dataComponent.setValueBinding("rows", vb); //$NON-NLS-1$
            } else {
                int _rows = new Integer(rows).intValue();
                dataComponent.setRows(_rows);
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                dataComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                dataComponent.setValue(value);
            }
        }
        if (_var != null) {
            if (isValueReference(_var)) {
                ValueBinding vb = TagUtil.getValueBinding(_var);
                dataComponent.setValueBinding("_var", vb); //$NON-NLS-1$
            } else {
                dataComponent.setVar(_var);
            }
        }
        if (bgcolor != null) {
            if (isValueReference(bgcolor)) {
                ValueBinding vb = TagUtil.getValueBinding(bgcolor);
                dataComponent.setValueBinding("bgcolor", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("bgcolor", bgcolor); //$NON-NLS-1$
            }
        }
        if (border != null) {
            if (isValueReference(border)) {
                ValueBinding vb = TagUtil.getValueBinding(border);
                dataComponent.setValueBinding("border", vb); //$NON-NLS-1$
            } else {
                int _border = new Integer(border).intValue();
                if (_border != Integer.MIN_VALUE) {
                    dataComponent.getAttributes().put("border", new Integer(_border)); //$NON-NLS-1$
                }
            }
        }
        if (cellpadding != null) {
            if (isValueReference(cellpadding)) {
                ValueBinding vb = TagUtil.getValueBinding(cellpadding);
                dataComponent.setValueBinding("cellpadding", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("cellpadding", cellpadding); //$NON-NLS-1$
            }
        }
        if (cellspacing != null) {
            if (isValueReference(cellspacing)) {
                ValueBinding vb = TagUtil.getValueBinding(cellspacing);
                dataComponent.setValueBinding("cellspacing", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("cellspacing", cellspacing); //$NON-NLS-1$
            }
        }
        if (columnClasses != null) {
            if (isValueReference(columnClasses)) {
                ValueBinding vb = TagUtil.getValueBinding(columnClasses);
                dataComponent.setValueBinding("columnClasses", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("columnClasses", columnClasses); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                dataComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (footerClass != null) {
            if (isValueReference(footerClass)) {
                ValueBinding vb = TagUtil.getValueBinding(footerClass);
                dataComponent.setValueBinding("footerClass", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("footerClass", footerClass); //$NON-NLS-1$
            }
        }
        if (forceFixedWidths != null) {
            if (isValueReference(forceFixedWidths)) {
                ValueBinding vb = TagUtil.getValueBinding(forceFixedWidths);
                dataComponent.setValueBinding("forceFixedWidths", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("forceFixedWidths", forceFixedWidths); //$NON-NLS-1$
            }
        }
        if (frame != null) {
            if (isValueReference(frame)) {
                ValueBinding vb = TagUtil.getValueBinding(frame);
                dataComponent.setValueBinding("frame", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("frame", frame); //$NON-NLS-1$
            }
        }
        if (headerClass != null) {
            if (isValueReference(headerClass)) {
                ValueBinding vb = TagUtil.getValueBinding(headerClass);
                dataComponent.setValueBinding("headerClass", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("headerClass", headerClass); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                dataComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                dataComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                dataComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                dataComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                dataComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                dataComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                dataComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                dataComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                dataComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                dataComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                dataComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (rowClasses != null) {
            if (isValueReference(rowClasses)) {
                ValueBinding vb = TagUtil.getValueBinding(rowClasses);
                dataComponent.setValueBinding("rowClasses", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("rowClasses", rowClasses); //$NON-NLS-1$
            }
        }
        if (rules != null) {
            if (isValueReference(rules)) {
                ValueBinding vb = TagUtil.getValueBinding(rules);
                dataComponent.setValueBinding("rules", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("rules", rules); //$NON-NLS-1$
            }
        }
        if (scrollSize != null) {
            if (isValueReference(scrollSize)) {
                ValueBinding vb = TagUtil.getValueBinding(scrollSize);
                dataComponent.setValueBinding("scrollSize", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("scrollSize", scrollSize); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                dataComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                dataComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (summary != null) {
            if (isValueReference(summary)) {
                ValueBinding vb = TagUtil.getValueBinding(summary);
                dataComponent.setValueBinding("summary", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("summary", summary); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                dataComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                dataComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                dataComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
