/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UIFileupload;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class FileuploadTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(FileuploadTag.class);

    //
    // Instance Variables
    //

    private java.lang.String required;
    private java.lang.String value;

    private java.lang.String accept;
    private java.lang.String accesskey;
    private java.lang.String alt;
    private java.lang.String dir;
    private java.lang.String disabled;
    private java.lang.String exclude;
    private java.lang.String maxlength;
    private java.lang.String onblur;
    private java.lang.String onchange;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String onselect;
    private java.lang.String readonly;
    private java.lang.String size;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String title;

    //
    // Setter Methods
    //

    public void setRequired(java.lang.String required) {
        this.required = required;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setAccept(java.lang.String accept) {
        this.accept = accept;
    }

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setAlt(java.lang.String alt) {
        this.alt = alt;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setDisabled(java.lang.String disabled) {
        this.disabled = disabled;
    }

    public void setExclude(java.lang.String exclude) {
        this.exclude = exclude;
    }

    public void setMaxlength(java.lang.String maxlength) {
        this.maxlength = maxlength;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnchange(java.lang.String onchange) {
        this.onchange = onchange;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setOnselect(java.lang.String onselect) {
        this.onselect = onselect;
    }

    public void setReadonly(java.lang.String readonly) {
        this.readonly = readonly;
    }

    public void setSize(java.lang.String size) {
        this.size = size;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Fileupload";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlFileupload"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIFileupload fileuploadComponent = (UIFileupload)component;

        if (required != null) {
            if (isValueReference(required)) {
                ValueBinding vb = TagUtil.getValueBinding(required);
                fileuploadComponent.setValueBinding("required", vb); //$NON-NLS-1$
            } else {
                boolean _required = new Boolean(required).booleanValue();
                fileuploadComponent.setRequired(_required);
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                fileuploadComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.setValue(value);
            }
        }
        if (accept != null) {
            if (isValueReference(accept)) {
                ValueBinding vb = TagUtil.getValueBinding(accept);
                fileuploadComponent.setValueBinding("accept", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("accept", accept); //$NON-NLS-1$
            }
        }
        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                fileuploadComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (alt != null) {
            if (isValueReference(alt)) {
                ValueBinding vb = TagUtil.getValueBinding(alt);
                fileuploadComponent.setValueBinding("alt", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("alt", alt); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                fileuploadComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (disabled != null) {
            if (isValueReference(disabled)) {
                ValueBinding vb = TagUtil.getValueBinding(disabled);
                fileuploadComponent.setValueBinding("disabled", vb); //$NON-NLS-1$
            } else {
                boolean _disabled = new Boolean(disabled).booleanValue();
                fileuploadComponent.getAttributes().put("disabled", _disabled ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (exclude != null) {
            if (isValueReference(exclude)) {
                ValueBinding vb = TagUtil.getValueBinding(exclude);
                fileuploadComponent.setValueBinding("exclude", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("exclude", exclude); //$NON-NLS-1$
            }
        }
        if (maxlength != null) {
            if (isValueReference(maxlength)) {
                ValueBinding vb = TagUtil.getValueBinding(maxlength);
                fileuploadComponent.setValueBinding("maxlength", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("maxlength", maxlength); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                fileuploadComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onchange != null) {
            if (isValueReference(onchange)) {
                ValueBinding vb = TagUtil.getValueBinding(onchange);
                fileuploadComponent.setValueBinding("onchange", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onchange", onchange); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                fileuploadComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                fileuploadComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                fileuploadComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                fileuploadComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                fileuploadComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                fileuploadComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                fileuploadComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                fileuploadComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                fileuploadComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                fileuploadComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                fileuploadComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (onselect != null) {
            if (isValueReference(onselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onselect);
                fileuploadComponent.setValueBinding("onselect", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("onselect", onselect); //$NON-NLS-1$
            }
        }
        if (readonly != null) {
            if (isValueReference(readonly)) {
                ValueBinding vb = TagUtil.getValueBinding(readonly);
                fileuploadComponent.setValueBinding("readonly", vb); //$NON-NLS-1$
            } else {
                boolean _readonly = new Boolean(readonly).booleanValue();
                fileuploadComponent.getAttributes().put("readonly", _readonly ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (size != null) {
            if (isValueReference(size)) {
                ValueBinding vb = TagUtil.getValueBinding(size);
                fileuploadComponent.setValueBinding("size", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("size", size); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                fileuploadComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                fileuploadComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                fileuploadComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                fileuploadComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                fileuploadComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
