/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIGraphic;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class GraphicImageExTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(GraphicImageExTag.class);

    //
    // Instance Variables
    //

    private java.lang.String url;
    private java.lang.String value;

    private java.lang.String accesskey;
    private java.lang.String align;
    private java.lang.String alt;
    private java.lang.String border;
    private java.lang.String dir;
    private java.lang.String height;
    private java.lang.String hspace;
    private java.lang.String ismap;
    private java.lang.String lang;
    private java.lang.String longdesc;
    private java.lang.String mimeType;
    private java.lang.String onblur;
    private java.lang.String onchange;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String serverRelative;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String title;
    private java.lang.String usemap;
    private java.lang.String vspace;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setUrl(java.lang.String url) {
        this.url = url;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setAlign(java.lang.String align) {
        this.align = align;
    }

    public void setAlt(java.lang.String alt) {
        this.alt = alt;
    }

    public void setBorder(java.lang.String border) {
        this.border = border;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setHspace(java.lang.String hspace) {
        this.hspace = hspace;
    }

    public void setIsmap(java.lang.String ismap) {
        this.ismap = ismap;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setLongdesc(java.lang.String longdesc) {
        this.longdesc = longdesc;
    }

    public void setMimeType(java.lang.String mimeType) {
        this.mimeType = mimeType;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnchange(java.lang.String onchange) {
        this.onchange = onchange;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setServerRelative(java.lang.String serverRelative) {
        this.serverRelative = serverRelative;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setUsemap(java.lang.String usemap) {
        this.usemap = usemap;
    }

    public void setVspace(java.lang.String vspace) {
        this.vspace = vspace;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.ImageEx";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlGraphicImageEx"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIGraphic graphicComponent = (UIGraphic)component;

        if (url != null) {
            if (isValueReference(url)) {
                ValueBinding vb = TagUtil.getValueBinding(url);
                graphicComponent.setValueBinding("url", vb); //$NON-NLS-1$
            } else {
                graphicComponent.setUrl(url);
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                graphicComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                graphicComponent.setValue(value);
            }
        }
        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                graphicComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (align != null) {
            if (isValueReference(align)) {
                ValueBinding vb = TagUtil.getValueBinding(align);
                graphicComponent.setValueBinding("align", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("align", align); //$NON-NLS-1$
            }
        }
        if (alt != null) {
            if (isValueReference(alt)) {
                ValueBinding vb = TagUtil.getValueBinding(alt);
                graphicComponent.setValueBinding("alt", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("alt", alt); //$NON-NLS-1$
            }
        }
        if (border != null) {
            if (isValueReference(border)) {
                ValueBinding vb = TagUtil.getValueBinding(border);
                graphicComponent.setValueBinding("border", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("border", border); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                graphicComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                graphicComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (hspace != null) {
            if (isValueReference(hspace)) {
                ValueBinding vb = TagUtil.getValueBinding(hspace);
                graphicComponent.setValueBinding("hspace", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("hspace", hspace); //$NON-NLS-1$
            }
        }
        if (ismap != null) {
            if (isValueReference(ismap)) {
                ValueBinding vb = TagUtil.getValueBinding(ismap);
                graphicComponent.setValueBinding("ismap", vb); //$NON-NLS-1$
            } else {
                boolean _ismap = new Boolean(ismap).booleanValue();
                graphicComponent.getAttributes().put("ismap", _ismap ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                graphicComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (longdesc != null) {
            if (isValueReference(longdesc)) {
                ValueBinding vb = TagUtil.getValueBinding(longdesc);
                graphicComponent.setValueBinding("longdesc", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("longdesc", longdesc); //$NON-NLS-1$
            }
        }
        if (mimeType != null) {
            if (isValueReference(mimeType)) {
                ValueBinding vb = TagUtil.getValueBinding(mimeType);
                graphicComponent.setValueBinding("mimeType", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("mimeType", mimeType); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                graphicComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onchange != null) {
            if (isValueReference(onchange)) {
                ValueBinding vb = TagUtil.getValueBinding(onchange);
                graphicComponent.setValueBinding("onchange", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onchange", onchange); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                graphicComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                graphicComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                graphicComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                graphicComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                graphicComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                graphicComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                graphicComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                graphicComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                graphicComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                graphicComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                graphicComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (serverRelative != null) {
            if (isValueReference(serverRelative)) {
                ValueBinding vb = TagUtil.getValueBinding(serverRelative);
                graphicComponent.setValueBinding("serverRelative", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("serverRelative", serverRelative); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                graphicComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                graphicComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                graphicComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                graphicComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (usemap != null) {
            if (isValueReference(usemap)) {
                ValueBinding vb = TagUtil.getValueBinding(usemap);
                graphicComponent.setValueBinding("usemap", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("usemap", usemap); //$NON-NLS-1$
            }
        }
        if (vspace != null) {
            if (isValueReference(vspace)) {
                ValueBinding vb = TagUtil.getValueBinding(vspace);
                graphicComponent.setValueBinding("vspace", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("vspace", vspace); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                graphicComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                graphicComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
