/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UIInputHelper;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class InputHelperAssistTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(InputHelperAssistTag.class);

    //
    // Instance Variables
    //


    private java.lang.String autoSubmit;
    private java.lang.String autoTab;
    private java.lang.String errorAction;
    private java.lang.String errorClass;
    private java.lang.String imeMode;
    private java.lang.String inputAssist;
    private java.lang.String onerror;
    private java.lang.String onfocusErrorAction;
    private java.lang.String onfocusErrorClass;
    private java.lang.String onfocusSuccessAction;
    private java.lang.String onfocusSuccessClass;
    private java.lang.String onfocuserror;
    private java.lang.String onfocussuccess;
    private java.lang.String onsuccess;
    private java.lang.String promptCharacter;
    private java.lang.String successAction;
    private java.lang.String successClass;
    private java.lang.String targetErrorAction;
    private java.lang.String targetOnfocusErrorAction;
    private java.lang.String targetOnfocusSuccessAction;
    private java.lang.String targetSuccessAction;
    private java.lang.String validation;

    //
    // Setter Methods
    //

    public void setAutoSubmit(java.lang.String autoSubmit) {
        this.autoSubmit = autoSubmit;
    }

    public void setAutoTab(java.lang.String autoTab) {
        this.autoTab = autoTab;
    }

    public void setErrorAction(java.lang.String errorAction) {
        this.errorAction = errorAction;
    }

    public void setErrorClass(java.lang.String errorClass) {
        this.errorClass = errorClass;
    }

    public void setImeMode(java.lang.String imeMode) {
        this.imeMode = imeMode;
    }

    public void setInputAssist(java.lang.String inputAssist) {
        this.inputAssist = inputAssist;
    }

    public void setOnerror(java.lang.String onerror) {
        this.onerror = onerror;
    }

    public void setOnfocusErrorAction(java.lang.String onfocusErrorAction) {
        this.onfocusErrorAction = onfocusErrorAction;
    }

    public void setOnfocusErrorClass(java.lang.String onfocusErrorClass) {
        this.onfocusErrorClass = onfocusErrorClass;
    }

    public void setOnfocusSuccessAction(java.lang.String onfocusSuccessAction) {
        this.onfocusSuccessAction = onfocusSuccessAction;
    }

    public void setOnfocusSuccessClass(java.lang.String onfocusSuccessClass) {
        this.onfocusSuccessClass = onfocusSuccessClass;
    }

    public void setOnfocuserror(java.lang.String onfocuserror) {
        this.onfocuserror = onfocuserror;
    }

    public void setOnfocussuccess(java.lang.String onfocussuccess) {
        this.onfocussuccess = onfocussuccess;
    }

    public void setOnsuccess(java.lang.String onsuccess) {
        this.onsuccess = onsuccess;
    }

    public void setPromptCharacter(java.lang.String promptCharacter) {
        this.promptCharacter = promptCharacter;
    }

    public void setSuccessAction(java.lang.String successAction) {
        this.successAction = successAction;
    }

    public void setSuccessClass(java.lang.String successClass) {
        this.successClass = successClass;
    }

    public void setTargetErrorAction(java.lang.String targetErrorAction) {
        this.targetErrorAction = targetErrorAction;
    }

    public void setTargetOnfocusErrorAction(java.lang.String targetOnfocusErrorAction) {
        this.targetOnfocusErrorAction = targetOnfocusErrorAction;
    }

    public void setTargetOnfocusSuccessAction(java.lang.String targetOnfocusSuccessAction) {
        this.targetOnfocusSuccessAction = targetOnfocusSuccessAction;
    }

    public void setTargetSuccessAction(java.lang.String targetSuccessAction) {
        this.targetSuccessAction = targetSuccessAction;
    }

    public void setValidation(java.lang.String validation) {
        this.validation = validation;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Assist";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlInputHelperAssist"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIInputHelper inputhelperComponent = (UIInputHelper)component;

        if (autoSubmit != null) {
            if (isValueReference(autoSubmit)) {
                ValueBinding vb = TagUtil.getValueBinding(autoSubmit);
                inputhelperComponent.setValueBinding("autoSubmit", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("autoSubmit", autoSubmit); //$NON-NLS-1$
            }
        }
        if (autoTab != null) {
            if (isValueReference(autoTab)) {
                ValueBinding vb = TagUtil.getValueBinding(autoTab);
                inputhelperComponent.setValueBinding("autoTab", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("autoTab", autoTab); //$NON-NLS-1$
            }
        }
        if (errorAction != null) {
            if (isValueReference(errorAction)) {
                ValueBinding vb = TagUtil.getValueBinding(errorAction);
                inputhelperComponent.setValueBinding("errorAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("errorAction", errorAction); //$NON-NLS-1$
            }
        }
        if (errorClass != null) {
            if (isValueReference(errorClass)) {
                ValueBinding vb = TagUtil.getValueBinding(errorClass);
                inputhelperComponent.setValueBinding("errorClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("errorClass", errorClass); //$NON-NLS-1$
            }
        }
        if (imeMode != null) {
            if (isValueReference(imeMode)) {
                ValueBinding vb = TagUtil.getValueBinding(imeMode);
                inputhelperComponent.setValueBinding("imeMode", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("imeMode", imeMode); //$NON-NLS-1$
            }
        }
        if (inputAssist != null) {
            if (isValueReference(inputAssist)) {
                ValueBinding vb = TagUtil.getValueBinding(inputAssist);
                inputhelperComponent.setValueBinding("inputAssist", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("inputAssist", inputAssist); //$NON-NLS-1$
            }
        }
        if (onerror != null) {
            if (isValueReference(onerror)) {
                ValueBinding vb = TagUtil.getValueBinding(onerror);
                inputhelperComponent.setValueBinding("onerror", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onerror", onerror); //$NON-NLS-1$
            }
        }
        if (onfocusErrorAction != null) {
            if (isValueReference(onfocusErrorAction)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocusErrorAction);
                inputhelperComponent.setValueBinding("onfocusErrorAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onfocusErrorAction", onfocusErrorAction); //$NON-NLS-1$
            }
        }
        if (onfocusErrorClass != null) {
            if (isValueReference(onfocusErrorClass)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocusErrorClass);
                inputhelperComponent.setValueBinding("onfocusErrorClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onfocusErrorClass", onfocusErrorClass); //$NON-NLS-1$
            }
        }
        if (onfocusSuccessAction != null) {
            if (isValueReference(onfocusSuccessAction)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocusSuccessAction);
                inputhelperComponent.setValueBinding("onfocusSuccessAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onfocusSuccessAction", onfocusSuccessAction); //$NON-NLS-1$
            }
        }
        if (onfocusSuccessClass != null) {
            if (isValueReference(onfocusSuccessClass)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocusSuccessClass);
                inputhelperComponent.setValueBinding("onfocusSuccessClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onfocusSuccessClass", onfocusSuccessClass); //$NON-NLS-1$
            }
        }
        if (onfocuserror != null) {
            if (isValueReference(onfocuserror)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocuserror);
                inputhelperComponent.setValueBinding("onfocuserror", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onfocuserror", onfocuserror); //$NON-NLS-1$
            }
        }
        if (onfocussuccess != null) {
            if (isValueReference(onfocussuccess)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocussuccess);
                inputhelperComponent.setValueBinding("onfocussuccess", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onfocussuccess", onfocussuccess); //$NON-NLS-1$
            }
        }
        if (onsuccess != null) {
            if (isValueReference(onsuccess)) {
                ValueBinding vb = TagUtil.getValueBinding(onsuccess);
                inputhelperComponent.setValueBinding("onsuccess", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onsuccess", onsuccess); //$NON-NLS-1$
            }
        }
        if (promptCharacter != null) {
            if (isValueReference(promptCharacter)) {
                ValueBinding vb = TagUtil.getValueBinding(promptCharacter);
                inputhelperComponent.setValueBinding("promptCharacter", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("promptCharacter", promptCharacter); //$NON-NLS-1$
            }
        }
        if (successAction != null) {
            if (isValueReference(successAction)) {
                ValueBinding vb = TagUtil.getValueBinding(successAction);
                inputhelperComponent.setValueBinding("successAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("successAction", successAction); //$NON-NLS-1$
            }
        }
        if (successClass != null) {
            if (isValueReference(successClass)) {
                ValueBinding vb = TagUtil.getValueBinding(successClass);
                inputhelperComponent.setValueBinding("successClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("successClass", successClass); //$NON-NLS-1$
            }
        }
        if (targetErrorAction != null) {
            if (isValueReference(targetErrorAction)) {
                ValueBinding vb = TagUtil.getValueBinding(targetErrorAction);
                inputhelperComponent.setValueBinding("targetErrorAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("targetErrorAction", targetErrorAction); //$NON-NLS-1$
            }
        }
        if (targetOnfocusErrorAction != null) {
            if (isValueReference(targetOnfocusErrorAction)) {
                ValueBinding vb = TagUtil.getValueBinding(targetOnfocusErrorAction);
                inputhelperComponent.setValueBinding("targetOnfocusErrorAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("targetOnfocusErrorAction", targetOnfocusErrorAction); //$NON-NLS-1$
            }
        }
        if (targetOnfocusSuccessAction != null) {
            if (isValueReference(targetOnfocusSuccessAction)) {
                ValueBinding vb = TagUtil.getValueBinding(targetOnfocusSuccessAction);
                inputhelperComponent.setValueBinding("targetOnfocusSuccessAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("targetOnfocusSuccessAction", targetOnfocusSuccessAction); //$NON-NLS-1$
            }
        }
        if (targetSuccessAction != null) {
            if (isValueReference(targetSuccessAction)) {
                ValueBinding vb = TagUtil.getValueBinding(targetSuccessAction);
                inputhelperComponent.setValueBinding("targetSuccessAction", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("targetSuccessAction", targetSuccessAction); //$NON-NLS-1$
            }
        }
        if (validation != null) {
            if (isValueReference(validation)) {
                ValueBinding vb = TagUtil.getValueBinding(validation);
                inputhelperComponent.setValueBinding("validation", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("validation", validation); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
