/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UIInputHelper;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class InputHelperDatePickerTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(InputHelperDatePickerTag.class);

    //
    // Instance Variables
    //


    private java.lang.String buttonBorder;
    private java.lang.String buttonColor;
    private java.lang.String delta;
    private java.lang.String deltaHours;
    private java.lang.String deltaMinutes;
    private java.lang.String deltaSeconds;
    private java.lang.String firstDay;
    private java.lang.String multiLine;
    private java.lang.String positional;
    private java.lang.String styleClass;

    //
    // Setter Methods
    //

    public void setButtonBorder(java.lang.String buttonBorder) {
        this.buttonBorder = buttonBorder;
    }

    public void setButtonColor(java.lang.String buttonColor) {
        this.buttonColor = buttonColor;
    }

    public void setDelta(java.lang.String delta) {
        this.delta = delta;
    }

    public void setDeltaHours(java.lang.String deltaHours) {
        this.deltaHours = deltaHours;
    }

    public void setDeltaMinutes(java.lang.String deltaMinutes) {
        this.deltaMinutes = deltaMinutes;
    }

    public void setDeltaSeconds(java.lang.String deltaSeconds) {
        this.deltaSeconds = deltaSeconds;
    }

    public void setFirstDay(java.lang.String firstDay) {
        this.firstDay = firstDay;
    }

    public void setMultiLine(java.lang.String multiLine) {
        this.multiLine = multiLine;
    }

    public void setPositional(java.lang.String positional) {
        this.positional = positional;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.DatePicker";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlInputHelperDatePicker"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIInputHelper inputhelperComponent = (UIInputHelper)component;

        if (buttonBorder != null) {
            if (isValueReference(buttonBorder)) {
                ValueBinding vb = TagUtil.getValueBinding(buttonBorder);
                inputhelperComponent.setValueBinding("buttonBorder", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("buttonBorder", buttonBorder); //$NON-NLS-1$
            }
        }
        if (buttonColor != null) {
            if (isValueReference(buttonColor)) {
                ValueBinding vb = TagUtil.getValueBinding(buttonColor);
                inputhelperComponent.setValueBinding("buttonColor", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("buttonColor", buttonColor); //$NON-NLS-1$
            }
        }
        if (delta != null) {
            if (isValueReference(delta)) {
                ValueBinding vb = TagUtil.getValueBinding(delta);
                inputhelperComponent.setValueBinding("delta", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("delta", delta); //$NON-NLS-1$
            }
        }
        if (deltaHours != null) {
            if (isValueReference(deltaHours)) {
                ValueBinding vb = TagUtil.getValueBinding(deltaHours);
                inputhelperComponent.setValueBinding("deltaHours", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("deltaHours", deltaHours); //$NON-NLS-1$
            }
        }
        if (deltaMinutes != null) {
            if (isValueReference(deltaMinutes)) {
                ValueBinding vb = TagUtil.getValueBinding(deltaMinutes);
                inputhelperComponent.setValueBinding("deltaMinutes", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("deltaMinutes", deltaMinutes); //$NON-NLS-1$
            }
        }
        if (deltaSeconds != null) {
            if (isValueReference(deltaSeconds)) {
                ValueBinding vb = TagUtil.getValueBinding(deltaSeconds);
                inputhelperComponent.setValueBinding("deltaSeconds", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("deltaSeconds", deltaSeconds); //$NON-NLS-1$
            }
        }
        if (firstDay != null) {
            if (isValueReference(firstDay)) {
                ValueBinding vb = TagUtil.getValueBinding(firstDay);
                inputhelperComponent.setValueBinding("firstDay", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("firstDay", firstDay); //$NON-NLS-1$
            }
        }
        if (multiLine != null) {
            if (isValueReference(multiLine)) {
                ValueBinding vb = TagUtil.getValueBinding(multiLine);
                inputhelperComponent.setValueBinding("multiLine", vb); //$NON-NLS-1$
            } else {
                boolean _multiLine = new Boolean(multiLine).booleanValue();
                inputhelperComponent.getAttributes().put("multiLine", _multiLine ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (positional != null) {
            if (isValueReference(positional)) {
                ValueBinding vb = TagUtil.getValueBinding(positional);
                inputhelperComponent.setValueBinding("positional", vb); //$NON-NLS-1$
            } else {
                boolean _positional = new Boolean(positional).booleanValue();
                inputhelperComponent.getAttributes().put("positional", _positional ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                inputhelperComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
