/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UIInputHelper;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class InputHelperSliderTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(InputHelperSliderTag.class);

    //
    // Instance Variables
    //


    private java.lang.String buttonBorder;
    private java.lang.String buttonColor;
    private java.lang.String delta;
    private java.lang.String hideLabels;
    private java.lang.String labelIncrement;
    private java.lang.String styleClass;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setButtonBorder(java.lang.String buttonBorder) {
        this.buttonBorder = buttonBorder;
    }

    public void setButtonColor(java.lang.String buttonColor) {
        this.buttonColor = buttonColor;
    }

    public void setDelta(java.lang.String delta) {
        this.delta = delta;
    }

    public void setHideLabels(java.lang.String hideLabels) {
        this.hideLabels = hideLabels;
    }

    public void setLabelIncrement(java.lang.String labelIncrement) {
        this.labelIncrement = labelIncrement;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Slider";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlInputHelperSlider"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIInputHelper inputhelperComponent = (UIInputHelper)component;

        if (buttonBorder != null) {
            if (isValueReference(buttonBorder)) {
                ValueBinding vb = TagUtil.getValueBinding(buttonBorder);
                inputhelperComponent.setValueBinding("buttonBorder", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("buttonBorder", buttonBorder); //$NON-NLS-1$
            }
        }
        if (buttonColor != null) {
            if (isValueReference(buttonColor)) {
                ValueBinding vb = TagUtil.getValueBinding(buttonColor);
                inputhelperComponent.setValueBinding("buttonColor", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("buttonColor", buttonColor); //$NON-NLS-1$
            }
        }
        if (delta != null) {
            if (isValueReference(delta)) {
                ValueBinding vb = TagUtil.getValueBinding(delta);
                inputhelperComponent.setValueBinding("delta", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("delta", delta); //$NON-NLS-1$
            }
        }
        if (hideLabels != null) {
            if (isValueReference(hideLabels)) {
                ValueBinding vb = TagUtil.getValueBinding(hideLabels);
                inputhelperComponent.setValueBinding("hideLabels", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("hideLabels", hideLabels); //$NON-NLS-1$
            }
        }
        if (labelIncrement != null) {
            if (isValueReference(labelIncrement)) {
                ValueBinding vb = TagUtil.getValueBinding(labelIncrement);
                inputhelperComponent.setValueBinding("labelIncrement", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("labelIncrement", labelIncrement); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                inputhelperComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                inputhelperComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
