/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UIInputHelper;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class InputHelperTypeaheadTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(InputHelperTypeaheadTag.class);

    //
    // Instance Variables
    //


    private java.lang.String inProgress;
    private java.lang.String matchWidth;
    private java.lang.String maxSuggestions;
    private java.lang.String oncomplete;
    private java.lang.String onstart;
    private java.lang.String size;
    private java.lang.String startCharacters;
    private java.lang.String startDelay;
    private java.lang.String styleClass;
    private java.lang.String type;
    private java.lang.String value;

    //
    // Setter Methods
    //

    public void setInProgress(java.lang.String inProgress) {
        this.inProgress = inProgress;
    }

    public void setMatchWidth(java.lang.String matchWidth) {
        this.matchWidth = matchWidth;
    }

    public void setMaxSuggestions(java.lang.String maxSuggestions) {
        this.maxSuggestions = maxSuggestions;
    }

    public void setOncomplete(java.lang.String oncomplete) {
        this.oncomplete = oncomplete;
    }

    public void setOnstart(java.lang.String onstart) {
        this.onstart = onstart;
    }

    public void setSize(java.lang.String size) {
        this.size = size;
    }

    public void setStartCharacters(java.lang.String startCharacters) {
        this.startCharacters = startCharacters;
    }

    public void setStartDelay(java.lang.String startDelay) {
        this.startDelay = startDelay;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setType(java.lang.String type) {
        this.type = type;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Typeahead";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlInputHelperTypeahead"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIInputHelper inputhelperComponent = (UIInputHelper)component;

        if (inProgress != null) {
            if (isValueReference(inProgress)) {
                ValueBinding vb = TagUtil.getValueBinding(inProgress);
                inputhelperComponent.setValueBinding("inProgress", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("inProgress", inProgress); //$NON-NLS-1$
            }
        }
        if (matchWidth != null) {
            if (isValueReference(matchWidth)) {
                ValueBinding vb = TagUtil.getValueBinding(matchWidth);
                inputhelperComponent.setValueBinding("matchWidth", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("matchWidth", matchWidth); //$NON-NLS-1$
            }
        }
        if (maxSuggestions != null) {
            if (isValueReference(maxSuggestions)) {
                ValueBinding vb = TagUtil.getValueBinding(maxSuggestions);
                inputhelperComponent.setValueBinding("maxSuggestions", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("maxSuggestions", maxSuggestions); //$NON-NLS-1$
            }
        }
        if (oncomplete != null) {
            if (isValueReference(oncomplete)) {
                ValueBinding vb = TagUtil.getValueBinding(oncomplete);
                inputhelperComponent.setValueBinding("oncomplete", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("oncomplete", oncomplete); //$NON-NLS-1$
            }
        }
        if (onstart != null) {
            if (isValueReference(onstart)) {
                ValueBinding vb = TagUtil.getValueBinding(onstart);
                inputhelperComponent.setValueBinding("onstart", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("onstart", onstart); //$NON-NLS-1$
            }
        }
        if (size != null) {
            if (isValueReference(size)) {
                ValueBinding vb = TagUtil.getValueBinding(size);
                inputhelperComponent.setValueBinding("size", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("size", size); //$NON-NLS-1$
            }
        }
        if (startCharacters != null) {
            if (isValueReference(startCharacters)) {
                ValueBinding vb = TagUtil.getValueBinding(startCharacters);
                inputhelperComponent.setValueBinding("startCharacters", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("startCharacters", startCharacters); //$NON-NLS-1$
            }
        }
        if (startDelay != null) {
            if (isValueReference(startDelay)) {
                ValueBinding vb = TagUtil.getValueBinding(startDelay);
                inputhelperComponent.setValueBinding("startDelay", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("startDelay", startDelay); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                inputhelperComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (type != null) {
            if (isValueReference(type)) {
                ValueBinding vb = TagUtil.getValueBinding(type);
                inputhelperComponent.setValueBinding("type", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("type", type); //$NON-NLS-1$
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                inputhelperComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                inputhelperComponent.getAttributes().put("value", value); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
