/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class OutputLinkExTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(OutputLinkExTag.class);

    //
    // Instance Variables
    //

    private java.lang.String converter;
    private java.lang.String value;

    private java.lang.String accesskey;
    private java.lang.String charset;
    private java.lang.String coords;
    private java.lang.String dir;
    private java.lang.String hreflang;
    private java.lang.String lang;
    private java.lang.String mimeType;
    private java.lang.String onblur;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String rel;
    private java.lang.String rev;
    private java.lang.String shape;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String target;
    private java.lang.String title;
    private java.lang.String type;

    //
    // Setter Methods
    //

    public void setConverter(java.lang.String converter) {
        this.converter = converter;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setCharset(java.lang.String charset) {
        this.charset = charset;
    }

    public void setCoords(java.lang.String coords) {
        this.coords = coords;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setHreflang(java.lang.String hreflang) {
        this.hreflang = hreflang;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setMimeType(java.lang.String mimeType) {
        this.mimeType = mimeType;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setRel(java.lang.String rel) {
        this.rel = rel;
    }

    public void setRev(java.lang.String rev) {
        this.rev = rev;
    }

    public void setShape(java.lang.String shape) {
        this.shape = shape;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTarget(java.lang.String target) {
        this.target = target;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setType(java.lang.String type) {
        this.type = type;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.LinkEx";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlOutputLinkEx"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIOutput outputComponent = (UIOutput)component;

        if (converter != null) {
            if (isValueReference(converter)) {
                      ValueBinding vb = 
                          TagUtil.getValueBinding(converter);
                  outputComponent.setValueBinding("converter", vb); //$NON-NLS-1$
            } else {
                Converter _converter = FacesContext.getCurrentInstance().
                    getApplication().createConverter(converter);
                outputComponent.setConverter(_converter);
            }
        }

        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                outputComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                outputComponent.setValue(value);
            }
        }
        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                outputComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (charset != null) {
            if (isValueReference(charset)) {
                ValueBinding vb = TagUtil.getValueBinding(charset);
                outputComponent.setValueBinding("charset", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("charset", charset); //$NON-NLS-1$
            }
        }
        if (coords != null) {
            if (isValueReference(coords)) {
                ValueBinding vb = TagUtil.getValueBinding(coords);
                outputComponent.setValueBinding("coords", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("coords", coords); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                outputComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (hreflang != null) {
            if (isValueReference(hreflang)) {
                ValueBinding vb = TagUtil.getValueBinding(hreflang);
                outputComponent.setValueBinding("hreflang", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("hreflang", hreflang); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                outputComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (mimeType != null) {
            if (isValueReference(mimeType)) {
                ValueBinding vb = TagUtil.getValueBinding(mimeType);
                outputComponent.setValueBinding("mimeType", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("mimeType", mimeType); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                outputComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                outputComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                outputComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                outputComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                outputComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                outputComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                outputComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                outputComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                outputComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                outputComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                outputComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                outputComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (rel != null) {
            if (isValueReference(rel)) {
                ValueBinding vb = TagUtil.getValueBinding(rel);
                outputComponent.setValueBinding("rel", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("rel", rel); //$NON-NLS-1$
            }
        }
        if (rev != null) {
            if (isValueReference(rev)) {
                ValueBinding vb = TagUtil.getValueBinding(rev);
                outputComponent.setValueBinding("rev", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("rev", rev); //$NON-NLS-1$
            }
        }
        if (shape != null) {
            if (isValueReference(shape)) {
                ValueBinding vb = TagUtil.getValueBinding(shape);
                outputComponent.setValueBinding("shape", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("shape", shape); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                outputComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                outputComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                outputComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (target != null) {
            if (isValueReference(target)) {
                ValueBinding vb = TagUtil.getValueBinding(target);
                outputComponent.setValueBinding("target", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("target", target); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                outputComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (type != null) {
            if (isValueReference(type)) {
                ValueBinding vb = TagUtil.getValueBinding(type);
                outputComponent.setValueBinding("type", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("type", type); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
