/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class OutputSelecticonsTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(OutputSelecticonsTag.class);

    //
    // Instance Variables
    //

    private java.lang.String converter;
    private java.lang.String value;

    private java.lang.String _for;
    private java.lang.String srcAll;
    private java.lang.String srcInverse;
    private java.lang.String srcNone;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String title;
    private java.lang.String useButtons;

    //
    // Setter Methods
    //

    public void setConverter(java.lang.String converter) {
        this.converter = converter;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setFor(java.lang.String _for) {
        this._for = _for;
    }

    public void setSrcAll(java.lang.String srcAll) {
        this.srcAll = srcAll;
    }

    public void setSrcInverse(java.lang.String srcInverse) {
        this.srcInverse = srcInverse;
    }

    public void setSrcNone(java.lang.String srcNone) {
        this.srcNone = srcNone;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setUseButtons(java.lang.String useButtons) {
        this.useButtons = useButtons;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Selecticons";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlOutputSelecticons"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIOutput outputComponent = (UIOutput)component;

        if (converter != null) {
            if (isValueReference(converter)) {
                      ValueBinding vb = 
                          TagUtil.getValueBinding(converter);
                  outputComponent.setValueBinding("converter", vb); //$NON-NLS-1$
            } else {
                Converter _converter = FacesContext.getCurrentInstance().
                    getApplication().createConverter(converter);
                outputComponent.setConverter(_converter);
            }
        }

        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                outputComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                outputComponent.setValue(value);
            }
        }
        if (_for != null) {
            if (isValueReference(_for)) {
                ValueBinding vb = TagUtil.getValueBinding(_for);
                outputComponent.setValueBinding("__for", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("for", _for); //$NON-NLS-1$
            }
        }
        if (srcAll != null) {
            if (isValueReference(srcAll)) {
                ValueBinding vb = TagUtil.getValueBinding(srcAll);
                outputComponent.setValueBinding("srcAll", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("srcAll", srcAll); //$NON-NLS-1$
            }
        }
        if (srcInverse != null) {
            if (isValueReference(srcInverse)) {
                ValueBinding vb = TagUtil.getValueBinding(srcInverse);
                outputComponent.setValueBinding("srcInverse", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("srcInverse", srcInverse); //$NON-NLS-1$
            }
        }
        if (srcNone != null) {
            if (isValueReference(srcNone)) {
                ValueBinding vb = TagUtil.getValueBinding(srcNone);
                outputComponent.setValueBinding("srcNone", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("srcNone", srcNone); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                outputComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                outputComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                outputComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (useButtons != null) {
            if (isValueReference(useButtons)) {
                ValueBinding vb = TagUtil.getValueBinding(useButtons);
                outputComponent.setValueBinding("useButtons", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("useButtons", useButtons); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
