/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class OutputSeparatorTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(OutputSeparatorTag.class);

    //
    // Instance Variables
    //

    private java.lang.String converter;
    private java.lang.String value;

    private java.lang.String align;
    private java.lang.String color;
    private java.lang.String dir;
    private java.lang.String escape;
    private java.lang.String height;
    private java.lang.String label;
    private java.lang.String lang;
    private java.lang.String noshade;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String title;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setConverter(java.lang.String converter) {
        this.converter = converter;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setAlign(java.lang.String align) {
        this.align = align;
    }

    public void setColor(java.lang.String color) {
        this.color = color;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setEscape(java.lang.String escape) {
        this.escape = escape;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setLabel(java.lang.String label) {
        this.label = label;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setNoshade(java.lang.String noshade) {
        this.noshade = noshade;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Separator";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlOutputSeparator"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIOutput outputComponent = (UIOutput)component;

        if (converter != null) {
            if (isValueReference(converter)) {
                      ValueBinding vb = 
                          TagUtil.getValueBinding(converter);
                  outputComponent.setValueBinding("converter", vb); //$NON-NLS-1$
            } else {
                Converter _converter = FacesContext.getCurrentInstance().
                    getApplication().createConverter(converter);
                outputComponent.setConverter(_converter);
            }
        }

        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                outputComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                outputComponent.setValue(value);
            }
        }
        if (align != null) {
            if (isValueReference(align)) {
                ValueBinding vb = TagUtil.getValueBinding(align);
                outputComponent.setValueBinding("align", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("align", align); //$NON-NLS-1$
            }
        }
        if (color != null) {
            if (isValueReference(color)) {
                ValueBinding vb = TagUtil.getValueBinding(color);
                outputComponent.setValueBinding("color", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("color", color); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                outputComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (escape != null) {
            if (isValueReference(escape)) {
                ValueBinding vb = TagUtil.getValueBinding(escape);
                outputComponent.setValueBinding("escape", vb); //$NON-NLS-1$
            } else {
                boolean _escape = new Boolean(escape).booleanValue();
                outputComponent.getAttributes().put("escape", _escape ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                outputComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (label != null) {
            if (isValueReference(label)) {
                ValueBinding vb = TagUtil.getValueBinding(label);
                outputComponent.setValueBinding("label", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("label", label); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                outputComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (noshade != null) {
            if (isValueReference(noshade)) {
                ValueBinding vb = TagUtil.getValueBinding(noshade);
                outputComponent.setValueBinding("noshade", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("noshade", noshade); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                outputComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                outputComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                outputComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                outputComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
