/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class OutputStatisticsTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(OutputStatisticsTag.class);

    //
    // Instance Variables
    //

    private java.lang.String converter;
    private java.lang.String value;

    private java.lang.String filtered;
    private java.lang.String _for;
    private java.lang.String paging;
    private java.lang.String selected;
    private java.lang.String shown;
    private java.lang.String statusText;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String title;
    private java.lang.String total;

    //
    // Setter Methods
    //

    public void setConverter(java.lang.String converter) {
        this.converter = converter;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setFiltered(java.lang.String filtered) {
        this.filtered = filtered;
    }

    public void setFor(java.lang.String _for) {
        this._for = _for;
    }

    public void setPaging(java.lang.String paging) {
        this.paging = paging;
    }

    public void setSelected(java.lang.String selected) {
        this.selected = selected;
    }

    public void setShown(java.lang.String shown) {
        this.shown = shown;
    }

    public void setStatusText(java.lang.String statusText) {
        this.statusText = statusText;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setTotal(java.lang.String total) {
        this.total = total;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Statistics";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlOutputStatistics"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIOutput outputComponent = (UIOutput)component;

        if (converter != null) {
            if (isValueReference(converter)) {
                      ValueBinding vb = 
                          TagUtil.getValueBinding(converter);
                  outputComponent.setValueBinding("converter", vb); //$NON-NLS-1$
            } else {
                Converter _converter = FacesContext.getCurrentInstance().
                    getApplication().createConverter(converter);
                outputComponent.setConverter(_converter);
            }
        }

        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                outputComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                outputComponent.setValue(value);
            }
        }
        if (filtered != null) {
            if (isValueReference(filtered)) {
                ValueBinding vb = TagUtil.getValueBinding(filtered);
                outputComponent.setValueBinding("filtered", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("filtered", filtered); //$NON-NLS-1$
            }
        }
        if (_for != null) {
            if (isValueReference(_for)) {
                ValueBinding vb = TagUtil.getValueBinding(_for);
                outputComponent.setValueBinding("__for", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("for", _for); //$NON-NLS-1$
            }
        }
        if (paging != null) {
            if (isValueReference(paging)) {
                ValueBinding vb = TagUtil.getValueBinding(paging);
                outputComponent.setValueBinding("paging", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("paging", paging); //$NON-NLS-1$
            }
        }
        if (selected != null) {
            if (isValueReference(selected)) {
                ValueBinding vb = TagUtil.getValueBinding(selected);
                outputComponent.setValueBinding("selected", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("selected", selected); //$NON-NLS-1$
            }
        }
        if (shown != null) {
            if (isValueReference(shown)) {
                ValueBinding vb = TagUtil.getValueBinding(shown);
                outputComponent.setValueBinding("shown", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("shown", shown); //$NON-NLS-1$
            }
        }
        if (statusText != null) {
            if (isValueReference(statusText)) {
                ValueBinding vb = TagUtil.getValueBinding(statusText);
                outputComponent.setValueBinding("statusText", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("statusText", statusText); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                outputComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                outputComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                outputComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (total != null) {
            if (isValueReference(total)) {
                ValueBinding vb = TagUtil.getValueBinding(total);
                outputComponent.setValueBinding("total", vb); //$NON-NLS-1$
            } else {
                outputComponent.getAttributes().put("total", total); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
