/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIPanel;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class PanelActionbarTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(PanelActionbarTag.class);

    //
    // Instance Variables
    //


    private java.lang.String autoseparate;
    private java.lang.String height;
    private java.lang.String layout;
    private java.lang.String nestedExpanded;
    private java.lang.String nestedImagePosition;
    private java.lang.String nestedIndent;
    private java.lang.String nestedTitleImage;
    private java.lang.String nestedTitleText;
    private java.lang.String separatorSize;
    private java.lang.String separatorStyle;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String title;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setAutoseparate(java.lang.String autoseparate) {
        this.autoseparate = autoseparate;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setLayout(java.lang.String layout) {
        this.layout = layout;
    }

    public void setNestedExpanded(java.lang.String nestedExpanded) {
        this.nestedExpanded = nestedExpanded;
    }

    public void setNestedImagePosition(java.lang.String nestedImagePosition) {
        this.nestedImagePosition = nestedImagePosition;
    }

    public void setNestedIndent(java.lang.String nestedIndent) {
        this.nestedIndent = nestedIndent;
    }

    public void setNestedTitleImage(java.lang.String nestedTitleImage) {
        this.nestedTitleImage = nestedTitleImage;
    }

    public void setNestedTitleText(java.lang.String nestedTitleText) {
        this.nestedTitleText = nestedTitleText;
    }

    public void setSeparatorSize(java.lang.String separatorSize) {
        this.separatorSize = separatorSize;
    }

    public void setSeparatorStyle(java.lang.String separatorStyle) {
        this.separatorStyle = separatorStyle;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Actionbar";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlPanelActionbar"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIPanel panelComponent = (UIPanel)component;

        if (autoseparate != null) {
            if (isValueReference(autoseparate)) {
                ValueBinding vb = TagUtil.getValueBinding(autoseparate);
                panelComponent.setValueBinding("autoseparate", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("autoseparate", autoseparate); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                panelComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (layout != null) {
            if (isValueReference(layout)) {
                ValueBinding vb = TagUtil.getValueBinding(layout);
                panelComponent.setValueBinding("layout", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("layout", layout); //$NON-NLS-1$
            }
        }
        if (nestedExpanded != null) {
            if (isValueReference(nestedExpanded)) {
                ValueBinding vb = TagUtil.getValueBinding(nestedExpanded);
                panelComponent.setValueBinding("nestedExpanded", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("nestedExpanded", nestedExpanded); //$NON-NLS-1$
            }
        }
        if (nestedImagePosition != null) {
            if (isValueReference(nestedImagePosition)) {
                ValueBinding vb = TagUtil.getValueBinding(nestedImagePosition);
                panelComponent.setValueBinding("nestedImagePosition", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("nestedImagePosition", nestedImagePosition); //$NON-NLS-1$
            }
        }
        if (nestedIndent != null) {
            if (isValueReference(nestedIndent)) {
                ValueBinding vb = TagUtil.getValueBinding(nestedIndent);
                panelComponent.setValueBinding("nestedIndent", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("nestedIndent", nestedIndent); //$NON-NLS-1$
            }
        }
        if (nestedTitleImage != null) {
            if (isValueReference(nestedTitleImage)) {
                ValueBinding vb = TagUtil.getValueBinding(nestedTitleImage);
                panelComponent.setValueBinding("nestedTitleImage", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("nestedTitleImage", nestedTitleImage); //$NON-NLS-1$
            }
        }
        if (nestedTitleText != null) {
            if (isValueReference(nestedTitleText)) {
                ValueBinding vb = TagUtil.getValueBinding(nestedTitleText);
                panelComponent.setValueBinding("nestedTitleText", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("nestedTitleText", nestedTitleText); //$NON-NLS-1$
            }
        }
        if (separatorSize != null) {
            if (isValueReference(separatorSize)) {
                ValueBinding vb = TagUtil.getValueBinding(separatorSize);
                panelComponent.setValueBinding("separatorSize", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("separatorSize", separatorSize); //$NON-NLS-1$
            }
        }
        if (separatorStyle != null) {
            if (isValueReference(separatorStyle)) {
                ValueBinding vb = TagUtil.getValueBinding(separatorStyle);
                panelComponent.setValueBinding("separatorStyle", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("separatorStyle", separatorStyle); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                panelComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                panelComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                panelComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                panelComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                panelComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
