/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIPanel;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class PanelBoxTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(PanelBoxTag.class);

    //
    // Instance Variables
    //


    private java.lang.String align;
    private java.lang.String bgcolor;
    private java.lang.String border;
    private java.lang.String cellpadding;
    private java.lang.String cellspacing;
    private java.lang.String dir;
    private java.lang.String height;
    private java.lang.String lang;
    private java.lang.String layout;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String title;
    private java.lang.String valign;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setAlign(java.lang.String align) {
        this.align = align;
    }

    public void setBgcolor(java.lang.String bgcolor) {
        this.bgcolor = bgcolor;
    }

    public void setBorder(java.lang.String border) {
        this.border = border;
    }

    public void setCellpadding(java.lang.String cellpadding) {
        this.cellpadding = cellpadding;
    }

    public void setCellspacing(java.lang.String cellspacing) {
        this.cellspacing = cellspacing;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setLayout(java.lang.String layout) {
        this.layout = layout;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setValign(java.lang.String valign) {
        this.valign = valign;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Box";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlPanelBox"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIPanel panelComponent = (UIPanel)component;

        if (align != null) {
            if (isValueReference(align)) {
                ValueBinding vb = TagUtil.getValueBinding(align);
                panelComponent.setValueBinding("align", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("align", align); //$NON-NLS-1$
            }
        }
        if (bgcolor != null) {
            if (isValueReference(bgcolor)) {
                ValueBinding vb = TagUtil.getValueBinding(bgcolor);
                panelComponent.setValueBinding("bgcolor", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("bgcolor", bgcolor); //$NON-NLS-1$
            }
        }
        if (border != null) {
            if (isValueReference(border)) {
                ValueBinding vb = TagUtil.getValueBinding(border);
                panelComponent.setValueBinding("border", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("border", border); //$NON-NLS-1$
            }
        }
        if (cellpadding != null) {
            if (isValueReference(cellpadding)) {
                ValueBinding vb = TagUtil.getValueBinding(cellpadding);
                panelComponent.setValueBinding("cellpadding", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("cellpadding", cellpadding); //$NON-NLS-1$
            }
        }
        if (cellspacing != null) {
            if (isValueReference(cellspacing)) {
                ValueBinding vb = TagUtil.getValueBinding(cellspacing);
                panelComponent.setValueBinding("cellspacing", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("cellspacing", cellspacing); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                panelComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                panelComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                panelComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (layout != null) {
            if (isValueReference(layout)) {
                ValueBinding vb = TagUtil.getValueBinding(layout);
                panelComponent.setValueBinding("layout", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("layout", layout); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                panelComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                panelComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                panelComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (valign != null) {
            if (isValueReference(valign)) {
                ValueBinding vb = TagUtil.getValueBinding(valign);
                panelComponent.setValueBinding("valign", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("valign", valign); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                panelComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
