/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIPanel;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class PanelMenuTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(PanelMenuTag.class);

    //
    // Instance Variables
    //


    private java.lang.String flyOpen;
    private java.lang.String flyOpenBody;
    private java.lang.String initialSelection;
    private java.lang.String onchange;
    private java.lang.String openInPlace;
    private java.lang.String openSticky;
    private java.lang.String selectAll;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabIndex;
    private java.lang.String vertical;
    private java.lang.String verticalBody;

    //
    // Setter Methods
    //

    public void setFlyOpen(java.lang.String flyOpen) {
        this.flyOpen = flyOpen;
    }

    public void setFlyOpenBody(java.lang.String flyOpenBody) {
        this.flyOpenBody = flyOpenBody;
    }

    public void setInitialSelection(java.lang.String initialSelection) {
        this.initialSelection = initialSelection;
    }

    public void setOnchange(java.lang.String onchange) {
        this.onchange = onchange;
    }

    public void setOpenInPlace(java.lang.String openInPlace) {
        this.openInPlace = openInPlace;
    }

    public void setOpenSticky(java.lang.String openSticky) {
        this.openSticky = openSticky;
    }

    public void setSelectAll(java.lang.String selectAll) {
        this.selectAll = selectAll;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabIndex(java.lang.String tabIndex) {
        this.tabIndex = tabIndex;
    }

    public void setVertical(java.lang.String vertical) {
        this.vertical = vertical;
    }

    public void setVerticalBody(java.lang.String verticalBody) {
        this.verticalBody = verticalBody;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Menu";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlPanelMenu"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIPanel panelComponent = (UIPanel)component;

        if (flyOpen != null) {
            if (isValueReference(flyOpen)) {
                ValueBinding vb = TagUtil.getValueBinding(flyOpen);
                panelComponent.setValueBinding("flyOpen", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("flyOpen", flyOpen); //$NON-NLS-1$
            }
        }
        if (flyOpenBody != null) {
            if (isValueReference(flyOpenBody)) {
                ValueBinding vb = TagUtil.getValueBinding(flyOpenBody);
                panelComponent.setValueBinding("flyOpenBody", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("flyOpenBody", flyOpenBody); //$NON-NLS-1$
            }
        }
        if (initialSelection != null) {
            if (isValueReference(initialSelection)) {
                ValueBinding vb = TagUtil.getValueBinding(initialSelection);
                panelComponent.setValueBinding("initialSelection", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("initialSelection", initialSelection); //$NON-NLS-1$
            }
        }
        if (onchange != null) {
            if (isValueReference(onchange)) {
                ValueBinding vb = TagUtil.getValueBinding(onchange);
                panelComponent.setValueBinding("onchange", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("onchange", onchange); //$NON-NLS-1$
            }
        }
        if (openInPlace != null) {
            if (isValueReference(openInPlace)) {
                ValueBinding vb = TagUtil.getValueBinding(openInPlace);
                panelComponent.setValueBinding("openInPlace", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("openInPlace", openInPlace); //$NON-NLS-1$
            }
        }
        if (openSticky != null) {
            if (isValueReference(openSticky)) {
                ValueBinding vb = TagUtil.getValueBinding(openSticky);
                panelComponent.setValueBinding("openSticky", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("openSticky", openSticky); //$NON-NLS-1$
            }
        }
        if (selectAll != null) {
            if (isValueReference(selectAll)) {
                ValueBinding vb = TagUtil.getValueBinding(selectAll);
                panelComponent.setValueBinding("selectAll", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("selectAll", selectAll); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                panelComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                panelComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabIndex != null) {
            if (isValueReference(tabIndex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabIndex);
                panelComponent.setValueBinding("tabIndex", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("tabIndex", tabIndex); //$NON-NLS-1$
            }
        }
        if (vertical != null) {
            if (isValueReference(vertical)) {
                ValueBinding vb = TagUtil.getValueBinding(vertical);
                panelComponent.setValueBinding("vertical", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("vertical", vertical); //$NON-NLS-1$
            }
        }
        if (verticalBody != null) {
            if (isValueReference(verticalBody)) {
                ValueBinding vb = TagUtil.getValueBinding(verticalBody);
                panelComponent.setValueBinding("verticalBody", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("verticalBody", verticalBody); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
