/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIPanel;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class PanelRowCategoryTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(PanelRowCategoryTag.class);

    //
    // Instance Variables
    //


    private java.lang.String alt;
    private java.lang.String collapsed;
    private java.lang.String collapsedImage;
    private java.lang.String dir;
    private java.lang.String expandedImage;
    private java.lang.String lang;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String tabindexStartAt;
    private java.lang.String title;
    private java.lang.String value;

    //
    // Setter Methods
    //

    public void setAlt(java.lang.String alt) {
        this.alt = alt;
    }

    public void setCollapsed(java.lang.String collapsed) {
        this.collapsed = collapsed;
    }

    public void setCollapsedImage(java.lang.String collapsedImage) {
        this.collapsedImage = collapsedImage;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setExpandedImage(java.lang.String expandedImage) {
        this.expandedImage = expandedImage;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTabindexStartAt(java.lang.String tabindexStartAt) {
        this.tabindexStartAt = tabindexStartAt;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.RowCategory";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlPanelRowCategory"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIPanel panelComponent = (UIPanel)component;

        if (alt != null) {
            if (isValueReference(alt)) {
                ValueBinding vb = TagUtil.getValueBinding(alt);
                panelComponent.setValueBinding("alt", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("alt", alt); //$NON-NLS-1$
            }
        }
        if (collapsed != null) {
            if (isValueReference(collapsed)) {
                ValueBinding vb = TagUtil.getValueBinding(collapsed);
                panelComponent.setValueBinding("collapsed", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("collapsed", collapsed); //$NON-NLS-1$
            }
        }
        if (collapsedImage != null) {
            if (isValueReference(collapsedImage)) {
                ValueBinding vb = TagUtil.getValueBinding(collapsedImage);
                panelComponent.setValueBinding("collapsedImage", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("collapsedImage", collapsedImage); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                panelComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (expandedImage != null) {
            if (isValueReference(expandedImage)) {
                ValueBinding vb = TagUtil.getValueBinding(expandedImage);
                panelComponent.setValueBinding("expandedImage", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("expandedImage", expandedImage); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                panelComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                panelComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                panelComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                panelComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (tabindexStartAt != null) {
            if (isValueReference(tabindexStartAt)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindexStartAt);
                panelComponent.setValueBinding("tabindexStartAt", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("tabindexStartAt", tabindexStartAt); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                panelComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                panelComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                panelComponent.getAttributes().put("value", value); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
