/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UIPlayer;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class PlayerMediaPlayerTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(PlayerMediaPlayerTag.class);

    //
    // Instance Variables
    //


    private java.lang.String accesskey;
    private java.lang.String align;
    private java.lang.String alt;
    private java.lang.String archive;
    private java.lang.String autoStart;
    private java.lang.String baseURL;
    private java.lang.String border;
    private java.lang.String codebase;
    private java.lang.String dir;
    private java.lang.String enableContextMenu;
    private java.lang.String height;
    private java.lang.String hspace;
    private java.lang.String lang;
    private java.lang.String mimeType;
    private java.lang.String onblur;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String playCount;
    private java.lang.String playerAttributes;
    private java.lang.String src;
    private java.lang.String standby;
    private java.lang.String stretchToFit;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String title;
    private java.lang.String uiMode;
    private java.lang.String volume;
    private java.lang.String vspace;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setAlign(java.lang.String align) {
        this.align = align;
    }

    public void setAlt(java.lang.String alt) {
        this.alt = alt;
    }

    public void setArchive(java.lang.String archive) {
        this.archive = archive;
    }

    public void setAutoStart(java.lang.String autoStart) {
        this.autoStart = autoStart;
    }

    public void setBaseURL(java.lang.String baseURL) {
        this.baseURL = baseURL;
    }

    public void setBorder(java.lang.String border) {
        this.border = border;
    }

    public void setCodebase(java.lang.String codebase) {
        this.codebase = codebase;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setEnableContextMenu(java.lang.String enableContextMenu) {
        this.enableContextMenu = enableContextMenu;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setHspace(java.lang.String hspace) {
        this.hspace = hspace;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setMimeType(java.lang.String mimeType) {
        this.mimeType = mimeType;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setPlayCount(java.lang.String playCount) {
        this.playCount = playCount;
    }

    public void setPlayerAttributes(java.lang.String playerAttributes) {
        this.playerAttributes = playerAttributes;
    }

    public void setSrc(java.lang.String src) {
        this.src = src;
    }

    public void setStandby(java.lang.String standby) {
        this.standby = standby;
    }

    public void setStretchToFit(java.lang.String stretchToFit) {
        this.stretchToFit = stretchToFit;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setUiMode(java.lang.String uiMode) {
        this.uiMode = uiMode;
    }

    public void setVolume(java.lang.String volume) {
        this.volume = volume;
    }

    public void setVspace(java.lang.String vspace) {
        this.vspace = vspace;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.MediaPlayer";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlPlayerMediaPlayer"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIPlayer playerComponent = (UIPlayer)component;

        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                playerComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (align != null) {
            if (isValueReference(align)) {
                ValueBinding vb = TagUtil.getValueBinding(align);
                playerComponent.setValueBinding("align", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("align", align); //$NON-NLS-1$
            }
        }
        if (alt != null) {
            if (isValueReference(alt)) {
                ValueBinding vb = TagUtil.getValueBinding(alt);
                playerComponent.setValueBinding("alt", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("alt", alt); //$NON-NLS-1$
            }
        }
        if (archive != null) {
            if (isValueReference(archive)) {
                ValueBinding vb = TagUtil.getValueBinding(archive);
                playerComponent.setValueBinding("archive", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("archive", archive); //$NON-NLS-1$
            }
        }
        if (autoStart != null) {
            if (isValueReference(autoStart)) {
                ValueBinding vb = TagUtil.getValueBinding(autoStart);
                playerComponent.setValueBinding("autoStart", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("autoStart", autoStart); //$NON-NLS-1$
            }
        }
        if (baseURL != null) {
            if (isValueReference(baseURL)) {
                ValueBinding vb = TagUtil.getValueBinding(baseURL);
                playerComponent.setValueBinding("baseURL", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("baseURL", baseURL); //$NON-NLS-1$
            }
        }
        if (border != null) {
            if (isValueReference(border)) {
                ValueBinding vb = TagUtil.getValueBinding(border);
                playerComponent.setValueBinding("border", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("border", border); //$NON-NLS-1$
            }
        }
        if (codebase != null) {
            if (isValueReference(codebase)) {
                ValueBinding vb = TagUtil.getValueBinding(codebase);
                playerComponent.setValueBinding("codebase", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("codebase", codebase); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                playerComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (enableContextMenu != null) {
            if (isValueReference(enableContextMenu)) {
                ValueBinding vb = TagUtil.getValueBinding(enableContextMenu);
                playerComponent.setValueBinding("enableContextMenu", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("enableContextMenu", enableContextMenu); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                playerComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (hspace != null) {
            if (isValueReference(hspace)) {
                ValueBinding vb = TagUtil.getValueBinding(hspace);
                playerComponent.setValueBinding("hspace", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("hspace", hspace); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                playerComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (mimeType != null) {
            if (isValueReference(mimeType)) {
                ValueBinding vb = TagUtil.getValueBinding(mimeType);
                playerComponent.setValueBinding("mimeType", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("mimeType", mimeType); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                playerComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                playerComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                playerComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                playerComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                playerComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                playerComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                playerComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                playerComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                playerComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                playerComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                playerComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                playerComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (playCount != null) {
            if (isValueReference(playCount)) {
                ValueBinding vb = TagUtil.getValueBinding(playCount);
                playerComponent.setValueBinding("playCount", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("playCount", playCount); //$NON-NLS-1$
            }
        }
        if (playerAttributes != null) {
            if (isValueReference(playerAttributes)) {
                ValueBinding vb = TagUtil.getValueBinding(playerAttributes);
                playerComponent.setValueBinding("playerAttributes", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("playerAttributes", playerAttributes); //$NON-NLS-1$
            }
        }
        if (src != null) {
            if (isValueReference(src)) {
                ValueBinding vb = TagUtil.getValueBinding(src);
                playerComponent.setValueBinding("src", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("src", src); //$NON-NLS-1$
            }
        }
        if (standby != null) {
            if (isValueReference(standby)) {
                ValueBinding vb = TagUtil.getValueBinding(standby);
                playerComponent.setValueBinding("standby", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("standby", standby); //$NON-NLS-1$
            }
        }
        if (stretchToFit != null) {
            if (isValueReference(stretchToFit)) {
                ValueBinding vb = TagUtil.getValueBinding(stretchToFit);
                playerComponent.setValueBinding("stretchToFit", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("stretchToFit", stretchToFit); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                playerComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                playerComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                playerComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                playerComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (uiMode != null) {
            if (isValueReference(uiMode)) {
                ValueBinding vb = TagUtil.getValueBinding(uiMode);
                playerComponent.setValueBinding("uiMode", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("uiMode", uiMode); //$NON-NLS-1$
            }
        }
        if (volume != null) {
            if (isValueReference(volume)) {
                ValueBinding vb = TagUtil.getValueBinding(volume);
                playerComponent.setValueBinding("volume", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("volume", volume); //$NON-NLS-1$
            }
        }
        if (vspace != null) {
            if (isValueReference(vspace)) {
                ValueBinding vb = TagUtil.getValueBinding(vspace);
                playerComponent.setValueBinding("vspace", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("vspace", vspace); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                playerComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                playerComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
