/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.component.UISelectOne;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class SelectOneColorTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(SelectOneColorTag.class);

    //
    // Instance Variables
    //

    private java.lang.String converter;
    private java.lang.String immediate;
    private java.lang.String required;
    private java.lang.String validator;
    private java.lang.String value;
    private java.lang.String valueChangeListener;

    private java.lang.String accesskey;
    private java.lang.String buttonBorder;
    private java.lang.String buttonColor;
    private java.lang.String dir;
    private java.lang.String disabled;
    private java.lang.String dropdownClass;
    private java.lang.String lang;
    private java.lang.String onblur;
    private java.lang.String onchange;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String onselect;
    private java.lang.String showLabels;
    private java.lang.String size;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String title;

    //
    // Setter Methods
    //

    public void setConverter(java.lang.String converter) {
        this.converter = converter;
    }

    public void setImmediate(java.lang.String immediate) {
        this.immediate = immediate;
    }

    public void setRequired(java.lang.String required) {
        this.required = required;
    }

    public void setValidator(java.lang.String validator) {
        this.validator = validator;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setValueChangeListener(java.lang.String valueChangeListener) {
        this.valueChangeListener = valueChangeListener;
    }

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setButtonBorder(java.lang.String buttonBorder) {
        this.buttonBorder = buttonBorder;
    }

    public void setButtonColor(java.lang.String buttonColor) {
        this.buttonColor = buttonColor;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setDisabled(java.lang.String disabled) {
        this.disabled = disabled;
    }

    public void setDropdownClass(java.lang.String dropdownClass) {
        this.dropdownClass = dropdownClass;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnchange(java.lang.String onchange) {
        this.onchange = onchange;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setOnselect(java.lang.String onselect) {
        this.onselect = onselect;
    }

    public void setShowLabels(java.lang.String showLabels) {
        this.showLabels = showLabels;
    }

    public void setSize(java.lang.String size) {
        this.size = size;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.Color";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlSelectOneColor"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UISelectOne selectoneComponent = (UISelectOne)component;

        if (converter != null) {
            if (isValueReference(converter)) {
                      ValueBinding vb = 
                          TagUtil.getValueBinding(converter);
                  selectoneComponent.setValueBinding("converter", vb); //$NON-NLS-1$
            } else {
                Converter _converter = FacesContext.getCurrentInstance().
                    getApplication().createConverter(converter);
                selectoneComponent.setConverter(_converter);
            }
        }

        if (immediate != null) {
            if (isValueReference(immediate)) {
                ValueBinding vb = TagUtil.getValueBinding(immediate);
                selectoneComponent.setValueBinding("immediate", vb); //$NON-NLS-1$
            } else {
                boolean _immediate = new Boolean(immediate).booleanValue();
                selectoneComponent.setImmediate(_immediate);
            }
        }
        if (required != null) {
            if (isValueReference(required)) {
                ValueBinding vb = TagUtil.getValueBinding(required);
                selectoneComponent.setValueBinding("required", vb); //$NON-NLS-1$
            } else {
                boolean _required = new Boolean(required).booleanValue();
                selectoneComponent.setRequired(_required);
            }
        }
        if (validator != null) {
            if (isValueReference(validator)) {
                Class args[] = { FacesContext.class, UIComponent.class, Object.class };
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(validator, args);
                selectoneComponent.setValidator(vb);
            } else {
              Object params [] = {validator};
              throw new javax.faces.FacesException();
            }
            }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                selectoneComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.setValue(value);
            }
        }
        if (valueChangeListener != null) {
            if (isValueReference(valueChangeListener)) {
                Class args[] = { ValueChangeEvent.class };
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(valueChangeListener, args);
                selectoneComponent.setValueChangeListener(vb);
            } else {
              Object params [] = {valueChangeListener};
              throw new javax.faces.FacesException();
            }
            }
        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                selectoneComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (buttonBorder != null) {
            if (isValueReference(buttonBorder)) {
                ValueBinding vb = TagUtil.getValueBinding(buttonBorder);
                selectoneComponent.setValueBinding("buttonBorder", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("buttonBorder", buttonBorder); //$NON-NLS-1$
            }
        }
        if (buttonColor != null) {
            if (isValueReference(buttonColor)) {
                ValueBinding vb = TagUtil.getValueBinding(buttonColor);
                selectoneComponent.setValueBinding("buttonColor", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("buttonColor", buttonColor); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                selectoneComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (disabled != null) {
            if (isValueReference(disabled)) {
                ValueBinding vb = TagUtil.getValueBinding(disabled);
                selectoneComponent.setValueBinding("disabled", vb); //$NON-NLS-1$
            } else {
                boolean _disabled = new Boolean(disabled).booleanValue();
                selectoneComponent.getAttributes().put("disabled", _disabled ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (dropdownClass != null) {
            if (isValueReference(dropdownClass)) {
                ValueBinding vb = TagUtil.getValueBinding(dropdownClass);
                selectoneComponent.setValueBinding("dropdownClass", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("dropdownClass", dropdownClass); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                selectoneComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                selectoneComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onchange != null) {
            if (isValueReference(onchange)) {
                ValueBinding vb = TagUtil.getValueBinding(onchange);
                selectoneComponent.setValueBinding("onchange", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onchange", onchange); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                selectoneComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                selectoneComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                selectoneComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                selectoneComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                selectoneComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                selectoneComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                selectoneComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                selectoneComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                selectoneComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                selectoneComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                selectoneComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (onselect != null) {
            if (isValueReference(onselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onselect);
                selectoneComponent.setValueBinding("onselect", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("onselect", onselect); //$NON-NLS-1$
            }
        }
        if (showLabels != null) {
            if (isValueReference(showLabels)) {
                ValueBinding vb = TagUtil.getValueBinding(showLabels);
                selectoneComponent.setValueBinding("showLabels", vb); //$NON-NLS-1$
            } else {
                boolean _showLabels = new Boolean(showLabels).booleanValue();
                selectoneComponent.getAttributes().put("showLabels", _showLabels ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (size != null) {
            if (isValueReference(size)) {
                ValueBinding vb = TagUtil.getValueBinding(size);
                selectoneComponent.setValueBinding("size", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("size", size); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                selectoneComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                selectoneComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                selectoneComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                selectoneComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                selectoneComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
