/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.taglib.html_extended;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.component.UISortHeader;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class SortHeaderTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(SortHeaderTag.class);

    //
    // Instance Variables
    //

    private java.lang.String action;

    private java.lang.String accesskey;
    private java.lang.String charset;
    private java.lang.String defaultSortOrder;
    private java.lang.String dir;
    private java.lang.String hreflang;
    private java.lang.String lang;
    private java.lang.String onblur;
    private java.lang.String onclick;
    private java.lang.String ondblclick;
    private java.lang.String onfocus;
    private java.lang.String onkeydown;
    private java.lang.String onkeypress;
    private java.lang.String onkeyup;
    private java.lang.String onmousedown;
    private java.lang.String onmousemove;
    private java.lang.String onmouseout;
    private java.lang.String onmouseover;
    private java.lang.String onmouseup;
    private java.lang.String srcAscending;
    private java.lang.String srcAscendingOn;
    private java.lang.String srcBi;
    private java.lang.String srcBiDown;
    private java.lang.String srcBiUp;
    private java.lang.String srcDescending;
    private java.lang.String srcDescendingOn;
    private java.lang.String style;
    private java.lang.String styleClass;
    private java.lang.String tabindex;
    private java.lang.String target;
    private java.lang.String title;
    private java.lang.String value;

    //
    // Setter Methods
    //

    public void setAction(java.lang.String action) {
        this.action = action;
    }

    public void setAccesskey(java.lang.String accesskey) {
        this.accesskey = accesskey;
    }

    public void setCharset(java.lang.String charset) {
        this.charset = charset;
    }

    public void setDefaultSortOrder(java.lang.String defaultSortOrder) {
        this.defaultSortOrder = defaultSortOrder;
    }

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setHreflang(java.lang.String hreflang) {
        this.hreflang = hreflang;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setOnblur(java.lang.String onblur) {
        this.onblur = onblur;
    }

    public void setOnclick(java.lang.String onclick) {
        this.onclick = onclick;
    }

    public void setOndblclick(java.lang.String ondblclick) {
        this.ondblclick = ondblclick;
    }

    public void setOnfocus(java.lang.String onfocus) {
        this.onfocus = onfocus;
    }

    public void setOnkeydown(java.lang.String onkeydown) {
        this.onkeydown = onkeydown;
    }

    public void setOnkeypress(java.lang.String onkeypress) {
        this.onkeypress = onkeypress;
    }

    public void setOnkeyup(java.lang.String onkeyup) {
        this.onkeyup = onkeyup;
    }

    public void setOnmousedown(java.lang.String onmousedown) {
        this.onmousedown = onmousedown;
    }

    public void setOnmousemove(java.lang.String onmousemove) {
        this.onmousemove = onmousemove;
    }

    public void setOnmouseout(java.lang.String onmouseout) {
        this.onmouseout = onmouseout;
    }

    public void setOnmouseover(java.lang.String onmouseover) {
        this.onmouseover = onmouseover;
    }

    public void setOnmouseup(java.lang.String onmouseup) {
        this.onmouseup = onmouseup;
    }

    public void setSrcAscending(java.lang.String srcAscending) {
        this.srcAscending = srcAscending;
    }

    public void setSrcAscendingOn(java.lang.String srcAscendingOn) {
        this.srcAscendingOn = srcAscendingOn;
    }

    public void setSrcBi(java.lang.String srcBi) {
        this.srcBi = srcBi;
    }

    public void setSrcBiDown(java.lang.String srcBiDown) {
        this.srcBiDown = srcBiDown;
    }

    public void setSrcBiUp(java.lang.String srcBiUp) {
        this.srcBiUp = srcBiUp;
    }

    public void setSrcDescending(java.lang.String srcDescending) {
        this.srcDescending = srcDescending;
    }

    public void setSrcDescendingOn(java.lang.String srcDescendingOn) {
        this.srcDescendingOn = srcDescendingOn;
    }

    public void setStyle(java.lang.String style) {
        this.style = style;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTabindex(java.lang.String tabindex) {
        this.tabindex = tabindex;
    }

    public void setTarget(java.lang.String target) {
        this.target = target;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "com.ibm.faces.SortHeader";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.HtmlSortHeader"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UISortHeader sortheaderComponent = (UISortHeader)component;

        if (action != null) {
             if (isValueReference(action)) {
                MethodBinding vb = FacesContext.getCurrentInstance().getApplication().createMethodBinding(action, null);
                sortheaderComponent.setAction(vb);
            } else {
                final String outcome = action;
                MethodBinding vb = new StaticMethodBinding(action);
                sortheaderComponent.setAction(vb);
            }
        }
        if (accesskey != null) {
            if (isValueReference(accesskey)) {
                ValueBinding vb = TagUtil.getValueBinding(accesskey);
                sortheaderComponent.setValueBinding("accesskey", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("accesskey", accesskey); //$NON-NLS-1$
            }
        }
        if (charset != null) {
            if (isValueReference(charset)) {
                ValueBinding vb = TagUtil.getValueBinding(charset);
                sortheaderComponent.setValueBinding("charset", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("charset", charset); //$NON-NLS-1$
            }
        }
        if (defaultSortOrder != null) {
            if (isValueReference(defaultSortOrder)) {
                ValueBinding vb = TagUtil.getValueBinding(defaultSortOrder);
                sortheaderComponent.setValueBinding("defaultSortOrder", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("defaultSortOrder", defaultSortOrder); //$NON-NLS-1$
            }
        }
        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                sortheaderComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (hreflang != null) {
            if (isValueReference(hreflang)) {
                ValueBinding vb = TagUtil.getValueBinding(hreflang);
                sortheaderComponent.setValueBinding("hreflang", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("hreflang", hreflang); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                sortheaderComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (onblur != null) {
            if (isValueReference(onblur)) {
                ValueBinding vb = TagUtil.getValueBinding(onblur);
                sortheaderComponent.setValueBinding("onblur", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onblur", onblur); //$NON-NLS-1$
            }
        }
        if (onclick != null) {
            if (isValueReference(onclick)) {
                ValueBinding vb = TagUtil.getValueBinding(onclick);
                sortheaderComponent.setValueBinding("onclick", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onclick", onclick); //$NON-NLS-1$
            }
        }
        if (ondblclick != null) {
            if (isValueReference(ondblclick)) {
                ValueBinding vb = TagUtil.getValueBinding(ondblclick);
                sortheaderComponent.setValueBinding("ondblclick", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("ondblclick", ondblclick); //$NON-NLS-1$
            }
        }
        if (onfocus != null) {
            if (isValueReference(onfocus)) {
                ValueBinding vb = TagUtil.getValueBinding(onfocus);
                sortheaderComponent.setValueBinding("onfocus", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onfocus", onfocus); //$NON-NLS-1$
            }
        }
        if (onkeydown != null) {
            if (isValueReference(onkeydown)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeydown);
                sortheaderComponent.setValueBinding("onkeydown", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onkeydown", onkeydown); //$NON-NLS-1$
            }
        }
        if (onkeypress != null) {
            if (isValueReference(onkeypress)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeypress);
                sortheaderComponent.setValueBinding("onkeypress", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onkeypress", onkeypress); //$NON-NLS-1$
            }
        }
        if (onkeyup != null) {
            if (isValueReference(onkeyup)) {
                ValueBinding vb = TagUtil.getValueBinding(onkeyup);
                sortheaderComponent.setValueBinding("onkeyup", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onkeyup", onkeyup); //$NON-NLS-1$
            }
        }
        if (onmousedown != null) {
            if (isValueReference(onmousedown)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousedown);
                sortheaderComponent.setValueBinding("onmousedown", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onmousedown", onmousedown); //$NON-NLS-1$
            }
        }
        if (onmousemove != null) {
            if (isValueReference(onmousemove)) {
                ValueBinding vb = TagUtil.getValueBinding(onmousemove);
                sortheaderComponent.setValueBinding("onmousemove", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onmousemove", onmousemove); //$NON-NLS-1$
            }
        }
        if (onmouseout != null) {
            if (isValueReference(onmouseout)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseout);
                sortheaderComponent.setValueBinding("onmouseout", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onmouseout", onmouseout); //$NON-NLS-1$
            }
        }
        if (onmouseover != null) {
            if (isValueReference(onmouseover)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseover);
                sortheaderComponent.setValueBinding("onmouseover", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onmouseover", onmouseover); //$NON-NLS-1$
            }
        }
        if (onmouseup != null) {
            if (isValueReference(onmouseup)) {
                ValueBinding vb = TagUtil.getValueBinding(onmouseup);
                sortheaderComponent.setValueBinding("onmouseup", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("onmouseup", onmouseup); //$NON-NLS-1$
            }
        }
        if (srcAscending != null) {
            if (isValueReference(srcAscending)) {
                ValueBinding vb = TagUtil.getValueBinding(srcAscending);
                sortheaderComponent.setValueBinding("srcAscending", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcAscending", srcAscending); //$NON-NLS-1$
            }
        }
        if (srcAscendingOn != null) {
            if (isValueReference(srcAscendingOn)) {
                ValueBinding vb = TagUtil.getValueBinding(srcAscendingOn);
                sortheaderComponent.setValueBinding("srcAscendingOn", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcAscendingOn", srcAscendingOn); //$NON-NLS-1$
            }
        }
        if (srcBi != null) {
            if (isValueReference(srcBi)) {
                ValueBinding vb = TagUtil.getValueBinding(srcBi);
                sortheaderComponent.setValueBinding("srcBi", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcBi", srcBi); //$NON-NLS-1$
            }
        }
        if (srcBiDown != null) {
            if (isValueReference(srcBiDown)) {
                ValueBinding vb = TagUtil.getValueBinding(srcBiDown);
                sortheaderComponent.setValueBinding("srcBiDown", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcBiDown", srcBiDown); //$NON-NLS-1$
            }
        }
        if (srcBiUp != null) {
            if (isValueReference(srcBiUp)) {
                ValueBinding vb = TagUtil.getValueBinding(srcBiUp);
                sortheaderComponent.setValueBinding("srcBiUp", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcBiUp", srcBiUp); //$NON-NLS-1$
            }
        }
        if (srcDescending != null) {
            if (isValueReference(srcDescending)) {
                ValueBinding vb = TagUtil.getValueBinding(srcDescending);
                sortheaderComponent.setValueBinding("srcDescending", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcDescending", srcDescending); //$NON-NLS-1$
            }
        }
        if (srcDescendingOn != null) {
            if (isValueReference(srcDescendingOn)) {
                ValueBinding vb = TagUtil.getValueBinding(srcDescendingOn);
                sortheaderComponent.setValueBinding("srcDescendingOn", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("srcDescendingOn", srcDescendingOn); //$NON-NLS-1$
            }
        }
        if (style != null) {
            if (isValueReference(style)) {
                ValueBinding vb = TagUtil.getValueBinding(style);
                sortheaderComponent.setValueBinding("style", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("style", style); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                sortheaderComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (tabindex != null) {
            if (isValueReference(tabindex)) {
                ValueBinding vb = TagUtil.getValueBinding(tabindex);
                sortheaderComponent.setValueBinding("tabindex", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("tabindex", tabindex); //$NON-NLS-1$
            }
        }
        if (target != null) {
            if (isValueReference(target)) {
                ValueBinding vb = TagUtil.getValueBinding(target);
                sortheaderComponent.setValueBinding("target", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("target", target); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                sortheaderComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                sortheaderComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                sortheaderComponent.getAttributes().put("value", value); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
