/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2000, 2004 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.taglib.html_extended;

import javax.faces.validator.Validator;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.ValidatorTag;
import javax.servlet.jsp.JspException;

import com.ibm.faces.util.TagUtil;
import com.ibm.faces.validator.ConstraintValidator;


public class ValidateConstraintTag extends ValidatorTag {
	
	private String regex;
	
	public ValidateConstraintTag(){
		super();
		super.setId("Constraint");
		super.setValidatorId("Constraint");
	}
	/**
	 * @return
	 */
	public String getRegex() {
		return regex;
	}

	/**
	 * @param string
	 */
	public void setRegex(String regex) {
		this.regex = regex;
	}

	/* (non-Javadoc)
	 * @see javax.faces.webapp.ValidatorTag#createValidator()
	 */
	protected Validator createValidator() throws JspException {
		ConstraintValidator validator = null;
		
		validator = (ConstraintValidator)super.createValidator();
		
		if(regex != null){ 
			if(UIComponentTag.isValueReference(regex)){ //This could be a VBL expression, if it is
				Object result = TagUtil.getValueBindingValue(regex);	// convert it to a String
				if(result instanceof String){
					setRegex((String)result);					
				}
			}
			validator.setRegex(regex);
		}
		return validator;
	}

}
