/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2000, 2004 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.taglib.html_extended;

import javax.faces.validator.Validator;
import javax.faces.webapp.ValidatorTag;
import javax.servlet.jsp.JspException;

import com.ibm.faces.validator.ExpressionValidator;


public class ValidateExpressionTag extends ValidatorTag {
	
	private String expression;
	
	public ValidateExpressionTag(){
		super();
		super.setId("Expression"); //$NON-NLS-1$
		super.setValidatorId("Expression"); //$NON-NLS-1$
	}

	
	public String getExpression() {
		return expression;
	}
	public void setExpression(String expression) {
		this.expression = expression;
	}
	
	/* (non-Javadoc)
	 * @see javax.faces.webapp.ValidatorTag#createValidator()
	 */
	protected Validator createValidator() throws JspException {
		ExpressionValidator validator = null;
		
		validator = (ExpressionValidator)super.createValidator();
				
		if(expression != null){
			validator.setExpression(expression);
		}
		return validator;
	}

}
