/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.taglib.html_extended;

import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.ValidatorTag;
import javax.servlet.jsp.JspException;

import com.ibm.faces.validator.ModulusSelfCheckValidator;

/**
 * @author pandrews
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ValidateModulusSelfCheckTag extends ValidatorTag {
	
	
	private String modulus;
	
	
	
	public String getModulus() {
		return modulus;
	}
	public void setModulus(String modulus) {
		this.modulus = modulus;
	}
	
	public ValidateModulusSelfCheckTag(){
		super();
		setId("com.ibm.faces.ModulusSelfCheck");
		setValidatorId("com.ibm.faces.ModulusSelfCheck");
	}
	
	protected Validator createValidator() throws JspException {
		
		ModulusSelfCheckValidator validator = null;
		validator = (ModulusSelfCheckValidator)super.createValidator();
		
		if(getModulus() != null){
			if(UIComponentTag.isValueReference(getModulus())){
				Object value = FacesContext.getCurrentInstance().getApplication().createValueBinding(getModulus()).getValue(FacesContext.getCurrentInstance());
				if(value instanceof String){
					validator.setModulus((String)value);
				}

			} else {
				validator.setModulus(getModulus());
			}
		}
		return validator;
	}
}
