/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.util;

/**
 * @author pandrews
 * <p>JWL context-param names.</p>
 */

public class ContextParams {
	
	//TODO need to gather the rest in here
	
	
	/*
	 * <p>If set to true disables use of MultipartFacesContext, allowing underlying implementations be used
	 */
	public static final String DISABLE_JWL_MULTIPART_CONTEXT = "com.ibm.faces.DISABLE_JWL_MULTIPART_CONTEXT";
	/*
	 * <p>Custom ibmjsfres resources expiry value set to milliseconds, default is never
	 */
	public static final String RESOURCE_EXPIRE_MS = "com.ibm.faces.RESOURCE_EXPIRE_MS";

	/*
	 * <p>Date strictness level for hxclient.</p>
	 * Defines the strictness of the conversion when converting from a string to a date. 
	 * The higher the value, the more exactly the value must conform to the format. 
	 * 
	 * If 0 (liberal), all "literals" are ignored while parsing a value, mis-ordered components will be rearranged, 
	 * any missing component is supplied using the current datetime, misspellings and incomplete spellings are allowed
	 * (to the extent that they can be evaluated), "E" and other non-unique components are ignored.
	 *  
	 * If 1 (strict), all "literals" are ignored while parsing a value, any missing component is supplied using the current
	 * datetime, misspellings and incomplete spellings are allowed (to the extent that they can be evaluated), 
	 * "E" and other non-unique components are ignored. For example if the pattern is MMMM dd, yyyy a user can enter "Feb/02/04" 
	 * and it will be parsed as February 02, 2004.
	 *  
	 * If 2 (very strict), an exact match is required except long month names can be "shortened" to the minimum number of unique 
	 * characters and "E" and other non-unique components are ignored. Literals must match exactly.
	 * 
	 * Default is 1.	 
	*/
	public static final String DATETIME_ASSIST_STRICTNESS = "com.ibm.faces.DATETIME_ASSIST_STRICTNESS";

	/*
	 * <p>Number strictness level for hxclient.</p>
	 * Defines the strictness of the conversion when converting from a string to a number. 
	 * The higher the value, the more exactly the value must conform to the pattern. 
	 * For numbers, currently strictness levels of 0 and 1 are equivalent. 
	 * If the strictness is 2, if number is signed, the sign must be provided (otherwise it's assumed positive).
	 * Default is 1. 
	 */
	public static final String NUMBER_ASSIST_STRICTNESS = "com.ibm.faces.NUMBER_ASSIST_STRICTNESS";
	//added for RATLC00285398...
	/*
	 * <p>Sets an unencoded context path or number of nodes to take from a encoded context path, 
	 * resolving resource caching problems caused by encoded context path
	 */
	public static final String USE_UNENCODED_CONTEXT_PATH = "com.ibm.faces.USE_UNENCODED_CONTEXT_PATH"; //$NON-NLS-1$
	
	//added for RATLC01083006
	/*
	 * <p>Sets a custom url-pattern for the JS Resource servlet, if a user modifies the default 
	 * value '/.ibmjsfres/*' they must also use this new context-param.</p>
	 */
    public static final String JS_RESOURCE_SERVLET_URL_PATTERN= "com.ibm.faces.JS_RESOURCE_SERVLET_URL_PATTERN";

    /*
     * <p>If true enables caching in JSResourceServlet.</p>
     */
    /**
     * @deprecated
     */
    public static final String PARAM_CACHE_OLD = "cache";
    public static final String JS_RESOURCE_SERVLET_CACHE = "com.ibm.faces.JS_RESOURCE_SERVLET_CACHE";
	
    /*
     * <p>Sets a custom charset mapping properties file similar to converter.properties in WAS.</p>
     */
    public static final String ENCODING_MAPPING = "com.ibm.faces.ENCODING_MAPPING";
    
    public static final String ENHANCED_SERVER_STATE_SAVING_SESSION_STORED_VIEWS = "com.ibm.faces.ENHANCED_SERVER_STATE_SAVING_SESSION_STORED_VIEWS";
    
    //TODO - this maybe removed, we're not 100% on going with pooling for 3.0 
    /*
     * <p>Sets the amount of FacesContext object to be stored in a pool to be recyclcled.</p>
     */
    public static final String FACES_CONTEXT_POOL_SIZE = "com.ibm.faces.FACES_CONTEXT_POOL_SIZE";
    
    /*
     * <p>If true renders a single comprehensive hx client script file when script is required as opposed 
     * to the default of emitting sections of the same script file as required.</p>
     */
    public static final String USE_HXCLIENT_FULL = "com.ibm.faces.USE_HXCLIENT_FULL";
    
    /*
     * <p>If false, client data will not be encoded, allowing multiple portlets on a page to
     * share the same client data model. By default, client data will be encoded, so any value other than
     * "false", or the absence of the parameter, will result in client data being encoded.</p>
     * <p> This also affects using Page Data with the Chart or Data Tree. By defualt
     * Page Data is encoded. Setting this value to "false" will also unencode any Page Data that is being used
     * with either a Chart or a Data Tree.</p>
     */
    public static final String ENCODE_DATA = "com.ibm.faces.ENCODE_DATA";
    
    
    /*
     * <p>Applied to Portal 5.1 ONLY. Hack for Portal 5.1.0.3 onwards. If you want to use ajax This value must be set to <b>true</b>.
     *  There are certains classes that became availible in later versions of Portal 5.1.0.X, that were
     *  at the time only meant to on Portal 6.0 and some of these are used for ajax, but not all are availabile.
     *  This says use the ajax encoder path that does not use the portal 6.0 enhancements. 
     * </p>
     */ 
    public static final String TURN_OFF_AJAX_PORTAL_60_PATH = "com.ibm.faces.TURN_OFF_AJAX_PORTAL_60_PATH";
    
    
    /*
     * <p> Used to specify the name of the jwl ajax encoder class for the  AjaxUrlFactory class
     *      to instancate and use as the encoder class for that application.     *     
     * </p>
     */ 
    public static final String JWL_AJAX_ENCODER_CLASS = "com.ibm.faces.JWL_AJAX_ENCODER_CLASS";
   
}
