/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.util;

import java.sql.ResultSet;
import java.util.Collections;
import java.util.List;

import javax.faces.model.ArrayDataModel;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.ResultDataModel;
import javax.faces.model.ResultSetDataModel;
import javax.faces.model.ScalarDataModel;
import javax.servlet.jsp.jstl.sql.Result;

/**
 * @author pandrews
 */


public class DataModelUtil {
	
	/*
	 *<p>Returns correct DataModel instance for value.</p> 
	 */
    public static DataModel getDataModel(Object value) {
    	DataModel model = null;
        if(value != null){
        	if(value instanceof List){
        		model = new ListDataModel((List)value);
        	} else if(value instanceof Object[]){
        		model =  new ArrayDataModel((Object[])value);
        	} else if(value instanceof Result){
        		model = new ResultDataModel((Result)value);
        	} else if(value instanceof ResultSet){
        		model = new ResultSetDataModel((ResultSet)value);
        	} else if(value instanceof DataModel){
        		model = (DataModel)value;
        	} else {
        		model = new ScalarDataModel(value);
        	}
        } else {
        	model = new ListDataModel(Collections.EMPTY_LIST);
        }
        return model;
    }
}
