/*
 * Created on 22-Mar-2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.faces.util;

import java.text.MessageFormat;
import java.util.ResourceBundle;
import java.lang.reflect.Array;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;

import com.ibm.faces.ResourceHandler;

/**
 * @author ieu93313
 *
 * This is to provide JSF 1.2 ability to allow a message to be specifed on a input tag.
 * 
 */
public class FacesMessageUtil {

	private static String _validatorMessage = "validatorMessage"; // JSF 1.2
	private static String _converterMessage = "converterMessage"; // JSF 1.2
	//private static String _requiredMessage = "requiredMessage"; // JSF 1.2 // don't know if we need this ?
	private static String _label = "label";
	
	/**
	 * This method will get the validator message
	 * 
	 * You are required to pass in the bundle to use, the UIInpout Based component you are validating on, The key in for summary string of the valiadton error in the bundle supplied
	 *   and the value you are validating. value can also be an array.
	 * 
	 * You should also pass in the FacesMessage.Severity for the severity level you want and The key in for detail string of the validation error in the bundle supplied
	 * if you pass in overRideMessage (this will appear as the summary and detail messages of your message object)
	 * */
	public static FacesMessage getValidatorFacesMessage(ResourceBundle rb, FacesMessage.Severity severity, String summaryKey, String detailKey, UIComponent component, Object value)
	{
		//String summaryMessage = null;
		//String detailMessage = null;
		
		String validatorMessage = null;
		if(component != null)
			validatorMessage =(String)component.getAttributes().get(_validatorMessage);
		//String label = (String)component.getAttributes().get(_label);
		// this is to cover JSF 1.2, done this way for backward compatability
	/*	if(validatorMessage != null)
		{
			summaryMessage = detailMessage = validatorMessage; // if message is set on the input, then it is both the summary and detail messages
		}
		else
		{			
			summaryMessage = ResourceHandler.getFacesMessageString(rb,summaryKey);
			detailMessage = ResourceHandler.getFacesMessageString(rb,detailKey);
		}
		// try to set the 'label' if it exists		 // start assume
		Object[] values = null;
		if(label != null)
			values = new Object[]{value,label};
		else
			values = new Object[]{value};
		
		MessageFormat message = new MessageFormat(summaryMessage);
		summaryMessage = message.format(values);
		message = new MessageFormat(detailMessage);
		detailMessage = message.format(values);     // end assume
		
						//assume we will always have a summary (at least)
		FacesMessage mess = new FacesMessage(summaryMessage);
		if(detailMessage != null)
			mess.setDetail(detailMessage);
		if(severity != null)	
			mess.setSeverity(severity);
		return mess; */
	
		return getFM(rb, severity, summaryKey, detailKey, component, value, validatorMessage);
	}

	/**
	 * This method will get the converter message
	 * 
	 * You are required to pass in the bundle to use, the UIInpout Based component you are converting on, The key in for summary string of the conversion error in the bundle supplied
	 *   and the value you are converting. value can also be an array.
	 * 
	 * You should also pass in the FacesMessage.Severity for the severity level you want and The key in for detail string of the conversion error in the bundle supplied
	 * if you pass in overRideMessage (this will appear as the summary and detail messages of your message object)
	 * */
	public static FacesMessage getConverterFacesMessage(ResourceBundle rb, FacesMessage.Severity severity, String summaryKey, String detailKey, UIComponent component, Object value)
	{
		String converterMessage = null;
		
		if(component != null)
			converterMessage = (String)component.getAttributes().get(_converterMessage);

		return getFM(rb, severity, summaryKey, detailKey, component, value, converterMessage);
	}
	
	
  	/**
	 * This method will get the required message
	 * Currently don't beleive that we nee this method, but leaving the code commented here
	 * You are required to pass in the bundle to use, the UIInpout Based component you are required on, The key in for summary string of the required error in the bundle supplied
	 *   and the value you are requiring. value can also be an array.
	 * 
	 * You should also pass in the FacesMessage.Severity for the severity level you want and The key in for detail string of the conversion error in the bundle supplied
	 * if you pass in overRideMessage (this will appear as the summary and detail messages of your message object)
	 * */
/*  public static FacesMessage getRequiredFacesMessage(ResourceBundle rb, FacesMessage.Severity severity, String summaryKey, String detailKey, UIComponent component, Object value)
	{
		
		String requiredMessage = null;
		
		if(component != null)
			requiredMessage = (String)component.getAttributes().get(_requiredMessage);
			
		return getFM(rb, severity, summaryKey, detailKey, component, value, requiredMessage);
	}*/
	
	
	/**
	 * This method will get a faces message
	 * 
	 * You are required to pass at the very least is the overRideMessage (this will appear as the summary and detail messages of your message object),
	 *  You can also pass in the bundle to use (for standard message), the (UIInpout Based) component you are using, The key in for summary string of the error in the bundle supplied
	 *   and the value you are converting. value can also be an array.
	 * 
	 * You should also pass in the FacesMessage.Severity for the severity level you want and The key in for detail string of the error in the bundle supplied
	 * 
	 * */
	public static FacesMessage getFM(ResourceBundle rb, FacesMessage.Severity severity, String summaryKey, String detailKey, UIComponent component, Object value, String overRideMessage)
	{
		String label = null;
		
		if(component != null)
			label = (String)component.getAttributes().get(_label);
		
		String summaryMessage = null;
		String detailMessage = null;
		// this is to cover JSF 1.2, done this way for backward compatability
		if(overRideMessage != null)
		{
			summaryMessage = detailMessage = overRideMessage; // if message is set on the input, then it is both the summary and detail messages
		}
		else
		{			
			summaryMessage = ResourceHandler.getFacesMessageString(rb,summaryKey);
			if(detailKey != null)
				detailMessage = ResourceHandler.getFacesMessageString(rb,detailKey);
			else
				detailMessage = summaryMessage;
		}
		
		/* if the 3 new attributes , requiredMessage, validatorMessage, convertorMessage on UIInput don't allow subsituations {x} in them,
		 	then moved the start end assume into the 'else' part of the if else above.
		*/
		// try to set the 'label' if it exists		 // start assume 
		Object[] values = null;
		if((label != null) && (value != null))
		{
			Class type = value.getClass();
			if(type.isArray())
			{
				int length = Array.getLength(value);
				values = new Object[length+1];
				for(int i = 0; i < length ;i++)
				{
					values[i] = Array.get(value,i);
				}
				values[length] = label;
			}
			else
			{
				values = new Object[]{value,label};
			}
		}
		else if((label != null) && (value == null))
		{
			values = new Object[]{label};
		}
		else if((label == null) && (value != null))
		{
			Class type = value.getClass();
			if(type.isArray())
				values = (Object[])value;
			else	
				values = new Object[]{value};
		}			
		
		if(values != null)
		{
			MessageFormat message = new MessageFormat(summaryMessage);
			summaryMessage = message.format(values);
			message = new MessageFormat(detailMessage);
			detailMessage = message.format(values);    
		}											 // end assume
						//assume we will always have a summary (at least)
		FacesMessage mess = new FacesMessage(summaryMessage);
		if(detailMessage != null)
			mess.setDetail(detailMessage);
		if(severity != null)	
			mess.setSeverity(severity);
		return mess; 
		
	}
	
}
