/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.util;

import com.ibm.faces.renderkit.html_extended.Utils;
import com.ibm.icu.text.DateFormat;

/**
 * <p>Util class specifically for ICU4J utility methods (Classes importing ICU4J classes should be limited in case ICU4J is not available on classpath).</p>
 * @author pandrews
 */
public class ICU4JUtil {
	
	/*
	 * <p>Get date style.</p>
	 */
	
	public static int getDateStyle(String s) {
		int dateCode = DateFormat.DEFAULT;
		if (s != null && s != "") { //$NON-NLS-1$
			if (Utils.DATESTYLE_SHORT.equalsIgnoreCase(s)) {
				dateCode = DateFormat.SHORT;
			} else if (Utils.DATESTYLE_MEDIUM.equalsIgnoreCase(s)) {
				dateCode = DateFormat.MEDIUM;
			} else if (Utils.DATESTYLE_LONG.equalsIgnoreCase(s)) {
				dateCode = DateFormat.LONG;
			} else if (Utils.DATESTYLE_FULL.equalsIgnoreCase(s)) {
				dateCode = DateFormat.FULL;
			}
		}
		return dateCode;
	}
	

}
