/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.util;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.MethodBinding;
import javax.faces.el.MethodNotFoundException;

/**
 * @author pandrews
 */
public class StaticMethodBinding extends MethodBinding {
	
	Object result;

	public StaticMethodBinding(){
	}

	public StaticMethodBinding(Object arg){
		this.result = arg;
	}

	public Object invoke(FacesContext arg0, Object[] arg1) throws EvaluationException, MethodNotFoundException {
		if(result != null){
			return result.toString();
		}
		return null;
	}

	public Class getType(FacesContext arg0) throws MethodNotFoundException {
		return String.class;
	}
	
	public String getExpressionString() {
		if(result != null){
			return result.toString();
		}
		return null;
	}
}
