/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2004 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.validator;

import javax.faces.validator.DoubleRangeValidator;

/**
 * DoubleRangeValidatorEx
 * 
 * @author doconnor
 * @Version 0.1
 * 
 * Feb 27, 2004 - 9:48:45 AM
 */
public class DoubleRangeValidatorEx extends DoubleRangeValidator {
	
	private boolean minimumSet = false;
	private boolean maximumSet = false;

	/* (non-Javadoc)
	 * @see javax.faces.validator.DoubleRangeValidator#getMaximum()
	 */
	public double getMaximum() {		
		return super.getMaximum();
	}

	/* (non-Javadoc)
	 * @see javax.faces.validator.DoubleRangeValidator#getMinimum()
	 */
	public double getMinimum() {			
		return super.getMinimum();
	}

	/* (non-Javadoc)
	 * @see javax.faces.validator.DoubleRangeValidator#setMaximum(double)
	 */
	public void setMaximum(double maximum) {				
		super.setMaximum(maximum);
		this.setMaximumSet(true);
	}

	/* (non-Javadoc)
	 * @see javax.faces.validator.DoubleRangeValidator#setMinimum(double)
	 */
	public void setMinimum(double minimum) {			
		super.setMinimum(minimum);
		this.setMinimumSet(true);
	}

	/**
	 * @return
	 */
	public boolean isMaximumSet() {		
		return maximumSet;
	}

	/**
	 * @return
	 */
	public boolean isMinimumSet() {		
		return minimumSet;
	}

	/**
	 * @param b
	 */
	public void setMaximumSet(boolean b) {
		maximumSet = b;
	}

	/**
	 * @param b
	 */
	public void setMinimumSet(boolean b) {
		minimumSet = b;
	}
}
