/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2004 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.faces.validator;

import javax.faces.validator.LongRangeValidator;

/**
 * LongRangeValidatorEx
 * 
 * @author doconnor
 * @Version 0.1
 * 
 * Feb 27, 2004 - 11:18:02 AM
 */
public class LongRangeValidatorEx extends LongRangeValidator {
	private boolean minimumSet = false;
	private boolean maximumSet = false;

	/* (non-Javadoc)
	 * @see javax.faces.validator.LongRangeValidator#getMaximum()
	 */
	public long getMaximum() {				
		return super.getMaximum();
	}

	/* (non-Javadoc)
	 * @see javax.faces.validator.LongRangeValidator#getMinimum()
	 */
	public long getMinimum() {				
		return super.getMinimum();
	}

	/* (non-Javadoc)
	 * @see javax.faces.validator.LongRangeValidator#setMaximum(long)
	 */
	public void setMaximum(long maximum) {				
		super.setMaximum(maximum);
		this.setMaximumSet(true);
	}

	/* (non-Javadoc)
	 * @see javax.faces.validator.LongRangeValidator#setMinimum(long)
	 */
	public void setMinimum(long minimum) {				
		super.setMinimum(minimum);
		this.setMinimumSet(true);
	}

	/**
	 * @return
	 */
	public boolean isMaximumSet() {
		return maximumSet;
	}

	/**
	 * @return
	 */
	public boolean isMinimumSet() {
		return minimumSet;
	}

	/**
	 * @param b
	 */
	public void setMaximumSet(boolean b) {
		maximumSet = b;
	}

	/**
	 * @param b
	 */
	public void setMinimumSet(boolean b) {
		minimumSet = b;
	}

}
