/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "Increment";		
hX_5.STR_SPINNER_DECREMENT	= "Decrement";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Scroll Left";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Scroll Right";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Show Slider";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Show Colors";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Show Times";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Show Calendar";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "Previous year";
hX_5.STR_DATE_NEXT_YEAR			= "Next year";
hX_5.STR_DATE_PREVIOUS_MONTH	= "Previous month";
hX_5.STR_DATE_NEXT_MONTH		= "Next month";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)
hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Greenwich Mean Time"],
[ "-0400", "AST", "-0300", "ADT",  "Atlantic Standard Time"],
[ "-0500", "EST", "-0400", "EDT",  "Eastern Standard Time"],
[ "-0600", "CST", "-0500", "CDT",  "Central Standard Time"],
[ "-0700", "MST", "-0600", "MDT",  "Mountain Standard Time"],
[ "-0800", "PST", "-0700", "PDT",  "Pacific Standard Time"],
[ "-1000", "HST", "-0900", "HDT",  "Hawaii-Aleutian Standard Time"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" cannot be interpreted as a date or time.";
hX_5.ERR_epoch_name 		= "\"{0}\" cannot be interpreted as a date. The epoch is not correct.";
hX_5.ERR_day_name 			= "\"{0}\" cannot be interpreted as a date. The day name is not correct.";
hX_5.ERR_month_name			= "\"{0}\" cannot be interpreted as a date. The month name is not correct.";
hX_5.ERR_month_range		= "\"{0}\" cannot be interpreted as a date. The month must be between 1 and 12.";
hX_5.ERR_month_rangelimit	= "\"{0}\" cannot be interpreted as a date. {1} doesn't have {2} days.";
hX_5.ERR_epoch_range		= "\"{0}\" cannot be interpreted as a date. The year is not correct.";
hX_5.ERR_hour_range_long 	= "\"{0}\" cannot be interpreted as a time. The hour must be between 0 and 23.";
hX_5.ERR_hour_range_short	= "\"{0}\" cannot be interpreted as a time. The hour must be between 1 and 12.";
hX_5.ERR_minute_range 		= "\"{0}\" cannot be interpreted as a time. Minutes must be between 0 and 59.";
hX_5.ERR_second_range 		= "\"{0}\" cannot be interpreted as a time. Seconds must be between 0 and 59.";
hX_5.ERR_ampm_name			= "\"{0}\" cannot be interpreted as a time. The time must have an AM or PM indicator.";
hX_5.ERR_tzone_name			= "\"{0}\" cannot be interpreted as a time. The time zone is not correct.";

hX_5.ERR_generic			= "This value cannot be interpreted.";
hX_5.ERR_empty				= "This value cannot be interpreted as no value was provided.";
hX_5.ERR_minimum			= "The value provided is less than the minimum allowed.";
hX_5.ERR_maximum			= "The value provided is greater than the maximum allowed.";
hX_5.ERR_required			= "This value is required.";
hX_5.ERR_constraint			= "This value cannot be intepreted.  The pattern of digits or alphabetic characters is not correct.";

hX_5.ERR_number_fail		= "\"{0}\" cannot be interpreted as a number.";
hX_5.ERR_number_char		= "\"{0}\" cannot be interpreted as a number. \"{1}\" is not a valid character.";