// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_3.STR_SPINNER_INCREMENT	= "Incrmenter";		
hX_3.STR_SPINNER_DECREMENT	= "Dcrmenter";	

// Slider control = tooltip for "drop down the slider"
hX_3.STR_SLIDER_LABEL 		= "Afficher la rgle";

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_3.STR_TABPANEL_SCROLLLEFT	= "Faire dfiler vers la gauche";
hX_3.STR_TABPANEL_SCROLLRIGHT= "Faire dfiler vers la droite";

// Date picker control -- tooltip for "drop down the date navigator"
hX_3.STR_DATE_DN_TOGGLE		= "Afficher le calendrier";

// Date picker control -- tooltips for navigation buttons in calendar
hX_3.STR_DATE_PREVIOUS_YEAR	= "Anne prcdente";
hX_3.STR_DATE_NEXT_YEAR		=" Anne suivante";
hX_3.STR_DATE_PREVIOUS_MONTH	= "Mois prcdent";
hX_3.STR_DATE_NEXT_MONTH		= "Mois suivant";

// Months of the year -- order matters, that is, first entry is first month of the year
hX_3.STR_DATE_MONTHS = new Array("Janvier","Fvrier","Mars","Avril","Mai","Juin","Juillet","Aot","Septembre","Octobre","Novembre","Dcembre");

// Months of the year as 3 letter abbreviations -- order matters, that is, first entry is first month of the year
hX_3.STR_DATE_SHMONTHS = new Array("Jan","Fv","Mar","Avr","Mai","Jun","Jul","Aou","Sep","Oct","Nov","Dc");

// Days of the week -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_DAYS = new Array("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");

// Days of the week as 3 letter abbreviations -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_SHDAYS = new Array("Dim","Lun","Mar","Mer","Jeu","Ven","Sam");

// Days of the week as 1 letter abbreviations -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_SHSHDAYS = new Array ("D","L","M","M","J","V","S");


// For Date: Epoch Schemes
// An "epoch" is a period of time that starts on a date and continues on to the next "epoch" (or forever)
// Each epoch has a "start date" and a name.  Each epoch scheme is an ordered list of epochs.
// For example, in Christianity, there are two epochs in the scheme -- Before Christ and After Christ
// For example, in Islam, there are two epochs in the scheme -- After Mohammed's Haj and before it
// For example, in Japan, the reign of each emperor is an epoch
// For example, in the Roman Empire, the rule of each proconsul (or pair thereof) is an epoch 
// In the following array, 	For each epoch scheme, each epoch (one line) consists of
// 							the start of the epoch, the full name of the epoch, the abbreviation of the epoch
//							For the start of the epoch, + and - are used for before/after type epochs
//							For "ruler/emperor" epochs, it's the start date of the ruler/emperor (yyyymmdd)
//
// Note:  To add additional epoch schemes (e.g., Hegiri), the corresponding descriptor in the hx constants
// 		  file needs to be added to as well
//
hX_3.DATE_EPOCHS = [
						// Christian Epochs -- religious form
						[["-", "Avant Jsus-Christ", "av. J.-C."],
						 ["+", "Aprs Jsus-Christ", 	"ap. J.-C."]],
						// Christian Epochs -- neutral form
						[["-", "Before Christ Era", "BCE"],
						 ["+", "Christian Era", 	"CE"]],
						// Japanese Epochs -- Meiji period and later
						[["18680908", "Meiji",  "Mei"],				  
						 ["19120731", "Taisho", "Tai"],
						 ["19261226", "Showa",  "Sho"],
						 ["19890108", "Heisei", "Hei"]]
						];

						
// For Time -- Default am and pm suffixes (case matters)
hX_3.STR_AM_SUFFIX  ="AM";
hX_3.STR_PM_SUFFIX  ="PM";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)
hX_3.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Greenwich"],
[ "-0400", "AST", "-0300", "ADT",  "Atlantique"],
[ "-0500", "EST", "-0400", "EDT",  "Est"],
[ "-0600", "CST", "-0500", "CDT",  "Centre"],
[ "-0700", "MST", "-0600", "MDT",  "Rocheuses"],
[ "-0800", "PST", "-0700", "PDT",  "Pacifique"],
[ "-1000", "HST", "-0900", "HDT",  "Hawa"],
["","","",""]];

// For Numbers -- default decimal character
hX_3.STR_NUMBER_DECIMAL		= ",";
// For Numbers -- default thousands grouping character
hX_3.STR_NUMBER_THOUSANDS	= " ";
// For Numbers -- default currency marker
hX_3.STR_NUMBER_CURRENCY		= "euros";

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_3.ERR_datetime_parse_fail= "\"{0}\" ne peut pas tre interprte comme date ou heure.";
hX_3.ERR_epoch_name 		= "\"{0}\" ne peut pas tre interprte comme date. La valeur epoch n'est pas correcte.";
hX_3.ERR_day_name 			= "\"{0}\" ne peut pas tre interprte comme date. Le nom du jour n'est pas correct.";
hX_3.ERR_month_name			= "\"{0}\" ne peut pas tre interprte comme date. Le nom du mois n'est pas correct.";
hX_3.ERR_month_range		= "\"{0}\" ne peut pas tre interprte comme date. La valeur du mois doit tre comprise entre 1 et 12.";
hX_3.ERR_month_rangelimit	= "\"{0}\" ne peut pas tre interprte comme date. {1} ne comporte pas {2} jours.";
hX_3.ERR_epoch_range		= "\"{0}\" ne peut pas tre interprte comme date. L'anne ne correspond pas  une anne impriale correcte."
hX_3.ERR_hour_range_long 	= "\"{0}\" ne peut pas tre interprte comme heure. L'heure doit tre comprise entre 0 et 23.";
hX_3.ERR_hour_range_short	= "\"{0}\" ne peut pas tre interprte comme heure. L'heure doit tre comprise entre 1 et 12.";
hX_3.ERR_minute_range 		= "\"{0}\" ne peut pas tre interprte comme heure. Les minutes doivent tre comprises entre 0 et 59.";
hX_3.ERR_second_range 		= "\"{0}\" ne peut pas tre interprte comme heure. Les secondes doivent tre comprises entre 0 et 59.";
hX_3.ERR_ampm_name			= "\"{0}\" ne peut pas tre interprte comme heure. L'heure doit comporter un indicateur AM ou PM.";
hX_3.ERR_tzone_name			= "\"{0}\" ne peut pas tre interprte comme heure. Le fuseau horaire n'est pas correct.";

hX_3.ERR_empty				= "Cette valeur ne peut pas tre interprte car aucune valeur n'a t fournie.";
hX_3.ERR_minimum			= "La valeur fournie est infrieure au minimum autoris.";
hX_3.ERR_maximum			= "La valeur fournie est suprieure au maximum autoris.";
hX_3.ERR_required			= "Cette valeur est requise.";
hX_3.ERR_constraint			= "Cette valeur ne peut pas tre interprte. Le modle de caractres alphanumriques n'est pas valide.";

hX_3.ERR_number_fail		= "\"{0}\" ne peut pas tre interprte comme nombre.";
hX_3.ERR_number_char		= "\"{0}\" ne peut pas tre interprte comme nombre. \"{1}\" ne correspond pas  un caractre valide.";

