// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_3.STR_SPINNER_INCREMENT	= "Incremento";		
hX_3.STR_SPINNER_DECREMENT	= "Decremento";	

// Slider control = tooltip for "drop down the slider"
hX_3.STR_SLIDER_LABEL 		= "Mostra dispositivo di scorrimento";

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_3.STR_TABPANEL_SCROLLLEFT	= "Scorri a sinistra";
hX_3.STR_TABPANEL_SCROLLRIGHT= "Scorri a destra";

// Date picker control -- tooltip for "drop down the date navigator"
hX_3.STR_DATE_DN_TOGGLE		= "Mostra calendario";

// Date picker control -- tooltips for navigation buttons in calendar
hX_3.STR_DATE_PREVIOUS_YEAR	= "Anno precedente";
hX_3.STR_DATE_NEXT_YEAR		=" Anno successivo";
hX_3.STR_DATE_PREVIOUS_MONTH	= "Mese precedente";
hX_3.STR_DATE_NEXT_MONTH		= "Mese successivo";

// Months of the year -- order matters, that is, first entry is first month of the year
hX_3.STR_DATE_MONTHS = new Array ("Gennaio","Febbbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre");

// Months of the year as 3 letter abbreviations -- order matters, that is, first entry is first month of the year
hX_3.STR_DATE_SHMONTHS = new Array ("Gen","Feb","Mar","Apr","Mag","Giu","Lug","Ago","Set","Ott","Nov","Dic");

// Days of the week -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_DAYS = new Array ("Domenica","Luned","Marted","Mercoled","Gioved","Venerd","Sabato");

// Days of the week as 3 letter abbreviations -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_SHDAYS = new Array ("Dom","Lun","Mar","Mer","Gio","Ven","Sab");

// Days of the week as 1 letter abbreviations -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_SHSHDAYS = new Array ("D","L","M","M","G","V","S" );


// For Date: Epoch Schemes
// An "epoch" is a period of time that starts on a date and continues on to the next "epoch" (or forever)
// Each epoch has a "start date" and a name.  Each epoch scheme is an ordered list of epochs.
// For example, in Christianity, there are two epochs in the scheme -- Before Christ and After Christ
// For example, in Islam, there are two epochs in the scheme -- After Mohammed's Haj and before it
// For example, in Japan, the reign of each emperor is an epoch
// For example, in the Roman Empire, the rule of each proconsul (or pair thereof) is an epoch 
// In the following array, 	For each epoch scheme, each epoch (one line) consists of
// 							the start of the epoch, the full name of the epoch, the abbreviation of the epoch
//							For the start of the epoch, + and - are used for before/after type epochs
//							For "ruler/emperor" epochs, it's the start date of the ruler/emperor (yyyymmdd)
//
// Note:  To add additional epoch schemes (e.g., Hegiri), the corresponding descriptor in the hx constants
// 		  file needs to be added to as well
//
hX_3.DATE_EPOCHS = [
						// Christian Epochs -- religious form
						[["-", "Avanti Cristo", "AC"],
						 ["+", "Anno Domini", 	"AD"]],
						// Christian Epochs -- neutral form
						[["-", "Before Christ Era", "BCE"],
						 ["+", "Christian Era", 	"CE"]],
						// Japanese Epochs -- Meiji period and later
						[["18680908", "Meiji",  "Mei"],				  
						 ["19120731", "Taisho", "Tai"],
						 ["19261226", "Showa",  "Sho"],
						 ["19890108", "Heisei", "Hei"]]
						];

						
// For Time -- Default am and pm suffixes (case matters)
hX_3.STR_AM_SUFFIX  ="AM";
hX_3.STR_PM_SUFFIX  ="PM";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)
hX_3.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Ora di Greenwich"],
[ "-0400", "AST", "-0300", "ADT",  "Ora solare Atlantico"],
[ "-0500", "EST", "-0400", "EDT",  "Ora solare Fuso Orientale"],
[ "-0600", "CST", "-0500", "CDT",  "Ora solare Fuso Centrale"],
[ "-0700", "MST", "-0600", "MDT",  "Ora solare Fuso Occidentale"],
[ "-0800", "PST", "-0700", "PDT",  "Ora solare Pacifico"],
[ "-1000", "HST", "-0900", "HDT",  "Ora solare Hawaii-Aleutian"],
["","","",""]];

// For Numbers -- default decimal character
hX_3.STR_NUMBER_DECIMAL		= ".";
// For Numbers -- default thousands grouping character
hX_3.STR_NUMBER_THOUSANDS	= ",";
// For Numbers -- default currency marker
hX_3.STR_NUMBER_CURRENCY		= "$";

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_3.ERR_datetime_parse_fail= "\"{0}\" non pu essere interpretato come data o ora.";
hX_3.ERR_epoch_name 		= "\"{0}\" non pu essere interpretato come data. Epoch non corretto.";
hX_3.ERR_day_name 			= "\"{0}\" non pu essere interpretato come data. Nome del giorno non corretto.";
hX_3.ERR_month_name			= "\"{0}\" non pu essere interpretato come data. Nome del mese non corretto.";
hX_3.ERR_month_range		= "\"{0}\" non pu essere interpretato come data. Il mese deve essere compreso tra 1 e 12.";
hX_3.ERR_month_rangelimit	= "\"{0}\" non pu essere interpretato come data. {1} non ha {2} giorni.";
hX_3.ERR_epoch_range		= "\"{0}\" non pu essere interpretato come data. Anno non corretto per Emperor."
hX_3.ERR_hour_range_long 	= "\"{0}\" non pu essere interpretato come ora. L'ora deve essere compresa tra 0 e 23.";
hX_3.ERR_hour_range_short	= "\"{0}\" non pu essere interpretato come ora. L'ora deve essere compresa tra 1 e 12.";
hX_3.ERR_minute_range 		= "\"{0}\" non pu essere interpretato come ora. I minuti devono essere compresi tra 0 e 59.";
hX_3.ERR_second_range 		= "\"{0}\" non pu essere interpretato come ora. I secondi devono essere compresi tra 0 e 59.";
hX_3.ERR_ampm_name			= "\"{0}\" non pu essere interpretato come ora. L'ora deve avere gli indicatori AM o PM.";
hX_3.ERR_tzone_name			= "\"{0}\" non pu essere interpretato come data. Fuso orario non corretto.";

hX_3.ERR_empty				= "Questo valore non pu essere interpretato perch non  stato fornito alcun valore.";
hX_3.ERR_minimum			= "Il valore fornito  inferiore al minimo consentito.";
hX_3.ERR_maximum			= "Il valore fornito  maggiore al massimo consentito.";
hX_3.ERR_required			= "Valore obbligatorio";
hX_3.ERR_constraint			= "Questo valore non pu essere interpretato. Il modello delle cifre o dei caratteri alfabetici non  corretto.";

hX_3.ERR_number_fail		= "\"{0}\" non pu essere interpretato come numero.";
hX_3.ERR_number_char		= "\"{0}\" non pu essere interpretato come numero \"{1}\" non  un carattere valido.";

