// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_3.STR_SPINNER_INCREMENT	= "";		
hX_3.STR_SPINNER_DECREMENT	= "";	

// Slider control = tooltip for "drop down the slider"
hX_3.STR_SLIDER_LABEL 		= "XC_[̕\";

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_3.STR_TABPANEL_SCROLLLEFT	= "XN[";
hX_3.STR_TABPANEL_SCROLLRIGHT= "EXN[";

// Date picker control -- tooltip for "drop down the date navigator"
hX_3.STR_DATE_DN_TOGGLE		= "J_[̕\";

// Date picker control -- tooltips for navigation buttons in calendar
hX_3.STR_DATE_PREVIOUS_YEAR	= "ON";
hX_3.STR_DATE_NEXT_YEAR		=" N";
hX_3.STR_DATE_PREVIOUS_MONTH	= "O";
hX_3.STR_DATE_NEXT_MONTH		= "";

// Months of the year -- order matters, that is, first entry is first month of the year
hX_3.STR_DATE_MONTHS = new Array ("1 ","2 ","3 ","4 ","5 ","6 ","7 ","8 ","9 ","10 ","11 ","12 ");
// Months of the year as 3 letter abbreviations -- order matters, that is, first entry is first month of the year
hX_3.STR_DATE_SHMONTHS = new Array ("1 ","2 ","3 ","4 ","5 ","6 ","7 ","8 ","9 ","10 ","11 ","12 ");

// Days of the week -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_DAYS = new Array ("j","j","Ηj","j","ؗj","j","yj");

// Days of the week as 3 letter abbreviations -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_SHDAYS = new Array ("","","","","","","y");

// Days of the week as 1 letter abbreviations -- order matters, that is, first entry is first day of the week
hX_3.STR_DATE_SHSHDAYS = new Array ("","","","","","","y" );


// For Date: Epoch Schemes
// An "epoch" is a period of time that starts on a date and continues on to the next "epoch" (or forever)
// Each epoch has a "start date" and a name.  Each epoch scheme is an ordered list of epochs.
// For example, in Christianity, there are two epochs in the scheme -- Before Christ and After Christ
// For example, in Islam, there are two epochs in the scheme -- After Mohammed's Haj and before it
// For example, in Japan, the reign of each emperor is an epoch
// For example, in the Roman Empire, the rule of each proconsul (or pair thereof) is an epoch 
// In the following array, 	For each epoch scheme, each epoch (one line) consists of
// 							the start of the epoch, the full name of the epoch, the abbreviation of the epoch
//							For the start of the epoch, + and - are used for before/after type epochs
//							For "ruler/emperor" epochs, it's the start date of the ruler/emperor (yyyymmdd)
//
// Note:  To add additional epoch schemes (e.g., Hegiri), the corresponding descriptor in the hx constants
// 		  file needs to be added to as well
//
hX_3.DATE_EPOCHS = [
						// Christian Epochs -- religious form
						[["-", "IO", "BC"],
						 ["+", "", 	"AD"]],
						// Christian Epochs -- neutral form
						[["-", "Before Christ Era", "BCE"],
						 ["+", "Christian Era", 	"CE"]],
						// Japanese Epochs -- Meiji period and later
						[["18680908", "Meiji",  "Mei"],				  
						 ["19120731", "Taisho", "Tai"],
						 ["19261226", "Showa",  "Sho"],
						 ["19890108", "Heisei", "Hei"]]
						];

						
// For Time -- Default am and pm suffixes (case matters)
hX_3.STR_AM_SUFFIX  ="AM";
hX_3.STR_PM_SUFFIX  ="PM";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)
hX_3.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "OjbWW"],
[ "-0400", "AST", "-0300", "ADT",  "吼mW"],
[ "-0500", "EST", "-0400", "EDT",  "W"],
[ "-0600", "CST", "-0500", "CDT",  "W"],
[ "-0700", "MST", "-0600", "MDT",  "AJRxW"],
[ "-0800", "PST", "-0700", "PDT",  "mW"],
[ "-1000", "HST", "-0900", "HDT",  "nCEA[VW"],
["","","",""]];

// For Numbers -- default decimal character
hX_3.STR_NUMBER_DECIMAL		= ".";
// For Numbers -- default thousands grouping character
hX_3.STR_NUMBER_THOUSANDS	= ",";
// For Numbers -- default currency marker
hX_3.STR_NUMBER_CURRENCY		= "";

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_3.ERR_datetime_parse_fail= "\"{0}\" t܂͎Ƃĉ߂ł܂B";
hX_3.ERR_epoch_name 		= "\"{0}\" tƂĉ߂ł܂BIO/܂B";
hX_3.ERR_day_name 			= "\"{0}\" tƂĉ߂ł܂Bj܂B";
hX_3.ERR_month_name			= "\"{0}\" tƂĉ߂ł܂B܂B";
hX_3.ERR_month_range		= "\"{0}\" tƂĉ߂ł܂B 1  12 ̊ԂłȂ΂Ȃ܂B";
hX_3.ERR_month_rangelimit	= "\"{0}\" tƂĉ߂ł܂B{1}  {2} ł";
hX_3.ERR_epoch_range		= "\"{0}\" tƂĉ߂ł܂Bɑ΂ĔN܂B"
hX_3.ERR_hour_range_long 	= "\"{0}\" Ƃĉ߂ł܂B 0  23 ̊ԂłȂ΂Ȃ܂B";
hX_3.ERR_hour_range_short	= "\"{0}\" Ƃĉ߂ł܂B 1  12 ̊ԂłȂ΂Ȃ܂B";
hX_3.ERR_minute_range 		= "\"{0}\" Ƃĉ߂ł܂B 0  59 ̊ԂłȂ΂Ȃ܂B";
hX_3.ERR_second_range 		= "\"{0}\" Ƃĉ߂ł܂Bb 0  59 ̊ԂłȂ΂Ȃ܂B";
hX_3.ERR_ampm_name			= "\"{0}\" Ƃĉ߂ł܂Bɂ AM ܂ PM ̕WȂ΂Ȃ܂B";
hX_3.ERR_tzone_name			= "\"{0}\" Ƃĉ߂ł܂B^C][܂B";

hX_3.ERR_empty				= "lw肳ȂꍇA̒l߂邱Ƃ͂ł܂B";
hX_3.ERR_minimum			= "w肳ꂽleŏl菬ȂĂ܂B";
hX_3.ERR_maximum			= "w肳ꂽleől傫ȂĂ܂B";
hX_3.ERR_required			= "̒l͕K{łB";
hX_3.ERR_constraint			= "̒l߂邱Ƃł܂B܂͉p̃p^[܂B";

hX_3.ERR_number_fail		= "\"{0}\" 𐔒lƂĉ߂ł܂B";
hX_3.ERR_number_char		= "\"{0}\" 𐔒lƂĉ߂ł܂B\"{1}\" ͖ȕłB";

