/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "P\u0159\u00edr\u016fstek";		
hX_5.STR_SPINNER_DECREMENT	= "\u00dabytek";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Posunout vlevo";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Posunout vpravo";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Zobrazit posuvn\u00fd ovlada\u010d";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Zobrazit barvy";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Zobrazit \u010dasy";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Zobrazit kalend\u00e1\u0159";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "P\u0159edchoz\u00ed rok";
hX_5.STR_DATE_NEXT_YEAR			= "Dal\u0161\u00ed rok";
hX_5.STR_DATE_PREVIOUS_MONTH	= "P\u0159edchoz\u00ed m\u011bs\u00edc";
hX_5.STR_DATE_NEXT_MONTH		= "Dal\u0161\u00ed m\u011bs\u00edc";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Greenwichsk\u00fd \u010das"],
[ "-0400", "AST", "-0300", "ADT",  "Atlantick\u00fd \u010das"],
[ "-0500", "EST", "-0400", "EDT",  "V\u00fdchodn\u00ed standardn\u00ed \u010das"],
[ "-0600", "CST", "-0500", "CDT",  "Centr\u00e1ln\u00ed standardn\u00ed \u010das"],
[ "-0700", "MST", "-0600", "MDT",  "Horsk\u00fd standardn\u00ed \u010das"],
[ "-0800", "PST", "-0700", "PDT",  "Pacifick\u00fd standardn\u00ed \u010das"],
[ "-1000", "HST", "-0900", "HDT",  "Havajsk\u00fd-Aleutsk\u00fd standardn\u00ed \u010das"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" nelze interpretovat jako datum nebo \u010das.";
hX_5.ERR_epoch_name 		= "\"{0}\" nelze interpretovat jako datum. Epocha nen\u00ed spr\u00e1vn\u00e1.";
hX_5.ERR_day_name 			= "\"{0}\" nelze interpretovat jako datum. N\u00e1zev dne nen\u00ed spr\u00e1vn\u00fd.";
hX_5.ERR_month_name			= "\"{0}\" nelze interpretovat jako datum. N\u00e1zev m\u011bs\u00edce nen\u00ed spr\u00e1vn\u00fd.";
hX_5.ERR_month_range		= "\"{0}\" nelze interpretovat jako datum. M\u011bs\u00edc mus\u00ed b\u00fdt mezi 1 a 12.";
hX_5.ERR_month_rangelimit	= "\"{0}\" nelze interpretovat jako datum. {1} nem\u00e1 {2} dn\u016f.";
hX_5.ERR_epoch_range		= "\"{0}\" nelze interpretovat jako datum. Rok nen\u00ed spr\u00e1vn\u00fd."
hX_5.ERR_hour_range_long 	= "\"{0}\" nelze interpretovat jako \u010das. Hodina mus\u00ed b\u00fdt mezi 0 a 23.";
hX_5.ERR_hour_range_short	= "\"{0}\" nelze interpretovat jako \u010das. Hodina mus\u00ed b\u00fdt mezi 1 a 12.";
hX_5.ERR_minute_range 		= "\"{0}\" nelze interpretovat jako \u010das. Minuty mus\u00ed b\u00fdt mezi 0 a 59.";
hX_5.ERR_second_range 		= "\"{0}\" nelze interpretovat jako \u010das. Vte\u0159iny mus\u00ed b\u00fdt mezi 0 a 59.";
hX_5.ERR_ampm_name			= "\"{0}\" nelze interpretovat jako \u010das. \u010cas mus\u00ed m\u00edt indik\u00e1tor AM nebo PM.";
hX_5.ERR_tzone_name			= "\"{0}\" nelze interpretovat jako \u010das. \u010casov\u00e9 p\u00e1smo nen\u00ed spr\u00e1vn\u00e9.";

hX_5.ERR_generic			= "Tuto hodnotu nelze interpretovat.";
hX_5.ERR_empty				= "Tuto hodnotu nelze interpretovat, proto\u017ee nebyla poskytnuta \u017e\u00e1dn\u00e1 hodnota.";
hX_5.ERR_minimum			= "Poskytnut\u00e1 hodnota je men\u0161\u00ed ne\u017e dovolen\u00e9 minimum.";
hX_5.ERR_maximum			= "Poskytnut\u00e1 hodnota je v\u011bt\u0161\u00ed ne\u017e dovolen\u00e9 maximum.";
hX_5.ERR_required			= "Tato hodnota je po\u017eadovan\u00e1.";
hX_5.ERR_constraint			= "Tuto hodnotu nelze vyhodnotit. Vzorek \u010d\u00edsel nebo abecedn\u00edch znak\u016f nen\u00ed spr\u00e1vn\u00fd.";

hX_5.ERR_number_fail		= "\"{0}\" nelze interpretovat jako \u010d\u00edslo.";
hX_5.ERR_number_char		= "\"{0}\" nelze interpretovat jako \u010d\u00edslo. \"{1}\" nen\u00ed platn\u00fd znak.";

