/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "Erh\u00f6hung";		
hX_5.STR_SPINNER_DECREMENT	= "Verringerung";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Nach links bl\u00e4ttern";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Nach rechts bl\u00e4ttern";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Schiebeleiste anzeigen";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Farben anzeigen";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Zeiten anzeigen";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Kalendar anzeigen";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "Vorheriges Jahr";
hX_5.STR_DATE_NEXT_YEAR			= "N\u00e4chstes Jahr";
hX_5.STR_DATE_PREVIOUS_MONTH	= "Vorheriger Monat";
hX_5.STR_DATE_NEXT_MONTH		= "N\u00e4chster Monat";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Greenwich Mean Time"],
[ "-0400", "AST", "-0300", "ADT",  "Atlantic Standard Time"],
[ "-0500", "EST", "-0400", "EDT",  "Eastern Standard Time"],
[ "-0600", "CST", "-0500", "CDT",  "Central Standard Time"],
[ "-0700", "MST", "-0600", "MDT",  "Mountain Standard Time"],
[ "-0800", "PST", "-0700", "PDT",  "Pacific Standard Time"],
[ "-1000", "HST", "-0900", "HDT",  "Hawaii-Aleutian Standard Time"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" kann nicht als Datum oder Uhrzeit interpretiert werden.";
hX_5.ERR_epoch_name 		= "\"{0}\" kann nicht als Datum interpretiert werden. Die Epoche ist nicht korrekt.";
hX_5.ERR_day_name 			= "\"{0}\" kann nicht als Datum interpretiert werden. Der Name des Tages ist nicht korrekt.";
hX_5.ERR_month_name			= "\"{0}\" kann nicht als Datum interpretiert werden. Der Name des Monats ist nicht korrekt.";
hX_5.ERR_month_range		= "\"{0}\" kann nicht als Datum interpretiert werden. Der Monatswert muss zwischen 1 und 12 liegen.";
hX_5.ERR_month_rangelimit	= "\"{0}\" kann nicht als Datum interpretiert werden. Der {1} hat nicht {2} Tage.";
hX_5.ERR_epoch_range		= "\"{0}\" kann nicht als Datum interpretiert werden. Der Wert f\u00fcr das Jahr ist nicht korrekt."
hX_5.ERR_hour_range_long 	= "\"{0}\" kann nicht als Uhrzeit interpretiert werden. Der Stundenwert muss zwischen 0 und 23 liegen.";
hX_5.ERR_hour_range_short	= "\"{0}\" kann nicht als Uhrzeit interpretiert werden. Der Stundenwert muss zwischen 1 und 12 liegen.";
hX_5.ERR_minute_range 		= "\"{0}\" kann nicht als Uhrzeit interpretiert werden. Der Minutenwert muss zwischen 0 und 59 liegen.";
hX_5.ERR_second_range 		= "\"{0}\" kann nicht als Uhrzeit interpretiert werden. Der Sekundenwert muss zwischen 0 und 59 liegen.";
hX_5.ERR_ampm_name			= "\"{0}\" kann nicht als Uhrzeit interpretiert werden. Die Uhrzeit muss die Angabe AM oder PM enthalten.";
hX_5.ERR_tzone_name			= "\"{0}\" kann nicht als Uhrzeit interpretiert werden. Die Zeitzone ist nicht korrekt.";

hX_5.ERR_generic			= "Dieser Wert kann nicht interpretiert werden.";
hX_5.ERR_empty				= "Dieser Wert kann nicht interpretiert werden, da kein Wert angegeben wurde.";
hX_5.ERR_minimum			= "Der angegebene Wert liegt unter dem zul\u00e4ssigen Minimum.";
hX_5.ERR_maximum			= "Der angegebene Wert liegt \u00fcber dem zul\u00e4ssigen Maximum.";
hX_5.ERR_required			= "Dieser Wert ist erforderlich.";
hX_5.ERR_constraint			= "Dieser Wert kann nicht interpretiert werden.  Das Muster aus Ziffern und alphabetischen Zeichen ist nicht korrekt.";

hX_5.ERR_number_fail		= "\"{0}\" kann nicht als Zahl interpretiert werden.";
hX_5.ERR_number_char		= "\"{0}\" kann nicht als Zahl interpretiert werden. \"{1}\" ist kein g\u00fcltiges Zeichen.";

