/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "Incr\u00e9menter";		
hX_5.STR_SPINNER_DECREMENT	= "D\u00e9cr\u00e9menter";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Faire d\u00e9filer vers la gauche";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Faire d\u00e9filer vers la droite";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Afficher la r\u00e8gle";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Afficher les couleurs";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Afficher les heures";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Afficher le calendrier";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "Ann\u00e9e pr\u00e9c\u00e9dente";
hX_5.STR_DATE_NEXT_YEAR			= "Ann\u00e9e suivante";
hX_5.STR_DATE_PREVIOUS_MONTH	= "Mois pr\u00e9c\u00e9dent";
hX_5.STR_DATE_NEXT_MONTH		= "Mois suivant";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Greenwich"],
[ "-0400", "AST", "-0300", "ADT",  "Atlantique"],
[ "-0500", "EST", "-0400", "EDT",  "Est"],
[ "-0600", "CST", "-0500", "CDT",  "Centre"],
[ "-0700", "MST", "-0600", "MDT",  "Rocheuses"],
[ "-0800", "PST", "-0700", "PDT",  "Pacifique"],
[ "-1000", "HST", "-0900", "HDT",  "Hawa\u00ef"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date ou heure.";
hX_5.ERR_epoch_name 		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date. La valeur epoch n'est pas correcte.";
hX_5.ERR_day_name 			= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date. Le nom du jour n'est pas correct.";
hX_5.ERR_month_name			= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date. Le nom du mois n'est pas correct.";
hX_5.ERR_month_range		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date. La valeur du mois doit \u00eatre comprise entre 1 et 12.";
hX_5.ERR_month_rangelimit	= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date. {1} ne comporte pas {2} jours.";
hX_5.ERR_epoch_range		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme date. L'ann\u00e9e n'est pas correcte."
hX_5.ERR_hour_range_long 	= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme heure. L'heure doit \u00eatre comprise entre 0 et 23.";
hX_5.ERR_hour_range_short	= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme heure. L'heure doit \u00eatre comprise entre 1 et 12.";
hX_5.ERR_minute_range 		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme heure. Les minutes doivent \u00eatre comprises entre 0 et 59.";
hX_5.ERR_second_range 		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme heure. Les secondes doivent \u00eatre comprises entre 0 et 59.";
hX_5.ERR_ampm_name			= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme heure. L'heure doit comporter un indicateur AM ou PM.";
hX_5.ERR_tzone_name			= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme heure. Le fuseau horaire n'est pas correct.";

hX_5.ERR_generic			= "Cette valeur ne peut pas \u00eatre interpr\u00e9t\u00e9e.";
hX_5.ERR_empty				= "Cette valeur ne peut pas \u00eatre interpr\u00e9t\u00e9e car aucune valeur n'a \u00e9t\u00e9 fournie.";
hX_5.ERR_minimum			= "La valeur fournie est inf\u00e9rieure au minimum autoris\u00e9.";
hX_5.ERR_maximum			= "La valeur fournie est sup\u00e9rieure au maximum autoris\u00e9.";
hX_5.ERR_required			= "Cette valeur est requise.";
hX_5.ERR_constraint			= "Cette valeur ne peut pas \u00eatre interpr\u00e9t\u00e9e. Le sch\u00e9ma de caract\u00e8res alphanum\u00e9riques n'est pas valide.";

hX_5.ERR_number_fail		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme nombre.";
hX_5.ERR_number_char		= "\"{0}\" ne peut pas \u00eatre interpr\u00e9t\u00e9e comme nombre. \"{1}\" n'est pas un caract\u00e8re valide.";

