/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "Incremento";		
hX_5.STR_SPINNER_DECREMENT	= "Decremento";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Scorri verso sinistra";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Scorri verso destra";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Mostra indicatore scorrevole";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Mostra colori";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Mostra ora";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Mostra calendario";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "Anno precedente";
hX_5.STR_DATE_NEXT_YEAR			= "Anno successivo";
hX_5.STR_DATE_PREVIOUS_MONTH	= "Mese precedente";
hX_5.STR_DATE_NEXT_MONTH		= "Mese successivo";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Greenwich Mean Time"],
[ "-0400", "AST", "-0300", "ADT",  "Atlantic Standard Time"],
[ "-0500", "EST", "-0400", "EDT",  "Eastern Standard Time"],
[ "-0600", "CST", "-0500", "CDT",  "Central Standard Time"],
[ "-0700", "MST", "-0600", "MDT",  "Mountain Standard Time"],
[ "-0800", "PST", "-0700", "PDT",  "Pacific Standard Time"],
[ "-1000", "HST", "-0900", "HDT",  "Hawaii-Aleutian Standard Time"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" non pu\u00f2 essere interpretato come data o ora.";
hX_5.ERR_epoch_name 		= "\"{0}\" non pu\u00f2 essere interpretato come data. Epoch non corretto.";
hX_5.ERR_day_name 			= "\"{0}\" non pu\u00f2 essere interpretato come data. Nome del giorno non corretto.";
hX_5.ERR_month_name			= "\"{0}\" non pu\u00f2 essere interpretato come data. Nome del mese non corretto.";
hX_5.ERR_month_range		= "\"{0}\" non pu\u00f2 essere interpretato come data. Il mese deve essere compreso tra 1 e 12.";
hX_5.ERR_month_rangelimit	= "\"{0}\" non pu\u00f2 essere interpretato come data. {1} non ha {2} giorni.";
hX_5.ERR_epoch_range		= "\"{0}\" non pu\u00f2 essere interpretato come data. Anno non corretto."
hX_5.ERR_hour_range_long 	= "\"{0}\" non pu\u00f2 essere interpretato come ora. L'ora deve essere compresa tra 0 e 23.";
hX_5.ERR_hour_range_short	= "\"{0}\" non pu\u00f2 essere interpretato come ora. L'ora deve essere compresa tra 1 e 12.";
hX_5.ERR_minute_range 		= "\"{0}\" non pu\u00f2 essere interpretato come ora. I minuti devono essere compresi tra 0 e 59.";
hX_5.ERR_second_range 		= "\"{0}\" non pu\u00f2 essere interpretato come ora. I secondi devono essere compresi tra 0 e 59.";
hX_5.ERR_ampm_name			= "\"{0}\" non pu\u00f2 essere interpretato come ora. L'ora deve avere gli indicatori AM o PM.";
hX_5.ERR_tzone_name			= "\"{0}\" non pu\u00f2 essere interpretato come data. Fuso orario non corretto.";

hX_5.ERR_generic			= "Questo valore non pu\u00f2 essere interpretato.";
hX_5.ERR_empty				= "Questo valore non pu\u00f2 essere interpretato perch\u00e9 non \u00e8 stato fornito alcun valore.";
hX_5.ERR_minimum			= "Il valore fornito \u00e8 inferiore al minimo consentito.";
hX_5.ERR_maximum			= "Il valore fornito \u00e8 maggiore al massimo consentito.";
hX_5.ERR_required			= "Valore obbligatorio";
hX_5.ERR_constraint			= "Questo valore non pu\u00f2 essere interpretato. Il modello delle cifre o dei caratteri alfabetici non \u00e8 corretto.";

hX_5.ERR_number_fail		= "\"{0}\" non pu\u00f2 essere interpretato come numero.";
hX_5.ERR_number_char		= "\"{0}\" non pu\u00f2 essere interpretato come numero. \"{1}\" non \u00e8 un carattere valido.";

