/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "\u5897\u52a0";		
hX_5.STR_SPINNER_DECREMENT	= "\u6e1b\u5c11";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "\u5de6\u65b9\u30b9\u30af\u30ed\u30fc\u30eb";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "\u53f3\u65b9\u30b9\u30af\u30ed\u30fc\u30eb";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "\u30b9\u30e9\u30a4\u30c0\u30fc\u306e\u8868\u793a";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "\u8272\u306e\u8868\u793a";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "\u6642\u9593\u306e\u8868\u793a";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "\u30ab\u30ec\u30f3\u30c0\u30fc\u306e\u8868\u793a";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "\u524d\u5e74";
hX_5.STR_DATE_NEXT_YEAR			= "\u7fcc\u5e74";
hX_5.STR_DATE_PREVIOUS_MONTH	= "\u524d\u6708";
hX_5.STR_DATE_NEXT_MONTH		= "\u7fcc\u6708";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "\u30b0\u30ea\u30cb\u30c3\u30b8\u6a19\u6e96\u6642"],
[ "-0400", "AST", "-0300", "ADT",  "\u5927\u897f\u6d0b\u6a19\u6e96\u6642"],
[ "-0500", "EST", "-0400", "EDT",  "\u6771\u90e8\u6a19\u6e96\u6642"],
[ "-0600", "CST", "-0500", "CDT",  "\u4e2d\u592e\u6a19\u6e96\u6642"],
[ "-0700", "MST", "-0600", "MDT",  "\u30a2\u30e1\u30ea\u30ab\u5c71\u5cb3\u6a19\u6e96\u6642"],
[ "-0800", "PST", "-0700", "PDT",  "\u592a\u5e73\u6d0b\u6a19\u6e96\u6642"],
[ "-1000", "HST", "-0900", "HDT",  "\u30cf\u30ef\u30a4\u30fb\u30a2\u30ea\u30e5\u30fc\u30b7\u30e3\u30f3\u6a19\u6e96\u6642"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" \u3092\u65e5\u4ed8\u307e\u305f\u306f\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002";
hX_5.ERR_epoch_name 		= "\"{0}\" \u3092\u65e5\u4ed8\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u7d00\u5143\u524d/\u897f\u66a6\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_day_name 			= "\"{0}\" \u3092\u65e5\u4ed8\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u66dc\u65e5\u540d\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_month_name			= "\"{0}\" \u3092\u65e5\u4ed8\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6708\u540d\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_month_range		= "\"{0}\" \u3092\u65e5\u4ed8\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6708\u306f 1 \u304b\u3089 12 \u306e\u9593\u3067\u306a\u3051\u308c\u3070\u306a\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_month_rangelimit	= "\"{0}\" \u3092\u65e5\u4ed8\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002{1} \u306b\u306f {2} \u65e5\u304c\u3042\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_epoch_range		= "\"{0}\" \u3092\u65e5\u4ed8\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u5e74\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_hour_range_long 	= "\"{0}\" \u3092\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6642\u306f 0 \u304b\u3089 23 \u306e\u9593\u3067\u306a\u3051\u308c\u3070\u306a\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_hour_range_short	= "\"{0}\" \u3092\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6642\u306f 1 \u304b\u3089 12 \u306e\u9593\u3067\u306a\u3051\u308c\u3070\u306a\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_minute_range 		= "\"{0}\" \u3092\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u5206\u306f 0 \u304b\u3089 59 \u306e\u9593\u3067\u306a\u3051\u308c\u3070\u306a\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_second_range 		= "\"{0}\" \u3092\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u79d2\u306f 0 \u304b\u3089 59 \u306e\u9593\u3067\u306a\u3051\u308c\u3070\u306a\u308a\u307e\u305b\u3093\u3002";
hX_5.ERR_ampm_name			= "\"{0}\" \u3092\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6642\u523b\u306b\u306f AM \u307e\u305f\u306f PM \u306e\u6a19\u8b58\u304c\u5fc5\u8981\u3067\u3059\u3002";
hX_5.ERR_tzone_name			= "\"{0}\" \u3092\u6642\u523b\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6642\u9593\u5e2f\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002";

hX_5.ERR_generic			= "\u3053\u306e\u5024\u3092\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002";
hX_5.ERR_empty				= "\u5024\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u306a\u3044\u305f\u3081\u3001\u3053\u306e\u5024\u3092\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002";
hX_5.ERR_minimum			= "\u6307\u5b9a\u3055\u308c\u305f\u5024\u304c\u3001\u8a31\u5bb9\u6700\u5c0f\u5024\u3088\u308a\u5c0f\u3055\u304f\u306a\u3063\u3066\u3044\u307e\u3059\u3002";
hX_5.ERR_maximum			= "\u6307\u5b9a\u3055\u308c\u305f\u5024\u304c\u3001\u8a31\u5bb9\u6700\u5927\u5024\u3088\u308a\u5927\u304d\u304f\u306a\u3063\u3066\u3044\u307e\u3059\u3002";
hX_5.ERR_required			= "\u3053\u306e\u5024\u306f\u5fc5\u9808\u3067\u3059\u3002";
hX_5.ERR_constraint			= "\u3053\u306e\u5024\u3092\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\u6841\u307e\u305f\u306f\u82f1\u5b57\u306e\u30d1\u30bf\u30fc\u30f3\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002";

hX_5.ERR_number_fail		= "\"{0}\" \u3092\u6570\u5024\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002";
hX_5.ERR_number_char		= "\"{0}\" \u3092\u6570\u5024\u3068\u3057\u3066\u89e3\u91c8\u3067\u304d\u307e\u305b\u3093\u3002\"{1}\" \u306f\u7121\u52b9\u306a\u6587\u5b57\u3067\u3059\u3002";

