/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "Zwi\u0119kszenie";		
hX_5.STR_SPINNER_DECREMENT	= "Zmniejszenie";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Przewi\u0144 w lewo";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Przewi\u0144 w prawo";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Poka\u017c suwak";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Poka\u017c kolory";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Poka\u017c godziny";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Poka\u017c kalendarz";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "Poprzedni rok";
hX_5.STR_DATE_NEXT_YEAR			= "Nast\u0119pny rok";
hX_5.STR_DATE_PREVIOUS_MONTH	= "Poprzedni miesi\u0105c";
hX_5.STR_DATE_NEXT_MONTH		= "Nast\u0119pny miesi\u0105c";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Czas Greenwich"],
[ "-0400", "AST", "-0300", "ADT",  "Standardowy czas atlantycki"],
[ "-0500", "EST", "-0400", "EDT",  "Standardowy czas wschodni"],
[ "-0600", "CST", "-0500", "CDT",  "Standardowy czas \u015brodkowy"],
[ "-0700", "MST", "-0600", "MDT",  "Standardowy czas g\u00f3rski"],
[ "-0800", "PST", "-0700", "PDT",  "Standardowy czas pacyficzny"],
[ "-1000", "HST", "-0900", "HDT",  "Standardowy czas hawajsko-aleucki"],
["","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako data lub godzina.";
hX_5.ERR_epoch_name 		= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako data. Epoka nie jest poprawna.";
hX_5.ERR_day_name 			= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako data. Nazwa dnia nie jest poprawna.";
hX_5.ERR_month_name			= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako data. Nazwa miesi\u0105ca nie jest poprawna.";
hX_5.ERR_month_range		= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako data. Miesi\u0105c musi nale\u017ce\u0107 do zakresu od 1 do 12.";
hX_5.ERR_month_rangelimit	= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako data. Miesi\u0105c {1} nie ma {2} dni.";
hX_5.ERR_epoch_range		= "Nie mo\u017cna zinterpretowa\u0107 warto\u015bci \"{0}\" jako daty. Okre\u015blono niepoprawn\u0105 warto\u015b\u0107 roku."
hX_5.ERR_hour_range_long 	= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako godzina. Godzina musi by\u0107 z zakresu od 0 do 23.";
hX_5.ERR_hour_range_short	= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako godzina. Godzina musi by\u0107 z zakresu od 1 do 12.";
hX_5.ERR_minute_range 		= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako godzina. Minuty musz\u0105 by\u0107 z zakresu od 0 do 59.";
hX_5.ERR_second_range 		= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako godzina. Sekundy musz\u0105 by\u0107 z zakresu od 0 do 59.";
hX_5.ERR_ampm_name			= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako godzina. Godzina musi mie\u0107 wska\u017anik AM lub PM.";
hX_5.ERR_tzone_name			= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako godzina. Strefa czasowa nie jest poprawna.";

hX_5.ERR_generic			= "Nie mo\u017cna zinterpretowa\u0107 tej warto\u015bci.";
hX_5.ERR_empty				= "Tej warto\u015bci nie mo\u017cna zinterpretowa\u0107, poniewa\u017c jej nie podano.";
hX_5.ERR_minimum			= "Podana warto\u015b\u0107 jest mniejsza ni\u017c dozwolona warto\u015b\u0107 minimalna.";
hX_5.ERR_maximum			= "Podana warto\u015b\u0107 jest wi\u0119ksza ni\u017c dozwolona warto\u015b\u0107 maksymalna.";
hX_5.ERR_required			= "Ta warto\u015b\u0107 jest wymagana.";
hX_5.ERR_constraint			= "Tej warto\u015bci nie mo\u017cna zinterpretowa\u0107. Wzorzec cyfr lub liter nie jest poprawny.";

hX_5.ERR_number_fail		= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako liczba.";
hX_5.ERR_number_char		= "Warto\u015b\u0107 \"{0}\" nie mo\u017ce zosta\u0107 zinterpretowana jako liczba. \"{1}\" nie jest poprawnym znakiem.";

