/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "Incrementar";		
hX_5.STR_SPINNER_DECREMENT	= "Decrementar";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "Rolar para a Esquerda";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "Rolar para a Direita";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "Mostrar Slider";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "Mostrar Cores";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "Mostrar Hor\u00e1rios";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "Mostrar Calend\u00e1rio";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "Ano anterior";
hX_5.STR_DATE_NEXT_YEAR			= "Pr\u00f3ximo ano";
hX_5.STR_DATE_PREVIOUS_MONTH	= "M\u00eas anterior";
hX_5.STR_DATE_NEXT_MONTH		= "Pr\u00f3ximo m\u00eas";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "Hora de Greenwich"],
[ "-0400", "AST", "-0300", "ADT",  "Hora Padr\u00e3o do Atl\u00e2ntico"],
[ "-0500", "EST", "-0400", "EDT",  "Hora Padr\u00e3o do Oriente"],
[ "-0600", "CST", "-0500", "CDT",  "Hora Padr\u00e3o Central"],
[ "-0700", "MST", "-0600", "MDT",  "Hora Padr\u00e3o das Montanhas"],
[ "-0800", "PST", "-0700", "PDT",  "Hora Padr\u00e3o do Pac\u00edfico"],
[ "-1000", "HST", "-0900", "HDT",  "Hora Padr\u00e3o do Hava\u00ed-Aleuti\u00e3"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\"{0}\" n\u00e3o pode ser interpretado como uma data ou hora.";
hX_5.ERR_epoch_name 		= "\"{0}\" n\u00e3o pode ser interpretado como uma data. A \u00e9poca n\u00e3o est\u00e1 correta. ";
hX_5.ERR_day_name 			= "\"{0}\" n\u00e3o pode ser interpretado como uma data. O nome do dia n\u00e3o est\u00e1 correto. ";
hX_5.ERR_month_name			= "\"{0}\" n\u00e3o pode ser interpretado como uma data. O nome do m\u00eas n\u00e3o est\u00e1 correto. ";
hX_5.ERR_month_range		= "\"{0}\" n\u00e3o pode ser interpretado como uma data. O m\u00eas deve estar entre 1 e 12.";
hX_5.ERR_month_rangelimit	= "\"{0}\" n\u00e3o pode ser interpretado como uma data. {1} n\u00e3o tem {2} dias. ";
hX_5.ERR_epoch_range		= "\"{0}\" n\u00e3o pode ser interpretado como uma data. O ano n\u00e3o est\u00e1 correto. "
hX_5.ERR_hour_range_long 	= "\"{0}\" n\u00e3o pode ser interpretado como uma hora. A hora deve estar entre 0 e 23.";
hX_5.ERR_hour_range_short	= "\"{0}\" n\u00e3o pode ser interpretado como uma hora. A hora deve estar entre 1 e 12.";
hX_5.ERR_minute_range 		= "\"{0}\" n\u00e3o pode ser interpretado como uma hora. O minutos devem estar entre 0 e 59.";
hX_5.ERR_second_range 		= "\"{0}\" n\u00e3o pode ser interpretado como uma hora. O segundos devem estar entre 0 e 59.";
hX_5.ERR_ampm_name			= "\"{0}\" n\u00e3o pode ser interpretado como uma hora. A hora deve ter um indicador AM ou PM.";
hX_5.ERR_tzone_name			= "\"{0}\" n\u00e3o pode ser interpretado como uma hora. O fuso hor\u00e1rio n\u00e3o est\u00e1 correto. ";

hX_5.ERR_generic			= "Este valor n\u00e3o pode ser interpretado.";
hX_5.ERR_empty				= "Este valor n\u00e3o pode ser inserido porque nenhum valor foi fornecido.";
hX_5.ERR_minimum			= "O valor fornecido \u00e9 menor que o m\u00ednimo permitido.";
hX_5.ERR_maximum			= "O valor fornecido \u00e9 maior que o m\u00e1ximo permitido.";
hX_5.ERR_required			= "Esse valor \u00e9 requerido.";
hX_5.ERR_constraint			= "Esse valor n\u00e3o pode ser interpretado. O padr\u00e3o de d\u00edgitos ou de caracteres alfab\u00e9ticos n\u00e3o est\u00e1 correto. ";

hX_5.ERR_number_fail		= "\"{0}\" n\u00e3o pode ser interpretado como um n\u00famero.";
hX_5.ERR_number_char		= "\"{0}\" n\u00e3o pode ser interpretado como um n\u00famero. \"{1}\" n\u00e3o \u00e9 um caractere v\u00e1lido. ";

