/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------------
// HxClient_Strings -- JSF Client Localized Strings
// ------------------------------------------------

// Spinner control = tooltips for "increment number" and "decrement number"
hX_5.STR_SPINNER_INCREMENT	= "\u589e\u91cf";		
hX_5.STR_SPINNER_DECREMENT	= "\u51cf\u91cf";	

// Tabbed panel control = tooltip for "scroll tabs to the left" and "right"
hX_5.STR_TABPANEL_SCROLLLEFT	= "\u5411\u5de6\u6eda\u52a8";
hX_5.STR_TABPANEL_SCROLLRIGHT	= "\u5411\u53f3\u6eda\u52a8";

// Slider control = tooltip for "drop down the slider"
hX_5.STR_SLIDER_LABEL 		= "\u663e\u793a\u6ed1\u5757";

// Color control -- tooltip for "drop down button"
hX_5.STR_COLOR_DN_TOGGLE	= "\u663e\u793a\u989c\u8272";

// Time picker control -- tooltip for "drop down button"
hX_5.STR_TIME_DN_TOGGLE		= "\u663e\u793a\u65f6\u95f4";

// Date picker control -- tooltip for "drop down the date navigator"
hX_5.STR_DATE_DN_TOGGLE		= "\u663e\u793a\u65e5\u5386";

// Date picker control -- tooltips for navigation buttons in calendar
hX_5.STR_DATE_PREVIOUS_YEAR		= "\u4e0a\u4e00\u5e74";
hX_5.STR_DATE_NEXT_YEAR			= "\u4e0b\u4e00\u5e74";
hX_5.STR_DATE_PREVIOUS_MONTH	= "\u4e0a\u4e2a\u6708";
hX_5.STR_DATE_NEXT_MONTH		= "\u4e0b\u4e2a\u6708";

// For Time -- Time Zone schemes
// The standard way of displaying time zones is of the form "GMT +03:00".  For many locales
// there are a well known set of abbreviations for some time zones.  For example, in North
// America, "EST" is the abbreviation for "GMT +05:00".
//
// The following table lists the abbreviations that are common for a locale.  Note that there are locales
// (many) that do not use abbreviations.
//
// Each entry in the table lists (in order):
//	1)	The GMT offset of the form hhmm (hours and minutes) with a plus/minus sign
//	2)	The abbreviation for the time zone (short form, usually 2 to 5 characters)
//	3)	The GMT offset of the form hhmm OF DAYLIGHT SAVINGS TIME for the zone
//	4)	The abbreviation for the time zone when daylight savings time is in effect
//		Note:  	Many locales do not use this kind of abbreviation.  In this case, make it the same
//				as the second entry
//	5)	The time zone in "long form" (non-daylight savings time)
//
//	IMPORTANT:  FOR ALL Locales, you must supply the first line and it MUST BE +0000 that is
// 	it's the definition of the abbreviation used for GMT (or UTC)

// START QUOTE TRANSLATABLE


hX_5.STR_TIMEZONES = [
[ "+0000", "GMT", "+0000", "GMT",  "\u683c\u6797\u5a01\u6cbb\u6807\u51c6\u65f6\u95f4"],
[ "-0400", "AST", "-0300", "ADT",  "\u5927\u897f\u6d0b\u6807\u51c6\u65f6\u95f4"],
[ "-0500", "EST", "-0400", "EDT",  "\u4e1c\u90e8\u6807\u51c6\u65f6\u95f4"],
[ "-0600", "CST", "-0500", "CDT",  "\u4e2d\u90e8\u6807\u51c6\u65f6\u95f4"],
[ "-0700", "MST", "-0600", "MDT",  "\u5c71\u5730\u6807\u51c6\u65f6\u95f4"],
[ "-0800", "PST", "-0700", "PDT",  "\u592a\u5e73\u6d0b\u6807\u51c6\u65f6\u95f4"],
[ "-1000", "HST", "-0900", "HDT",  "\u590f\u5a01\u5937-\u963f\u7559\u7533\u6807\u51c6\u65f6\u95f4"],
["","","",""]];

//-----------------------------------------------------------------------------------------------
// Error Messages
//-----------------------------------------------------------------------------------------------

hX_5.ERR_datetime_parse_fail= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u6216\u65f6\u95f4\u3002";
hX_5.ERR_epoch_name 		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u3002\u7eaa\u5143\u4e0d\u6b63\u786e\u3002";
hX_5.ERR_day_name 			= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u3002\u65e5\u671f\u540d\u4e0d\u6b63\u786e\u3002";
hX_5.ERR_month_name			= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u3002\u6708\u4efd\u540d\u4e0d\u6b63\u786e\u3002";
hX_5.ERR_month_range		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u3002\u6708\u4efd\u5fc5\u987b\u5728 1 \u548c 12 \u4e4b\u95f4\u3002";
hX_5.ERR_month_rangelimit	= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u3002{1} \u6ca1\u6709 {2} \u5929\u3002";
hX_5.ERR_epoch_range		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65e5\u671f\u3002\u5e74\u4efd\u4e0d\u6b63\u786e\u3002"
hX_5.ERR_hour_range_long 	= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65f6\u95f4\u3002\u5c0f\u65f6\u5fc5\u987b\u5728 0 \u548c 23 \u4e4b\u95f4\u3002";
hX_5.ERR_hour_range_short	= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65f6\u95f4\u3002\u5c0f\u65f6\u5fc5\u987b\u5728 1 \u548c 12 \u4e4b\u95f4\u3002";
hX_5.ERR_minute_range 		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65f6\u95f4\u3002\u5206\u949f\u5fc5\u987b\u5728 0 \u548c 59 \u4e4b\u95f4\u3002";
hX_5.ERR_second_range 		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65f6\u95f4\u3002\u79d2\u5fc5\u987b\u5728 0 \u548c 59 \u4e4b\u95f4\u3002";
hX_5.ERR_ampm_name			= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65f6\u95f4\u3002\u65f6\u95f4\u5fc5\u987b\u6709 AM \u6216 PM \u6307\u793a\u7b26\u3002";
hX_5.ERR_tzone_name			= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u65f6\u95f4\u3002\u65f6\u533a\u4e0d\u6b63\u786e\u3002";

hX_5.ERR_generic			= "\u4e0d\u80fd\u89e3\u91ca\u6b64\u503c\u3002";
hX_5.ERR_empty				= "\u4e0d\u80fd\u5c06\u6b64\u503c\u89e3\u91ca\u4e3a\u6ca1\u6709\u63d0\u4f9b\u503c\u3002";
hX_5.ERR_minimum			= "\u63d0\u4f9b\u7684\u503c\u5c0f\u4e8e\u5141\u8bb8\u7684\u6700\u5c0f\u503c\u3002";
hX_5.ERR_maximum			= "\u63d0\u4f9b\u7684\u503c\u5927\u4e8e\u5141\u8bb8\u7684\u6700\u5927\u503c\u3002";
hX_5.ERR_required			= "\u6b64\u503c\u662f\u5fc5\u9700\u7684\u3002";
hX_5.ERR_constraint			= "\u4e0d\u80fd\u89e3\u91ca\u6b64\u503c\u3002\u6570\u5b57\u6216\u5b57\u6bcd\u5b57\u7b26\u7684\u6a21\u5f0f\u4e0d\u6b63\u786e\u3002";

hX_5.ERR_number_fail		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u6570\u5b57\u3002";
hX_5.ERR_number_char		= "\u65e0\u6cd5\u5c06\u201c{0}\u201d\u89e3\u91ca\u4e3a\u6570\u5b57\u3002\u201c{1}\u201d\u4e0d\u662f\u6709\u6548\u7684\u5b57\u7b26\u3002";

