//==================================================================
// Licensed Materials - Property of IBM
// (c) Copyright IBM Corp. 2003,2006.  All rights reserved.
//
// US Government Users Restricted Rights - Use, duplication or
// disclosure restricted by GSA ADP Schedule Contract with IBM
// Corp.
//
// DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
// sample code created by IBM Corporation.  This sample code is
// not part of any standard or IBM product and is provided to you
// solely for the purpose of assisting you in the development of
// your applications.  The code is provided "AS IS", without
// warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have
// been advised of the possibility of such damages.
//==================================================================

/**
* @class public Base64 
* Base64 Encoder/Decoder
* <code>Base64</code> consists of static methods for encoding and decoding
* data in Base64.
*/
HxG_5.prototype.base64=function()
{
   //Base64 alphabet..
   this.base64Alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
}

/**
* @method public base64.prototype.decode
*   This function is used to set the style sheet prefix for this tree
* @param String prefix
*	the prefix which is added before the style sheet name. Like "tree1",
*	so the css name will be "tree1_labelNormalStyle".
* @return decoded string
**/
HxG_5.prototype.base64.prototype.decodeBase64 = function(base64Text)
{
 	var decodedStr= ""; 
	var char1, char2, char3 = ""; //These are the 3 decoded bytes
	var encChar1, encChar2, encChar3, encChar4 = ""; //These are the 4 bytes to be decoded
	var i = 0; //Position counter
	
	// remove all characters that are not A-Z, a-z, 0-9, +, /, or =
	var base64test = /[^A-Za-z0-9\+\/\=]/g;
	
	//if these characters exist display error
	if (base64test.exec(base64Text)) 
	{ 
		alert("all characters in string to be decoded are not in base64 format");
	}
	base64Text = base64Text.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	
	//Loop though string to decode
	do { 
	
		//Grab 4 bytes of encoded content.
		encChar1 = this.base64Alphabet.indexOf(base64Text.charAt(i++));
		encChar2 = this.base64Alphabet.indexOf(base64Text.charAt(i++));
		encChar3 = this.base64Alphabet.indexOf(base64Text.charAt(i++));
		encChar4 = this.base64Alphabet.indexOf(base64Text.charAt(i++));
	
		//Decoding logic
		char1 = (encChar1 << 2) | (encChar2 >> 4);
		char2 = ((encChar2 & 15) << 4) | (encChar3 >> 2);
		char3 = ((encChar3 & 3) << 6) | encChar4;
		
		//append decoded values to decodedStr
		decodedStr = decodedStr + String.fromCharCode(char1);
		
		if (encChar3 != 64) 
		{
			decodedStr = decodedStr + String.fromCharCode(char2);
		}
		if (encChar4 != 64) 
		{
			decodedStr = decodedStr + String.fromCharCode(char3);
		}
		
		//reinitialise character variables
		char1 = char2 = char3 = "";
		encChar1 = encChar2 = encChar3 = enc4Char = "";
	
	} while (i < base64Text.length); //finish off the loop
	
	//Now return the decoded values.
	return decodedStr;
}
 
 
/**
* @method public base64.prototype.
*   This function is used encode input to be base64
* @param String text
*	text to be encoded
* @return encoded string
**/
HxG_5.prototype.base64.prototype.encodeBase64 = function(text)
 {
	var encodedStr = ""; 
	//Used to hold bytes to be encoded
	var char1, char2, char3 = ""; 
	
	//Used to hold encoded bytes
	var encChar1, encChar2, encChar3, encChar4 = ""; 
	
	//Counter
	var i = 0;  
	
	//Loop through input to encode characters
	do 
	{ 
		//Take three bytes from the inputted string
		char1 = text.charCodeAt(i++); 
		char2 = text.charCodeAt(i++); 
		char3 = text.charCodeAt(i++); 
		
		//Encoding logic to base64
		encChar1 = char1 >> 2;
		encChar2 = ((char1 & 3) << 4) | (char2 >> 4);
		encChar3 = ((char2 & 15) << 2) | (char3 >> 6);
		encChar4 = char3 & 63;
		
		if (isNaN(char2)) {
		encChar3 = encChar4 = 64;
		} else if (isNaN(char3)) {
		encChar4 = 64;
		}
	
	//Appended encoded bytes to encoded string
	encodedStr = encodedStr + this.base64Alphabet.charAt(encChar1) + this.base64Alphabet.charAt(encChar2) + this.base64Alphabet.charAt(encChar3) +	this.base64Alphabet.charAt(encChar4);
	
	//Reinitialise variables for bytes
	char1 = char2 = char3 = "";
	encChar1 = encChar2 = encChar3 = encChar4 = "";
	
	} while (i < text.length); 
	
	//Now return the encoded values.
	return encodedStr;
}