/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ---------------
// JSF calendar control
// This is an embedded date picker
// ---------------

// Public:  Constructor
HxG_5.prototype.JSFCalendar = function () {
	this.type = hX_5.CMP_calendar;

	// Add in common attributes
	this.commonConstructor();

	// The parent Div component
	this.objcalDiv = this.objcalDiv_input = this.DOMobj_input = null;
	this.disabled = false;

	// Attributes supported on this object
	this.attributeTable = [];
		this.attributeTable ['validator']			= ['DTVid',			hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable ['converter']			= ['DTPid',			hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable	['css-prefix']			= ['CSSPrefix',		hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable ['first-day-of-week']	= ['nFirstDayOfWeek',	hX_5.ARG_TO_NUM,false,	0,		6];
		this.attributeTable	['multi-line']			= ['multiLine',		hX_5.ARG_IS_TRUE,	false,	null,	null];
		this.attributeTable	['disabled']			= ['disabled',		hX_5.ARG_TO_NAN,	false,	null,	null];
		// N.B.  The attributes for the DateTimeValidator and DateTimeConverter are allowed as well
	this.setAttribute(arguments);
}
HxG_5.prototype.JSFCalendar.prototype.commonConstructor = HxG_5.prototype.JSFDatePicker.prototype.commonConstructor;
// Constants are defined in hxclient_c.js

// Public:  Page level onLoad handler
HxG_5.prototype.JSFCalendar.prototype.onPageLoad = function () {

	// Try refinding the converter if it didn't exist when we first parsed arguments
	// Create a default one if none is found
	if (this.DTPid && this.DTP == null) this.DTP = hX_5.getConverterById(this.DTPid);
	if (this.DTP == null) this.DTP = new hX_5.DateTimeConverter();

	// Try refinding the validator if it didn't exist when we first parsed arguments
	// Create a default one if none is found
	if (this.DTVid && this.DTV == null) this.DTV = hX_5.getValidatorById(this.DTVid);
	if (this.DTV == null) this.DTV = new hX_5.DateTimeValidator();

	// Add the calDiv to the HTML on the page	
	this.objcalDiv = this.DOMobj;
	this.DOMobj_input = this.objcalDiv_input = hX_5.getElementById(this.id + hX_5.CAL_extra_id_for_input);
		
	this.sUnique = this.id + "_CALDIV_";
	this.sUniqueD = this.sUnique + "DAY_";

	if(!(this.disabled)) // this is if you want only to disable the thing totally and do 
		this.objcalDiv_input.disabled = false;
	else
		this.objcalDiv_input.disabled = true;

	// set up  'hidden' style on input
	this.objcalDiv_input.style.display = hX_5._E;
	this.objcalDiv_input.style.width = hX_5._ZPX;		// Needs a little size so it can take focus
	this.objcalDiv_input.style.height = hX_5._ZPX;		// 1PX was visible, so set to zero, doen't seem to be a security problem in IE sp2 winxp sp2
	this.objcalDiv_input.style.borderWidth = hX_5._ZPX;
	this.objcalDiv_input.style.padding = hX_5._ZPX; 	// Kill off padding etc
	this.objcalDiv_input.style.margin = hX_5._ZPX; 		// Kill off padding etc

	this.setupEvents();	
	this.redraw();
	return true;
}

// Public:  used to provide consistant api (like datepicker and spinner) to disable/enable the control.
HxG_5.prototype.JSFCalendar.prototype.redraw = function (resizeOnly) {
	this.setDateFromValue();	// Update selected date
	if(this.DOMobj.disabled)  
	{
		this.disabled = true;
		this.objcalDiv_input.disabled = true;
	}
	else
	{
		this.disabled = false;		
		this.objcalDiv_input.disabled = false;
	}
	
	this.objcalDiv_input.lang = this.DOMobj.lang;
	this.objcalDiv_input.dir = this.DOMobj.dir;
	
	if(this.DOMobj.accessKey != null && this.DOMobj.accessKey != 'undefined' && "" != hX_5.Trim(this.DOMobj.accessKey))
		this.objcalDiv_input.accessKey = this.DOMobj.accessKey;	
	
	if(this.DOMobj.tabIndex != null && this.DOMobj.tabIndex > 0)
	{	
		this.objcalDiv_input.tabIndex = this.DOMobj.tabIndex;
		this.DOMobj.tabIndex = -1;
	}
		
	this.sizeCalendar();		
}

//private sets up the events for the div.
HxG_5.prototype.JSFCalendar.prototype.setupEvents = function (){
	// Attach mouse events to the div
	var evts = [hX_5._onMD, hX_5._onMU, hX_5._onMM, hX_5._onMC, hX_5._onMV, hX_5._onMO];
	for (var i=0; i<evts.length; i++)
		hX_5.attachComponentEvent(this.objcalDiv, evts[i], hX_5._lL);
	// Attach keyboard and focus management events to the input field
	evts = [hX_5._onKD, hX_5._onKU, hX_5._onKP, hX_5._onF, hX_5._onB];
	for (i=0; i<evts.length; i++)
		hX_5.attachEvent(this.objcalDiv_input, evts[i], hX_5._lL, this.dispatchInputComponent);
		
	// setup a monitor	
	hX_5.i.attachMonitor(this.DOMobj, "standard1", hX_5._DSB, "lang", "dir", "accessKey", "tabIndex");	
}

// Public:  Release the ui state of the Calendar
HxG_5.prototype.JSFCalendar.prototype.uirelease = function (free) {
	if (this.HTML) {
		this.pressButton (this.HTML.hdrbtn1, false);
		this.pressButton (this.HTML.hdrbtn2, false);
		this.pressButton (this.HTML.hdrbtn3, false);
		this.pressButton (this.HTML.hdrbtn4, false);
	}
	// Release framework resources
	if (free!=null) hX_5.uirelease(true);
	return true;
}

// Public:  Destroy -- remove event handlers and large memory objects
HxG_5.prototype.JSFCalendar.prototype.destroy = function () {
	// Remove events not on the object itself
	hX_5.removeAllEvents(this.objcalDiv_input, this.objcalDiv_input.id);
	// Destroy large memory objects
	var i,d = [this.classes];
	for (i=0; i<d.length; i++) {
		if (d[i]) {
			while (d[i].length>0) d[i].pop();
			delete d[i];
		}
	}
	delete d;
	if (this.attributeTable) delete this.attributeTable;
	if (this.HTML) delete this.HTML;
	return true;

}

// Value management -- common with date picker
HxG_5.prototype.JSFCalendar.prototype.iSetValue 	= HxG_5.prototype.JSFDatePicker.prototype.iSetValue;
HxG_5.prototype.JSFCalendar.prototype.reValue 		= HxG_5.prototype.JSFDatePicker.prototype.reValue;
HxG_5.prototype.JSFCalendar.prototype.reValuePop 	= HxG_5.prototype.JSFDatePicker.prototype.reValuePop;
HxG_5.prototype.JSFCalendar.prototype.setDateFromValue = HxG_5.prototype.JSFDatePicker.prototype.setDateFromValue;
HxG_5.prototype.JSFCalendar.prototype.getValue 		= HxG_5.prototype.JSFDatePicker.prototype.getValue;
HxG_5.prototype.JSFCalendar.prototype.setClassNames	= HxG_5.prototype.JSFDatePicker.prototype.setClassNames;
HxG_5.prototype.JSFCalendar.prototype.getAttribute	= HxG_5.prototype.JSFDatePicker.prototype.getAttribute;

HxG_5.prototype.JSFCalendar.prototype.setValue = function(value) {
	this.iSetValue(value, false);	// Set notify to fire the change event
	// Make sure focus is OK
	this.reValuePop (0,0,0,this.oDate,true,true);
}

// Public:  Set an "attribute" on the Picker.  Attributes are passed as strings of the form "name:value"
// *** NOT SHAREABLE ***
HxG_5.prototype.JSFCalendar.prototype.setAttribute = function(a) {

	var wasvalidator = this.DTVid, wasconverter = this.DTPid;
	hX_5.parseArg (this.attributeTable, this, a);

	// Find the converter
	if (this.DTPid && this.DTPid != wasconverter) {
		// converter is passed in
		var DTP = hX_5.getConverterById(this.DTPid);
		if (DTP != null) this.DTP = DTP;
	}
	if (!this.DTPid && this.DTP)
		// using our own converter
		this.DTP.setAttribute(a);

	// Find the validator
	if (this.DTVid && this.DTVid != wasvalidator) {
		// validator is passed in
		var DTV = hX_5.getValidatorById(this.DTVid);
		if (this.DTV != null) this.DTV = DTV;
	}
	if (!this.DTVid && this.DTV)
		// using our own validator
		this.DTV.setAttribute(a);

	// Redraw the changes
	if (this.HTMLrendered)
		this.redraw();

	return true;
}

// Private: Event dispatcher from the input field
// *** NOT SHAREABLE ***
HxG_5.prototype.JSFCalendar.prototype.dispatchInputComponent = function (evt) {
	// N.B. "this" doesn't exist in a direct dispatch like this
	var c, r = true;
	if ((typeof hX_5)=="undefined") return r;
	evt = (evt) ? evt : ((event) ? event: null);
	if (evt) {
		var c=hX_5.evtGetTarget(evt);
		if (c && c.id!=undefined) {
			c = hX_5.getComponentById(hX_5.replaceAll(c.id,hX_5.CAL_extra_id_for_input,hX_5._E));
			// Now that we have the component (so we have a this pointer)
			if (c) r = c.dispatchInputComponent1(evt);
		}
	}
	if (!r)	hX_5.i.cancelAction(evt, true);
	return r;
}

HxG_5.prototype.JSFCalendar.prototype.dispatchInputComponent1 = function (evt) {
	var r=true, nYrAdj=0, nDayAdj=0, nMonAdj=0;

	// Handle receiving focus (sometimes called twice)
	if (evt.type==hX_5._evF) {
		// Make sure the div knows the current date
		this.setDateFromValue();	// Update selected date
		// Redraw with focus shown in the div
		this.reValuePop (0,0,0,this.oDate);
	}

	// Handle losing focus
	else if (evt.type==hX_5._evB) {
		// Redraw without focus in the component and div
		this.hideFocus();

	// Handle keyboard
	} else if (evt.type==hX_5._evKU) {
		// Keyup stops any button spinning
		if ((this.timerTimed != 0 || this.timerInterval != 0)) this.stopTimer();
	
	} else if (evt.type==hX_5._evKD) {
		r = false;
		// Keydown stops any button spinning
		if ((this.timerTimed != 0 || this.timerInterval != 0)) this.stopTimer();

		switch (evt.keyCode) {

		// Space and Enter = accept focused date
		case hX_5.KEY_SPACEBAR:
			this.iSetValue(this.oFocDate, true);	// Set notify to fire the change event
			// Make sure focus is OK
			this.reValuePop (0,0,0,this.oDate,true);
			break;		
		case hX_5.KEY_ENTER:
			this.iSetValue(this.oFocDate, true);	// Set notify to fire the change event
			// Make sure focus is OK
			this.reValuePop (0,0,0,this.oDate,true);
			r = true; // This is to give IE and firefox same behavoiur if calendar is only input on page
			break;

		case hX_5.KEY_HOME: // Go to start of display
			nDayAdj = -100;
			break;

		case hX_5.KEY_PGUP:	// Prev Month
			nMonAdj = -1;
			break;

		case hX_5.KEY_END: 	// Go to end of display
			nDayAdj = +100;
			break;
			
		case hX_5.KEY_PGDN: // Next month
			nMonAdj = +1;
			break;

		case hX_5.KEY_LTARROW: // LeftArrow
			if (evt.ctrlKey) r = true;
			else {
				if (evt.shiftKey) nMonAdj = -1;
				else nDayAdj = -1;
			}
			break;

		case hX_5.KEY_UPARROW: // UpArrow
			if (evt.ctrlKey) r = true;
			else {
				if (evt.shiftKey) nYrAdj = -1;
				else nDayAdj = -7;
			}
			break;

		case hX_5.KEY_RTARROW: // RightArrow
			if (evt.ctrlKey) r = true;
			else {
				if (evt.shiftKey) nMonAdj = 1;
				else nDayAdj = 1;
			}
			break;

		case hX_5.KEY_DNARROW: // DownArrow
			if (evt.ctrlKey) r = true;
			else {
				if (evt.shiftKey) nYrAdj = +1;
				else nDayAdj = 7;
			}
			break;

		// Any other key sequence is allowed to process (notably TAB)
		default:
			r = true;
			break;
		}
		if (nYrAdj!=0 || nDayAdj!=0 || nMonAdj!=0) this.reValuePop (nYrAdj,nMonAdj,nDayAdj);
	}
	return r;
}

// Private: Standard component event dispatcher (for events from the div)
// *** NOT SHAREABLE ***
HxG_5.prototype.JSFCalendar.prototype.dispatchComponent = function (item, evt, action, keycode) {
	var r=false, stop=true, nYrAdj=0, nDayAdj=0, nMonAdj=0, b, bo;
	if (!this.disabled && evt) {
		var src = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : (hX_5.brw.isIE() ? document.body : null));
		if (src) {
			src = (src.nodeType == hX_5.ELEMENT_NODE || src.nodeType == hX_5.DOCUMENT_NODE) ? src : src.parentNode;

			// Only Mouse events should be coming in here
			if (src.tagName!=undefined) {
				var td, p=(src.tagName==hX_5._SPN || src.tagName==hX_5._ANC)?src.parentNode:src;
				td = (p && p.tagName && p.tagName == hX_5._TD && p.id && p.id.indexOf(this.sUniqueD)>=0)?p:null;

				// If we have a "spin" timer on, kill it if need be
				if ((this.timerTimed != 0 || this.timerInterval != 0) && (evt.type==hX_5._evMU || evt.type==hX_5._evMM)) {
					if (evt.type==hX_5._evMM) stop = (this.timerInterval!=0)?((Math.abs(this.wiggleX-evt.clientX)>4 || Math.abs(this.wiggleY-evt.clientY)>4)):false;
					if (stop) this.stopTimer();
				}
	
				switch (evt.type) {

				// Mouse Down
				case hX_5._evMD:

					// See if a scroller is being pressed
					if (src.id!=undefined && src.id.indexOf("HDRBTN")>=0) {
						b = parseInt (src.id.substr(src.id.length-1),10);
						bo = (b==1) ? this.HTML.hdrbtn1 : ((b==2) ? this.HTML.hdrbtn2 : ((b==3) ? this.HTML.hdrbtn3 : this.HTML.hdrbtn4));
						nYrAdj	= (b==1) ? -1 : ((b==2) ? +1 : 0);
						nMonAdj	= (b==3) ? -1 : ((b==4) ? +1 : 0);
						this.pressButton (bo, true);
						this.reValuePop (nYrAdj,nMonAdj,0);
						this.wiggleX = evt.clientX;
						this.wiggleY = evt.clientY;
						this.timerTimed = hX_5.i.startTimerTimed (this.id, "btn" + b, "start", 100);
		
					// See if a td is being clicked
					} else if (td) {
						this.oDate = this.tagToDate(td);
						this.reValuePop (0,0,0,this.oDate,true);
					}
					break;

				// Mouse over/Mouse out
				case hX_5._evMO:
				case hX_5._evMV:
					if (td) {
						if (evt.type==hX_5._evMV) {
							this.reValuePop (0,0,0,this.tagToDate(td));
						} else {
							this.hideFocus();
						}
					}
					break;

				// Mouse up
				case hX_5._evMU:
					// Set the value (firing events when we do) and update focus
					if (td) if (this.iSetValue (this.tagToDate(td),true)) {
						this.reValuePop (0,0,0,this.oDate,true);
						hX_5.i.setFocus(this.objcalDiv_input, false, true);
					}
					break;

				// All else will cancel
				default:
					break;					
				}
			}
		}
	}
	if (!r)	hX_5.i.cancelAction(evt, true);
	return r;
}

// Private:  Timer management
HxG_5.prototype.JSFCalendar.prototype.dispatchTimer = HxG_5.prototype.JSFDatePicker.prototype.dispatchTimer;
HxG_5.prototype.JSFCalendar.prototype.stopTimer 	= HxG_5.prototype.JSFDatePicker.prototype.stopTimer;

//*****************************************************
// START:  HTML Manipulation -- shared with date picker
//*****************************************************

// Private:  Rebuild the contents of the Calendar calDiv given the current attributes
// Use the common builder code
HxG_5.prototype.JSFCalendar.prototype.sizeCalendar = function () {

	if (this.objcalDiv) {
		this.buildContent(this.objcalDiv, window.document, this.sUnique);
		// Move the input field inside the div so that tabbing will scroll to the div (cuz the input
		// field which is in the tab order is co-located in the page)
		if (this.objcalDiv_input.parentNode != this.objcalDiv) this.objcalDiv.appendChild(this.objcalDiv_input);
		hX_5.g.setP(this.objcalDiv_input, hX_5._POS, hX_5._ABS);
		return true;
	}
	return false;
}

// HTML management code shared with the date picker
HxG_5.prototype.JSFCalendar.prototype.buildContent	= HxG_5.prototype.JSFDatePicker.prototype.buildContent;
HxG_5.prototype.JSFCalendar.prototype.emitButtonHTML= HxG_5.prototype.JSFDatePicker.prototype.emitButtonHTML;
HxG_5.prototype.JSFCalendar.prototype.pressButton	= HxG_5.prototype.JSFDatePicker.prototype.pressButton;
HxG_5.prototype.JSFCalendar.prototype.updateGrid	= HxG_5.prototype.JSFDatePicker.prototype.updateGrid;
HxG_5.prototype.JSFCalendar.prototype.updateMonthGrid = HxG_5.prototype.JSFDatePicker.prototype.updateMonthGrid;
HxG_5.prototype.JSFCalendar.prototype.dateToTag		= HxG_5.prototype.JSFDatePicker.prototype.dateToTag;
HxG_5.prototype.JSFCalendar.prototype.dateToID 		= HxG_5.prototype.JSFDatePicker.prototype.dateToID;
HxG_5.prototype.JSFCalendar.prototype.tagToDate		= HxG_5.prototype.JSFDatePicker.prototype.tagToDate;
HxG_5.prototype.JSFCalendar.prototype.calcClass		= HxG_5.prototype.JSFDatePicker.prototype.calcClass;
HxG_5.prototype.JSFCalendar.prototype.showFocus		= HxG_5.prototype.JSFDatePicker.prototype.showFocus;
HxG_5.prototype.JSFCalendar.prototype.hideFocus		= HxG_5.prototype.JSFDatePicker.prototype.hideFocus;
