/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// Enhancement Requested: Add a mouse-over to buttons
// Enhancement Reqested: Fancier buttons

// ---------------
// JSF Date Picker
// ---------------

// Public:  Constructor
HxG_5.prototype.JSFDatePicker = function () {
	this.type = hX_5.CMP_datepicker;
	this.ctype = hX_5.CLASS_DP;
	this.DOMobj_input = null;

	// Attributes set by caller
	this.buttonBorder = -1;
	this.buttonColor = hX_5.CLR_BTN;

	// Add in common attributes
	this.commonConstructor();

	// The popup component
	this.objPopup = null;
	this.JSFBTN = null;

	// Attributes supported on this object
	this.attributeTable = [];
		this.attributeTable ['validator']			= ['DTVid',			hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable ['converter']			= ['DTPid',			hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable	['css-prefix']			= ['CSSPrefix',		hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable ['first-day-of-week']	= ['nFirstDayOfWeek',	hX_5.ARG_TO_NUM,false,	0,		6];
		this.attributeTable	['multi-line']			= ['multiLine',		hX_5.ARG_IS_TRUE,	false,	null,	null];
		this.attributeTable	['button-color']		= ['buttonColor',	hX_5.ARG_TO_NAN,	false,	null,	null];
		this.attributeTable	['button-border']		= ['buttonBorder',	hX_5.ARG_TO_NUM,	false,	-1,		3];
	this.setAttribute(arguments);
}
// Private: constructor code common with other components
HxG_5.prototype.JSFDatePicker.prototype.commonConstructor = function () {

	// Common attributes
	this.nFirstDayOfWeek = hX_5.DTFMT_DEFAULTFIRSTDAYWEEK;		// For calendars, which day is shown as first day of week
	this.CSSPrefix = null;
	this.multiLine = true;

	// Converter and validator
	this.DTPid = this.DTVid = hX_5._E;
	this.DTP = this.DTV = null;

	// Following can be passed directly instead of to the constructor/validator
	// Date currently selected in the popup, date with focus, and copies of things
	this.oDate = this.oFocDate = this.oLastDate = this.oLastFocus = this.escapeToValue = null;
	this.oToday = new Date();	// Today as as date

	// Classes
	this.baseClass = hX_5._E;
	this.classes = null;
	this.CL_HDR = 0;
	this.CL_HDR_L1 = 1;
	this.CL_HDR_L2 = 2;
	this.CL_HDR_YR = 3;
	this.CL_HDR_MN = 4;
	this.CL_HDR_WD = 5;
	this.CL_BODY = 6;
	this.CL_BTN = 7;
	this.CL_M_HOV = 8;
	this.CL_M_CUR = 9;
	this.CL_M_OTH = 10;
	this.CL_D_CUR = 11;
	this.CL_D_INV = 12;
	this.CL_T = 13;
	this.CL_T_CUR = 14;
	this.CL_SZ = 15;

	// Implementation of calendar
	// Holds references to HTML objects in the popup, prefixes for ids
	this.HTML = this.sUnique = this.sUniqueD = null;
	// Timer management
	this.timerTimed = this.timerInterval = this.wiggleX = this.wiggleY = 0;

	// Some heavily used strings
	this.HPCT = "100%";
	this.SPN1 = hX_5.brw.isIE()?'<span style="word-break:normal" unselectable="on">':'<span unselectable="on">';
	this.ESPN = '</span>';
}

// Public:  Page level onLoad handler
HxG_5.prototype.JSFDatePicker.prototype.onPageLoad = function () {
	this.DOMobj_input = this.DOMobj;

	// Try refinding the converter if it didn't exist when we first parsed arguments
	// Create a default one if none is found
	if (this.DTPid && this.DTP == null) this.DTP = hX_5.getConverterById(this.DTPid);
	if (this.DTP == null) this.DTP = new hX_5.DateTimeConverter();
	// Try refinding the validator if it didn't exist when we first parsed arguments
	// Create a default one if none is found
	if (this.DTVid && this.DTV == null) this.DTV = hX_5.getValidatorById(this.DTVid);
	if (this.DTV == null) this.DTV = new hX_5.DateTimeValidator();
	// Add the date picker button to the HTML on the page
	this.JSFBTN = new hX_5.JSFSubButton(this, 1, this.buttonBorder, this.buttonColor, hX_5.L[this.lc].STR_DATE_DN_TOGGLE, null, true, hX_5.R_IMG_CAL_HINKIES);
	// Add the popup to the HTML on the page
	this.objPopup = hX_5.addPopup (this.id + "_POPUP", this.JSFBTN.oSpn.id, null, hX_5.POP_STYLE_CLICK, this);
	this.sUnique = this.id + "_POPUP_";
	this.sUniqueD = this.sUnique + "DAY_";

	// Redraw to make it all happen
	this.redraw();
	return true;
}

// Public:  Redraw the picker incorporating any changes to the HTML of the input or picker fields
HxG_5.prototype.JSFDatePicker.prototype.redraw = function (resizeOnly) {
	// Rebuild the button
	if (this.JSFBTN) this.JSFBTN.size(resizeOnly);
	return true;
}

// Public:  Release the ui state of the Picker
HxG_5.prototype.JSFDatePicker.prototype.uirelease = function (free) {
	// N.B. popup has its own uirelease code
	if (this.JSFBTN) this.JSFBTN.depress("btn1", false);
	if (this.HTML) {
		this.pressButton (this.HTML.hdrbtn1, false);
		this.pressButton (this.HTML.hdrbtn2, false);
		this.pressButton (this.HTML.hdrbtn3, false);
		this.pressButton (this.HTML.hdrbtn4, false);
	}
	// If we're active, then on release set the focus
	if (hX_5.uistate.getActiveComponent()==this && this.JSFBTN && this.JSFBTN.btn1) hX_5.i.setFocus(this.JSFBTN.btn1);
	if (free!=null) hX_5.uirelease(true);
	return true;
}

// Public:  Destroy -- remove event handlers and large memory objects
HxG_5.prototype.JSFDatePicker.prototype.destroy = function () {

	if (this.objPopup) hX_5.removePopup(this.objPopup.id);
	if (this.JSFBTN) {
		if (this.JSFBTN.destroy) this.JSFBTN.destroy();
		delete this.JSFBTN;
	}
	// Delete the larger memory objects
	if (this.classes) {
		while (this.classes.length>0) this.classes.pop();
		delete this.classes;
	}
	delete this.attributeTable;
	if (this.HTML) delete this.HTML;
	return true;
}

/* NOTE:
 * We set hours to 12 in various places in the code to try to better
 * cope with date changes as a result of jumping in and out of Daylight Savings Time. 
 */

// Public:  Set a value into the input field and picker
HxG_5.prototype.JSFDatePicker.prototype.setValue = function (value, notify, raw, returns) {
	return this.iSetValue(value, notify, raw, returns);
}
HxG_5.prototype.JSFDatePicker.prototype.iSetValue = function (value, notify, raw, returns) {

	var r = false;
	if (this.DOMobj_input) {

		// If raw is set, just set the string no matter what it is
		if (raw) {
			this.DOMobj_input.value = value;
			r = true;

		// Otherwise assume that this call is being made instead of a direct assignment to "obj.value"
		// so that validation is performed
		} else {
			var ivalue=null, was=this.getValue();
			// If a string is passed in, convert it to a date
			if (hX_5.isString(value)) ivalue = this.DTP.stringToValue (value);
			else if (hX_5.isObject(value) && value.constructor && value.constructor == Date) ivalue = value.Hx4Clone(0);
			if (ivalue && this.DTV.validate(ivalue, this.DTP, null, true)) {
				this.oDate = ivalue;
				if (returns)
					r = this.DTP.valueToString(ivalue);
				else {
					this.DOMobj_input.value = this.DTP.valueToString(ivalue);
					// Fire an onBlur event to cause behavior checking
					if (notify && was!=this.DOMobj_input.value) {
						hX_5.i.markEvent (this.DOMobj_input, hX_5._onF);
						hX_5.i.fireEvent (this.DOMobj_input, hX_5._onC);
						hX_5.i.fireEvent (this.DOMobj_input, hX_5._onB);
					}
					r = true;
				}
			} else {
				r = (returns) ? hX_5._E : false;
			}
		}
	}
	return r;
}

// Private: Increment or decrement the current value in the field when called from OUTSIDE the popup itself
// e.g., when called from input assist or when called from the input field (not the dropdown)
HxG_5.prototype.JSFDatePicker.prototype.reValue = function (dInc, notify, inValue) {

	if (this.DOMobj_input) {
		var skipInc = false, value = (inValue!=null) ? this.DTP.stringToValue(inValue) : this.getValue(true);
		if (value==null || !this.DTV.validate(value, this.DTP, null, true) && (inValue != null || this.DOMobj_input.value.length==0) && this.DTV && this.DTP) {
			value = this.oToday.Hx4Clone(0);
			value = this.DTV.coerce(value, this.DTP, null, true);
		} else if (this.DOMobj_input.value.length==0)
			skipInc = true;
		if (value) {
			if (!skipInc) {
				this.DTP.setCalendar();
				value=hX_5.cal.adjustDate(value,0,0,dInc,0,0,0);
			}
			if (this.DTV.validate(value, this.DTP, null, true)) {
				if (inValue!=null) return (this.iSetValue(value, false, false, true));
				else {
					this.iSetValue (value, notify);
					return true;
				}
			}
		}
	}
	return ((inValue) ? inValue : false);
}

// Private: Increment or decrement the current value in the popup
HxG_5.prototype.JSFDatePicker.prototype.reValuePop = function (y, m, d, idate, updateSel, nofocus) {
	if (this.DOMobj_input) {
		var td, dd=d, o, f=null;
		if (idate) {
			f = idate;
			if (!this.DTV.validate(f, this.DTP, null, true)) return;
		} else {
			this.DTP.setCalendar();
			f = this.oFocDate.Hx4Clone(0);
			if ((dd>=100 || dd<=-100)) {
				o = hX_5.cal.dateToCalendar(f);
				dd = (dd>=100) ? (hX_5.cal.daysInMonth(o.month,o.year)-o.date) : (-(o.date-1));
			}
			f = hX_5.cal.adjustDate(f,y,m,dd,0,0,0);
			f = this.DTV.coerce(f, this.DTP, null, true);
			if (f==null) return;
		}
		this.updateGrid(f, (y!=0 || m!=0), (updateSel!=null));
		if (nofocus==null) {		
			this.oFocDate = f;
			this.showFocus (f);
		}
	}
}

// Private: Set the value of the popup (only) from the current value
HxG_5.prototype.JSFDatePicker.prototype.setDateFromValue = function () {
	this.oDate = this.getValue(true);
	if (this.oDate == null || !this.DTV.validate(this.oDate, this.DTP, null, true))  {
		this.oDate = this.oToday.Hx4Clone(0);
		this.oDate = this.DTV.coerce(this.oDate, this.DTP, null, true);
	}
	this.oFocDate = this.oDate.Hx4Clone(0);
	return true;
}

// Public:  Get a value from the input field
HxG_5.prototype.JSFDatePicker.prototype.getValue = function(cast) {
	// If cast, then convert the value as a date
	if (this.DOMobj_input) {
		if (cast) {
			var d = this.DTP.stringToValue (this.DOMobj_input.value);
			return ((d != null) ? d.Hx4Clone(0) : this.oToday.Hx4Clone(0));
		}
		return (this.DOMobj_input.value);
	}
	return null;
}

// Public:  Set an "attribute" on the Picker.  Attributes are passed as strings of the form "name:value"
HxG_5.prototype.JSFDatePicker.prototype.setAttribute = function(a) {
	var wasV = this.DTVid, wasC = this.DTPid;
	hX_5.parseArg (this.attributeTable, this, a);
	if (this.bDsc) {
		this.bDsc.btnColor = this.buttonColor
		this.bDsc.btnBorder = this.buttonBorder;
	}
	// Find the converter and validators if they exist
	if (this.DTPid && this.DTPid != wasC) this.DTP = hX_5.getConverterById(this.DTPid);
	if (this.DTVid && this.DTVid != wasV) this.DTV = hX_5.getValidatorById(this.DTVid);
	// Redraw the changes
	if (this.HTMLrendered) this.redraw();

	return true;
}

// Public: Retrieve the value of an attribute
HxG_5.prototype.JSFDatePicker.prototype.getAttribute = function (attribute) {
	return (hX_5.getArg(this.attributeTable, this, attribute));
}

// Implementation:  Given a prefix, generate the names of all classes we use
HxG_5.prototype.JSFDatePicker.prototype.setClassNames = function () {
	var i, test;
	if (this.type==hX_5.CMP_calendar)
		test = ((this.CSSPrefix != null && this.CSSPrefix.length>0) ? this.CSSPrefix : hX_5.CLASS_CA);
	else
		test = ((this.CSSPrefix != null && this.CSSPrefix.length>0) ? this.CSSPrefix : hX_5.CLASS_DEF) + hX_5.CLASS_DP;
	if (test != this.baseClass) {
		// Currently we don't test for valid CSS names (it's expensive, and it's rare that stylesheet.css isn't in use)
		// If this changes, the following should be sufficient
		// if (!hX_5.isClassDefined(test))
		//	window.status = hX_5.INTERR_Bad_Family;
		// else		
		this.baseClass = test;
		this.classes = [];
		for (i=0; i<=this.CL_SZ; i++) this.classes.push(this.baseClass + hX_5.CLASS_DPS[i]);
	}
	if (!hX_5.isClassDefined(this.classes[this.CL_M_HOV])) this.classes[this.CL_M_HOV] = null;
}

// Private -- Is this a keycode that is owned by a component that's in a mask (which runs the keycodes)?
HxG_5.prototype.JSFDatePicker.prototype.isRedirectFcnKey = function (evt) {
	if (evt.altKey || evt.ctrlKey) return false;
	var code = (evt.keyCode && (evt.keyCode != 0)) ? evt.keyCode : -1;
	return (code == hX_5.KEY_UPARROW || code == hX_5.KEY_DNARROW);
}
HxG_5.prototype.JSFDatePicker.prototype.doRedirectFcnKey = function (evt, newValue) {
	var r = null, code = (evt.keyCode && (evt.keyCode != 0)) ? evt.keyCode : -1;
	if (evt.altKey || evt.ctrlKey) return r;
	if (code == hX_5.KEY_UPARROW) r = this.reValue(+1, false, newValue);
	else if (code == hX_5.KEY_DNARROW) r = this.reValue(-1, false, newValue);
	return r;
}

// Private:  Popup callback -- handle a Popup cancel event coming from the popup manager
HxG_5.prototype.JSFDatePicker.prototype.dispatchCancel = function (evt) {
	if (this.objPopup.isPopped()) this.iSetValue(this.escapeToValue, true, true);
}
							
// Private:  Handle a DOM event dispatched from within the popup
HxG_5.prototype.JSFDatePicker.prototype.dispatchPopEvent = function (evt, src) {
	var r=false, stop=true, nYrAdj=0, nDayAdj=0, nMonAdj=0, b, bo;
	if (!this.objPopup.isPopped()) return r;

	// If we have a "spin" timer on, kill it if need be
	if ((this.timerTimed != 0 || this.timerInterval != 0) && (evt.type==hX_5._evKD || evt.type==hX_5._evKU || evt.type==hX_5._evMU || evt.type==hX_5._evMM)) {
		if (evt.type==hX_5._evMM) stop = (this.timerInterval!=0)?((Math.abs(this.wiggleX-evt.clientX)>4 || Math.abs(this.wiggleY-evt.clientY)>4)):false;
		if (stop) this.stopTimer();
	}

	// Handle keydown and mouse events
	if (evt.type==hX_5._evKD) {
		switch (evt.keyCode) {
		// ESC (cancel) is handled by the popup

		// Space and Enter = accept focused date
		case hX_5.KEY_SPACEBAR:
		case hX_5.KEY_ENTER:
			this.setValue(this.oFocDate, true);
			// Make sure focus is OK
			this.reValuePop (0,0,0,this.oDate,true);
			// Try to end the popup
			hX_5.popMgr.endTimed(true);
			break;

		case hX_5.KEY_HOME: // Go to start of display
			nDayAdj = -100;
			break;

		case hX_5.KEY_PGUP:	// Prev Month
			nMonAdj = -1;
			break;

		case hX_5.KEY_END: 	// Go to end of display
			nDayAdj = +100;
			break;
			
		case hX_5.KEY_PGDN: // Next month
			nMonAdj = +1;
			break;

		case hX_5.KEY_LTARROW: // LeftArrow
			if (evt.shiftKey) nMonAdj = -1;
			else nDayAdj = -1;
			break;

		case hX_5.KEY_UPARROW: // UpArrow
			if (evt.shiftKey) nYrAdj = -1;
			else nDayAdj = -7;
			break;

		case hX_5.KEY_RTARROW: // RightArrow
			if (evt.shiftKey) nMonAdj = 1;
			else nDayAdj = 1;
			break;

		case hX_5.KEY_DNARROW: // DownArrow
			if (evt.shiftKey) nYrAdj = +1;
			else nDayAdj = 7;
			break;

		case hX_5.KEY_TAB: //Tab, Shift+Tab
			nDayAdj = evt.shiftKey ? -1 : 1;
			break;

		default:
			break;
		}
		if (nYrAdj!=0 || nDayAdj!=0 || nMonAdj!=0) this.reValuePop (nYrAdj,nMonAdj,nDayAdj);

	} else if (src.tagName!=undefined && (evt.type==hX_5._evMD || evt.type==hX_5._evMM)) {
		// See if a scroller is being pressed
		if (evt.type==hX_5._evMD && src.id!=undefined && src.id.indexOf("HDRBTN")>=0) {
			b = parseInt (src.id.substr(src.id.length-1),10);
			bo = (b==1) ? this.HTML.hdrbtn1 : ((b==2) ? this.HTML.hdrbtn2 : ((b==3) ? this.HTML.hdrbtn3 : this.HTML.hdrbtn4));
			nYrAdj	= (b==1) ? -1 : ((b==2) ? +1 : 0);
			nMonAdj	= (b==3) ? -1 : ((b==4) ? +1 : 0);
			this.pressButton (bo, true);
			this.reValuePop (nYrAdj,nMonAdj,0);
			this.wiggleX = evt.clientX;
			this.wiggleY = evt.clientY;
			this.timerTimed = hX_5.i.startTimerTimed (this.id, "btn" + b, "start", 100);

		// See if a td is being clicked/moused
		} else {
			if (src.tagName==hX_5._SPN || src.tagName==hX_5._ANC) src = src.parentNode;
			if (src && src.tagName && src.tagName == hX_5._TD && src.id && src.id.indexOf(this.sUniqueD)>=0) {							
				if (evt.type==hX_5._evMD) {
					this.oDate = this.tagToDate(src);
					this.reValuePop (0,0,0,this.tagToDate(src),true);
				} else this.reValuePop (0,0,0,this.tagToDate(src));
			}
		}
	} else if (src.tagName!=undefined && evt.type==hX_5._evMU) {
		if (src.tagName == hX_5._SPN || src.tagName == hX_5._ANC) src = src.parentNode;
		if (src && src.tagName && src.tagName == hX_5._TD && src.id && src.id.indexOf(this.sUniqueD)>=0) {
			// Don't close now, close after a bit
			if (this.setValue (this.tagToDate(src),true)) {
				// Make sure focus is OK
				this.reValuePop (0,0,0,this.oDate,true);
				// Try to end the popup
				hX_5.popMgr.endTimed();
			}
		}
	}
	return r;
}

// Private:  Handle a DOM event dispatched from the drop-down button or the input field
HxG_5.prototype.JSFDatePicker.prototype.dispatchComponent = function (item, evt, action, keycode) {
	var r=true, dropit=false, undropit=false;
	if (this.objPopup != null) {
		if (item=="btn1") {
			if (action==hX_5._evMD) {
				if (this.objPopup.isPopped()) undropit = true;
				else dropit = true;
			} else if (action==hX_5._evKD) {
				if (keycode == hX_5.KEY_ENTER || keycode == hX_5.KEY_SPACEBAR || ((!evt.ctrlKey) && (keycode == hX_5.KEY_UPARROW || keycode == hX_5.KEY_DNARROW))) {
					if (this.objPopup.isPopped()) undropit = true;
					else dropit = true;
					r = false;
				} else if (!evt.ctrlKey && (keycode >= hX_5.KEY_SPACEBAR && keycode <= hX_5.KEY_DNARROW)) {
					r = false;
				}
			} else if (action==hX_5._evKP || action==hX_5._evKU) {
				if (keycode >= hX_5.KEY_SPACEBAR && keycode <= hX_5.KEY_DNARROW) r = false;
			} else if (action==hX_5._evMC || action==hX_5._evMCC || action==hX_5._evMM || action==hX_5._evMO || action==hX_5._evMV || action==hX_5._evMU ||
					   action==hX_5._evB  || action==hX_5._evF) { // don't ask how we get these
				// nothing to do
			} else {
				// release is all we need to do if we don't know what it is
				this.uirelease(true);
			}

		// Provide keyboard access from the input field (spin up/down)
		} else if (item==hX_5._lINP) {
			if (action==hX_5._evKD) {
				if (!evt.altKey && !evt.ctrlKey) {
					if (keycode == hX_5.KEY_DNARROW) this.reValue(-1, false);
					else if (keycode == hX_5.KEY_UPARROW) this.reValue(+1, false);
				}
			}

		} else {
			// Faulty dispatch, release all
			this.uirelease(true);
		}

		if (dropit) {
			this.uirelease(true);		// Ensures no other popup is on display and that input assist is off
			this.escapeToValue = this.DOMobj_input.value;
			hX_5.i.setFocus(this.JSFBTN.btn1);
			hX_5.uistate.setActiveComponent (this);
			this.JSFBTN.depress("btn1", true);
			this.setDateFromValue();	// Update selected date
			this.sizePickerToInput();	// Ensure the popup reflects any changes in users current prefs
			this.objPopup.uivisible();
			this.showFocus(this.oFocDate); // Reset focus now that we're visible
			r = false;

		} else if (undropit) {
			this.uirelease(true);
			r = false;
		}
	}
	if (!r)	hX_5.i.cancelAction(evt, true);
	return r;
}

// Private:  Catch a timer event
HxG_5.prototype.JSFDatePicker.prototype.dispatchTimer = function (item, action) {
	// If a spin event occurs, spin the spinner
	if (action == "spin") {
		var btn = parseInt(item.substr(item.length-1),10);
		var nYrAdj  = (btn==1) ? -1 : ((btn==2) ? +1 : 0);
		var nMonAdj = (btn==3) ? -1 : ((btn==4) ? +1 : 0);
		this.reValuePop (nYrAdj, nMonAdj, 0, null);
	// If a start event occurs, start the "spin" timer
	} else if (action == "start") {
		this.timerTimed = 0;
		this.timerInterval = hX_5.i.startTimerInterval (this.id, item, "spin", 50);
	}
}

HxG_5.prototype.JSFDatePicker.prototype.stopTimer = function (item, action) {
	if (this.timerInterval != 0) hX_5.i.killTimerInterval(this.timerInterval);
	if (this.timerTimed != 0) hX_5.i.killTimerTimed(this.timerTimed);
	this.timerTimed = this.timerInterval = 0;
	this.pressButton (this.HTML.hdrbtn1, false);
	this.pressButton (this.HTML.hdrbtn2, false);
	this.pressButton (this.HTML.hdrbtn3, false);
	this.pressButton (this.HTML.hdrbtn4, false);
}

//******************************
// START:  HTML Manipulation
//******************************

// Private:  Rebuild the contents of the Picker popup given the current attributes
HxG_5.prototype.JSFDatePicker.prototype.sizePickerToInput = function () {
	return (this.objPopup) ? (this.buildContent(this.objPopup.getElem(), this.objPopup.getDoc(), this.sUnique)):false;
}

// Private: Build the content of the container
HxG_5.prototype.JSFDatePicker.prototype.buildContent = function (el, doc, unq) {

	// Ensure the div has the correct set of HTML tables in it
	this.setClassNames();
	if (!this.HTML) this.HTML = new hX_5.JSFMonth(this, el, doc, unq, this.multiLine, this.lc);
	if (!this.HTML.valid) return false;

	// Ensure the div is the right size and has the right class to style it
	// We make the div small and then let the browser is expand it to fit around the 
	// table inside it (which in turn sizes itself using a fixed size which will expand
	// if need be so that all the text inside it fits).
	if (el.className != this.baseClass)	el.className = this.baseClass;
	hX_5.g.setP(el, hX_5._OFW, hX_5._VS);
	hX_5.g.setP(el, hX_5._WD, hX_5._E);
	hX_5.g.setP(el, hX_5._HT, hX_5._E);
	if (this.type==hX_5.CMP_datepicker) {
		if (this.HTML.table.className != this.classes[this.CL_SZ]) 	this.HTML.table.className = this.classes[this.CL_SZ];
	} else {
		if (this.HTML.table.width != this.HPCT)	this.HTML.table.width = this.HPCT;
	}

	// For the header, class it and size the cells 
	if (this.HTML.td1.width != hX_5._E) 		this.HTML.td1.width = hX_5._E;
	if (this.HTML.td2.width != hX_5._E) 		this.HTML.td2.width = hX_5._E;
	if (this.HTML.hdrTable.className != this.classes[this.CL_HDR])			this.HTML.hdrTable.className = this.classes[this.CL_HDR];
	if (this.HTML.hdrTable.width != this.HPCT) 								this.HTML.hdrTable.width = this.HPCT;
	if (this.HTML.hdrtr1.cells[0].className != this.classes[this.CL_HDR_L1])this.HTML.hdrtr1.cells[0].className = this.classes[this.CL_HDR_L1];
	if (this.HTML.hdrtr1.cells[1].className != this.classes[this.CL_HDR_YR])this.HTML.hdrtr1.cells[1].className = this.classes[this.CL_HDR_YR];
	if (this.HTML.hdrtr1.cells[2].className != this.classes[this.CL_HDR_L1])this.HTML.hdrtr1.cells[2].className = this.classes[this.CL_HDR_L1];
	if (this.multiLine) {
		if (this.HTML.hdrtr2.cells[0].className != this.classes[this.CL_HDR_L2])this.HTML.hdrtr2.cells[0].className = this.classes[this.CL_HDR_L2];
		if (this.HTML.hdrtr2.cells[1].className != this.classes[this.CL_HDR_MN])this.HTML.hdrtr2.cells[1].className = this.classes[this.CL_HDR_MN];
		if (this.HTML.hdrtr2.cells[2].className != this.classes[this.CL_HDR_L2])this.HTML.hdrtr2.cells[2].className = this.classes[this.CL_HDR_L2];
	} else {
		if (this.HTML.hdrtr2.cells[0].className != this.classes[this.CL_HDR_L2])this.HTML.hdrtr2.cells[0].className = this.classes[this.CL_HDR_L2];
		if (this.HTML.hdrtr2.cells[1].className != this.classes[this.CL_HDR_L2])this.HTML.hdrtr2.cells[1].className = this.classes[this.CL_HDR_L2];
		if (this.HTML.hdrtr2.cells[2].className != this.classes[this.CL_HDR_MN])this.HTML.hdrtr2.cells[2].className = this.classes[this.CL_HDR_MN];
		if (this.HTML.hdrtr2.cells[3].className != this.classes[this.CL_HDR_L2])this.HTML.hdrtr2.cells[3].className = this.classes[this.CL_HDR_L2];
		if (this.HTML.hdrtr2.cells[4].className != this.classes[this.CL_HDR_L2])this.HTML.hdrtr2.cells[4].className = this.classes[this.CL_HDR_L2];
	}
	if (this.HTML.hdrbtn1.className != this.classes[this.CL_BTN]) 			this.HTML.hdrbtn1.className = this.classes[this.CL_BTN];
	if (this.HTML.hdrbtn2.className != this.classes[this.CL_BTN]) 			this.HTML.hdrbtn2.className = this.classes[this.CL_BTN];
	if (this.HTML.hdrbtn3.className != this.classes[this.CL_BTN]) 			this.HTML.hdrbtn3.className = this.classes[this.CL_BTN];
	if (this.HTML.hdrbtn4.className != this.classes[this.CL_BTN]) 			this.HTML.hdrbtn4.className = this.classes[this.CL_BTN];

	// Make sure the day-of-week header is correct
	var i,c,s;
	if (this.HTML.bodyTable.className != this.classes[this.CL_BODY])	this.HTML.bodyTable.className = this.classes[this.CL_BODY];
	if (this.HTML.bodyTable.width != this.HPCT) 						this.HTML.bodyTable.width = this.HPCT;
	for (i = this.nFirstDayOfWeek; i < this.nFirstDayOfWeek + 7; i++) {
		c = this.HTML.bodytr1.cells[i - this.nFirstDayOfWeek];
		if (c.width != hX_5._E) c.width = hX_5._E;
		if (c.className != this.classes[this.CL_HDR_WD]) c.className = this.classes[this.CL_HDR_WD];
		s = this.SPN1 + this.DTP.valueToSShortDayLabel(i%7) + this.ESPN;
		if (hX_5.getIHTML(c) != s) hX_5.setIHTML(c,s);
	}

	// Finally, fill in the grid with the month days
	this.updateGrid(this.oFocDate, true, false);
	return true;		
}

// Implementation:  Make sure the div contains the table (and buttons) used to draw a calendar and scroller buttons
HxG_5.prototype.JSFMonth = function (thisp, inobj, doc, suffix, multi, locale) {

	this.valid = false;
	if (inobj == null) return;

	// Basic table = two rows (header and bdy), each row with one cell
	this.table = this.tr1 = this.tr2 = this.td1 = this.td2 = null;
	// Header = one table of two rows, each row with three cells
	this.hdrTable = this.hdrtr1 = this.hdrtr2 = null;
	// Header has scroller buttons in the leftmost/rightmost cells (4 total)
	this.hdrbtn1 = this.hdrbtn2 = this.hdrbtn3 = this.hdrbtn4 = null;
	// Header has the year and month (which will be spans)
	this.hdrMonth = this.hdrYear = null;
	// Body is a table that's 7 rows by 7 cells, top row is day labels
	this.bodyTable = this.bodytr1 = this.bodytr2 = null;

	// Verify the basic structure = a two row table
	this.table = hX_5.getFirstChildInCell(inobj);
	if ((this.table == null) || (this.table.tagName != hX_5._TAB)) {
		this.table = doc.createElement(hX_5._TAB);
		this.table.setAttribute (hX_5._ID, suffix + "TABLE");
		this.table.cellPadding = this.table.cellSpacing = this.table.border = hX_5._Z;
		inobj.appendChild(this.table);
		this.tr1 = this.table.insertRow(0);
		this.tr2 = this.table.insertRow(1);
		this.td1 = this.tr1.insertCell(0);
		this.td2 = this.tr2.insertCell(0);
		this.td1.vAlign = this.td2.vAlign = hX_5._TOP;
		this.td1.align = this.td2.align = hX_5._LFT;
	}
	if (!this.table) return;
	this.tr1 = this.table.rows[0];
	this.tr2 = this.table.rows[1];
	this.td1 = this.tr1.cells[0];
	this.td2 = this.tr2.cells[0];
	if (!this.tr1 || !this.tr2 || !this.td1 || !this.td2) return;

	// Header row contains a 2x3 table
	var htd1, htd2, htd3, htd4, htd5, htd6, htd7=null, htd8=null;
	this.hdrTable = hX_5.getFirstChildInCell(this.td1);
	if (this.hdrTable == null) {
		this.hdrTable = doc.createElement(hX_5._TAB);
		this.hdrTable.setAttribute (hX_5._ID, suffix + "HDR_TABLE");
		this.hdrTable.cellPadding = this.hdrTable.cellSpacing = this.hdrTable.border = hX_5._Z;
		this.td1.appendChild(this.hdrTable);
		this.hdrtr1 = this.hdrTable.insertRow(0);
		this.hdrtr2 = this.hdrTable.insertRow(1);
		htd1 = this.hdrtr1.insertCell(0);
		htd2 = this.hdrtr1.insertCell(0);
		htd3 = this.hdrtr1.insertCell(0);
		if (!multi) htd7 = this.hdrtr2.insertCell(0);
		htd4 = this.hdrtr2.insertCell(0);
		htd5 = this.hdrtr2.insertCell(0);
		htd6 = this.hdrtr2.insertCell(0);
		if (!multi) {
			htd8 = this.hdrtr2.insertCell(0);
			htd7.vAlign = htd8.vAlign = hX_5._MID;
			htd7.align = hX_5._LFT;
			htd8.align = hX_5._RGT;
		}
		htd1.vAlign = htd2.vAlign = htd3.vAlign = htd4.vAlign = htd5.vAlign = htd6.vAlign = hX_5._MID;
		htd1.align = htd4.align = hX_5._LFT;
		htd2.align = htd5.align = hX_5._CTR;
		htd3.align = htd6.align = hX_5._RGT;
	}
	if (!this.hdrTable) return;
	this.hdrtr1 = this.hdrTable.rows[0];
	this.hdrtr2 = this.hdrTable.rows[1];
	htd1 = this.hdrtr1.cells[0];
	htd2 = this.hdrtr1.cells[1];
	htd3 = this.hdrtr1.cells[2];
	if (multi) {
		htd4 = this.hdrtr2.cells[0];
		htd5 = this.hdrtr2.cells[1];
		htd6 = this.hdrtr2.cells[2];
	} else {
		htd7 = this.hdrtr2.cells[0];
		htd4 = this.hdrtr2.cells[1];
		htd5 = this.hdrtr2.cells[2];
		htd6 = this.hdrtr2.cells[3];
		htd8 = this.hdrtr2.cells[4];
	}
	if (!this.hdrtr1 || !this.hdrtr2 || !htd1 || !htd2 || !htd3 || !htd4 || !htd5 || !htd6) return;

	// There are four scroller buttons -- in the left/right cells of the header table
	this.hdrbtn1 = hX_5.getFirstChildInCell(htd1);
	if (!this.hdrbtn1) this.hdrbtn1 = thisp.emitButtonHTML (((multi)?htd1:htd7), suffix + "HDRBTN1", doc, ((multi)?1:3), 0, hX_5.L[locale].STR_DATE_PREVIOUS_YEAR)
	this.hdrbtn2 = hX_5.getFirstChildInCell(htd3);
	if (!this.hdrbtn2) this.hdrbtn2 = thisp.emitButtonHTML (((multi)?htd3:htd8), suffix + "HDRBTN2", doc, ((multi)?0:2), 0, hX_5.L[locale].STR_DATE_NEXT_YEAR)
	this.hdrbtn3 = hX_5.getFirstChildInCell(htd4);
	if (!this.hdrbtn3) this.hdrbtn3 = thisp.emitButtonHTML (htd4, suffix + "HDRBTN3", doc, 1, 0, hX_5.L[locale].STR_DATE_PREVIOUS_MONTH)
	this.hdrbtn4 = hX_5.getFirstChildInCell(htd6);
	if (!this.hdrbtn4) this.hdrbtn4 = thisp.emitButtonHTML (htd6, suffix + "HDRBTN4", doc, 0, 0, hX_5.L[locale].STR_DATE_NEXT_MONTH)
	this.hdrYear = htd2;
	this.hdrMonth = htd5;

	// Last but certainly not least, create the body table = a 7x7 table
	var i, j, r, c;
	this.bodyTable = hX_5.getFirstChildInCell(this.td2);
	if (this.bodyTable == null) {
		this.bodyTable = doc.createElement(hX_5._TAB);
		this.bodyTable.setAttribute (hX_5._ID, suffix + "BODY_TABLE");
		this.bodyTable.cellPadding = this.bodyTable.cellSpacing = this.bodyTable.border = hX_5._Z;
		this.td2.appendChild(this.bodyTable);
		for (i = 0; i < 7; i++) {
			r = this.bodyTable.insertRow(i);
			for (j = 0; j < 7; j++) {
				c = r.insertCell(j);
				c.vAlign = hX_5._MID;
				c.align = hX_5._CTR;
				c.style.cursor = hX_5._PTR;
			}
		}
	}

	if (!this.bodyTable) return;
	this.bodytr1 = this.bodyTable.rows[0];
	this.bodytr2 = this.bodyTable.rows[1];
	if (this.bodytr1 && this.bodytr2) this.valid = true;
}

// Private: Make a scroller button
HxG_5.prototype.JSFDatePicker.prototype.emitButtonHTML = function (parent, id, doc, wellx, welly, alt) {
	var b = null;
	if (id) {
		b = doc.createElement(hX_5._IMG);
		b.setAttribute (hX_5._ID, id);
		b.className = this.classes[this.CL_BTN];
		b.src = this.r.getURL (hX_5.R_IMG_SPACER);
		if (hX_5.brw.isIE()) b.hideFocus = true;
		else if (hX_5.brw.isNavOrMoz()) hX_5.g.setP(b, hX_5._ZUF, hX_5._IGN);
		b.alt = b.title = alt;
		b.style.backgroundImage = this.r.getURI (hX_5.R_IMG_VLG_HINKIES);
		b.style.backgroundPosition = this.r.wellPosition(hX_5.R_IMG_VLG_HINKIES, wellx, welly);
		b.style.backgroundRepeat = hX_5._NREP;
		b.style.margin = hX_5._ZPX;
		b.style.cursor = "pointer";
		if (b.unselectable!=undefined) b.unselectable=true;
		parent.appendChild(b);
	}
	return b;
}

// Private: (Un)depress a scroller button
HxG_5.prototype.JSFDatePicker.prototype.pressButton = function (id, down) {
	var b=hX_5.getElementById(id), w=((b==this.HTML.hdrbtn1||b==this.HTML.hdrbtn3)?1:0)+((!this.multiLine&&(b==this.HTML.hdrbtn1||b==this.HTML.hdrbtn2))?2:0);
	if (b) hX_5.g.setP(b,hX_5._BPOS,this.r.wellPosition(hX_5.R_IMG_VLG_HINKIES,w,((down)?1:0)));
}

// Private:  Fill HTML with the proper "labels"
HxG_5.prototype.JSFDatePicker.prototype.updateGrid = function (newDate, init, updateSel) {
	this.DTP.setCalendar();
	var was=this.oLastDate,el,cl,x,y,iDaysBefore,iDaysInAndBefore,iNoOfRows,dInM,sizeChanged=false,row,cell,t,tC,tF;
	this.oLastDate = this.oDate;
	// See if this date is already on display
	if (!init && this.dateToTag(newDate)!=null) {
		// If we only have to ensure it's on display, we're done
		if (!updateSel) return true;
		el = this.dateToTag(this.oDate);
		if (el!=null) {
			cl = this.calcClass(this.oDate, el.id.charAt(el.id.length-1)=="X");
			if (el.className!=cl) el.className = cl;
		}
		el = (was!=null)?this.dateToTag(was):null;
		if (el!=null) {
			cl = this.calcClass(was, el.id.charAt(el.id.length-1)=="X");
			if (el.className!=cl) el.className = cl;
		}
		return true;
	}
	// Otherwise, rebuild the grid, start by making sure the right number of header rows is on display
	hX_5.g.setP(this.HTML.hdrtr1, hX_5._DSP, (this.multiLine)?hX_5._E:hX_5._NO);

	// Write the "year" and "month" names into the header table
	// They're spans so that they're not selectable. 
	var yr=this.DTP.valueToYearLabel(newDate), mo=this.DTP.valueToMonthLabel(newDate);
	if (!hX_5.brw.isNavOrMoz()) {
		yr = this.SPN1 + yr + this.ESPN;
		mo = this.SPN1 + mo + this.ESPN;
	}
	if (this.multiLine) {
		if (hX_5.getIHTML(this.HTML.hdrYear) != yr) 	hX_5.setIHTML(this.HTML.hdrYear,yr);
		if (hX_5.getIHTML(this.HTML.hdrMonth) != mo) 	hX_5.setIHTML(this.HTML.hdrMonth,mo);
	} else {
		yr = mo + "&nbsp;" + yr;
		if (hX_5.getIHTML(this.HTML.hdrMonth) != yr) 	hX_5.setIHTML(this.HTML.hdrMonth,yr);
	}
	// calc the start of the month and then the start of the week that contains it
	tC = hX_5.cal.dateToCalendar(newDate);
	dInM = hX_5.cal.daysInMonth(tC.month, tC.year);
	t = newDate.Hx4Clone(0);
	// start of month is the 1st of the month
	t = hX_5.cal.adjustDate(t,0,0,(1-tC.date),0,0,0);
	// Given the first day of the month display, check if the prev month/year buttons are enabled
	if (this.DTV) {
		if (this.DTV.minimumDate) {
			t = hX_5.cal.adjustDate(t,0,0,-1,0,0,0);
			x = t.Hx4CompareDate(this.DTV.minimumDate, false) >=0;
			hX_5.g.setP(this.HTML.hdrbtn1, hX_5._DSP, (x)?hX_5._E:hX_5._NO);
			hX_5.g.setP(this.HTML.hdrbtn3, hX_5._DSP, (x)?hX_5._E:hX_5._NO);
			t = hX_5.cal.adjustDate(t,0,0,+1,0,0,0);
		}
		if (this.DTV.maximumDate) {
			t = hX_5.cal.adjustDate(t,0,0,dInM,0,0,0);
			x = t.Hx4CompareDate(this.DTV.maximumDate, false) <= 0;
			hX_5.g.setP(this.HTML.hdrbtn2, hX_5._DSP, (x)?hX_5._E:hX_5._NO);
			hX_5.g.setP(this.HTML.hdrbtn4, hX_5._DSP, (x)?hX_5._E:hX_5._NO);
			t = hX_5.cal.adjustDate(t,0,0,-dInM,0,0,0);
		}
	}
	// Continue on to find the first day to display
	iDaysBefore = hX_5.cal.getDay(t) - this.nFirstDayOfWeek;
	if (iDaysBefore < 0) iDaysBefore += 7;
	iDaysInAndBefore = dInM + iDaysBefore;
	iNoOfRows = Math.floor(iDaysInAndBefore/7);
	if (iDaysInAndBefore > iNoOfRows*7) iNoOfRows++;
	if (iDaysBefore) t = hX_5.cal.adjustDate(t,0,0,-iDaysBefore,0,0,0);
		
	// Most months show 5 rows, a few show only 4 (e.g., 2/2/98) and a few 6 (e.g., 11/1/03)
	// First hide any rows not needed -- we need to do this FIRST because of an issue in Netscape
	// where when a row is hidden, the ids of the cells in it are still "active" and they can conflict
	// with the ids we're about to put in a (potentially) new month (e.g., if the old display is April
	// 2006, it will display "May 1" (disabled).  If we're scrolling to the next month, it will have
	// May 1 as an "active" day.  There could be two "May 1" TD's -- one left over in the now
	// hidden row for the previous month and one in this month.  Netscape will try to set focus
	// in the "hidden" one leading to all kinds of messes (though ones only seen when switching
	// between very specific months).  So we destroy the old row's ids before creating new ones
	for (y=iNoOfRows; y<6; y++) {
		row = this.HTML.bodyTable.rows[y+1];
		if (row && row.style.display != hX_5._NO) {
			row.style.display = hX_5._NO;
			for(x=0; x<7; x++) row.cells[x].id = hX_5._E;
			sizeChanged = true;
		}
	}
	for (y=0; y<iNoOfRows; y++) {
		row = this.HTML.bodyTable.rows[y+1];
		if (row.style.display != hX_5._E) {
			row.style.display = hX_5._E;
			sizeChanged = true;
		}
		for(x=0; x<7; x++) {
			this.updateMonthGrid(t, y, x, iNoOfRows);
			t = hX_5.cal.adjustDate(t,0,0,1,0,0,0)
		}
	}

	// If the size changed, notify the popup manager that the popup's size has changed
	if (sizeChanged && this.objPopup && this.objPopup.isPopped() && hX_5.popMgr) hX_5.popMgr.resetSize();
	return true;
}

HxG_5.prototype.JSFDatePicker.prototype.updateMonthGrid = function (oDate, r, c, nRows) {
	var cell=this.HTML.bodyTable.rows[r+1].cells[c], oLDate=hX_5.cal.dateToCalendar(oDate);
	var inM=((r==0 && oLDate.date>7) || (r==nRows-1 && oLDate.date<7)), sid=this.dateToID(oDate, inM), sDate=this.DTP.cvtToDigits(oLDate.date), cl = this.calcClass(oDate, inM);
	if (cell.id != sid)				cell.setAttribute(hX_5._ID, sid);
	if (cell.className != cl)		cell.className = cl;
	if (this.type==hX_5.CMP_datepicker && cell.tabIndex!=undefined && cell.tabIndex != hX_5._1) cell.tabIndex =  hX_5._1;
	if (cell.firstChild!=undefined && cell.firstChild.tagName!=undefined && cell.firstChild.tagName==hX_5._SPN && 
		cell.firstChild.firstChild!=undefined && cell.firstChild.firstChild.nodeType==hX_5.TEXT_NODE) {
		cell.firstChild.firstChild.nodeValue = sDate;
	} else hX_5.setIHTML(cell, this.SPN1 + sDate + this.ESPN);
	return true;
}

// Convert a date to an td tag
HxG_5.prototype.JSFDatePicker.prototype.dateToTag = function(oDate,inM) {
	var r = hX_5.getElementById(this.dateToID(oDate,true));
	if (r==null) r = hX_5.getElementById(this.dateToID(oDate,false));
	return r;
}

// Convert a date to an HTML id
HxG_5.prototype.JSFDatePicker.prototype.dateToID = function(oDate,inM) {
	return ((oDate) ? this.sUniqueD + this.DTP.valueToConstant(oDate)+((inM)?"X":"O"): hX_5._E);
}
// Convert an HTML id to a date
HxG_5.prototype.JSFDatePicker.prototype.tagToDate = function(tag) {
	return ((tag&&tag.id!=undefined) ? this.DTP.constantToValue(tag.id.substr(this.sUniqueD.length,tag.id.length-1)) : null);
}

// Calculate the visual class of a cell
HxG_5.prototype.JSFDatePicker.prototype.calcClass = function(oDate, inMonth) {
	var s=(this.oDate!=null) && (0==oDate.Hx4CompareDate(this.oDate)), t=(0==oDate.Hx4CompareDate(this.oToday));
	// Use class for day in the month or not
	var	cl = (inMonth)?this.CL_M_OTH:this.CL_M_CUR;
	// If this is "today", use the today class
	if (t) cl = this.CL_T;
	// If this is the currently selected date, use the selected class
	if (s) cl = (t)?this.CL_T_CUR:this.CL_D_CUR;
	cl = this.classes[cl];
	// If this isn't a valid date, use the invalid date class
	if (!this.DTV.validate(oDate, this.DTP, true, true)) cl = this.classes[this.CL_D_INV];
	return cl;
}

// Move the focus to the current date in the div
HxG_5.prototype.JSFDatePicker.prototype.showFocus = function(d) {
	var w, o=(d)?this.dateToTag(d):null;
	if (o!=null) {
		// We only throw focus if it's the datepicker and then
		// only if it's actually still there
		if (this.type==hX_5.CMP_datepicker && this.objPopup.isPopped()) {
			// See if we can throw focus onto the td
			if (o.focus!=undefined) {
				o.focus();
			// Not all browsers (e.g., Netscape) let TD's have focus
			} else {
				w = hX_5.getFirstChildInCell(o);
				if (w && w.tagName!=undefined && w.focus) hX_5.i.setFocus(w,false,true);
			}
		}
		if (this.classes[this.CL_M_HOV]!=null) {
			w = (this.lastFocus!=null)?this.dateToTag(this.lastFocus):null;
			if (w!=null) w.className = hX_5.replaceAll(w.className,hX_5._B + this.classes[this.CL_M_HOV],hX_5._E);
			o.className = o.className + hX_5._B + this.classes[this.CL_M_HOV];
			this.lastFocus = this.tagToDate(o);
		}			
	}
}

// Hide the focus current date in the div
HxG_5.prototype.JSFDatePicker.prototype.hideFocus = function() {
	var w = (this.lastFocus!=null)?this.dateToTag(this.lastFocus):null;
	if (w!=null && this.classes[this.CL_M_HOV]!=null)
		w.className = hX_5.replaceAll(w.className,hX_5._B + this.classes[this.CL_M_HOV],hX_5._E);
	this.lastFocus = null;

}
