/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2007 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


// Public: Constructor
HxG_5.prototype.JSFSection = function() { 
	this.type = hX_5.CMP_section;
	
	this._expanded = null; // This is the current state of the section
							// true means open, false means closed

	this._contents = null; // dom element for the DIV that holds the sections contents
	this._container = null;
	this._title = null;
	this._headerAnchor = null; 
	this._headerAnchor_OPENED = null; // this is the dom element for the anchor when section is open
	this._headerAnchor_CLOSED = null; // this is the dom element for the anchor when section is closed
	this._header_OPENED = null; // this is the dom element for DIV that holds the anchor when section is open
	this._header_CLOSED = null; // this is the dom element for DIV that holds the anchor when section is closed
	
	this._disabled = null;				// allows you to enable or disable this control
	this._hidden_DISABLED = false;		// reflects our understanding of the disabled state of the content

	this._hidden_UISTATE = null; // this refers to a hidden input that will hold the UIState open ("false") or closed ("true")
									// for this section.
	//this.CSSPrefix = null;

	// Attributes supported on this object
	this.attributeTable = new Array();
	
	//this.attributeTable	['css-prefix'] = ['CSSPrefix', hX_5.ARG_TO_NAN,	false,	null,	null];
	this.attributeTable	['expanded'] = ['_expanded', hX_5.ARG_IS_TRUE, false, null, null];		
	this.attributeTable	['disabled'] = ['_disabled', hX_5.ARG_IS_TRUE,	false,	null,	null];
	
	this.setAttribute(arguments);
	this.saveArgs = arguments;	

}

HxG_5.prototype.JSFSection.prototype._HIDDEN_UISTATE_ID = "_initClosed"; 
HxG_5.prototype.JSFSection.prototype._CONTENTS_ID = "_CONTENTS";
// Additional constants moved to hxclient_c.js

HxG_5.prototype.JSFSection.prototype.onPageLoad = function(){
	
	//this.setupStyle();
	
	//this.DOMobj.className = this.classes[this.CL_DIV]; 
	if (this._disabled) this.DOMobj.disabled = true;
	
	this._hidden_UISTATE = document.getElementById(this.id + this._HIDDEN_UISTATE_ID);
	
	this._contents = document.getElementById(this.id + this._CONTENTS_ID);
	this._headerAnchor_OPENED = document.getElementById(this.id + hX_5._SECTIONHEADERANCHOR_OPENED_ID);
	this._headerAnchor_CLOSED = document.getElementById(this.id + hX_5._SECTIONHEADERANCHOR_CLOSED_ID);
	this._header_OPENED = document.getElementById(this.id + hX_5._SECTIONHEADER_OPENED_ID);
	this._header_CLOSED = document.getElementById(this.id + hX_5._SECTIONHEADER_CLOSED_ID);
	this._title = document.getElementById(this.id + hX_5._SECTIONHEADER_TITLE);
	
	this.setupEvents();
	
	this.setSection(true);
	
} 

// Public:  Set an "attribute" on the section.  Attributes are passed as strings of the form "name:value"
HxG_5.prototype.JSFSection.prototype.setAttribute = function(a) {
	var wasDisabled;
	hX_5.parseArg (this.attributeTable, this, a);
	if (wasDisabled!= this._disabled && this.DOMobj)
		this.DOMobj.disabled = this._disabled;
	// NOTE: We could redraw in this case, but for now we force the user to call it

	if(this._expanded == null) // if it not set by the parameters set it to open 
		this._expanded = false;
	
} 

// Public: Retrieve the value of an attribute
HxG_5.prototype.JSFSection.prototype.getAttribute = function (attribute) {
	return (hX_5.getArg(this.attributeTable, this, attribute));
}

// Public:  Set expanded on the section.  if a is true, section will be expanded, 
//else if a is false section will be collapsed
HxG_5.prototype.JSFSection.prototype.setValue = function(a) {
	
	if(a == "true" || a == true)	 
		this.setAttribute("expanded:true"); // keep everything in sync
	
	if(a == "false" || a == false) 
		this.setAttribute("expanded:false"); // keep everything in sync
	
} 

// Public: if return is true, section is expanded, else if return is false section is collapsed
HxG_5.prototype.JSFSection.prototype.getValue = function () {
	return this._expanded;
}


//private
HxG_5.prototype.JSFSection.prototype.setupEvents = function(){
	
	//add onclick event to anchor for toggling
	hX_5.attachEvent(this._headerAnchor_OPENED, hX_5._onMC, hX_5._lL, this.dis);
	hX_5.attachEvent(this._headerAnchor_CLOSED, hX_5._onMC, hX_5._lL, this.dis);

		// these are for keyboard accessiblity
	hX_5.attachEvent(this._headerAnchor_OPENED, hX_5._onKD, hX_5._lL, this.dis);
	hX_5.attachEvent(this._headerAnchor_CLOSED, hX_5._onKD, hX_5._lL, this.dis);
	if(!(hX_5.brw.isIE())) // moz +
	{
		hX_5.attachEvent(this._headerAnchor_OPENED, hX_5._onKP, hX_5._lL, this.dis);
		hX_5.attachEvent(this._headerAnchor_CLOSED, hX_5._onKP, hX_5._lL, this.dis);			
	}


	hX_5.i.attachMonitor(this.DOMobj, "standard1", hX_5._DSB, "lang", "dir", "accessKey", "tabIndex");

}

//private
/*HxG_5.prototype.JSFSection.prototype.setupStyle = function(){
	if (!this.DOMobj) return;
	var i, test = (this.CSSPrefix != null && this.CSSPrefix.length>0) ? this.CSSPrefix : hX_5.CLASS_PB;
	if (test != this.baseClass) {
		// Currently we don't test for valid CSS names (it's expensive, and it's rare that stylesheet.css isn't in use)
		// If this changes, the following should be sufficient
//		if (!hX_5.isClassDefined(test))
//			window.status = hX_5.INTERR_Bad_Family;
//		else		
			this.baseClass = test;
		this.classes = new Array();
		for (i = 0; i <= this.CL_SZ; i++)
			this.classes.push(this.baseClass + hX_5.CLASS_PBS[i]);
	}
}*/

/*HxG_5.prototype.JSFSection.prototype.ce = function (evt){
	var c, r = true;
	var disabled = false;
	if ((typeof hX_5)=="undefined") return r;
	evt = (evt) ? evt : ((event) ? event: null);
	if (evt) {
		var c=hX_5.evtGetTarget(evt);
		var oc = c.parentNode;
		if(c.disabled || oc.disabled)
			disabled = true;
		if(disabled)
			r = false;	
	}
	
	return r;
}*/


HxG_5.prototype.JSFSection.prototype.dis = function (evt){
	// N.B. "this" doesn't exist in a direct dispatch like this
	var oc, c, r = true;
	if ((typeof hX_5)=="undefined") return r;
	evt = (evt) ? evt : ((event) ? event: null);
	if (evt) {
		c = hX_5.evtGetTarget(evt);
		oc = c.parentNode;
		while (oc!=null) {
			if (oc.id!=undefined && oc.id!=null) {
				c=hX_5.getComponentById(hX_5.replaceAll(oc.id,hX_5._SECTIONHEADERANCHOR_OPENED_ID,hX_5._E));
				if(c == null) c=hX_5.getComponentById(hX_5.replaceAll(oc.id,hX_5._SECTIONHEADERANCHOR_CLOSED_ID,hX_5._E));
				if(c == null) c=hX_5.getComponentById(hX_5.replaceAll(oc.id,hX_5._SECTIONHEADER_OPENED_ID,hX_5._E));
				if(c == null) c=hX_5.getComponentById(hX_5.replaceAll(oc.id,hX_5._SECTIONHEADER_CLOSED_ID,hX_5._E));	
				if(c == null) c=hX_5.getComponentById(hX_5.replaceAll(oc.id,hX_5._SECTIONHEADER_TITLE,hX_5._E));					
				// Now that we have the component (so we have a this pointer)
				if (c!=null) {
					r = c.dispatchComponent(null, evt, null, null, true);
					break;
				}
			}
			oc = oc.parentNode;
		}
	}
	if (!r)	hX_5.i.cancelAction(evt, true);
	return r;
}

// private - return true is source of the event was in the opened or closed header, else false
/*HxG_5.prototype.JSFSection.prototype.comesFromHeader=function (src)
{
	var isfromheader = false;

	if(
		(src.id == this._headerAnchor_OPENED.id) || (src.id == this._headerAnchor_CLOSED.id)
		|| (src.parentNode.id == this._headerAnchor_OPENED.id) || (src.parentNode.id == this._headerAnchor_CLOSED.id)
		|| (src.id == this._header_OPENED.id) || (src.id == this._header_CLOSED.id)
	)
		isfromheader = true;

	return isfromheader;
}*/

/*HxG_5.prototype.JSFSection.prototype.stopEvent=function (evt){
	var r;

	evt.cancelBubble=true;
	if(evt.stopPropagation)
		evt.stopPropagation();
	r = false; // r should be false

	evt.returnValue=false;
	if(evt.preventDefault)
		evt.preventDefault();
		
	return r;						
}*/

HxG_5.prototype.JSFSection.prototype.dispatchComponent=function (item, evt, action, keycode, fromHeader) {

	var r=true;
	evt=(evt) ? evt : ((event) ? event: null);
	if (evt) 
	{
		var src=hX_5.evtGetTarget(evt);
		if (this._disabled) 
		{
			// we always need to let tab throught for accessibility
			if ((evt.type==hX_5._evKU || evt.type==hX_5._evKP || evt.type==hX_5._evKD) && (evt.keyCode == hX_5.KEY_TAB))
				r = true;
			else
				r = false;
		} else
		{
			if (src && fromHeader!=null) 
			{
				// The events we get are keydown, keyup, mouseclick
				if (evt.type==hX_5._evKU || evt.type==hX_5._evKP || evt.type==hX_5._evKD) 
				{
					if (evt.keyCode==hX_5.KEY_SPACEBAR || evt.keycode==hX_5.KEY_ENTER) 
					{
						this.toggle();	
					}
	 			} else if (evt.type==hX_5._evMC) 
	 			{
		 			this.toggle();
		 		}
	 		}
		}
	}
	if (!r)	hX_5.i.cancelAction(evt, true);
	return r;
}

//public
HxG_5.prototype.JSFSection.prototype.redraw = function()
{
	// set our own disabled flag is the anchor is disabled
	if(this.DOMobj.disabled == true || this.DOMobj.disabled == "true" || this.DOMobj.disabled == "disabled")
		this._disabled = true;
	else if(this.DOMobj.disabled == false || this.DOMobj.disabled == "false" || this.DOMobj.disabled == "")
		this._disabled = false;
	
	this._headerAnchor_OPENED.lang = this.DOMobj.lang;
	this._headerAnchor_CLOSED.lang = this.DOMobj.lang; 
	this._headerAnchor_OPENED.dir = this.DOMobj.dir;
	this._headerAnchor_CLOSED.dir = this.DOMobj.dir; 
	
	if(this.DOMobj.accessKey != null && this.DOMobj.accessKey != 'undefined' && "" !=  hX_5.Trim(this.DOMobj.accessKey))
	{
		this._headerAnchor_OPENED.accessKey = this.DOMobj.accessKey;
		this._headerAnchor_CLOSED.accessKey = this.DOMobj.accessKey;
	}
	
	if(this.DOMobj.tabIndex != null && this.DOMobj.tabIndex > 0)
	{
		this._headerAnchor_OPENED.tabIndex = this.DOMobj.tabIndex;
		this._headerAnchor_CLOSED.tabIndex = this.DOMobj.tabIndex; 
		this.DOMobj.tabIndex = -1;
	}

	// display the section based on current values	
	this.setSection(true);
}

// Public to AJAX only -- destroy handlers and large objects
HxG_5.prototype.JSFSection.prototype.destroy = function() {

	// Unhook handlers and destroy the objects they are attached to
	hX_5.removeAllEvents(this._headerAnchor_OPENED, this._headerAnchor_OPENED.id);
	hX_5.removeAllEvents(this._headerAnchor_CLOSED, this._headerAnchor_CLOSED.id);
	
	// Destroy larger memory objects
	if (this.attributeTable) delete this.attributeTable;
	return true;
}

// Calling this will set the section to open regardless of current state.
// there is NO need to call redraw after this
/*HxG_5.prototype.JSFSection.prototype.expand = function()
{
	if(!this._disabled)
		this.setAttribute("expanded:true");
	this.setSection();
}*/

// Calling this will set the section to closed regardless of current state.
// there is NO need to call redraw after this
/*HxG_5.prototype.JSFSection.prototype.collapse = function()
{
	if(!this._disabled)
		this.setAttribute("expanded:false");
	this.setSection();
}*/


// private toggle 
// this is what does the opening and closing based on user clicks
HxG_5.prototype.JSFSection.prototype.toggle = function()
{
	if(!this._disabled) {// it is open, so we close the section and set the section closed ( hidden input) flag to true
		// If we have disabled content, undisable it
		if (this._hidden_DISABLED) {
			this._hidden_DISABLED = false;
			hX_5.applyNestedAttribute(this._contents, hX_5._DSB, false, true);
		}
		if(this._expanded)
		{
			this._contents.style.display=hX_5._NO;
			
			this._header_OPENED.style.display=hX_5._NO;
		
			this._header_CLOSED.style.display=hX_5._BLK;
			
			this._expanded=false;
			this._hidden_UISTATE.value="true";
			hX_5.redrawWithODC(this);
			hX_5.i.setFocus(this._headerAnchor_CLOSED, false, true);
		}
		else // it is closed, so we open the section and set the section closed ( hidden input) flag to false
		{
			this._contents.style.display=hX_5._BLK;
			
			this._header_OPENED.style.display=hX_5._BLK;
		
			this._header_CLOSED.style.display=hX_5._NO;
			
			this._expanded=true;
			this._hidden_UISTATE.value="false";
			hX_5.redrawWithODC(this);
			hX_5.i.setFocus(this._headerAnchor_OPENED, false, true);
		}
	} else {
		// If we have do not have disabled content, disable it
		if (!this._hidden_DISABLED) {
			this._hidden_DISABLED = true;
			hX_5.applyNestedAttribute(this._contents, hX_5._DSB, true, true);
		}
	}
}


// private  
// this is what does the opening or closing without toggling the _expanded value
HxG_5.prototype.JSFSection.prototype.setSection = function(initial)
{
	// this is a simpler version
	/*if(this._contents.style.display == "block") // it is open, so we close the section
	{
		this._contents.style.display = "none";	
		this._img.src=this.cimg; 
	}
	else // it is closed, so we open the section
	{
		this._contents.style.display = "block";	
		sec_img.src=this.oimg; 
	}*/
	if(!this._disabled) { // if is NOT disabled run this code
		// If we have disabled content, undisable it
		if (this._hidden_DISABLED) {
			this._hidden_DISABLED = false;
			hX_5.applyNestedAttribute(this._contents, hX_5._DSB, false, true);
		}
		if(this._expanded)// it is meant to be expanded, so we open the section
		{
			this._contents.style.display=hX_5._BLK;

			this._header_OPENED.style.display=hX_5._BLK;
		
			this._header_CLOSED.style.display=hX_5._NO;
				
			this._hidden_UISTATE.value="false";
			if(initial == null || initial == false)
				hX_5.i.setFocus(this._headerAnchor_OPENED, false, true);
		}
		else // it is meant to be closed, so we closed the section
	 	{
			this._contents.style.display=hX_5._NO;
			
			this._header_OPENED.style.display=hX_5._NO;
		
			this._header_CLOSED.style.display=hX_5._BLK;
			
			this._hidden_UISTATE.value="true";
			if(initial == null || initial == false)
				hX_5.i.setFocus(this._headerAnchor_CLOSED, false, true);
		}
	} else {
		// If we have do not have disabled content, disable it
		if (!this._hidden_DISABLED) {
			this._hidden_DISABLED = true;
			hX_5.applyNestedAttribute(this._contents, hX_5._DSB, true, true);
		}
	}
}

