/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// --------------------------------------------------------
// Create a cookie in order to compute the client time zone
// --------------------------------------------------------

// Usage:  Since this is encapsulated in the singleton HxG_5 object, it
//         is now used as follows:
//             var foo = new hX.DSTCookie("designerClientTimeZone");
//             foo.CreateCookie();
// If we get the read() version of this code, and understand how XFaces want
// to use it, the constructor can create the cookie, or retrieve an existing
// one to use as part of the read.


// Public:  Constructor
HxG_5.prototype.DSTCookie = function(nam) {
   this.CookieName = nam;

   // Private: Used to identify the Summer Time start & end dates
   HxG_5.prototype.DSTCookie.getDSTStartEnd = function(Y) {
      var janO, Mar, JulO, Oct, JANO, jan, Jul, JUl, JAN, T, J;
      with(new Date(Y, 0, 1)) {
         jan = getTime() ; janO = getTimezoneOffset();
         setMonth(06) ; Jul=JUl = getTime() ; JulO = getTimezoneOffset();
         setMonth(12) ;     JAN = getTime() ; JANO = getTimezoneOffset();
         if (janO==JulO) {
            // no daylight saving;
            return [];
         }
         Mar = jan ; Oct = JAN;
         for (J=0; J<21; J++) {
            setTime(Mar) ; T = Mar;
            if (getTimezoneOffset() != janO) {
               Mar = (jan + Mar)/2 ; Jul = T;
            } else {
               Mar = (Mar + Jul)/2 ; jan = T;
            }
            setTime(Oct) ; T = Oct;
            if (getTimezoneOffset() != JulO) {
               Oct = (JUl + Oct)/2 ; JAN = T;
            } else {
               Oct = (Oct + JAN)/2 ; JUl = T;
            }
         }
         Mar = Math.round(Mar/60000)*60000 // to nearest minute;
         Oct = Math.round(Oct/60000)*60000;
      }
      return [Mar, Oct];
   }
   
   
// Public:  Push the data into the cookie
   HxG_5.prototype.DSTCookie.CreateCookie = function() {
      var currentYear = new Date().getFullYear();
      var jan = new Date(currentYear,0,1).getTimezoneOffset();
      var jul = new Date(currentYear,6,1).getTimezoneOffset();
      var tabDates = this.getDSTStartEnd(currentYear);
      var result = jan + " " + jul;
      if (tabDates[0]!=null && tabDates[1]!=null) {
         var dateMar = new Date();
         dateMar.setTime(tabDates[0]);
         var timeMar = dateMar.getHours()*3600000  +  dateMar.getMinutes()*60000;
   
         var dateOct = new Date();
         dateOct.setTime(tabDates[1]);
         var timeOct = dateOct.getHours()*3600000  +  dateOct.getMinutes()*60000;
   
         result  + = " " + dateMar.getMonth() + " " + dateMar.getDate() + " " + dateMar.getDay() + " " + timeMar;
         result  + = " " + dateOct.getMonth() + " " + dateOct.getDate() + " " + dateOct.getDay() + " " + timeOct;
      }
      document.cookie = HxG_5.prototype.DSTCookie.CookieName  +  "="  +  result  +  "; path=/";
   }
}

